# @(#)55        1.15 src/43haes/lib/perl/cl_testtool/Event/CLSTRMGR_KILL.pm, hacmp, 52haes_r540, r5400622c 4/4/06 15:21:20
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2004,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

package Event::CLSTRMGR_KILL;

use 5.006;
use strict;
use warnings;

use Event;
use Event::NODE_DOWN_TAKEOVER;

require Exporter;

our @ISA = qw(Event::NODE_DOWN_TAKEOVER Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration       use Event::EVENT_NAME ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(

) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(

);
our $VERSION = '1.15';

=head1 NAME

CLSTRMGR_KILL -- 
Perl extension providing the object class for the CLSTRMGR_KILL event.

=head1 SYNOPSIS

    use Event::CLSTRMGR_KILL;

    my $event = Event::CLSTRMGR_KILL->new( $logger, $staticconfg, \@params );
    
    if ( $event->is_valid() ) {
        my $eventRC = $event->execute();
        $eventRC = $event->wait_for_stable() if $eventRC eq Event::Continue;
        $eventRC = $event->check_status() if $eventRC eq Event::Continue;
    }

=head1 DESCRIPTION

Objects of the CLSTRMGR_KILL class represent CLSTMGR_KILL Test Tool events.
The class inherits from the Event class, but will over-ride most of that
classes methods.

=head1 METHODS

Most of the methods used for CLSTRMGR_KILL are identical to those in the
parent class NODE_DOWN_TAKEOVER. Examine the metods for that class and for
the Event class for more details about how this class functions.

=head2 new -- create a new instance of CLSTRMGR_KILL

=head3     Description:

Each event specific class must have its own new() method. The new method will
create an instance of the correct CLSTRMGR_KILL class and will perform the
appropriate checks of the event parameters to ensure that the event parameters
do not conflict with the actual cluster configuration, setting the object's
"valid" variable accordingly.

=head3     Arguments:

    This constructor takes two arguments:

        $logger: a reference to a previously created Logger object.

        $staticconfig: a reference to a previously created StaticConfig object

        $paramters: a reference to the parameters array.

=head3     Returns:

    A new Event::CLSTRMGR_KILL object.

=head3     Examples:

    my $event = Event::CLSTRMGR_KILL->new( $logger, $staticconfig, \@parameters );

=cut

sub new ( )
{
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    $self->{logger} = shift;
    $self->{StaticConfig} = shift;
    my $params = shift;
    $self->{nodename} = (shift @{$params}) || "";
    $self->{description} = (join ',', @{$params}) || "";
    $self->{event_name} = "CLSTRMGR_KILL";
    $self->{valid} = 1;
    Event::NODE_DOWN_TAKEOVER::validate( $self, $class );
    return bless $self, $class;
}

=head2 local_node_is_control_node  -- check if local node is the control node

=head3     Description:
	local_node_is_control_node checks to see if the local node is the
	control node for the cluster test tool

=head3     Arguments:

    $local_node 

=head3     Returns:

    0  = $local_node is not the control node 
    1  = $local_node is the control node 

=head3     Examples:

    $self->local_node_is_control_node();
   
=head3     Internal Flow:

    see code below

=cut

sub local_node_is_control_node()
{
    my $self = shift;
    if ( $self->{StaticConfig}->{local_node} ne $self->{nodename} ) {
        return 0;
    } else {
        return 1;
    }
}


=head2 execute -- Execute the event.

=head3     Description:

execute() will control, at a high level, the execution of the specified event.
As each event performs a different set of actions, each type of CLSTRMGR_KILL class
will most likely over-ride the execute() method of the Event class.

=head3     Arguments:

    none.

=head3     Returns:

    Event::FATAL if unable to collect pre-event state data

    Event::NotRational if it doesn't make sense to run the test

    Event::Failed if unable to save state data before running event

    or the return value from Event::execute_cmd

=head3     Examples:

    $event->execute();
    
=cut

sub execute()
{
    my $self = shift;
                                                                                
    if ( ! Event::collect_preevent($self) ) {
        return Event::Fatal;
    }
                                                                                
    if ( ! $self->is_rational() ) {
        return Event::NotRational;
    }
   
    if ( $self->local_node_is_control_node() ) {
        if ( ! $self->{preevent}->write_state_data_file() ) {
            $self->{logger}->err_msg(2,1,
                "Failed initializing environment for execution of test %s\n" .
                "to be run on node %s.\n", "CLSTRMGR_KILL", $self->{nodename});
            return Event::Failed;
        }
    } 
       
                                                                                
    return Event::execute_cmd (
        $self->{nodename}, $self, $self->{nodename});
}

 
=head2 to_string -- writes the event out as an event file record.

=head3     Description:

to_string returns an event record to write out for this object. CLSTRMGR_KILL
objects write out CLSTRMGR_KILL_COMPLETE records if a tag is passed in. This
is to allow them to function correctly in the case where a CLSTRMGR_KILL event
is run on the localnode.

=head3     Arguments:

    $filehandle: filehandle to write the record to.
    $tag: data/time stamp that was written to hacmp.out on all nodes
          at the start of the event.

=head3     Returns:

    scalar value of the event record.

=head3     Examples:

    for my $event (@event_list) {
        print TESTSUITE, $event->to_string() . "\n";
    }

=cut
                                                                                     
sub to_string() {
    
    my $self = shift;
    my $eventnum = shift;
    my $errAbort = shift;
    my $verbose = shift;
    my $EST = shift;
    my $retstring = "";

    if ( $EST ) {
        # tag specified, so this is a continuation event
        $retstring = sprintf "%s,%s,%ld,%ld,%ld,%s,%s",
                "CLSTRMGR_KILL_COMPLETE", $self->{nodename}, $eventnum,
                $errAbort,$verbose,$EST,$self->{description};
    } else {
        # no tag, so this is not a continuation event
        $retstring = sprintf "%s,%s,%s",
                "CLSTRMGR_KILL", $self->{nodename},$self->{description};
    }

    return $retstring;
}


# it's a module, so the last statement should always just be '1;'
1;
__END__

