# @(#)64        1.13 src/43haes/lib/perl/cl_testtool/Event/CLSTRMGR_KILL_COMPLETE.pm, hacmp, 52haes_r540, r5400622c 4/4/06 15:20:56
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2004,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

package Event::CLSTRMGR_KILL_COMPLETE;

use 5.006;
use strict;
use warnings;

use lib '/usr/es/lib/perl';
use lib '/usr/es/lib/perl/cl_testtool';

use Event;
use Event::NODE_DOWN_TAKEOVER;

require Exporter;

our @ISA = qw(Event::NODE_DOWN_TAKEOVER Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration       use Event::EVENT_NAME ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(

) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(

);
our $VERSION = '1.13';

=head1 NAME

CLSTRMGR_KILL_COMPLETE -- 
Perl extension providing the object class for the named event.

=head1 SYNOPSIS

    use Event::CLSTRMGR_KILL_COMPLETE;

    my $event = Event::CLSTRMGR_KILL_COMPLETE->new( $logger, $staticconfig, \@params );
    
    if ( $event->is_valid() ) {
        my $eventRC = $event->execute();
        $eventRC = $event->wait_for_stable() if $eventRC eq Event::Continue;
        $eventRC = $event->check_status() if $eventRC eq Event::Continue;
    }

=head1 DESCRIPTION

For each supported type of test event, one Perl module is provided that
supplies the required event specific code. These classes inherit from the 
Event class, and so will use all of the methods defined for that class unless 
the methods are over-ridden by the event specific class.

=head1 METHODS

Many of the methods used for CLSTRMGR_KILL_COMPLETE are identical to those
in the parent class NODE_DOWN_TAKEOVER. Examine the metods for that class 
and for the Event class for more details about how this class functions.

=head2 new -- create a new instance of CLSTRMGR_KILL_COMPLETE

=head3     Description:

Each event specific class must have its own new() method. The new method will
create an instance of the correct CLSTRMGR_KILL_COMPLETE class and will perform the
appropriate checks of the event parameters to ensure that the event parameters
do not conflict with the actual cluster configuration, setting the object's
"valid" variable accordingly.

=head3     Arguments:

    This constructor takes two arguments:

        $logger: a reference to a previously created Logger object.

        $staticconfig: a reference to a previously created StaticConfig object

        $paramters: a reference to the parameters array.

=head3     Returns:

    A new Event::CLSTRMGR_KILL_COMPLETE object.

=head3     Examples:

    my $event = Event::CLSTRMGR_KILL_COMPLETE->new( $logger, $staticconfg, \@parameters );

=cut

sub new ( )
{
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    $self->{logger} = shift;
    $self->{StaticConfig} = shift;
    my $params = shift;
    $self->{nodename} = (shift @{$params}) || "";
    $self->{eventnum} = (shift @{$params}) || "";
    $self->{errAbort} = (shift @{$params}) || "";
    $self->{verbose} = (shift @{$params}) || "";
    $self->{EST} = (shift @{$params}) || "";
    $self->{description} = (join ',', @{$params}) || "";
    $self->{event_name} = "CLSTRMGR_KILL_COMPLETE";
    $self->{valid} = 1;

    my $data = StateData->new( $self->{logger}, $self->{StaticConfig} );
    $data->process_state_data_file();
    $self->{preevent} = $data;

    validate($self);

    return bless $self, $class;
}

=head2 is_valid -- Check whether the event is valid.

=head3     Description:

is_valid() returns the value of the event's 'valid' data member. This method
does not need to be over-ridden by subclasses.

=head3     Arguments:

    none.

=head3     Returns:

    1  == event is valid.
    0 == event is not valid.

=head3     Examples:

sub is_valid ( )
{
    my $self = shift;
    if ( $self->{preevent}->is_valid() ) {
        return $self->{valid};
    }
    return 0;
}

=head2 validate -- validates the event parameters.

=head3     Description:

validate() will validate the the event parameters to ensure that they reflect
the base HACMP configuration. For example, it will check to ensure that the
specified node name or RG name exists in the HACMP configuration. If it finds
a problem with the parameters, it will set the object's 'valid' data member
to 0. validate() will virtually always be called directly from within
the new() method.

=head3     Arguments:

    $event: reference to CLSTRMGR_KILL_COMPLETE object.

=head3     Returns:

    none.

=head3     Examples:

    validate ( $event );
    if ( $event->{valid} == 0 ) {
        print "Event is not valid.\n";
    }

=cut

sub validate()
{
# check that the $nodename field is either "ALL" or a cluster node.
    my $self = shift;

    $self->{logger}->phase_header("Validate CLSTRMGR_KILL_COMPLETE");

# check that the $nodename field is a cluster node.
    my $nodes_configured = join " ",@{$self->{StaticConfig}->{node_names}};
    $self->{logger}->verb_log_msg("\tEvent node: $self->{nodename}\n");
    $self->{logger}->verb_log_msg("\tConfigured nodes: $nodes_configured\n");

    my @node_configured = 
        grep {/$self->{nodename}/} @{$self->{StaticConfig}->{node_names}};
    if ( ! (scalar (@node_configured)) ) {
        $self->{logger}->err_msg(2, 2,
            "%s: Invalid Test\n".
            "Node %s not in cluster configuration\n", 
            "CLSTRMGR_KILL_COMPLETE", $self->{nodename});
        $self->{valid} = 0;
    }

    $self->{logger}->verb_log_msg("\tRequired Data:\n" .
        "\t\t\tEvent Number: " . $self->{eventnum} . "\n" .
        "\t\t\tAbort on Error: " . $self->{errAbort} . "\n" .
        "\t\t\tVerbose Logging: " . $self->{verbose} . "\n" .
        "\t\t\tTest Start Time: " . $self->{EST} . "\n");

    if ( $self->{EST} eq "" ) {
         $self->{logger}->err_msg(2, 3, 
            "%s: Invalid Test\n" .
            "The test record is incorrectly formed.\n",
            "CLSTRMGR_KILL_COMPLETE");
         $self->{valid} = 0;
    }
}


=head2 execute -- Execute the event.

=head3     Description:

execute() will do nothing for this event type, since it's a continuation of
an event that was already started.

=head3     Arguments:

    none.

=head3     Returns:

    Event::Continue

=head3     Examples:

    $event->execute();
    
=cut

sub execute ( )
{
    return Event::Continue;
}


=head2 to_string -- writes the event out as an event file record.

=head3     Description:

to_string returns an event record to write out for this object.

=head3     Arguments:

    none.

=head3     Returns:

    scalar value of the event record.

=head3     Examples:

    for my $event (@event_list) {
        print TESTSUITE, $event->to_string() . "\n";
    }

=cut

sub to_string() {
    
    my $self = shift;
    my $retstring = sprintf "%s,%s,%ld,%ld,%ld,%s,%s",
                "CLSTRMGR_KILL_COMPLETE", $self->{nodename},$self->{eventnum},
                $self->{errAbort}, $self->{verbose}, $self->{EST}, 
                $self->{description};
    return $retstring;
}

=cut
