# @(#)56        1.19 src/43haes/lib/perl/cl_testtool/Event/NETWORK_DOWN_LOCAL.pm, hacmp, 52haes_r540, r5400622c 3/27/06 18:43:14
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2004,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
                                                                                          
package Event::NETWORK_DOWN_LOCAL;

use 5.006;
use strict;
use warnings;
use Event;                                                                                          
require Exporter;
                                                                                          
our @ISA = qw(Event Exporter);
                                                                                          
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
                                                                                          
# This allows declaration       use Event::EVENT_NAME ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
                                                                                          
) ] );
                                                                                          
our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );
                                                                                          
our @EXPORT = qw(
                                                                                          
);
our $VERSION = '1.19';
                                                                                          
##
## Put all the methods and global data for your module here
##

=head1 NAME

NETWORK_DOWN_LOCAL -- 
Perl extension providing the object class for the named event.

=head1 SYNOPSIS

    use Event::NETWORK_DOWN_LOCAL;

    my $event = Event::NETWORK_DOWN_LOCAL->new( $logger, $staticconfg, \@params );
    
    if ( $event->is_valid() ) {
        my $eventRC = $event->execute();
        $eventRC = $event->wait_for_stable() if $eventRC eq Event::Continue;
        $eventRC = $event->check_status() if $eventRC eq Event::Continue;
    }

=head1 DESCRIPTION

For each supported type of test event, one Perl module is provided that
supplies the required event specific code. These classes inherit from the 
Event class, and so will use all of the methods defined for that class unless 
the methods are over-ridden by the event specific class.

=head1 METHODS

=head2 new -- create a new instance of NETWORK_DOWN_LOCAL

=head3     Description:

Each event specific class must have its own new() method. The new method will
create an instance of the correct NETWORK_DOWN_LOCAL class and will perform the
appropriate checks of the event parameters to ensure that the event parameters
do not conflict with the actual cluster configuration, setting the object's
"valid" variable accordingly.

=head3     Arguments:

    This constructor takes two arguments:

        $logger: a reference to a previously created Logger object.

        $staticconfig: a reference to a previously created StaticConfig object

        $paramters: a reference to the parameters array.

=head3     Returns:

    A new Event::NETWORK_DOWN_LOCAL object.

=head3     Examples:

    my $event = Event::NETWORK_DOWN_LOCAL->new( $logger, $staticconfig, \@parameters );

=cut

sub new ( )
{
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    $self->{logger} = shift;
    $self->{StaticConfig} = shift;
    my $params = shift;
    $self->{nodename} = (shift @{$params}) || "";
    $self->{network} = (shift @{$params}) || "";
    $self->{description} = (join ',', @{$params}) || "";
    $self->{valid} = 1;
    $self->{event_name} = "NETWORK_DOWN_LOCAL";
    validate( $self );
    return bless $self, $class;
}


=head2 validate -- validates the event parameters.

=head3     Description:

validate() will validate the the event parameters to ensure that they reflect
the base HACMP configuration. For example, it will check to ensure that the
specified node name or RG name exists in the HACMP configuration. If it finds
a problem with the parameters, it will set the object's 'valid' data member
to 0. validate() will virtually always be called directly from within
the new() method.

=head3     Arguments:

    $event: reference to NETWORK_DOWN_LOCAL object.

=head3     Returns:

    none.

=head3     Examples:

    validate ( $event );
    if ( $event->is_valid() ) {
        print "Event is valid.\n";
    }

=cut

sub validate()
{
    my $self = shift;

    $self->{logger}->phase_header("Validate " . $self->{event_name});

    my $nodes_configured = join " ",@{$self->{StaticConfig}->{node_names}};
    $self->{logger}->verb_log_msg("\tEvent node: $self->{nodename}\n");
    $self->{logger}->verb_log_msg("\tConfigured nodes: $nodes_configured\n");

    $self->{valid} = $self->{StaticConfig}->is_node_valid($self->{nodename});
    if (!$self->{valid}) {
        $self->{logger}->err_msg(2, 2,
            "%s: Invalid Test\n".
            "Node %s not in cluster configuration\n",
            $self->{event_name}, $self->{nodename});
    }

    my $rc = $self->{StaticConfig}->is_network_valid($self->{network});
    if ($rc != 1) {
        Event::handle_invalid_network($self, $self->{network}, $rc);
        $self->{valid} = 0;
    }
    else {
        $self->{valid} = 1;
    }

    $self->{valid} = $self->{StaticConfig}->is_node_on_network($self->{nodename},
                                                               $self->{network});
    if (!$self->{valid}) {
        $self->{logger}->err_msg(2, 31,
            "%s: Invalid Test\n".
            "Node %s has no interfaces on network %s.\n",
            $self->{event_name}, $self->{nodename}, $self->{network});
    }
} 

    
=head2 is_rational -- Check whether it is rational to run the event .

=head3     Description:

is_rational() checks whether the entrance criteria for the event are satisfied.
The entrance criteria for each event will be quite specific to that event, and
so each type of NETWORK_DOWN_LOCAL class will most likely over-ride the is_rational()
method of the Event class. 

is_rational() will typically only be called from within the execute() method.

=head3     Arguments:

    none.

=head3     Returns:

    0 = event is rational

    1 = event is not rational

=head3     Examples:

    if ( $event->is_rational() ) {
        print "Event is rational.\n";
    }
    
=cut

sub is_rational() {
    my $self = shift;

    $self->{logger}->phase_header("is_rational $self->{event_name}");

    if ( ! $self->{preevent}->cluster_is_stable() ) {
        $self->{logger}->warn_msg(2, 10,
            "%s cannot be run: Not Rational\n" .
            "Cluster is not stable\n", $self->{event_name});
        return 0;
    }
    if ( ! Event::is_node_active($self, $self->{nodename})) {
        $self->{logger}->warn_msg(2, 11,
            "%s cannot be run: Not Rational\n" .
            "Specified node is not active in the cluster: %s\n",
            $self->{event_name}, $self->{nodename});
        return 0;
    }

    if ( ! Event::is_network_up_on_node($self, $self->{network},
            $self->{nodename}))
    {
        $self->{logger}->warn_msg(2, 71,
            "%s cannot be run: Not Rational\n" .
            "Network %s is not up on node %s\n",
            $self->{event_name}, $self->{network}, $self->{nodename});
        return 0;
    }

    return 1;
}

=head2 execute -- Execute the event.

=head3     Description:

execute() will control, at a high level, the execution of the specified event.
As each event performs a different set of actions, each type of NETWORK_DOWN_LOCAL class
will most likely over-ride the execute() method of the Event class.

=head3     Arguments:

    none.

=head3     Returns:

    Event::FATAL if unable to collect pre-event state data

    Event::NotRational if it doesn't make sense to run the test

    or the return value from Event::execute_cmd

=head3     Examples:

    $event->execute();
    
=cut

sub execute()
{
    my $self = shift;
    if ( ! Event::collect_preevent($self) ) {
        return Event::Fatal;
    }
    if ( ! $self->is_rational() ) {
        return Event::NotRational;
    }
    return Event::execute_cmd (
        $self->{nodename}, $self, $self->{network});
}


=head2  wait_for_stable -- waits until the cluster is stable.

=head3     Description:

Event::NETWORK_DOWN_LOCAL::wait_for_stable() will determine the failure
detection rate for the NIM type of the network being stopped, and wait
that long before handing control off to Event::wait_for_stable.

=head3     Arguments:

    none.

=head3     Returns:

    Event::Continue == cluster reached the stable state.
    Event::Timeout  == cluster did not reach the stable state, and the
                       timeout for this event was reached.
    Event::Fatal    == a fatal error occured testing for stability

=head3     Examples:

    if ( $event->wait_for_stable() eq Event::Timeout ) {
        print "Timeout waiting for cluster to stabilize.\n".
    }   
   
=cut

sub wait_for_stable ( )
{
    my $self = shift;
        
    # look up the nim object for the network
    my $nim = "";
    foreach my $net ( @{$self->{StaticConfig}->{networks}} ) {
        if ( $self->{network} eq $net->{name} ) {
            $nim = $net->{nimname};
        }
    }   
    my $odm = ODM->new("HACMPnim", ODMDIR=>"/etc/objrepos");
    my ($nim_obj) = $odm->get(-q => "name = $nim");
        
    # now calculate the failure detection rate
    if ($nim_obj) {
        my $hb_rate = ($nim_obj->{hbrate} / 1000000);
        # round up for sub-second hb rate
        if ($nim_obj->{hbrate} % 1000000) {
            $hb_rate += 1;
        }
        my $fail_rate = ($hb_rate * $nim_obj->{cycle} * 2);
        if ( $fail_rate > 0 ) {
            # needs new message in catalog for next release
            $self->{logger}->info_msg(2, 999,
            "%s: Waiting for failure detection interval %ld before checking stability.\n",
            "NETWORK_DOWN_LOCAL", "$fail_rate");
            sleep $fail_rate;
        }
    }   
        
    return Event::wait_for_stable($self);
}       


=head2 check_status -- checks the event's completion status.

=head3     Description:

check_status() will collect and analyze all of the data required to determine
whether an event has completed successfully. It will also report the final 
event status to the log file and the console.

=head3     Arguments:

    none.

=head3     Returns:

    Event::Fatal if unable to collect post-event state data

    Event::Failed if the event has failed (see below for specifics)

    Event::Continue if the event passed

=head3     Examples:

    if ( $event->check_status() eq Event::Failed ) {
        print "Test failed status check\n";
    }
    
=cut

sub check_status()
{
    my $self = shift;
    my $tag  = shift;
    my $retval = Event::Continue;

    $self->{logger}->phase_header(
            "NETWORK_DOWN_LOCAL: Checking post-event status"); 

    if ( ! Event::collect_postevent($self, $tag) ) {
        return Event::Fatal;
    }

    my @post_active_nodes = @{$self->{postevent}->{active_nodes}};
    my @pre_active_nodes = @{$self->{preevent}->{active_nodes}};

#
# no node has changed state
#
    $self->{logger}->verb_log_msg("Checking node states\n");
    my $pre_node_states = $self->{preevent}->get_node_states();
    my $post_node_states = $self->{postevent}->get_node_states();

    foreach my $node ( sort( keys( %{$pre_node_states} ))) {

        $self->{logger}->verb_log_msg(
            "$node: Preevent state: $pre_node_states->{$node}, " .
            "Postevent state: $post_node_states->{$node}\n");

        if ($pre_node_states->{$node} ne $post_node_states->{$node}) {

            $self->{logger}->err_msg(2, 20,
                "%s: Unexpected state change: node %s\n" .
                "Pre-event state %s, Post-event state %s\n",
                "NETWORK_DOWN_LOCAL", $node, 
                Event::get_node_statename($pre_node_states->{$node}),
                Event::get_node_statename($post_node_states->{$node}));
            $retval = Event::Failed;
        }
    }

# checking RG state changes
    $self->{logger}->verb_log_msg("Checking RG states\n");
    RGRP: foreach my $resgrp ( @{$self->{StaticConfig}->{resource_groups}} ) {

        $self->{logger}->verb_log_msg("\tResource Group: $resgrp->{group}\n");

        my $pre_states = $self->{preevent}->get_rg_states($resgrp->{group});
        my $post_states = $self->{postevent}->get_rg_states($resgrp->{group});
        my $rgtype = $self->{StaticConfig}->get_rg_type($resgrp->{group});

        # have nodes moved into the ERROR state?
        foreach my $node ( sort( keys( %{$post_states} ))) {

            $self->{logger}->verb_log_msg(
                "\t\tNode: $node Pre Event State: %s, Post Event State: %s\n",
                (($pre_states->{$node}) ? $pre_states->{$node} : "OFFLINE"), 
                $post_states->{$node});

            if ( $post_states->{$node} eq "ERROR" &&
                 $pre_states->{$node} ne "ERROR" ) {

                # output error message
                $self->{logger}->err_msg(2, 21,
                    "%s: Unexpected state change\n" .
                    "Resource Group %s changed to %s state on node %s\n",
                    "NETWORK_DOWN_LOCAL", $resgrp->{group}, "ERROR", "$node");
                $retval = Event::Failed;
            }
        }

        # don't bother looking at nonconcurrent RGS that were ONLINE on
        # the event node. they will be checked below.
        if ( $rgtype == StaticConfig::nonconcurrent &&
             $pre_states->{$self->{nodename}} eq "ONLINE" ) {

            next RGRP;
        }

        # have RGs unexpectedly gone OFFLINE on nonevent nodes?
        foreach my $node ( sort( keys( %{$pre_states} ))) {
            if ( $pre_states->{$node} eq "ONLINE"  &&
                 $post_states->{$node} ne "ONLINE" &&
                 $post_states->{$node} ne "ERROR"  ) {

                $self->{logger}->err_msg(2, 21,
                    "%s: Unexpected state change\n" .
                    "Resource Group %s changed to %s state on node %s\n",
                    "NETWORK_DOWN_LOCAL", $resgrp->{group}, 
                    $post_states->{$node}, $node);
                $retval = Event::Failed;
            }
        }
    }

# check RG state/node changes for event node to make sure they're correct
#
	$self->{logger}->verb_log_msg("Checking RG state changes on the local node\n");

    my $monitor_odm = ODM->new("HACMPmonitor");
    my @pre_rgs_online_eventnode = 
            $self->{preevent}->get_rgs_for_node( $self->{nodename}, "ONLINE");
    RG: foreach my $rgpre_online ( @pre_rgs_online_eventnode ) {
        my $rgtype = $self->{StaticConfig}->get_rg_type($rgpre_online);
            
        $self->{logger}->verb_log_msg(
            "\tResource Group: $rgpre_online Type: $rgtype\n");

        if ( $rgtype == StaticConfig::concurrent ) {
            # these were checked already
            next RG;
        }

        my @post_rg_online_nodes =
            $self->{postevent}->get_nodes_for_rg( $rgpre_online, "ONLINE");
        my @svc_labels_for_rg = 
            $self->{StaticConfig}->get_resources_for_rg( 
                $rgpre_online, "SERVICE_LABEL" );

        # are there any service labels on correct net with 'fallover' as action?
        $self->{logger}->verb_log_msg("\tChecking service label recovery action\n");
        my $has_svc_on_net = 0;
        my $recovery_type = "notify";
        SVC: foreach my $svc ( @svc_labels_for_rg ) {

            IFACE: foreach my $if ( @{ $self->{StaticConfig}->{interfaces} } ) {
                next IFACE if ( $if->{ip_label} ne $svc );
                next IFACE if ( $if->{network} ne $self->{network} );
                
                my ($monitor) = $monitor_odm->get(-q =>
                        "monitor = $svc and name = FAILURE_ACTION");
                my $mon_type = (($monitor) ? $monitor->{value} : "fallover");
                $self->{logger}->verb_log_msg(
                    "Service Label: $if->{ip_label} Network: $if->{network} " .
                    "Monitor Type: $mon_type\n");

                if ( $mon_type ne "notify" ) {
                    $recovery_type = "fallover";
                    last SVC;
                }
            }
        }

        # if no service labels with fallover as action, 
        # then there should be no change in RG state/location
        if ( $recovery_type eq "notify"  ) {
            if ( ! scalar( grep {/^$self->{nodename}$/} @post_rg_online_nodes)){
                $self->{logger}->err_msg( 2, 32,
                    "%s: Unexpected state change\n" .
                    "Resource Group %s is no longer ONLINE on node %s.\n",
                    "NETWORK_DOWN_LOCAL", $rgpre_online, $self->{nodename});
                $retval = Event::Failed;
            }
            next RG;
        }

        # otherwise, RG should be online somewhere else
        if ( scalar( grep {/^$self->{nodename}$/} @post_rg_online_nodes)){
            $self->{logger}->err_msg( 2, 33,
                "%s: Unexpected state\n" .
                "Resource Group %s is still ONLINE on node %s.\n",
                "NETWORK_DOWN_LOCAL", $rgpre_online, $self->{nodename});
            $retval = Event::Failed;
        } elsif ( ! scalar( @post_rg_online_nodes ) ) {
            $self->{logger}->err_msg(2, 34,
                "%s: Unexpected state change\n" .
                "Resource Group %s is no longer ONLINE on any node.\n",
                "NETWORK_DOWN_LOCAL", $rgpre_online);
            $retval = Event::Failed;
        }
    }

# Process event history record
    $self->{logger}->verb_log_msg("Checking event history\n");

    my $event_complete_found = 0;
    my $event_history = $self->{postevent}->get_event_history(
            "network_down", "network_down_complete");
    # We need to search for the nodename or for -1.  -1 means that the event
    # was a global network down, i.e. we just brought the network down on the
    # last node where it was alive.
    my $search_str = 
        "network_down_complete (?:-1|" . $self->{nodename} . ") " . $self->{network};

    my $EVENT_COMPLETED_MSG = Event::get_EVENT_COMPLETED_msg($self);
    my $EVENT_FAILED_MSG = Event::get_EVENT_FAILED_msg($self);

    foreach my $node ( sort( keys ( %{$event_history} ))) {
                                                                                
        my @FAILED_records =
            grep {/^.* ${EVENT_FAILED_MSG}: .*$/} @{$event_history->{$node}};
        my @COMPLETED_records =
            grep {/^.* ${EVENT_COMPLETED_MSG}: $search_str/}
                @{$event_history->{$node}};
                                                                                
        foreach my $record ( @FAILED_records ) {
                                                                                
            $self->{logger}->err_msg(2, 22,
                "%s: EVENT FAILED message logged on node %s\n%s\n",
                "NETWORK_DOWN_LOCAL", $node, $record);
            $retval = Event::Failed;
        }
        if ( scalar(@COMPLETED_records) ) {
            $event_complete_found = 1;
        }
    }
                                                                                
    if ( ! $event_complete_found ) {
        $self->{logger}->err_msg(2, 23,
            "%s: No EVENT COMPLETED message logged.\n" .
            "Search string: %s\n",
            "NETWORK_DOWN_LOCAL", "${EVENT_COMPLETED_MSG}: $search_str");
        $retval = Event::Failed;
    }
                                                                                
    return $retval;
}


=head2 to_string -- return a string version of event

=head3     Description:

to_string() will build a Test record to insert in a Test Suite file.

=head3     Arguments:

    none.

=head3     Returns:

    Test event record as scalar value

=head3     Examples:

    for my $event (@event_list) {
        print TESTSUITE, $event->to_string() . "\n";
    }

=cut

sub to_string() {
                                                                                       
    my $self = shift;
    my $retstring = sprintf "%s,%s,%s",
                "NETWORK_DOWN_LOCAL", $self->{nodename}, $self->{network}, 
                 $self->{description};
    return $retstring;
}

# it's a module, so the last statement should always just be '1;'
1;
__END__

