# @(#)52        1.14 src/43haes/lib/perl/cl_testtool/StaticConfig.pm, hacmp, 52haes_r540, r5400622c 3/29/06 12:48:18
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2004,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

package StaticConfig;

use 5.006;
use strict;
use warnings;

use lib '/usr/es/lib/perl';
use lib '/usr/es/lib/perl/cl_testtool';

use ODM;

require Exporter;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration       use Event::EVENT_NAME ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);
our $VERSION = '1.14';

=head2 nonconcurrent -- constant used for readability

=head3      Description:

The nonconcurrent method is used as a constant to represent nonconcurrent
RG types.

=head3      Arguments:

    none

=head3      Returns:

    1

=cut

sub nonconcurrent ( )
{
    return 0;
}

=head2 concurrent -- constant used for readability

=head3      Description:

The concurrent method is used as a constant to represent concurrent
RG types.

=head3      Arguments:

    none

=head3      Returns:

    2

=cut

sub concurrent ( )
{
    return 1;
}

=head2 new -- method to create new a StaticConfig object

=head3      Description:

The new method creates an object of class StaticConfig, which respresents
a grouping of data from the base cluster manager configuration.

=head3      Arguments:

    none

=head3      Returns:

    the new StaticConfig object

=cut

sub new ( )
{
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    $self->{logger} = shift;
    $self->{valid} = 1;

    if (defined $self->{logger}) {
        $self->{logger}->phase_header("Reading Static Configuration Data");
    }

    $self->{cluster_version} = lookup_cluster_version ( $self );
    $self->{local_node} = lookup_local_node ( $self );
    $self->{node_names} = lookup_node_names ( $self );
    $self->{networks} = lookup_networks ( $self );
    $self->{interfaces} = lookup_interfaces ( $self );
    $self->{resource_groups} = lookup_resource_groups ( $self );
    $self->{resources} = lookup_resources ( $self );
    $self->{timeout} = lookup_timeout ( $self );
    $self->{max_timeout} = lookup_max_timeout ( $self );
    $self->{sites} = lookup_sites($self);

    # define some static config values to act as constants
    $self->{restart_file}  = "/tmp/cl_testtool_restart";
    $self->{event_file} = "/tmp/cl_testtool_events";
    $self->{event_old} = "/tmp/cl_testtool_events.old";
    $self->{state_file} = "/tmp/cl_testtool_state_data";
    $self->{state_old} = "/tmp/cl_testtool_state_data.old";

    return bless $self, $class;
}

=head2 is_valid -- is the object valid 

=head3      Description:

Returns the {valid} data member of the object.

=head3      Arguments:

    non

=head3      Returns:

    $self->{valid}

=cut

sub is_valid ( )
{
    my $self = shift;
    return $self->{valid};
}

=head2 lookup_cluster_version -- get cluster version from HACMPcluster

=head3      Description:

Get the cluster version from HACMPcluster. Sets {valid} = 0 if attempt
to lookup HACMPcluster fails.

=head3      Arguments:

    none

=head3      Returns:

    cluster version

=cut

sub lookup_cluster_version ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPcluster");
    my ($cluster) = $odm->get();

    if ( ! $cluster ) {
        $self->{logger}->err_msg(1, 14,
            "Cannot determine cluster version.\n");
        $self->{valid} = 0;
        return "";
    }
    $self->{logger}->verb_log_msg(
        "\tCluster Name: " . $cluster->{name} . "\n");
    $self->{logger}->verb_log_msg(
        "\tCluster Version: " . $cluster->{cluster_version} . "\n");
    return $cluster->{cluster_version};
}

=head2 lookup_local_node -- get local node name

=head3      Description:

Get local node name using 'get_local_nodename' utility. Sets {valid} = 0
if no local nodename can be determined.

=head3      Arguments:

    none

=head3      Returns:

    local node name

=cut

sub lookup_local_node ( )
{
    my $self = shift;
    my $localnode = `/usr/es/sbin/cluster/utilities/get_local_nodename`;
    chomp($localnode);
    if ( ! $localnode ) {
        $self->{logger}->err_msg(1, 15,
                "Cannot determine local node name.\n");
        $self->{valid} = 0;
        return "";
    }
    $self->{logger}->verb_log_msg("\tLocal Node Name: $localnode\n");
    return $localnode;
}

=head2 lookup_node_names -- get list of node names

=head3      Description:

Get list of cluster node names using 'clnodename' utility. Sets {valid} = 0
if unable to find any node names.

=head3      Arguments:

    none

=head3      Returns:

    arrayref for list of nodes

=cut

sub lookup_node_names ( )
{
    my $self = shift;

    my @nodelist = `/usr/es/sbin/cluster/utilities/clnodename 2> /dev/null`;
    chomp(@nodelist);
    if ( ! scalar(@nodelist) ) {
        $self->{logger}->err_msg(1, 16,
                "Cannot find any cluster nodes.\n");
        $self->{valid} = 0;
        return ();
    }
    $self->{logger}->verb_log_msg("\tCluster Nodes: @nodelist\n");
    return \@nodelist;
}

=head2 lookup_networks -- lookup a list of all networks in the cluster

=head3      Description:

Get list of HACMPnetwork objects. Sets {valid} = 0 if unable to find any
networks.

=head3      Arguments:

    none

=head3      Returns:

    arrayref for list of network objects

=cut

sub lookup_networks ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPnetwork");
    my @networks = $odm->get();
    if ( ! scalar(@networks) ) {
        $self->{logger}->err_msg(1, 17,
                "Cannot find any cluster networks.\n");
        $self->{valid} = 0;
        return ();
    }
    $self->{logger}->verb_log_msg(
        "\tFound %ld Cluster Networks\n", scalar(@networks));
    return \@networks;
}

=head2 lookup_interfaces -- get list of all interfaces in the network

=head3      Description:

Get list of all interfaces/devices/labels from HACMPadapter. Sets {valid} = 0
if no HACMPadapter objects are found.

=head3      Arguments:

    none

=head3      Returns:

    array of HACMPadapter objects

=cut

sub lookup_interfaces ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPadapter");
    my @interfaces = $odm->get();
    if ( ! scalar(@interfaces) ) {
        $self->{logger}->err_msg(1, 18,
                "Cannot find any cluster interfaces or labels.\n");
        $self->{valid} = 0;
        return ();
    }
    $self->{logger}->verb_log_msg(
        "\tFound %ld Cluster Interfaces/Device/Labels\n", scalar(@interfaces));
    return \@interfaces;
}

=head2 lookup_resource_groups -- get list of resource groups

=head3      Description:

Get list of all HACMPgroup objects and return as array.

=head3      Arguments:

    none

=head3      Returns:

    arrayref for array of HACMPgroup objects.

=cut

sub lookup_resource_groups ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPgroup");
    my @resource_groups = $odm->get();
    $self->{logger}->verb_log_msg(
        "\tFound %ld Cluster Resource Groups\n", scalar(@resource_groups));
    return \@resource_groups;
}


=head2 lookup_sites -- get list of sites

=head3      Description:

Get list of all HACMPsite objects and return as array.

=head3      Arguments:

    none

=head3      Returns:

    arrayref for array of HACMPsite objects.

=cut

sub lookup_sites ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPsite");
    my @sites = $odm->get();
    $self->{logger}->verb_log_msg(
        "\tFound %ld Cluster Sites\n", scalar(@sites));
    # Replace the space separated nodelist in each site stanza
    # with an array of nodes for easier handling.
    foreach my $site (@sites) {
        my @nodes = split(' ',  $site->{nodelist});
	# delete existing scalar list and overwrite with array of nodes
	delete ($site->{nodelist});
        @{$site->{nodelist}} = @nodes;
    }
    return \@sites;
}


=head2 lookup_resources -- get list of all resources in cluster

=head3      Description:

Get a list of all HACMPresource objects.

=head3      Arguments:

    none

=head3      Returns:

    arrayref to list of HACMPresource objects

=cut

sub lookup_resources ( )
{
    my $self = shift;
    my $odm = ODM->new("HACMPresource");
    my @resources = $odm->get();
    $self->{logger}->verb_log_msg(
        "\tFound %ld Cluster Resources\n", scalar(@resources));
    return \@resources;
}

=head2 lookup_timeout -- calculate the maximum timeout value.

=head3     Description:

lookup_timeout() determines the maximum amount of time that the test
tool will wait for the cluster to stabilize between test tool events. The
algorithm used for the caculation is:

  ( N * &lt;nodecount&gt; * &lt;config_too_long_timeout&gt; )

where N defaults to 4 (unless the environment variable 
TEST_TOOL_TIMEOUT_CONSTANT is set), nodecount is the total number of nodes in
the cluster, and config_too_long_timeout is the length of time the cluster will wait for a long event to finish before running a config_too_long event.

It is expected that if the config_too_long timer values are set correctly for
the cluster, then the maximum stabilization timeout will never be reached
unless the cluster has managed to fall into an endless loop state where a
cycle of common events is occuring (e.g. network_up -> network_down -> 
network_up . . . ). The TEST_TOOL_TIMEOUT_CONSTANT is available for 
troubleshooting purposes, but will not be documented for end users.

=head3     Arguments:

  $self = reference to object of type StaticConfig
  
=head3     Returns:

  none.
  
=cut
  
sub lookup_timeout ( )
{
    my $self = shift;

    # use ODM.pm to look up the config_too_long timeout values
    my $cluster_odm = ODM->new("HACMPcluster");
    my ($cluster) = $cluster_odm->get();
    my $config_too_long = 
                ($cluster->{reserved1} + $cluster->{reserved2}) || 360;

    $self->{logger}->verb_log_msg(
        "\tEvent Timeout Value: %ld\n", (2 * $config_too_long));
    return (2 * $config_too_long);
}

=head2 

=head3      Description:

=head3      Arguments:

=head3      Returns:

=cut

sub lookup_max_timeout ( )
{
    my $self = shift;
    my $timeout_constant = $ENV{TEST_TOOL_TIMEOUT_CONSTANT} || 4;
    my $nodecount = scalar(@{$self->{node_names}});
    my $config_too_long = $self->{timeout} / 2;

    $self->{logger}->verb_log_msg(
        "\tMaximum Timeout Value: %ld\n", 
        ($timeout_constant * $nodecount * $config_too_long));
    return ($timeout_constant * $nodecount * $config_too_long);
}

=head2 get_nodes_for_rg -- get list of nodes for an RG.

=head3     Description:

get_nodes_for_rg() will look up nodelist for an RG and return it as a
perl array.

=head3     Arguments:

    $rgname: name of the RG.

=head3     Returns:

    @list    == list of nodes for the RG.

=cut

sub get_nodes_for_rg($$)
{
    my $self   = shift;
    my $rgname = shift;
    my $group  = "";
    my @nodes;

    # look up the record in HACMPgroup
    LOOP: foreach my $tmpgroup (@{$self->{resource_groups}}) {
        if ( $rgname eq $tmpgroup->{group} ) {
            $group = $tmpgroup;
            last LOOP;
        }
    }
    # found it?
    if($group) {
        @nodes = split /\s+/, "$group->{nodes}";
    }

    return @nodes;
}


=head2 get_resources_for_rg -- get list of resources for an rg

=head3     Description:

get_resources_for_rg() will look up resources of a particular type
for an RG and return them as a perl array.

=head3     Arguments:

    $rgname: name of the RG.
    $type: resources type

=head3     Returns:

    @list    == list of resources for the RG.

=cut

sub get_resources_for_rg()
{
    my $self   = shift;
    my $rgname = shift;
    my $type  = shift;
    my @resources;

    # look up the record in HACMPgroup
    foreach my $tmpres (@{$self->{resources}}) {
        if ( $rgname eq $tmpres->{group} &&
             $type eq $tmpres->{name} ) {

            push @resources, $tmpres->{value};
        }
    }

    return @resources;
}


=head2 get_rgs_for_node -- get list of RGs for a node.

=head3     Description:

get_rgs_for_node() will return a list of all RGs with the 
specified node in their node lists.

=head3     Arguments:

    $nodename: name of node to check for.

=head3     Returns:

    @list == list of RGs for the node.

=cut

sub get_rgs_for_node()
{
    my $self     = shift;
    my $nodename = shift;
    my @rglist;

    # search HACMPgroup for all objects with specified
    # node in the nodelist
    foreach my $group (@{$self->{resource_groups}}) {
        my @nodes = split /\s+/, "$group->{nodes}";
        my @matches = grep {/^$nodename$/} @nodes;
        push(@rglist, "$group->{group}") if ( scalar(@matches) );
    }

    return @rglist;
}

=head2 get_rg_type -- Get type for specified RG

=head3      Description:

Get type (concurrent or nonconcurrent) for an RG.

=head3      Arguments:

    $rgname

=head3      Returns:

    StaticConfig::concurrent
    StaticConfig::nonconcurrent

=cut

sub get_rg_type()
{
    my $self   = shift;
    my $rgname = shift;
    my $rgtype = StaticConfig::nonconcurrent;

    # search HACMPgroup for all objects with specified
    # node in the nodelist
    GROUP: foreach my $group (@{$self->{resource_groups}}) {
        if ( $group->{group} eq $rgname ) {
            if ( $group->{startup_pref} eq "OAAN" ) {
                $rgtype = StaticConfig::concurrent;
            }
            last GROUP;
        }
    }

    return $rgtype;
}

=head2 get_rg_id -- get RG id for specified RG

=head3      Description:

Get RG id for a specified RG.

=head3      Arguments:

    $rgname

=head3      Returns:

    RG id of specified group
    "" if RG is not found

=cut

sub get_rg_id()
{
    my $self   = shift;
    my $rgname = shift;
    my $rgid = "";

    # search HACMPgroup for all objects with specified
    # node in the nodelist
    GROUP: foreach my $group (@{$self->{resource_groups}}) {
        if ( $group->{group} eq $rgname ) {
            $rgid = $group->{id};
            last GROUP;
        }
    }

    return $rgid;
}

=head2 get_rg_for_res -- lookup RG name for specified resource

=head3      Description:

Get the name for the RG associated with a specified resource.

=head3      Arguments:

    $resname
    $type (e.g. "APPLICATIONS")

=head3      Returns:

    name of RG
    "" if resource not found

=cut

sub get_rg_for_res()
{
    my $self   = shift;
    my $resname = shift;
    my $type = shift;
    my $rgname = "";

    # search HACMPgroup for all objects with specified
    # node in the nodelist
    RES: foreach my $res (@{$self->{resources}}) {
        if ( $res->{name} eq $type &&
             $res->{value} eq $resname) {
            $rgname = $res->{group};
            last RES;
        }
    }

    return $rgname;
}

=head2 get_res_id -- lookup the resource id for a specified resource

=head3      Description:

Get the ID of a specified resource.

=head3      Arguments:

    $resname
    $type (e.g. "APPLICATIONS")

=head3      Returns:

    ID of resource
    "" if resource not found

=cut

sub get_res_id()
{
    my $self   = shift;
    my $resname = shift;
    my $type = shift;
    my $resid = "";

    # search HACMPgroup for all objects with specified
    # node in the nodelist
    RES: foreach my $res (@{$self->{resources}}) {
        if ( $res->{name} eq $type &&
             $res->{value} eq $resname) {
            $resid = $res->{id};
            last RES;
        }
    }

    return $resid;
}


=head2 is_node_valid -- check if node is configured

=head3      Description:

Check if the node is in the list of configured nodes for the cluster

=head3      Arguments:

    node

=head3      Returns:

    1 if the node is configured, 0 otherwise

=cut

# check that the $nodename field is a cluster node.
sub is_node_valid
{
    my $self = shift || return 0;
    my $node = shift || return 0;

    foreach my $configured_node (@{$self->{node_names}}) {
        if ($node eq $configured_node) {
            return 1;
        }
    }

   return 0;
}


#check that the specified network is configured and that the nodename
#is a member
sub is_node_on_network
{
    my $self = shift || return 0;
    my $node = shift || return 0;
    my $network = shift || return 0;

    foreach my $interface ( @{$self->{interfaces}}) {
        if (defined $self->{logger}) {
            $self->{logger}->verb_log_msg(
                "\tInterface: $interface->{ip_label}, Network: $interface->{network}, " .
                "Nodename: $interface->{nodename}\n"); 
        }
        if ( ($interface->{nodename} eq $node) && 
             ($interface->{network} eq $network) )
        {
            return 1;  # found it
        }
    }
    return 0;
}


#check to make sure we support this type of network for this event
sub is_network_valid
{
    my $self = shift || return 0;
    my $network = shift || return 0;
    my $found_net = 0;
    my $ip_net_count = 0;

    foreach my $net ( @{$self->{networks}} ) {
        if (defined $self->{logger}) {
            $self->{logger}->verb_log_msg(
                "\tNetwork Name: $net->{name}, Network Type: $net->{attr}\n"); 
        }

        #if ( $self->{network} eq $net->{name} ) {
        if ( $network eq $net->{name} ) {
            $found_net = 1;
            #if ( $net->{attr} eq "serial"         ||
            #if ($net->{nimname} eq "atm"          ||
            #    $net->{nimname} eq "hps"          ||
            #    $net->{nimname} eq "XD_data"      ||
            #    $net->{nimname} eq "XD_ip"        ||
            #    $net->{nimname} eq "XD_rs232"     ||
            if ($net->{nimname} eq "atm"           ||
                $net->{nimname} eq "hps"           ||
                $net->{nimname} eq "Geo_Primary"   ||
                $net->{nimname} eq "Geo_Secondary")
            {
                return -1;
            }
        }
        if ( $net->{attr} ne "serial" ) {
            $ip_net_count++;
        }
        if ($found_net && $ip_net_count > 1) {
            return 1;
        }
    }
    if ( ! $found_net ) {
        return -2;
    }
    if ( $ip_net_count < 2 ) {
        return -3;
    }
    return 0;
}


sub is_valid_interface_label
{
    my $self = shift;
    my $label = shift || return "";

    foreach my $iface (@{$self->{interfaces}}) {
        if ($iface->{ip_label} eq $label) {
            if ($iface->{function} eq "persistent") {
                return -1;
            }
            else {
                return 1;
            }
        }
    }

    return 0;
}


sub get_network_of_interface_label
{
    my $self = shift;
    my $label = shift || return "";

    foreach my $iface (@{$self->{interfaces}}) {
        if ($iface->{ip_label} eq $label) {
            return $iface->{network};
        }
    }

    return "";
}


sub get_address_of_interface_label
{
    my $self = shift;
    my $label = shift || return "";

    foreach my $iface (@{$self->{interfaces}}) {
        if ($iface->{ip_label} eq $label) {
            return $iface->{identifier}
        }
    }
    
    return "";
}


=head2 is_rg_valid -- check if RG is configured

=head3      Description:

Check if the node is in the list of configured RGs for the cluster

=head3      Arguments:

    rg_name

=head3      Returns:

    1 if the RG is configured, 0 otherwise

=cut

sub is_rg_valid
{
    my $self = shift || return 0;
    my $rg_name = shift || return 0;

    foreach my $rg (@{$self->{resource_groups}}) {
        if ($rg->{group} eq $rg_name) {
            return 1; #found it
        }
    }
    return 0;
}


=head2 is_node_in_rg_nodelist -- check if node is listed in RG nodelist

=head3      Description:

Checks if the node is one of the nodes listed in the nodelist retrieved
from HACMPgroup for the RG.

=head3      Arguments:

    RGname
    nodename

=head3      Returns:

    1 if the node is in the RG nodelist, 0 otherwise

=cut

sub is_node_in_rg_nodelist
{
    my $self = shift || return 0;
    my $RGname = shift || return 0;
    my $nodename = shift || return 0;

    my @RGnodes = get_nodes_for_rg($self, $RGname);

    foreach my $node (@RGnodes) {
        if ($node eq $nodename) {
            return 1; #found it
        }
    }
    return 0;
}


sub get_nodes_on_network
{
    my @none = ();
    my $self = shift || return \@none;
    my $network = shift || return \@none;
    my @nodelist = ();

    foreach my $node (@{$self->{node_names}}) {
        my $found = 0;
        foreach my $iface (@{$self->{interfaces}}) {
            if ($iface->{network} eq $network &&
                $iface->{nodename} eq $node)
            {
                $found = 1;
                last;
            }
        }
        if ($found) {
            push @nodelist, $node;
        }
    }

    return \@nodelist;
}


=head2 rg_is_nonconcurrent - check if RG is nonconcurrent

=head3      Description:

boolean helper that uses $self->get_rg_type()

=head3      Arguments:

    RGname

=head3      Returns:

    1 if the RG is nonconcurrent, 0 otherwise

=cut

sub rg_is_nonconcurrent
{
    my $self = shift || return 0;
    my $RGname = shift || return 0;
    my $rg_type = $self->get_rg_type($RGname); 
    ($rg_type == $self->nonconcurrent()) ? return 1: return 0;
}


=head2 rg_is_concurrent - check if RG is concurrent

=head3      Description:

boolean helper that uses $self->get_rg_type()

=head3      Arguments:

    RGname

=head3      Returns:

    1 if the RG is concurrent, 0 otherwise

=cut

sub rg_is_concurrent
{
    my $self = shift || return 0;
    my $RGname = shift || return 0;
    my $rg_type = $self->get_rg_type($RGname); 
    ($rg_type == $self->concurrent()) ? return 1: return 0;
}


=head2 is_site_valid - check that site is configured

=head3      Description:

Loop over HACMPsite objects and see if the site is configured

=head3      Arguments:

    sitename

=head3      Returns:

    1 if the site is configured, 0 otherwise

=cut

sub is_site_valid
{
    my $self = shift || return 0;
    my $site = shift || return 0;

    foreach my $configured_site (@{$self->{sites}}) {
        if ($site eq $configured_site->{name}) {
            return 1;
        }
    }

   return 0;
}


=head2 get_site_nodes - list nodes at a site

=head3      Description:

Return the list of nodes in the HACMPsite stanza

=head3      Arguments:

    sitename

=head3      Returns:

    a reference to a list of nodes in the site

=cut

sub get_site_nodes
{
    my @none = ();
    my $self = shift || return \@none;
    my $sitename = shift || return \@none;

    my @site_nodes = ();
    foreach my $site (@{$self->{sites}}) {
        if ($sitename eq $site->{name}) {
            @site_nodes = @{$site->{nodelist}};
            last;
        }
    }

    return \@site_nodes;
}


=head2 is_site_rg - check if RG is site aware

=head3      Description:

Checks that the RG site policy is not ignore

=head3      Arguments:

    rgname

=head3      Returns:

    1 if the RG is configured for sites, 0 otherwise

=cut

sub is_site_rg
{
    my $self = shift || return 0;
    my $RGname = shift || return 0;
    foreach my $group (@{$self->{resource_groups}}) {
      if (($group->{group} eq $RGname) && ($group->{stype} ne "ignore")) {
	return 1;
      }
    }
    return 0;
}


=head2 is_site_in_rg_nodelist - check if the site has a node in the RG nodelist

=head3      Description:

Loops over each node in the site and checks if it is in the nodelist for the
rg

=head3      Arguments:

    rgname
    sitename

=head3      Returns:

    1 if the site has a node in the RG nodelist, 0 otherwise

=cut

sub is_site_in_rg_nodelist
{
    my $self = shift || return 0;
    my $RGname = shift || return 0;
    my $sitename = shift || return 0;

    my $sitenodes = get_site_nodes($self,$sitename);

    foreach my $nodename (@{$sitenodes}) {
      my @RGnodes = get_nodes_for_rg($self, $RGname);
      foreach my $node (@RGnodes) {
	if ($node eq $nodename) {
	  return 1; #found it
	}
      }
    }

    return 0;
}


# it's a module, so the last statement should always just be '1;'
1;
__END__
