# @(#)57	1.13 src/43haes/lib/perl/libcl_disp.pm, hacmp.wsm, 52haes_r541, 0737A_hacmp541 9/8/07 18:31:41
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/lib/perl/libcl_disp.pm 1.13 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 1004,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
###########################################################
#
# Name: libcl_disp.pm
#
# A Perl library containing routines common to both cldisp
# and wsm_cldisp.cgi.
#
###########################################################

package libcl_disp;

# "use strict" will help to keep this code cleaner
use strict;

use vars qw(@EXPORT @ISA);
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(
    snmpinfoRefresh
    nodes_in_cluster
    interfaces_on_node
    name_of_interface
    ip_of_interface
    network_of_interface
    apps_on_cluster
    nodes_of_app_of_rg
    rg_of_app
    vgs_of_app_of_rg
    cc_vgs_of_app_of_rg
    filesystems_of_app_of_rg
    fast_connect_services_of_app_of_rg
    startscript_of_app
    stopscript_of_app
    service_labels_of_app_of_rg
    ip_of_service_label
    network_of_service_label
    monitors_of_app
    get_monitor_value
    state_of_local_clstrmgr
    state_of_cluster
    substate_of_cluster
    state_of_node
    state_of_interface
    state_of_network
    state_of_app_of_rg
    nodes_providing_app_of_rg
    calculateDNPPFallover
    calculateFalloverToNextPriorityNode
    calculateOfflineFallover
    initRgPrefs
    fallover_node_for_app_of_rg
    state_of_service_label
    translate
    translateCustomAttr
    probeStatic
    probeDynamic
    $clusterName
    $HACMPBASE
    $ACTIVE
    $INACTIVE
    $UP
    $DOWN
    $UNKNOWN
    $UNSTABLE
    $STABLE
    $ERROR
    $RECONFIG
    $ONLINE
    $OFFLINE
    $ACQUIRING
    $RELEASING
    $MESSAGE_CL_HIGHEST_FREE_MEM
    $MESSAGE_CL_HIGHEST_IDLE_CPU
    $MESSAGE_CL_LOWEST_DISK_BUSY
    $MESSAGE_USER_SPECIFIED
    $MESSAGE_UNKNOWN_UNLESS_ONLINE
    $clusterName
    $overall_clstrmgr_state
    $local_clstrmgr_state
    $clusterState
    $clusterSubstate
    @apps
    $localNodeName
    $h
    $r
    @appStates
    $c
    @nodesByApp
    @providingNodesByApp
    @falloverNodesOfApps
    @startscriptsByApp
    @stopscriptsByApp
    @serviceIpLabelsOfApps
    @vgsOfApps
    @ccVgsOfApps
    @filesystemsOfApps
    @fastConnectServicesOfApps
    $s
    $t
    $rg
    @RgsByApp
    @serviceIpStates
    $c2
    $rr2
    @nodeNames
    $cc2
    @interfacesByNode
    @networksOfInterfaces
    @networksOfServiceLabels
    @interfaceStatesByNode
    @ipsByNode
    @nodeStates
    @networkStates
    @monitorsOfApps
    @cllsif
    $SNMPINFO_SOURCE
    @serviceIpsOfApps
    $startupPref
    $falloverPref
    $fallbackPref
);

# Subroutine declarations are in the same order in which they appear below
sub snmpinfoRefresh($);
sub snmpinfoRefreshViaSnmpinfo($);
sub snmpinfoRefreshViaWsm_cmd_exec($);
sub nodes_in_cluster();
sub interfaces_on_node($);
sub name_of_interface($$);
sub ip_of_interface($$);
sub network_of_interface($$);
sub apps_on_cluster();
sub nodes_of_app_of_rg($$);
sub rg_of_app($);
sub vgs_of_app_of_rg($$);
sub cc_vgs_of_app_of_rg($$);
sub filesystems_of_app_of_rg($$);
sub fast_connect_services_of_app_of_rg($$);
sub startscript_of_app($);
sub stopscript_of_app($);
sub service_labels_of_app_of_rg($$);
sub ip_of_service_label($);
sub network_of_service_label($);
sub monitors_of_app($);
sub get_monitor_value($$);
sub state_of_local_clstrmgr();
sub state_of_cluster();
sub substate_of_cluster();
sub state_of_node($);
sub state_of_interface($$);
sub state_of_network($);
sub state_of_app_of_rg($$);
sub nodes_providing_app_of_rg($$);
sub calculateDNPPFallover($);
sub calculateFalloverToNextPriorityNode();
sub calculateOfflineFallover();
sub initRgPrefs($);
sub fallover_node_for_app_of_rg($$);
sub state_of_service_label($);
sub translate($);
sub translateCustomAttr($);
sub probeStatic();
sub probeDynamic();

our $HACMPBASE="/usr/es/sbin/cluster";

# cluster services
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $ACTIVE = 'active';
our $INACTIVE = 'inactive';

# cluster states
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $UP = 'up';
our $DOWN = 'down';
our $UNKNOWN = 'unknown';

# cluster substates
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $UNSTABLE = 'unstable';
our $STABLE = 'stable';
our $ERROR = 'error';
our $RECONFIG = 'reconfig';
#   $UNKNOWN (defined above)

# app states
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $ONLINE = 'online';
our $OFFLINE = 'offline';
our $ACQUIRING = 'acquiring';
our $RELEASING = 'releasing';
#   $ERROR (defined above)
#   $UNKNOWN (defined above)

# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $JOINING = 'joining';
our $LEAVING = 'leaving';

# Messages explaining to which node an application will fallover when the
# resource group is set to use a particular dynamic node priority protocol.
# Setting these doesn't actually help much because of having to use dspmsg.

# these have been addded to cluster.cat, set 47, starting with msg 28
our $MESSAGE_CL_HIGHEST_FREE_MEM = "whichever node has the most free memory";
our $MESSAGE_CL_HIGHEST_IDLE_CPU = "whichever node has the least cpu usage";
our $MESSAGE_CL_LOWEST_DISK_BUSY = "whichever node has the least disk usage";
our $MESSAGE_USER_SPECIFIED = "placement is decided dynamically using a user-specified resource variable";

our $MESSAGE_UNKNOWN_UNLESS_ONLINE = "impossible to determine unless cluster services are active";

# The next three lines declare variables that are reused throughout the program
# Care must be taken not to clobber some of these globals, particularly vars:
# @snmpinfo, $app, $rg, $r, $c, $rr, $cc, $rr2, $cc2
our (@tmp, @tmp2, @word, $app, $rg, $h, $r, $c, $rr, $cc, $r2, $c2, $rr2, $cc2, $t, $s);
our (@scrap, @odm, $ip, $netState);
our @snmpinfo;

our @cllsif;
our @clshowsrv;

our $SNMPINFO_SOURCE;

# These declarations are arranged by how they relate to one another. Descriptions
# of these variables can be found in the locations in which they're initialized.
our $clusterName;                   our $overall_clstrmgr_state;     our $local_clstrmgr_state;
    our $clusterState;    our $clusterSubstate;

our $localNodeName;

our @apps;
    our @monitorsOfApps;
    our @nodesByApp;
    our @RgsByApp;                  our @nodesOfRg;
    our @startscriptsByApp;
    our @stopscriptsByApp;
    our @appStates;
    our @providingNodesByApp;
    our @falloverNodesOfApps;
    our @serviceIpLabelsOfApps;     our @serviceIpStates;     our @networksOfServiceLabels;
    our @serviceIpsOfApps;
    our @vgsOfApps;
    our @ccVgsOfApps;
    our @filesystemsOfApps;
    our @fastConnectServicesOfApps;

our @nodeNames;                     our @nodeStates;
    our @interfacesByNode;          our @interfaceStatesByNode;     our @networksOfInterfaces;    our @networkStates;
    our @ipsByNode;

# These store resource group policies
our $startupPref;
our $falloverPref;
our $fallbackPref;

#####################################################
#
# Function:
#
#    snmpinfoRefresh
#
# Description:
#
#    Determines how to query the the MIB for the
#    needed info. If the this process is being run
#    by root it will use 'snmpinfo', but in the case
#    of wsm_cldisp the user will be 'nobody' so
#    wsm_cmd_exec will be used to query the info.
#    
# Arguments:
#
#    Name of  the output file to create
#
#####################################################
sub snmpinfoRefresh($){
    # If the Real UID of this process is 0
    if($< == 0){
        return &snmpinfoRefreshViaSnmpinfo($_[0]);
    }
    else{
        return &snmpinfoRefreshViaWsm_cmd_exec($_[0]);
    }
}
#####################################################
#
# Function:
#
#    snmpinfoRefreshViaSnmpinfo
#
# Description:
#
# Arguments:
#
#    Name of  the output file to create
#
#####################################################
sub snmpinfoRefreshViaSnmpinfo($){
    umask 177;
    my $SNMPINFO_OUT = $_[0];
    # Try probing the MIB on each of the cluster's other nodes.
    # If nothing is returned by a node its cluster mgr must not
    # be active. We'll try successive nodes until we've found
    # or are forced to give up.
    
    # These are the keys for the info we're looking for in the MIB:
    # CLUSTER_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.1"
    # NODE_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.2.1.1"
    # ADDRESS_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.3.1.1"
    # RG_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.11.1.1"
    # RES_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.11.2.1"
    # RG_STATE_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.11.3.1"
    # NETWORK_BRANCH="1.3.6.1.4.1.2.3.1.2.1.5.4.1.1"
    my @nodes = &nodes_in_cluster();
    my $found_active_node = 0;
    foreach my $remoteNode (@nodes){
        system("$HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.1 > $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.2.1.1 >> $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.3.1.1 >> $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.11.1.1 >> $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.11.2.1 >> $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.11.3.1 >> $SNMPINFO_OUT; $HACMPBASE/utilities/clrexec $remoteNode SNMPINFO -v 1.3.6.1.4.1.2.3.1.2.1.5.4.1.1 >> $SNMPINFO_OUT");
        # We now need to check to see if the remote node actually had cluster services enabled.
        # If it didn't, the $SNMPINFO_OUT file will be empty and we'll have to try another node
        if( -s "$SNMPINFO_OUT" ){
            $found_active_node = 1;
            last;
        }
    }
    if(!$found_active_node){
        return $INACTIVE;
    }
    return $ACTIVE;
}
#####################################################
#
# Function:
#
#    snmpinfoRefreshViaWsm_cmd_exec
#
# Description:
#
# Arguments:
#
#    Name of  the output file to create
#
#####################################################
sub snmpinfoRefreshViaWsm_cmd_exec($){
    umask 077;
    my $SNMPINFO_OUT = $_[0];

    # Random filenames will be used for increased security
    my $random_num;
    $random_num = int(rand 999999);

    # Verification that the file doesn't already exist
    while( -e "snmpinfo.command.$random_num"){
        $random_num = int(rand 999999);
    }

    # create a tmp file to run the command
    my $SNMPINFO_SCRIPT = "/tmp/snmpinfo.command.$random_num";

    # Try probing the MIB on each of the cluster's other nodes.
    # If nothing is returned by a node its cluster mgr must not
    # be active. We'll try successive nodes until we've found
    # or are forced to give up.
    my @nodes = &nodes_in_cluster();
    my $found_active_node = 0;
    foreach my $remoteNode (@nodes){
        open (FPT, ">$SNMPINFO_SCRIPT");
        print FPT "#!/bin/ksh\n";
        print FPT "umask 111\n";
        print FPT "BINDIR=$HACMPBASE/wsm/cgi-bin\n";
        print FPT "CONFDIR=$HACMPBASE/wsm\n";
        print FPT "\n";
        print FPT ". \$CONFDIR/wsm_smit.conf > /dev/null\n";
        print FPT "export AUTHORIZED_PORT REDIRECT_TO_HTTPS REQUIRE_AUTHENTICATION\n";
        print FPT "export ACCEPTED_USERS SESSION_TIMEOUT REQUIRED_WEBSERVER_UID\n";
        print FPT "\n";
        print FPT "\$BINDIR/wsm_cmd_exec -M -n $remoteNode -e cluster > $SNMPINFO_OUT\n";
        print FPT "\$BINDIR/wsm_cmd_exec -M -n $remoteNode -e node >> $SNMPINFO_OUT\n";
        print FPT "\$BINDIR/wsm_cmd_exec -M -n $remoteNode -e address >> $SNMPINFO_OUT\n";
        print FPT "\$BINDIR/wsm_cmd_exec -M -n $remoteNode -e resmanager >> $SNMPINFO_OUT\n";
        print FPT "\$BINDIR/wsm_cmd_exec -M -n $remoteNode -e network >> $SNMPINFO_OUT\n";
        close(FPT);
        system("chmod +x $SNMPINFO_SCRIPT");
        system("$SNMPINFO_SCRIPT");
        # We now need to check to see if the remote node actually had cluster services enabled.
        # If it didn't, the $SNMPINFO_OUT file will be empty and we'll have to try another node
        if( -s "$SNMPINFO_OUT" ){
            $found_active_node = 1;
            last;
        }
        # cleanup
        system("rm -f $SNMPINFO_SCRIPT");
    }
    if(!$found_active_node){
        return $INACTIVE;
    }
    return $ACTIVE;
}
#####################################################
#
# Function:
#
#    nodes_in_cluster
#
# Description:
#
#    Returns a list of the names of nodes in the
#    cluster
#
# Arguments:
#
#    none
#
#####################################################
sub nodes_in_cluster(){
    my @nodes;
    my @tmp = `$HACMPBASE/utilities/clshownets`;
    $_ = $tmp[$#tmp];
    @nodes = split;
    if(!$nodes[0]){
        print STDERR `dspmsg -s 20 scripts.cat 25 "Error: No nodes in cluster or no access to cluster ODM.\n"`;
        exit 1;
    }
    return @nodes;
}
#####################################################
#
# Function:
#
#    interfaces_on_nodes
#
# Description:
#
#    Returns a list of the interfaces on a 
#    node
#
# Arguments:
#
#    $_[0]: a node name
#
#####################################################
sub interfaces_on_node($){
    my @interfaces;
    my $node = $_[0];
    foreach my $cllsif_node (@cllsif){
        my @cnode = split(/:/, $cllsif_node);
        if( ($cnode[3] eq "diskhbmulti") ){
            if( ($cnode[5] eq $node) && ($cnode[6] ne "") ) {
                push @interfaces, $cnode[6];
            }
        } else {
            if( ($cnode[5] eq $node) && ($cnode[8] ne "") ) {
                push @interfaces, $cnode[8];
            }
        }
    }
    if(!$interfaces[0]){
        print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Node %s does not appear to have any network interfaces.\n" "$node"`;
    }
    return @interfaces;
}
#####################################################
#
# Function:
#
#    name_of_interface
#
# Description:
#
#    Returns the name (as known to HACMP) of an
#    interface
#
# Arguments:
#
#    $_[0]: a node name
#    $_[1]: an interface name (on that node. ex: en0)
#
#####################################################
sub name_of_interface($$){
    my $node = $_[0];
    my $interface = $_[1];

    foreach my $intf (@cllsif){
        my @inf = split(/:/,$intf);
        if( ($inf[3] eq "diskhbmulti") ){
            if( ($inf[5] eq $node) && ($inf[6] eq $interface) ){
                return $inf[0];
            }
        } else {
            if( ($inf[5] eq $node) && ($inf[8] eq $interface) ){
                return $inf[0];
            }
	}
    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: No interface name found for %s on %s.\n" "$interface" "$node"`;
}
#####################################################
#
# Function:
#
#    ip_of_interface
#
# Description:
#
#    Returns the boot/standby IP address of an
#    interface. (In the case of a non-ip based
#    interface returns the path to the 
#    corresponding device. ex: /dev/tty0)
#
# Arguments:
#
#    $_[0]: a node name
#    $_[1]: an interface name (on that node. ex: en0)
#
#####################################################
sub ip_of_interface($$){
    my $node = $_[0];
    my $interface = $_[1];
        
    # Finds and returns the ip that corresponds to
    # both the supplied node and interface
    foreach my $intf (@cllsif){
        my @inf = split(/:/,$intf);
        if( ($inf[3] eq "diskhbmulti") ){
            if( ($inf[5] eq $node) && ($inf[6] eq $interface) ){
                return $inf[6];
            }
        } else {
            if( ($inf[5] eq $node) && ($inf[8] eq $interface) ){
                return $inf[6];
            }
        }

    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: No interface '%s' exists on node '%s'.\n" "$interface" "$node"`;
}
#####################################################
#
# Function:
#
#    network_of_interface
#
# Description:
#
#    Returns the network (as it's known to HACMP) to
#    which an interface belongs
#
# Arguments:
#
#    $_[0]: a node name
#    $_[1]: an interface name (on that node. ex: en0)
#
#####################################################
sub network_of_interface($$){
    my $node = $_[0];
    my $interface = $_[1];
    # We must check to make sure that both the node and interface names correspond
    # to the network which we're going to return
    foreach my $intf (@cllsif){
        my @inf = split(/:/,$intf);
        if( ($inf[3] eq "diskhbmulti") ){
            if( ($inf[5] eq $node) && ($inf[6] eq $interface) ){
                return $inf[2];
            }
        } else {
            if( ($inf[5] eq $node) && ($inf[8] eq $interface) ){
                return $inf[2];
            }
        }

    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: No interface '%s' exists on node '%s'.\n" "$interface" "$node"`;
}
#####################################################
#
# Function:
#
#    apps_on_cluster
#
# Description:
#
#    Returns a list of the names of all applications
#    known to HACMP
#
# Arguments:
#
#    none
#
#####################################################
sub apps_on_cluster(){
    my @apps = `$HACMPBASE/utilities/cllsserv -c | cut -f1 -d:`;
    chomp @apps;
    return @apps;
}
#####################################################
#
# Function:
#
#    nodes_of_app_of_rg
#
# Description:
#
#    Returns an array of the all nodes that are members
#    of a application's resource group
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub nodes_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    local @_;
    local $_;
    my @ret_nodes;

    if($rg eq "NONE"){
        return @ret_nodes;
    }

    my @nodes = `$HACMPBASE/utilities/clgetgrp -g $rg -f nodes`;
    chomp @nodes;
    foreach (@nodes) {
        my @tmp = split;
        for (my $i = 0; $i <= $#tmp; $i++){
            push @ret_nodes, $tmp[$i];
        }
    }
    return @ret_nodes;
}
#####################################################
#
# Function:
#
#    rg_of_app
#
# Description:
#
#    Returns an array holding resource groups' name
#    to which the application belongs
#
# Arguments:
#
#    $_[0]: an application name
#
#####################################################
sub rg_of_app($){
    
    my $app = $_[0];
    $_ = `$HACMPBASE/utilities/cllsres -q "value = $app" -f group`;
    chomp $_;
    my @odm = split(/ +/,$_);
    chomp @odm;
    if ($odm[0] eq "") {
	$odm[0]="NONE";
    }
    return @odm;
}
#####################################################
#
# Function:
#
#    vgs_of_app_of_rg
#
# Description:
#
#    Returns a list of the volume groups associated
#    with an application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub vgs_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    local $_;
    local @_;
    
    # @odm = `odmget -q "group=$rg and name=VOLUME_GROUP" HACMPresource`;

    if($rg eq "NONE"){
        return my @vgs;
    }
    
    $_ = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f2 -d:`;
    chomp $_;
    my @vgs = split (/ +/, $_);
    chomp @vgs;
    return @vgs;
}
#####################################################
#
# Function:
#
#    cc_vgs_of_app_of_rg
#
# Description:
#
#    Returns a list of the concurrent volume groups
#    associated with an application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub cc_vgs_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    local $_;
    local @_;
    
    # @odm = `odmget -q "group=$rg and name=CONCURRENT_VOLUME_GROUP" HACMPresource`;

    if($rg eq "NONE"){
        return my @ccvgs;
    }

    $_ = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f3 -d:`;
    chomp $_;
    my @ccvgs = split (/ +/, $_);
    chomp @ccvgs;
    return @ccvgs;
}
#####################################################
#
# Function:
#
#    filesystems_of_app_of_rg
#
# Description:
#
#    Returns a list of the filesystems associated
#    with an application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub filesystems_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    local $_;
    local @_;

    # @odm = `odmget -q "group=$rg and name=FILESYSTEM" HACMPresource`;

    if($rg eq "NONE"){
        return my @fs;
    }

    $_ = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f5 -d:`;
    chomp $_;
    my @fs = split (/ +/, $_);
    chomp @fs;
    return @fs;
}
#####################################################
#
# Function:
#
#    fast_connect_services_of_app_of_rg
#
# Description:
#
#    Returns a list of the AIX fast connect services
#    associated with a application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub fast_connect_services_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    local $_;
    local @_;
    
    # @odm = `odmget -q "group=$rg and name=AIX_FAST_CONNECT_SERVICES" HACMPresource`;

    if($rg eq "NONE"){
        return my @fc;
    }

    $_ = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f11 -d:`;
    chomp $_;
    my $fc = split (/ +/, $_);
    chomp $fc;
    return $fc;
}
#####################################################
#
# Function:
#
#    startscript_of_app
#
# Description:
#
#    Returns the path to the starting script of an
#    application
#
# Arguments:
#
#    $_[0]: an application name
#
#####################################################
sub startscript_of_app($){
    # my @odm = `odmget -q name=$_[0] HACMPserver`;
    my $start = `$HACMPBASE/utilities/cllsserv -cn $_[0] | cut -f2 -d:`;
    chomp $start;
    return $start;
}
#####################################################
#
# Function:
#
#    stopscript_of_app
#
# Description:
#
#    Returns the path to the stop script of an
#    application
#
# Arguments:
#
#    $_[0]: an application name
#
#####################################################
sub stopscript_of_app($){
    # my @odm = `odmget -q name=$_[0] HACMPserver`;
    my $stop = `$HACMPBASE/utilities/cllsserv -cn $_[0] | cut -f3 -d:`;
    chomp $stop;
    return $stop;
}
#####################################################
#
# Function:
#
#    service_labels_of_app_of_rg
#
# Description:
#
#    Returns a list of the service labels of an
#    application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub service_labels_of_app_of_rg($$){
    my $rg = $_[1];
    # my @odm = `odmget -q"group=$rg and name=SERVICE_LABEL" HACMPresource`;

    my @serviceLabels;
    my $tmpserviceLabels;

    if($rg eq "NONE"){
        $serviceLabels[0] = "NONE";
        return @serviceLabels;
    }

    $tmpserviceLabels = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f15 -d:`;
    if (length($tmpserviceLabels) == 0) {
        $serviceLabels[0] == "NONE";
    }

    @serviceLabels = split( " ", $tmpserviceLabels);

    chomp @serviceLabels;
    return @serviceLabels;
}
#####################################################
#
# Function:
#
#    ip_of_service_label
#
# Description:
#
#    Returns the IP address of a service label
#
# Arguments:
#
#    $_[0]: a service label
#
#####################################################
sub ip_of_service_label($){
    foreach(@cllsif){
        my @tmp = split(/:/);
        if (($tmp[1] eq "service") && ($tmp[0] eq "$_[0]")){
            return $tmp[6];
        }
    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: No service label '%s' was found on this cluster.\n" "$_[0]"`;
}
#####################################################
#
# Function:
#
#    network_of_service_label
#
# Description:
#
#    Returns the network to which a particular
#    service IP label belongs
#
# Arguments:
#
#    $_[0]: a service label
#
#####################################################
sub network_of_service_label($){
    foreach(@cllsif){
        my @tmp = split(/:/);
        if (($tmp[1] eq "service") && ($tmp[0] eq "$_[0]")){
            return $tmp[2];
        }
    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: No service label '%s' exists on this cluster.\n" "$_[0]"`;
}
#####################################################
#
# Function:
#
#    monitors_of_app
#
# Description:
#
#    Returns a list of the application monitors
#    configured for an application
#
# Arguments:
#
#    $_[0]: an application name
#
#####################################################
sub monitors_of_app($){
    my $app = $_[0];
    local $_;
    local @_;

    # @odm = `odmget -q "name=RESOURCE_TO_MONITOR and value=$app" HACMPmonitor`;
    $_ = `$HACMPBASE/utilities/cllsserv -csm -n $app | cut -f4 -d:`;
    chomp $_;
    my @monitors = split (/ +/, $_);
    chomp @monitors;
    return @monitors;
}
#####################################################
#
# Function:
#
#    get_monitor_value
#
# Description:
#
#    Returns the value stored in the HACMPmonitor odm
#    for a particular monitor and attribute
#
# Arguments:
#
#    $_[0]: a monitor name
#    $_[1]: index
#    
#####################################################
sub get_monitor_value($$){
    my $monitor = $_[0];
    my $index = $_[1];
    local $_;
    local @_;
    
    # @odm = `odmget -q "monitor=$monitor and name=$attribute" HACMPmonitor`;
    my $mval = `$HACMPBASE/utilities/cllsappmon -c $monitor | tail -1 | cut -f $index -d:`;
    chomp $mval;
    return $mval;
}
#####################################################
#
# Function:
#
#    state_of_local_clstrmgr
#
# Description:
#
#    Returns "active" if cluster services are active
#    and "inactive" if not.
#
# Arguments:
#
#    none
#
#####################################################
# Possible return values:
# "active"
# "inactive"
sub state_of_local_clstrmgr(){
    @clshowsrv = `LC_ALL=C $HACMPBASE/utilities/clshowsrv clstrmgrES`;
    foreach my $line (@clshowsrv){
        $line =~ s/^\s+//;  # strip leading whitespace
        chomp $line;
        my @tmp = split (/ +/, $line);
        if(($tmp[0] eq "clstrmgrES") && ($tmp[3] eq "active")){
            return $ACTIVE;
        }
    }
    return $INACTIVE;
}
#####################################################
#
# Function:
#
#    state_of_cluster
#
# Description:
#
#    Returns the state of the cluster
#
# Arguments:
#
#    none
#
#####################################################
# Possible return values:
# "up"
# "down"
# "unknown"
sub state_of_cluster(){
    # $SNMPINFO_SOURCE is generated by snmpinfoRefresh which should be called
    # shortly before this script is executed.
    foreach my $info (@snmpinfo){
        my @entry = split (/ +/, $info);
        if ($entry[0] eq "clusterState.0"){
            if ($entry[2] == 2){
                return $UP;
            }
            elsif ($entry[2] == 4){
                return $DOWN;
            }
            elsif ($entry[2] == 8){
                return $UNKNOWN;
            }
            # This shouldn't happen
            print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Unable to determine cluster status.\n"`;
            return;
        }
    }
}
#####################################################
#
# Function:
#
#    substate_of_cluster
#
# Description:
#
#    Returns the substate of the cluster
#
# Arguments:
#
#    none
#
#####################################################
# Possible return values:
# "unknown"
# "unstable"
# "stable"
# "error"
# "reconfig"
sub substate_of_cluster(){
    my @tmp;
    foreach(@snmpinfo){
        @tmp = split;
        if ($tmp[0] eq "clusterSubState.0"){
            if ($tmp[2] == 8){
                return $UNKNOWN;
            }
            elsif ($tmp[2] == 16){
                return $UNSTABLE;
            }
            elsif ($tmp[2] == 32){
                return $STABLE;
            }
            elsif ($tmp[2] == 64){
                return $ERROR;
            }
            elsif ($tmp[2] == 128){
                return $RECONFIG;
            }
            print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Unable to determine cluster substate.\n"`;
            return;
        }
    }
}
#####################################################
#
# Function:
#
#    state_of_node
#
# Description:
#
#    Returns the state of a node. ("up", "down",
#    "joining", "leaving")
#
# Arguments:
#
#    $_[0]: node name
#
#####################################################
# Possible return values:
# "up"
# "down"
# "joining"
# "leaving"
sub state_of_node($){
    my @nodeNames;
    my @nodeStates;
    # Here we'll extract the node names and store them
    # in the array @nodeNames in the order in which we
    # found them.
    foreach(@snmpinfo){
        my @tmp = split /\s|\./;
        if ($tmp[0] eq "nodeName"){
            $tmp[3] =~ s/\"//g;
            push @nodeNames, $tmp[3];
        }
        # This will keep us from searching through the
        # entire @snmpinfo array after we've found
        # what we're looking for.
        elsif($tmp[0] =~ /addr/){
            last;
        }
    }
    foreach(@snmpinfo){
        my @tmp = split /\s|\./;
        if ($tmp[0] =~ /nodeState/){
            push @nodeStates, $tmp[3];
        }
        # This will keep us from searching through the
        # entire @snmpinfo array after we've found
        # what we're looking for.
        elsif($tmp[0] =~ /addr/){
            last;
        }
    }
    for(my $r = 0; $nodeNames[$r]; $r++){
        if ($_[0] eq $nodeNames[$r]){
            if($nodeStates[$r] == 2){
                return $UP;
            }
            elsif($nodeStates[$r] == 4){
                return $DOWN;
            }
            elsif($nodeStates[$r] == 32){
                return $JOINING;
            }
            elsif($nodeStates[$r] == 64){
                return $LEAVING;
            }
            print STDERR `dspmsg scripts.cat 9999 "\nWARNING:'%s' was found but a problem occurred while attempting to fetch state.\n" "$_[0]"`;
            return;
        }
    }
}
#####################################################
#
# Function:
#
#    state_of_interface
#
# Description:
#
#    Returns the state of an interface. (up/down)
#
# Arguments:
#
#    $_[0]: a node name
#    $_[1]: an interface name (on that node. ex: en0)
#
#####################################################
# Possible return values:
# "up"
# "down"
# "unknown"
sub state_of_interface($$){
    my $node = $_[0];
    my $interface = $_[1];
    if($ip = &ip_of_interface($_[0],$_[1]) ){
        # This is a work-around for non-ip interfaces. It probes
        # the MIB's ip-like value assigned to the interface so
        # that it can be used in-place of a real IP address.
        $_ = $ip;
        s/[0-9]//g;
        if($_ ne "..."){
            my $interfaceName = &name_of_interface($node, $interface);
            foreach(@snmpinfo){
                my @tmp = split /\s|\./;
                if($tmp[7]){
                    $tmp[7] =~ s/\"//g;
                    if( ($tmp[0] eq "addrLabel") && ($tmp[7] eq $interfaceName) ){
                        $ip = "$tmp[2].$tmp[3].$tmp[4].$tmp[5]";
                        last;
                    }
                }
            }
        }
        foreach (@snmpinfo){
            my @tmp = split /\s|\./;
            if( $tmp[0] ne "addrState"){
                next;
            }
            if( ($tmp[0] eq "addrState") && ($ip eq "$tmp[2].$tmp[3].$tmp[4].$tmp[5]") && ($tmp[7] == 2) ){
                return $UP;
            }
            elsif( ($tmp[0] eq "addrState") && ($ip eq "$tmp[2].$tmp[3].$tmp[4].$tmp[5]") && ($tmp[7] == 4) ){
                return $DOWN;
            }
            elsif( ($tmp[0] eq "addrState") && ($ip eq "$tmp[2].$tmp[3].$tmp[4].$tmp[5]") && ($tmp[7] == 8) ){
                return $UNKNOWN;
            }       
        }
        print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Unable to locate interface '%s' on node '%s'.\n" "$interface" "$node"`;
    }
    print STDERR `dspmsg scripts.cat 9999 "\nWARNING: An unknown problem occurred while executing the ip_of_interface subroutine.\n"`;
}
#####################################################
#
# Function:
#
#    state_of_network
#
# Description:
#
#    Returns the state of a network.
#    (up/down/joining/leaving)
#
# Arguments:
#
#    $_[0]: the name of a network
#
#####################################################
# Possible return values:
# "up"
# "down"
# "joining"
# "leaving"
# "unknown"
sub state_of_network($){
    local $_;
    my @snmpinfo = @snmpinfo; # Changes will only be for this dynamic scope
    my @tmp;
    my $netID = 9999;
    # First we need to find the netID of the network
    # While our @snmpinfo stack is still popping elements ...
    while($_ = shift @snmpinfo){
        @tmp = split /\s|\./;
        if( ($tmp[0] eq "netName") && ($tmp[4] eq "\"$_[0]\"") ){
            $netID = $tmp[2];
            last;
        }
    }
    if($netID == 9999){
        print STDERR `dspmsg scripts.cat 9999 "\nERROR: Unable to find the network '%s' in the Management Information Base.\n" "$_[0]"`;
        return;
    }
    # Now, using the netID, we can find the state
    while($_ = shift @snmpinfo){
        @tmp = split /\s|\./;
        if( ($tmp[0] eq "netState") && ($tmp[2] == $netID) ){
            $netState = $tmp[4];
            last;
        }
    }
    # Interprets and reports the state
    if($netState == 2){
        return $UP;
    }
    elsif($netState == 4){
        return $DOWN;
    }
    elsif($netState == 32){
        return $JOINING;
    }
    elsif($netState == 64){
        return $LEAVING;
    }
    else{
        return $UNKNOWN;
    }
}
#####################################################
#
# Function:
#
#    state_of_app_of_rg
#
# Description:
#
#    Returns the state of an application.
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
# Possible return values:
# "$INACTIVE" (the application server is configured but is not a member of a RG)
# "$ONLINE"
# "$OFFLINE"
# "$ACQUIRING"
# "$RELEASING"
# "$ERROR"
# "$UNKNOWN"
sub state_of_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    my @resGroupNodeStates;
    my $resGroupID;
    if($rg eq "NONE"){
        return $INACTIVE;
    }
    # Uses the resource group name to parse the resource group ID from snmpinfo
    my @tmpSnmpinfo = `cat $SNMPINFO_SOURCE | fgrep resGroupName`;
    foreach(@tmpSnmpinfo){
        my @tmp = split /\s|\./;
        $tmp[3] =~ s/\"//g;
        if($tmp[3] eq $rg){
            $resGroupID = $tmp[1];
            last;
        }
    }
    # Builds a list of the states of all the nodes in the resource group we're
    # examining.
    @tmpSnmpinfo = `cat $SNMPINFO_SOURCE | grep resGroupNodeState`;
    foreach(@tmpSnmpinfo){
        my @tmp = split /\s|\./;
        if(($tmp[0] eq "resGroupNodeState") && ($tmp[1] == $resGroupID)){
            push @resGroupNodeStates, $tmp[4];
        }
    }
    # This shouldn't happen, but if it does something obviously went wrong.
    if(!@resGroupNodeStates){
        print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Could not determine the state of application '%s'.\n" "$_[0]"`;
        return;
    }
    # Here we look at the state of the application on each of the nodes that are
    # capable of providing it and determine the app's state accordingly.
    my $nodes_acquiring = 0;
    my $nodes_releasing = 0;
    my $nodes_offline = 0;
    my $nodes_error = 0;
    my $nodes_unknown = 0;
    foreach(@resGroupNodeStates){
        if($_ == 2){
            # if its online on any node, the global state is online
            return $ONLINE;
        }
        elsif($_ == 4){
            $nodes_offline++;
        }
        elsif($_ == 8){
            $nodes_unknown++;
        }
        elsif($_ == 16){
            $nodes_acquiring++;
        }
        elsif($_ == 32){
            $nodes_releasing++;
        }
        elsif($_ == 64){
            # if its in error state on any node, the global state is error
            return $ERROR;
        }
    }
    if($nodes_acquiring){
        return $ACQUIRING;
    }
    # If they're all OFFLINE / RELEASING / ERROR 
    elsif($nodes_offline == ($#resGroupNodeStates + 1)){
        return $OFFLINE;
    }
    elsif($nodes_error == ($#resGroupNodeStates + 1)){
        return $ERROR;
    }
    elsif($nodes_releasing == ($#resGroupNodeStates + 1)){
        return $RELEASING;
    }
    # If they're any other combination of states
    return $UNKNOWN;
}
#####################################################
#
# Function:
#
#    nodes_providing_app_of_rg
#
# Description:
#
#    Returns a list of the nodes currently providing
#    an application
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub nodes_providing_app_of_rg($$){
    my $app = $_[0];
    my $rg = $_[1];
    my @nodes;
    my @nodesWithID;
    my @resGroupNodesID;
    my $resGroupID;
    my @resGroupNodeStates;
    my @results;
    my @tmpSnmpinfo = `cat $SNMPINFO_SOURCE | grep -e nodeName -e resGroupName -e resGroupNodeState`;
    my @tmp;
    if($rg eq "NONE"){
        $results[0] = "NONE";
        return @results;
    }
    # Parses snmpinfo's output for ...
    foreach my $line (@tmpSnmpinfo){
        @tmp = split /\s|\./, $line;
        # ... the names of the nodes in the cluster ...
        # (Although we already have a subroutine that does this
        # we do it again here because we will also be gathering
        # the states of the nodes from snmpinfo and we need to
        # insure that our nodes and node-states match.)
        if("$tmp[0]" eq "nodeName"){
            $tmp[3] =~ s/\"//g;
	    push @nodesWithID, "$tmp[3].$tmp[1]";
        }
        # ... the ID by which snmpinfo refers to app's RG ...
        elsif("$tmp[0]" eq "resGroupName"){
            $tmp[3] =~ s/\"//g;
            if($tmp[3] eq $rg){
                $resGroupID = $tmp[1];
            }
        }
        # ... and the states of each node (This IF will never be
        # followed until after all the resGroupIDs have been found
        # since states are listed later in snmpinfo's output.)
        elsif( ("$tmp[0]" eq "resGroupNodeState") && ($tmp[1] == $resGroupID) ){
            push @resGroupNodeStates, $tmp[4];
	    push @resGroupNodesID, $tmp[2];
        }
    }
    # We should always find the nodes' states. If not, something's gone wrong.
    if(!@resGroupNodeStates){
        print STDERR `dspmsg scripts.cat 9999 "\nWARNING: Could not determine the state of application %s.\n" "$app"`;
        return;
    }
    # Keep only nodes that have this RG
    for(my $id = 0; $resGroupNodesID[$id]; $id++){
       for(my $node_id = 0; $nodesWithID[$node_id]; $node_id++) {
          @tmp = split /\s|\./, $nodesWithID[$node_id];
    	  if ($tmp[1] == $resGroupNodesID[$id]) {
		push @nodes, $tmp[0];
	}
      }
    }
    # Returns a list of all nodes that are both in the app's RG and
    # have a state of "online".
    for(my $r = 0; $resGroupNodeStates[$r]; $r++){
        if($resGroupNodeStates[$r] == 2){
            push  @results, $nodes[$r];
        }
    }
    if(!$results[0]){
        $results[0] = "NONE";
    }
    return @results;
}

# ------------------------------------------------------------------------
#   The next four subroutines are only called by fallover_node_for_app_of_rg
# ------------------------------------------------------------------------
#####################################################
#
# Function:
#
#    calculateDNPPFallover
#
# Description:
#
#    Returns an explanation of which node will be
#    selected for fallover by the dynamic node
#    priority policy
#
# Arguments: 
#
#    resource group name
#
#####################################################
sub calculateDNPPFallover($){
    my $rg = $_[0];
    local @_; # This keeps the global from being clobbered by local changes
    local $_; # This keeps the global from being clobbered by local changes
    # my @tmp = `odmget -q "group=$rg and name=NODE_PRIORITY_POLICY" HACMPresource`;
    
    my @currNode = &nodes_providing_app_of_rg($app,$rg);
    my $availableNodes = 0;
    # Counts up how many cluster nodes are $UP
    if(scalar(@currNode) > 0){
        foreach(@nodesOfRg){
            if( ( &state_of_node($_) eq $UP) && ($_ ne $currNode[0]) ){
                $availableNodes++;
            }
        }
    }
    
    # We only need to report the dnpp message if there are two or
    # more other nodes available to fallover to.
    if($availableNodes > 1){
        my $dnp = `$HACMPBASE/utilities/cllsres -cg $rg | tail -1 | cut -f23 -d:`;
        chomp $dnp;
        if($dnp eq "cl_highest_free_mem"){
            return $MESSAGE_CL_HIGHEST_FREE_MEM;
        }
        elsif($dnp eq "cl_highest_idle_cpu"){
            return $MESSAGE_CL_HIGHEST_IDLE_CPU;
        }
        elsif($dnp eq "cl_lowest_disk_busy"){
            return $MESSAGE_CL_LOWEST_DISK_BUSY;
        }
        else{
            return $MESSAGE_USER_SPECIFIED;
        }
        # This should never happen
        print STDERR `dspmsg scripts.cat 9999 "\nERROR: Unable to determine the dynamic node priority policy for group '%s'.\n" "$rg"`;
    }
    # If there is only one other node available to fallover to,
    # we can just have calculateFalloverToNextPriorityNode() do
    # our work for us.
    elsif ($availableNodes == 1){
        return calculateFalloverToNextPriorityNode();
    }
    else{
        return "NONE";
    }
}
#####################################################
#
# Function:
#
#    calculateFalloverToNextPriorityNode
#
# Description:
#
#    Returns the highest-priority available node.
#    (The one to which a standard rotating or
#    cascading RG will fallover.)
#
# Arguments:
#
#    none
#
#####################################################
sub calculateFalloverToNextPriorityNode(){
    local $_; # This keeps the global from being clobbered by local changes

    # nodes_providing_app_of_rg will normally return a single node or a list of nodes (in
    # the case of a concurrent RG) but in this case we've already screened out the
    # concurrent RGs so we can just assume that the array @currNode will only have
    # a single element.
    my @currNode = &nodes_providing_app_of_rg($app,$rg);
    
    # Checks each of the nodes in the RG from highest to lowest precedence.
    # The RG will move to the first available node, so it's returned.
    if(scalar(@currNode) > 0){
        foreach(@nodesOfRg){
            if( ( &state_of_node($_) eq $UP) && ($_ ne $currNode[0]) ){
                return "$_";
            }
        }
    }
    return "NONE";
}
#####################################################
#
# Function:
#
#    calculateOfflineFallover
#
# Description:
#
#    Returns the second node on the list of nodes
#    that are configured to provide the application
#    or "NONE" if there isn't one. This subroutine is
#    used only for clusters that are offline.    
#
# Arguments:
#
#    none
#
#####################################################
sub calculateOfflineFallover(){
    if($nodesOfRg[1]){
        return "$nodesOfRg[1]";
    }
    else{
        return "NONE";
    }
}
#####################################################
#
# Function:
#
#    initRgPrefs
#
# Description:
#
#    Initializes $startupPref, $falloverPref,
#    and $fallbackPref
#
# Arguments:
#
#    $_[0]: Resource group name
#
#####################################################
sub initRgPrefs($){
    local $rg = $_[0];
    # my $tmp = `odmget -q group=$rg HACMPgroup | grep startup_pref`;
    $startupPref = `$HACMPBASE/utilities/clgetgrp -cg $rg | tail -1 | cut -f5 -d:`;
    chomp $startupPref;
    
    # $tmp = `odmget -q group=$rg HACMPgroup | grep fallover_pref`;
    $falloverPref = `$HACMPBASE/utilities/clgetgrp -cg $rg | tail -1 | cut -f6 -d:`;
    chomp $falloverPref;
    
    # $tmp = `odmget -q group=$rg HACMPgroup | grep fallback_pref`;
    $fallbackPref = `$HACMPBASE/utilities/clgetgrp -cg $rg | tail -1 | cut -f7 -d:`;
    chomp $fallbackPref;
}
#####################################################
#
# Function:
#
#    fallover_node_for_app_of_rg
#
# Description:
#
#    Returns the node to which an application will
#    fallover if the node on which it is currently
#    running fails. (Or if the resource group is
#    offline it returns the node that the app would
#    fallover to if it can be determined.)
#
# Arguments:
#
#    $_[0]: an application name
#    $_[1]: rg name
#
#####################################################
sub fallover_node_for_app_of_rg($$){
    $app = $_[0];
    $rg = $_[1];
    local $_;  # keeps the global from being clobbered by local changes
    local @_;  # keeps the global from being clobbered by local changes
    if($rg eq "NONE"){
        return;
    }

    # nodes_of_app_of_rg effectively gives us a list of the nodes in the same RG
    @nodesOfRg = &nodes_of_app_of_rg($app,$rg);
    
    # First we'll parse HACMPgroup for the custom config info
    # POSSIBLE VALUES:
    # startupPref = "OFAN"  Online on first available node
    # startupPref = "OHN"  Online on home node only
    # startupPref = "OAAN"  Online on all available nodes
    # startupPref = "OUDP"  Online Using Distribution Policy
    # falloverPref = "FNPN"  Fallover to next priority node in the list
    # falloverPref = "FUDNP"  Fallover Using Dynamic Node Priority
    # falloverPref = "BO"  Bring offline (on error node only)
    # -- We don't actually care about fallback settings but here they are:
    # fallbackPref = "NFB"  Never fall back
    # fallbackPref = "FBHPN"  Fallback To Higher Priority Node In The List
    
    initRgPrefs($rg);
    
    # If the app is online
    if( $appStates[$h][$r] eq $ONLINE ){
        if ($startupPref eq "OAAN"){
            print STDERR `dspmsg scripts.cat 9999 "\nApplication '%s' belongs to a resource group which is configured to run on all its nodes simultaneously. No fallover will occur." "$app"`;
        }
        elsif($falloverPref eq "BO"){
            return "NONE";
        }
        elsif($falloverPref eq "FNPN"){
            return &calculateFalloverToNextPriorityNode;
        }
        elsif($falloverPref eq "FUDNP"){
            return &calculateDNPPFallover($rg);
        }
    }
    # If cluster services are down
    elsif (&state_of_cluster() eq $DOWN){   #else if cluster is inactive
        if ($startupPref eq "OAAN"){
            print STDERR `dspmsg scripts.cat 9999 "\nApplication '%s' belongs to a resource group which is configured to run on all its nodes simultaneously. No fallover will occur." "$app"`;
        }
        elsif($falloverPref eq "BO"){
            return "NONE";
        }
        elsif($falloverPref eq "FUDNP"){
            return &calculateDNPPFallover($rg);
        }
        elsif($startupPref eq "OHN" && $falloverPref eq "FNPN"){
            return &calculateOfflineFallover;
        }
        else{
            return $MESSAGE_UNKNOWN_UNLESS_ONLINE;
        }
    }
    else{
        return "NONE";
    }
}
#####################################################
#
# Function:
#
#    state_of_service_label
#
# Description:
#
#    Returns the state of a service label ("online"
#    or "offline/unknown").
#
# Arguments:
#
#    $_[0]: a service label
#
#####################################################
# Possible return values:
# "online"
# "offline/unknown"
sub state_of_service_label($){
    my $serviceLabel = $_[0];
    my $ip;
    my $tmpIP;
    local $_;
    local @_;
    my @snmpinfo = `cat $SNMPINFO_SOURCE | grep -e addrLabel -e addrRole -e addrState`;
    # Parses snmpinfo's output for ...
    foreach my $ent (@snmpinfo){
        my @entry = split (/\s|\./, $ent);
        # ... the ip of the service label
        if($entry[0] eq "addrLabel"){
            $entry[7] =~ s/\"//g;
            if($entry[7] eq $serviceLabel){
                # Cat stuff together to form the ip we're looking for
                $ip = "$entry[2].$entry[3].$entry[4].$entry[5]";
            }
        }
        # ... the role of the service label in order to ensure that addrLabel is
        # really a service label
        elsif($entry[0] eq "addrRole"){ 
            $tmpIP = "$entry[2].$entry[3].$entry[4].$entry[5]";
            # If we've found the line containing the role of our IP ...
            if($ip && ($tmpIP eq $ip) ){
                # see /usr/es/sbin/cluster/hacmp.my for description of these values
                if( !( ($entry[7] == 16)||($entry[7] == 32)||($entry[7] == 128)||($entry[7] == 144)) ){
                    print STDERR `dspmsg scripts.cat 9999 "\nERROR: %s is not a service label.\n" "$serviceLabel"`;
                  return;
                }
            }
        }
        # ... 
        elsif( $entry[0] eq "addrState" ){
            $tmpIP = "$entry[2].$entry[3].$entry[4].$entry[5]";
            # If we've found the line containing the state of our IP (on a
            # particular node
            if($ip && ($tmpIP eq $ip) ){
                if($entry[7] == 2){
                    return $ONLINE;
                }
            }
        }
    }
    return "offline/unknown";
}
#####################################################
#
# Function:
#
#    translate
#
# Description:
#
#    Calls a predefined 'dspmsg' command based on the
#    input it's passed. This is a workaround to make
#    values stored in the ODM or returned by other
#    functions in this program translate correctly
#    into other languages.
#
# Arguments:
#
#    $_[0]: any word or phrase (should be in english)
#
#####################################################
sub translate($){
    if($_[0] eq "") {
	return;
    }

    if($_[0] eq "custom"){
        return `dspmsg scripts.cat 9999 "custom"`;
    }
    elsif($_[0] eq "up"){
        return `dspmsg scripts.cat 9999 "up"`;
    }
    elsif($_[0] eq "down"){
        return `dspmsg scripts.cat 9999 "down"`;
    }
    elsif($_[0] eq "unknown"){
        return `dspmsg scripts.cat 9999 "unknown"`;
    }
    elsif($_[0] eq "joining"){
        return `dspmsg scripts.cat 9999 "joining"`;
    }
    elsif($_[0] eq "leaving"){
        return `dspmsg scripts.cat 9999 "leaving"`;
    }
    elsif($_[0] eq "unstable"){
        return `dspmsg scripts.cat 9999 "unstable"`;
    }
    elsif($_[0] eq "stable"){
        return `dspmsg scripts.cat 9999 "stable"`;
    }
    elsif($_[0] eq "error"){
        return `dspmsg scripts.cat 9999 "error"`;
    }
    elsif($_[0] eq "reconfig"){
        return `dspmsg scripts.cat 9999 "reconfig"`;
    }
    elsif($_[0] eq "active"){
        return `dspmsg scripts.cat 9999 "active"`;
    }
    elsif($_[0] eq "inactive"){
        return `dspmsg scripts.cat 9999 "inactive"`;
    }
    elsif($_[0] eq "online"){
        return `dspmsg scripts.cat 9999 "online"`;
    }
    elsif($_[0] eq "offline"){
        return `dspmsg scripts.cat 9999 "offline"`;
    }
    elsif($_[0] eq "offline/unknown"){
        return `dspmsg scripts.cat 9999 "offline/unknown"`;
    }
    elsif($_[0] eq "acquiring"){
        return `dspmsg scripts.cat 9999 "acquiring"`;
    }
    elsif($_[0] eq "releasing"){
        return `dspmsg scripts.cat 9999 "releasing"`;
    }
    elsif($_[0] eq "process"){
        return `dspmsg scripts.cat 9999 "process"`;
    }
    elsif($_[0] eq "notify"){
        return `dspmsg scripts.cat 9999 "notify"`;
    }
    elsif($_[0] eq "fallover"){
        return `dspmsg scripts.cat 9999 "fallover"`;
    }
# These next nine elsifs must be identical to the decalartions of $UP/$DOWN/$UNKNOWN/etc
# in are changed in wsm_cldisp.cgi
    elsif($_[0] eq $UP){
        return '<span class="up">'.`dspmsg scripts.cat 9999 "up"`.'</span>';
    }
    elsif($_[0] eq $DOWN){
        return '<span class="down">'.`dspmsg scripts.cat 9999 "down"`.'</span>';
    }
    elsif($_[0] eq $UNKNOWN){
        return '<span class="unknown">'.`dspmsg scripts.cat 9999 "unknown"`.'</span>';
    }
    elsif($_[0] eq $UNSTABLE ){
        return '<span class="unstable">'.`dspmsg scripts.cat 9999 "unstable"`.'</span>';
    }
    elsif($_[0] eq $STABLE ){
        return '<span class="up">'.`dspmsg scripts.cat 9999 "stable"`.'</span>';
    }
    elsif($_[0] eq $ERROR ){
        return '<span class="down">'.`dspmsg scripts.cat 9999 "error"`.'</span>';
    }
    elsif($_[0] eq $RECONFIG ){
        return '<span class="unknown">'.`dspmsg scripts.cat 9999 "reconfig"`.'</span>';
    }
    elsif($_[0] eq $ACTIVE ){
        return '<span class="up">'.`dspmsg scripts.cat 9999 "active"`.'</span>';
    }
    elsif($_[0] eq $INACTIVE ){
        return '<span class="inactive">'.`dspmsg scripts.cat 9999 "inactive"`.'</span>';
    }
    elsif($_[0] eq $ONLINE ){
        return '<span class="up">'.`dspmsg scripts.cat 9999 "online"`.'</span>';
    }
    elsif($_[0] eq $OFFLINE ){
        return '<span class="down">'.`dspmsg scripts.cat 9999 "offline"`.'</span>';
    }
    elsif($_[0] eq $ACQUIRING ){
        return '<span class="unstable">'.`dspmsg scripts.cat 9999 "acquiring"`.'</span>';
    }
    elsif($_[0] eq $RELEASING ){
        return '<span class="unstable">'.`dspmsg scripts.cat 9999 "releasing"`.'</span>';
    }
    # If it's not in the table we'll just print the english word.
    else{
        print STDERR `dspmsg scripts.cat 9999 "\nWARNING: translate() was called on the word '%s' which is not in translation table.\n" "$_[0]"`;
        print "$_[0]";
    }
}
#####################################################
#
# Function:
#
#    translateCustomAttr
#
# Description:
#
#    Returns the english/other language equivalent
#    of a resource group's startup/fallover/
#    fallback settings.
#
# Arguments:
#
#    $_[0]: a startup/fallover/fallback setting
#           acronym
#
#####################################################
sub translateCustomAttr($){
    if($_[0] eq "OFAN"){
        return `dspmsg scripts.cat 9999 "on first available node"`;
    }
    elsif($_[0] eq "OHN"){
        return `dspmsg scripts.cat 9999 "on home node only"`;
    }
    elsif($_[0] eq "OUDP"){
        return `dspmsg scripts.cat 9999 "using distribution policy"`;
    }
    elsif($_[0] eq "OAAN"){
        return `dspmsg scripts.cat 9999 "on all available nodes"`;
    }
    elsif($_[0] eq "FNPN"){
        return `dspmsg scripts.cat 9999 "to next priority node in the list"`;
    }
    elsif($_[0] eq "FUDNP"){
        return `dspmsg scripts.cat 9999 "using dynamic node priority to determine target"`;
    }
    elsif($_[0] eq "BO"){
        return `dspmsg scripts.cat 9999 "bring offline on error node"`;
    }
    elsif($_[0] eq "NFB"){
        return `dspmsg scripts.cat 9999 "never"`;
    }
    elsif($_[0] eq "FBHPN"){
        return `dspmsg scripts.cat 9999 "if higher priority node becomes available"`;
    }
}
#####################################################
#
# Function:
#
#    probeStatic
#
# Description:
#
#    Most of the static info about the cluster config
#    is gathered here
#
# Arguments:
#
#    none
#
#####################################################
sub probeStatic(){
    # Gets the name of our cluster.
    $clusterName = `$HACMPBASE/utilities/cllsclstr -c | tail -1 | cut -f2 -d:`;
    chomp $clusterName;
    $localNodeName = `$HACMPBASE/utilities/get_local_nodename`;
    chomp $localNodeName;
    # @nodeNames stores the names of each of the nodes in the cluster
    @nodeNames = &nodes_in_cluster;
    chomp @nodeNames;
    # Creation of @interfacesByNode-- a 2D array of the interfaces on each
    # host. The rows of the arrays are in the same order as @nodeNames.
    @scrap = @nodeNames;
    $r = 0;
    while ($_ = shift @scrap){
        my @tmp = &interfaces_on_node($_);
        for($c = 0; $c <= $#tmp; $c++){
            $interfacesByNode[$r][$c] = $tmp[$c];
        }
        $r++;
    } # /while
    # Creation of @ipsByNode--a 2D array of the ip addresses of each of the
    # interfaces on each node. This array is in the same layout as
    # @interfacesByNode.
    for($r = 0; $interfacesByNode[$r][0]; $r++){
        for($c = 0; $interfacesByNode[$r][$c]; $c++){
            $ipsByNode[$r][$c] = &ip_of_interface($nodeNames[$r], $interfacesByNode[$r][$c]);
        }
    }
    # Creation of @networksOfInterfaces--a 2D array of the networks to which
    # each interface belongs. This array is in the same layout as
    # @interfacesByNode.
    for($r = 0; $interfacesByNode[$r][0]; $r++){
        for($c = 0; $interfacesByNode[$r][$c]; $c++){
            $networksOfInterfaces[$r][$c] = &network_of_interface($nodeNames[$r], $interfacesByNode[$r][$c]);
        }
    }
    # Initializes @apps, a list of all the cluster's apps
    @apps = &apps_on_cluster();
    # Initializes @RgsByApp---a 2D array of the applications and the resource groups to which application
    # belongs. It's order is the same as @apps.
    for($r = 0; $apps[$r]; $r++){
	  @scrap = &rg_of_app($apps[$r]);
	  for($c = 0; $scrap[$c]; $c++) {
        	$RgsByApp[$r][$c] = $scrap[$c];
	  }
    }

    # Creation of @nodesByApp--a 3D array of the nodes configured to provide each
    # application. The application corresponds to height, rg to rows and nodes to 
    # column of the array @apps.
    @scrap = @apps;
    $h = 0;
    while ($_ = shift @scrap){
        for($r = 0; $RgsByApp[$h][$r]; $r++) {
            @tmp = &nodes_of_app_of_rg($_,$RgsByApp[$h][$r]);
            for($c = 0; $c <= $#tmp; $c++){
                $nodesByApp[$h][$r][$c] = $tmp[$c];
            }
       }
       $h++;
    } # /while
    # Initializes @startscriptsByApp
    @scrap = @apps;
    $r = 0;
    while ($_ = shift @scrap){
        $startscriptsByApp[$r] = &startscript_of_app($_);
        $r++;
    }
    # Initializes @stopscriptsByApp
    @scrap = @apps;
    $r = 0;
    while ($_ = shift @scrap){
        $stopscriptsByApp[$r] = &stopscript_of_app($_);
        $r++;
    }
    # Initializes @serviceIpLabelsOfApps, a 3D array whose height is in same 
    # order as @apps, rows in the order of rgs(to which the app belongs)
    # and columns contain the service ip labels.
    @scrap = @apps;
    $h = 0;
    while ($_ = shift @scrap){
	  for($r = 0; $RgsByApp[$h][$r]; $r++) {
            @tmp = &service_labels_of_app_of_rg($_, $RgsByApp[$h][$r]);
            for($c = 0; $tmp[$c]; $c++){
                $serviceIpLabelsOfApps[$h][$r][$c] = $tmp[$c];
	    }
        }
        $h++;
    } # /while
    # Initializes @serviceIpsOfApps, a 3D array whose entries correspond to the entries of
    # @serviceIpLabelsOfApps.
    for($h = 0; $h <= $#serviceIpLabelsOfApps; $h++) {
        for($r = 0; $serviceIpLabelsOfApps[$h][$r][0]; $r++){
            for($c = 0; $serviceIpLabelsOfApps[$h][$r][$c]; $c++){
                if($serviceIpLabelsOfApps[$h][$r][$c] ne "NONE"){
                    $serviceIpsOfApps[$h][$r][$c] = &ip_of_service_label($serviceIpLabelsOfApps[$h][$r][$c]);
                }
            }
       }
    } # /for
    # Initializes @networksOfServiceLabels
    for($h = 0; $h <= $#serviceIpLabelsOfApps; $h++) {
	for($r = 0; $serviceIpLabelsOfApps[$h][$r][0] ; $r++){
          for($c = 0; $serviceIpLabelsOfApps[$h][$r][$c]; $c++){
              if($serviceIpLabelsOfApps[$h][$r][$c] ne "NONE"){
                $networksOfServiceLabels[$h][$r][$c] = &network_of_service_label($serviceIpLabelsOfApps[$h][$r][$c]);
              }
          }
	}
    } # /for

    # Initializes @vgsOfApps, a 3D array of the shared volume groups
    # associated with a particular app corresponding to each rg, it belongs to.
    for($h = 0; $apps[$h]; $h++){
	  for($r = 0; $RgsByApp[$h][$r]; $r++) {
            my @tmp = &vgs_of_app_of_rg($apps[$r],$RgsByApp[$h][$r]);
            for($c = 0; $tmp[$c]; $c++){
                $vgsOfApps[$h][$r][$c] = $tmp[$c];
            }
        }
    }
    # Initializes @ccVgsOfApps, a 3D array of the concurrent shared volume
    # groups associated with a particular app corresponding to each rg, it belongs to.
    for($h = 0; $apps[$h]; $h++){
        for($r = 0; $RgsByApp[$h][$r]; $r++) {
            my @tmp = &cc_vgs_of_app_of_rg($apps[$r],$RgsByApp[$h][$r]);
            for($c = 0; $tmp[$c]; $c++){
                $ccVgsOfApps[$h][$r][$c] = $tmp[$c];
            }
        }
    }
    # Initializes @filesystemsOfApps, a 3D array of the filesystems 
    # associated with a particular app corresponding to each rg, it belongs to.
    for($h = 0; $apps[$h]; $h++){
        for($r = 0; $r < $RgsByApp[$h][$r]; $r++) {
            my @tmp = &filesystems_of_app_of_rg($apps[$r],$RgsByApp[$h][$r]);
            for($c = 0; $tmp[$c]; $c++){
                $filesystemsOfApps[$h][$r][$c] = $tmp[$c];
            }
        }
    }
    # Initializes @fastConnectServicesOfApps, a 3D array of the fast
    # connect services associated with each rg to which the app belongs. 
    for($h = 0; $apps[$h]; $h++){
	for($r = 0; $RgsByApp[$h][$r]; $r++) {
            my @tmp = &fast_connect_services_of_app_of_rg($apps[$r],$RgsByApp[$h][$r]);
            for($c = 0; $tmp[$c]; $c++){
                $fastConnectServicesOfApps[$h][$r][$c] = $tmp[$c];
            }
        }
    }
    # Initializes @monitorsOfApps, a 2D array of the application monitors
    # configured to monitor a particular application
    for($r = 0; $apps[$r]; $r++){
        my @tmp = &monitors_of_app($apps[$r]);
        for($c = 0; $tmp[$c]; $c++){
            $monitorsOfApps[$r][$c] = $tmp[$c];
        }
    }
}
#####################################################
#
# Function:
#
#    probeDynamic
#
# Description:
#
#    Probes the cluster for information on it's
#    current state.
#
# Arguments:
#
#    none
#
#####################################################
sub probeDynamic(){
    # Here we probe the MIB of potentially every node in
    # the cluster looking for a node where cluster
    # services are active. The MIB info is extracted
    # and stored in the file $SNMPINFO_SOURCE. If an active
    # cluster node was found, snmpinfoRefresh returns a 1
    # indicating we should go ahead an extract the cluster's
    # current state from the $SNMPINFO_SOURCE file.
    $overall_clstrmgr_state = &snmpinfoRefresh("$SNMPINFO_SOURCE");
    if($overall_clstrmgr_state eq $ACTIVE){
        if( !(-e "$SNMPINFO_SOURCE") ){
            print STDERR `dspmsg scripts.cat 9999 "\nERROR: SNMP information file %s not found.\n" "$SNMPINFO_SOURCE"`;
        }
        @snmpinfo = `cat $SNMPINFO_SOURCE`;
        chomp @snmpinfo;
        $clusterState = &state_of_cluster;
        $clusterSubstate = &substate_of_cluster;
        # Initializes @nodeStates, an array of the states of the nodes in @nodeNames
        # Initializes @interfaceStatesByNode, a 2D array of the states of the interfaces in @interfacesByNode
        # Initializes @networkStates, a 2D array of the states of the networks in @networksOfInterfaces
        for($r = 0; $nodeNames[$r]; $r++){
            $nodeStates[$r] = &state_of_node($nodeNames[$r]);
            for($c = 0; $interfacesByNode[$r][$c]; $c++){
                $interfaceStatesByNode[$r][$c] = &state_of_interface($nodeNames[$r], $interfacesByNode[$r][$c]);
                $networkStates[$r][$c] = &state_of_network($networksOfInterfaces[$r][$c]);
            }
        } # /for
        for($h = 0; $apps[$h]; $h++){
      	    for($r = 0; $RgsByApp[$h][$r]; $r++) {
		$appStates[$h][$r] = &state_of_app_of_rg($apps[$h],$RgsByApp[$h][$r]);
                @tmp = &nodes_of_app_of_rg($apps[$h], $RgsByApp[$h][$r]);
                for($c = 0; $c <= $#tmp; $c++){
                    $nodesByApp[$h][$r][$c] = $tmp[$c];
                }
	    } # /for
      	   for($r = 0; $RgsByApp[$h][$r]; $r++) {
	       $appStates[$h][$r] = &state_of_app_of_rg($apps[$h],$RgsByApp[$h][$r]);
               @tmp = &nodes_providing_app_of_rg($apps[$h], $RgsByApp[$h][$r]);
               for($c = 0; $c <= $#tmp; $c++){
                   $providingNodesByApp[$h][$r][$c] = $tmp[$c];
               }
	    } # /for

            # Now we'll calculate the fallover nodes for the applications. We must make sure not
            # to call fallover_node_for_app_of_rg on an app that runs concurrently across the nodes
            # of it's RG because it will cause an error. We'll store the fallover nodes in 
            # @falloverNodesOfApps, which is in the same order as @apps.
            # my $x = `odmget -q group=$RgsByApp[$r] HACMPgroup | grep startup_pref`;
            if($RgsByApp[$h][0] ne "NONE"){
		for($r = 0; $RgsByApp[$h][$r]; $r++) {
                    my $startupPref = `$HACMPBASE/utilities/clgetgrp -cg $RgsByApp[$h][$r] | tail -1 | cut -f5 -d:`;
                    chomp $startupPref;
                    # If it's not a concurrent rg ...
                    if( $startupPref ne "OAAN" ){
                        $falloverNodesOfApps[$h][$r] = &fallover_node_for_app_of_rg($apps[$h],$RgsByApp[$h][$r]);
		    }
                }
            }

	    for(my $h2 = 0; $h2 <= $#serviceIpLabelsOfApps; $h2++) {
	  	for($r = 0; $serviceIpLabelsOfApps[$h][$r][0] ; $r++){
          	    for($c = 0; $serviceIpLabelsOfApps[$h][$r][$c]; $c++){
                        $serviceIpStates[$h2][$r][$c] = &state_of_service_label($serviceIpLabelsOfApps[$h2][$r][$c]);
                    }
		}
	    }
        } # /for

        return 0;
    }
    return 1; # No probe done because cluster services are not active
}

#Since this is a Perl module, '1;' must be the last statement
1;
