#!/usr/bin/perl -wI/usr/es/sbin/cluster/conversion -I/usr/sbin/cluster/conversion
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 1999,2005 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# @(#)67	1.9 src/43haes/usr/sbin/cluster/clconvert/cl_odmmanMAIN.pm.sh, hacmp.conversion, 52haes_r540, r5400622c 2/20/04 10:58:11
#####################################################################
# cl_odmman_MAIN.pm
#
# PURPOSE: to parse the ODM manipulator script
#
# INPUTS:  this is a module...each subroutine has inputs
# RETURNS: same
#####################################################################			

	############################
	#   INCLUDES               #
	############################
use cl_odmmanMANIP;
use cl_odmmanIO;
use cl_odmmanPROCESS;


# International message number = 13

	############################
	#   GLOBALS
	############################
# GLOBALS
# Note that to reference these in other modules, you must
# say "$::var" instead of "$var". - L. Mayhew

# Log file info
$LOG_FILE = "/tmp/clconvert.log";
$TMP_FILE = "/tmp/clconvert_tmp_file";

# %ODMs will store all the read in ODM's.  When the ODM
# manager sees it must operate on an ODM, it will first see
# if the ODM has been read in by checking %ODMs.  If it
# has been read in, it operates on the one in %ODMs.  Otherwise
# it will read in the ODM and put it in %ODMs

%ODM = ();

# Used for sorting classes
# set this variable before doing a sort

@SORT_FIELDS = ();
@HOW_SORT    = ();
@DIR_SORT    = ();
$ODM_NAME    = "";

# The current line number read in from the conversion file

$LINE_NUMBER = 0;

# If an odm is actually changed by running this script, set
$ODMwasChanged = 0;

# DEBUGGING STUFF
# These are the constants to turn on debug information
# for a particular function
# $DEBUG_all = 0;

$DEBUG_IOreadODMstanzas  = 0;
$DEBUG_IOgetODMdefAsHash = 0;
$DEBUG_IOgetODMdefAsList = 0;
$DEBUG_IOwriteODMstanzas = 0;
$DEBUG_IOreadODMstanzas  = 0;
$DEBUG_IOreadODMstanzasGlobal  = 0;
$DEBUG_IOwriteODMstanzasGlobal = 0;

$DEBUG_MANIPstanzaExists  = 0;
$DEBUG_MANIPinsertStanzas = 0;
$DEBUG_MANIPdeleteStanzas = 0;
$DEBUG_MANIPupdateStanzas = 0;
$DEBUG_MANIPautoStanzas   = 0;
$DEBUG_MANIPsortStanzas   = 0;
$DEBUG_MANIPcustom        = 1;
$DEBUG_MANIPfindMax       = 0;
$DEBUG_MANIPinsertStanzasWithFields = 0;
$DEBUG_MANIPcopyStanzasWithFields   = 0;

$DEBUG_PROCESSInsert = 0;
$DEBUG_PROCESSSort   = 0;
$DEBUG_PROCESSDelete = 0;
$DEBUG_PROCESSCustom = 0;
$DEBUG_PROCESSCommit = 1;
$DEBUG_PROCESSUpdate = 0;
$DEBUG_PROCESSAuto   = 0;
$DEBUG_PROCESSCopyAsNew      = 0;
$DEBUG_PROCESSCopyAsExisting = 0;

$DEBUG_PARSEgetFields     = 0;
$DEBUG_PARSEgetValues     = 0;
$DEBUG_PARSEgetFieldValid = 0;
$DEBUG_PARSEgetFieldValuePairs = 0;

$DEBUG_PARSEInsert    = 0;
$DEBUG_PARSECopy      = 0;
$DEBUG_PARSESort      = 0;
$DEBUG_PARSEUpdate    = 0;
$DEBUG_PARSEDelete    = 0;
$DEBUG_PARSEAuto      = 0;
$DEBUG_PARSECustom    = 0;
$DEBUG_PARSECommit    = 0;

$DEBUG_PARSEStatement = 0;
$DEBUG_GetStatement   = 0;

$DEBUG_MAIN           = 0;

# These 2 global variables control debug output
# if DEBUG is set to 0, debugging is off.  The
# DEBUG_LEVEL can be set to a constant above to limit
# debugging to a certain function. 

$DEBUG = 0;        # 0 = debugging off
$DEBUG_LEVEL = 1;  # 0 = print everything

#####################################################################
# DEBUG_PRINT
# Purpose:
#     To print when debugging is enabled.  This means that the global
#     DEBUG variable is not 0.
# Input:
#     printStatement - The string to print
#     debugLevel - A number that corresponds to the DEBUG_LEVEL global
#                  variable.  If this matches DEBUG_LEVEL, then the
#                  statement will print. Rewritten such that if the
#                  debugLevel is set to print, else not. 
# Returns:
sub DEBUG_PRINT
{
    my($printStatement, $debugLevel) = @_;

    # the DEBUG_LEVEL lets you filter debug statements
    if ( ($DEBUG) && 
	 (($DEBUG_LEVEL == $debugLevel) || ($DEBUG_LEVEL == 0)))
    {
        print $printStatement;
    }
}
#####################################################################
# DEBUG_PRINT_ODMs
# Purpose:
#	To print out the $ODMs stanzas
# Input:
#	none
# Returns:
#	none
sub DEBUG_PRINT_ODMs 
{
     my ($ODMname)=@_;
     my $ODMstanzas;
     my $href;
     my $role;

     print "Current ODMs: \n";


	$ODMstanzas = $ODM{$ODMname};

     	for $href (@{$ODMstanzas})
	{
	     print "{\n";
	     for $role (keys (%{$href})) 
	     {
		print "\t$role=$href->{$role}\n";
	     }
	     print "}\n";
	}
}

#############################################################
# PARSEGetStatement 
# Purpose:
#	To divide a $Line by the semicolon, used as
#	a delimeter between commands.
#	Rules:
#	1. The $Line should contain from the beginning
#	of the current command through the semicolon
#	in question, and possibly containing part of
#	another command.
#	2. If the semicolon is contained within a set of
#	double quotes, it is ignored.
#	3. If a double quote has a backslash before it
#	(\"), it is not counted as a quote.
# 
# Input:
#	Line - line to be broken up into two commands
#
# Returns:
#	Error - 0 = none
#               1 = no legit semicolon encountered 
#	ThisCommand - string with the first command in it
#	NextCommand - string with the remaining chars in it
#
sub PARSEGetStatement
{
    my ($Line) = @_;

   DEBUG_PRINT( "GET_STATEMENT: Line is [${Line}]\n",
	$DEBUG_GetStatement );

    my @Chars = ();

    # Note: The array gets joined into the string.
    my @NextCommand = ();
    my $NextCommand = "";
 
    my @ThisCommand = ();
    my $ThisCommand = "";

    my $FoundSemiColon = 0;
    my $OddQuote       = 0;
    my $ThisChar       = "";
    my $PrevChar       = "";
    my $Error          = 0;


    @Chars = split //, $Line;

    foreach $ThisChar (@Chars)
    {

       if ($FoundSemiColon)
       {
           @NextCommand = (@NextCommand, $ThisChar);

       }else{
  
           @ThisCommand = (@ThisCommand, $ThisChar);

           if (($ThisChar eq ";") && (!$OddQuote))
           {
	       $FoundSemiColon = 1;
	       pop(@ThisCommand);  ## Dont include ';'

           }elsif (($ThisChar eq "\"") && ($PrevChar ne "\\")) {
	
	       if ($OddQuote) {$OddQuote = 0;}  #Toggle
               else           {$OddQuote = 1;}
           }

       }#end if $FoundSemiColon

       $PrevChar = $ThisChar;


    }#end foreach

    if (!$FoundSemiColon) 
    {
        $Error = 1;
        $ThisCommand = $Line;
        $NextCommand = "";
    }else{
        $ThisCommand = join '', @ThisCommand;
        $NextCommand = join '', @NextCommand;
    }

    DEBUG_PRINT ("\tError: $Error\n", $DEBUG_GetStatement );
    DEBUG_PRINT ("\tThis Command = [${ThisCommand}]\n",
	$DEBUG_GetStatement);
    DEBUG_PRINT ("\tNext Command = [${NextCommand}]\n",
	$DEBUG_GetStatement);

    return ($Error, $ThisCommand, $NextCommand);

}#end PARSEGetStatement
#####################################################################
# USER_PRINT
# Purpose:
#     To print output to the screen
# Input:
#     printStatement - The string to print to standard output
# Returns:
#     none
sub USER_PRINT
{
    my($msgNum, $printStatement, $params) = @_;
  
    print $printStatement;
}

#####################################################################
# LOG_PRINT
# Purpose:
#     To print output messages to a log
# Input:
#     printStatement - The string to print to standard output
# Returns:
#     none
sub LOG_PRINT
{
    my($msgNum, $printStatement, $param) = @_;

    open(LOG,">>$LOG_FILE"); 
    print LOG $printStatement;
    close (LOG);
}


#####################################################################
# ODMmanager PARSER >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#####################################################################
# PARSEgetFieldValid 
# Purpose:
#     To determine if the specified field list is valid for
#     the specified ODM
# Input:
#     ODMname - ODM to check validity of
#     UseList - 1 given list of fields
#               0 given hash of field/value pairs
#     FieldList - list (or hash) of fields to check 
# Returns:
#     1 if fields not valid or error
#     0 if fields are valid 
sub PARSEgetFieldValid
{
    my ($ODMname, $UseList, $FieldList) = @_;
    my @ValidFields = ();
    my $error = 0;
    my ($Fld, $ValidFld);
    my $FieldOK = 0;

    DEBUG_PRINT("PARSEgetFieldValid\n", $DEBUG_PARSEgetFieldValid);

    DEBUG_PRINT("\t$ODMname, $UseList\n",$DEBUG_PARSEgetFieldValid);
 
    ####################
    # Get Valid fields #
    ####################
    (@ValidFields) = cl_odmmanIO::IOgetODMdefAsList($ODMname);   
    
    ####################
    # Use List Version #
    ####################
    if ($UseList)
    {

        #####################
        # Test for validity #
        #####################
        foreach $Fld (@{$FieldList})
        {
            $FieldOK = 0;
	    foreach $ValidFld (@ValidFields)
	    {
	        if ($Fld eq $ValidFld) {$FieldOK = 1;}
	    }

	    if (!$FieldOK)
	    {
		LOG_PRINT (1, "ERROR: Invalid field in line $LINE_NUMBER\n",
		    "$LINE_NUMBER");
	        return 1;
	    }
        }# end for each field
    }else{

        ####################
        # Use Hash Version #
        ####################

	#####################
        # Test for validity #
        #####################
        foreach $Fld (keys (%{$FieldList}) )
        {
            $FieldOK = 0;
	    foreach $ValidFld (@ValidFields)
	    {
	        if ($Fld eq $ValidFld){$FieldOK = 1;} 

		DEBUG_PRINT("\t$Fld = $ValidFld?\n",
			$DEBUG_PARSEgetFieldValid);
	    }

	    if (!$FieldOK)
	    {
	        LOG_PRINT (1, "ERROR: Invalid field in line $LINE_NUMBER\n",
		    "$LINE_NUMBER");
	        return 1;
	    }
        }# end for each field


    }# end if uselist

    DEBUG_PRINT("End PARSEgetFieldValid\n", $DEBUG_PARSEgetFieldValid);

    return 0;

}# End PARSEgetFieldValid

#####################################################################
# PARSEgetFields 
# Purpose:
#     To search through a string to find all the words separated by a 
#     space. Each of these will be classified as a field.  This 
#     function will continue to search until a ) is found, or a
#     syntax error is detected.
# Input:
#     statement - The string to search for fields in
# Returns:
#     error - 1 if an error was detected, otherwise 0
#     statement - The remaining piece of the input statement after the
#                  ) is found 
#     fields - A list of the fields found  
sub PARSEgetFields
{
    my ($statement) = @_;
    my @fields = ();
    my $error = 0;
    my $Field;
    my $i;
    my $j;

    DEBUG_PRINT("PARSEgetFields\n", $DEBUG_PARSEgetFields);
 
    ##############
    # Get fields #
    ##############
    my $gettingFields = 1;
    while ($gettingFields)
    {
	##################
        # get next field #
	##################
        if ($statement =~ /^\s*?(\w+)(.*)/)
        {
           DEBUG_PRINT("\tGot field '$1', and $2\n", 
		$DEBUG_PARSEgetFields);
            @fields = (@fields, $1);
            $statement = $2;
        }else{
            $error = 1;
            LOG_PRINT  (1, "ERROR: syntax error found parsing fields, 
possibly missing ) at line $LINE_NUMBER\n", "$LINE_NUMBER");
            return 1;
        }
        ###################### 
        # right parethesis ? #
	######################
        if ($statement =~ /^\s*?\)(.*)/)
        {
            DEBUG_PRINT("\tGot right paren and '$1'\n", 
		$DEBUG_PARSEgetFields);
            $statement = $1;
            $gettingFields = 0;
        }
    } 
    ###############
    # duplicates? #
    ###############
    for ($i=0; $i < $#fields; $i++)
    {
	for ($j=$i+1; $j <= $#fields; $j++)
	{
	    if ($fields[$i] eq $fields[$j])
	    {

            LOG_PRINT  (1, "ERROR: Duplicate field at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
            return 1;
	
	    }
	}
    }

    DEBUG_PRINT("End PARSEgetFields\n", $DEBUG_PARSEgetFields);

    return ($error, $statement, \@fields);

}# End PARSEgetFields

#####################################################################
# PARSEgetValues
# Purpose:
#	To search through a string for the second occurance of '"'.
#	If a '\' preceeds it, contine to the next until you get
#	a '"' without a '\'. Note that this subroutine assumes
#	the first quote is present.
# Input:
#	statement - string to search for fields in
# Returns:
#	error - 1 if an error detected, 0 else
#       statement - the remaining piece of the input statement
#		after the final '"' is found
#	value - the value between the actual quotes
#
sub PARSEgetValues
{
    my ($statement) = @_;
    my $value       = "";
    my $error       = 0;
    my $TmpValue    = "";
    my $TmpContinue = "";
    my $GettingValue = 1;

    DEBUG_PRINT("PARSEgetValues\n",$DEBUG_PARSEgetValues);
 
    ########################
    # Check for open quote #
    ########################      
    if ($statement =~ /^\s*?"(.*)/)
    {
    	DEBUG_PRINT("\tFound open quote and '$1'\n", 
		$DEBUG_PARSEgetValues);

	$TmpContinue = $1;
	$TmpValue = "";

	#########################################
	# For each quote, if preceeded by '\' 	#
	# continue, else you are done		#
	#########################################
	while($GettingValue)
	{
	    if ($TmpContinue =~ /^(.*?)"(.*)/)
	    {
	    	$TmpValue = $TmpValue.$1;
		$TmpContinue = $2;

	        if ($TmpValue =~ /\\$/)  # the " is actually a '\"'
	        {
		    $TmpValue = $TmpValue . "\"".$1;
		    DEBUG_PRINT("\tNow got '$TmpValue' and '$TmpContinue'\n",
			$DEBUG_PARSEgetValues);

  	         }else{
		    $GettingValue = 0;
 	         }
	     }else{
		$GettingValue = 0;
	     }#end if still finding quotes
	}#end while	

    }else{
	LOG_PRINT (1,"ERROR: Expecting \" in line $LINE_NUMBER\n",
		"$LINE_NUMBER");
	return 1;
    }# end if open quote
       
    $value     = $TmpValue;
    $statement = $TmpContinue;

    DEBUG_PRINT("\tVALUE='$value', STATEMENT='$statement'\n",
	$DEBUG_PARSEgetValues);
    
    DEBUG_PRINT("End PARSEgetValues\n", $DEBUG_PARSEgetValues);

 
    return ($error, $value, $statement);


}#end PARSEgetValues
#####################################################################
# PARSEgetFieldValuePairs
# Purpose:
#     To search through a string to find all field="xxxxx" strings.
#     Each field found will be used as the key into the returned be
#     used as a key in the returned fields hash table.  The "xxxxx" 
#     will be the value stored in the hash table for each key.  This
#     function will continue to search until a ) is found, or a
#     syntax error is detected.
# Input:
#     statement - The string to search for fields in
# Returns:
#     error - 1 if an error was detected, otherwise 0
#     statement - The remaining piece of the input statement after the
#                  ) is found 
#     fields - A hash table of all field, value pairs found as 
#                  described above in the Purpose
sub PARSEgetFieldValuePairs
{
    my ($statement) = @_;
    my %fields = ();
    my $error = 0;
    my $TmpValue;
    my $TmpField;
    my $TmpContinue;
    my $Dink = 0;
    my $i;
    my $j;
    my @keyslist;

    DEBUG_PRINT("PARSEgetFieldValuePairs:\n",$DEBUG_PARSEgetFieldValuePairs);
 
    #########################   
    # Get fields and values #
    #########################
    my $gettingFields = 1;
    while ($gettingFields)
    {
	#############
 	# Get field #
	#############
	if ($statement =~ /^\s*?(\w+)?\s*?=(.*)/)
	{
	    DEBUG_PRINT("\tGot field '$1', and '$2'\n",
		$DEBUG_PARSEgetFieldValuePairs);
	    
	    if ($1 eq "")
            {
		LOG_PRINT ( 2, "ERROR: syntax error found...missing field at 
line $LINE_NUMBER\n","$LINE_NUMBER");
		return 1;
	    }
	    $TmpField  = $1;
	    $statement = $2;

	    #############
 	    # Get value #
	    #############
	    ($error,$TmpValue,$statement) = 
		PARSEgetValues($statement);
	   
	     if($error)
	     {
		return 1;
	     }else{
		DEBUG_PRINT("\tVALUE is '$TmpValue'\n",
			$DEBUG_PARSEgetFieldValuePairs);
		
		if (exists $fields{$TmpField})
		{
		     LOG_PRINT (1,"ERROR: duplicate field name in line
$LINE_NUMBER\n","$LINE_NUMBER");
		     return 1;
		}else{
		     $fields{$TmpField} = $TmpValue;
		}
	     }
         }else{
             $error = 1;
             LOG_PRINT  (2, "ERROR: syntax error found parsing 
field=\"value\" pairs, possibly missing ) or \" or qutoes around 
numeric values or non-alphanumeric characters in field at line 
$LINE_NUMBER\n", "$LINE_NUMBER");
            return 1;
         }

        ###################### 
        # right parethesis ? #
	######################
        if ($statement =~ /^\s*?\)(.*)/)
        {
            DEBUG_PRINT("\tGot right paren and '$1'\n", 
		$DEBUG_PARSEgetFieldValuePairs);
            $statement = $1;
            $gettingFields = 0;
        }
    }# end while 
    
    DEBUG_PRINT("End PARSEgetFieldValuePairs\n",
	$DEBUG_PARSEgetFieldValuePairs);   

    return ($error, $statement, \%fields);

} # End PARSEgetFieldValuePairs

#####################################################################
# PARSEInsert
# Purpose:
#     To parse an insert ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		insert)
#     form - (see note at top)
#		insert <ODM_name> values ( {<field>="<value>"} )
#			[auto ( {<field>} )] [unique];
#     user supplies:
#		ODM_name
#		field, value pairs to be inserted
#		field to do auto on (optional)
# Returns:
#     1 - error
#     0 - success 
sub PARSEInsert
{
    my ($statement) = @_;
    my $ODMname;
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %fieldValues = ();
    my $autoField;
    my $afield;
    my $fvfield;

    DEBUG_PRINT("PARSEInsert: Doing an insert...\n", $DEBUG_PARSEInsert);
    
    ################
    #  Get the ODM #
    ################ 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", $DEBUG_PARSEInsert);
        $ODMname = $1;
        $statement = $2;     
    }
    else
    {
        LOG_PRINT  (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ####################
    # Get values token # 
    ####################
    if ($statement =~ /^\s*?\bvalues\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot values and '$1'\n", $DEBUG_PARSEInsert);
        $statement = $1;
    }
    else
    {
        LOG_PRINT  (4, "ERROR: \"values\" expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ##############
    # Do unique? #
    ##############
   # if ($statement =~ /^\s*?\bunique\b(.*)/i)
   # {
   #     DEBUG_PRINT ("\tDoing a unique insert and '$1'\n", $DEBUG_PARSEInsert);
   #     $unique = 1;
   #     $statement = $1;
   # }

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSEInsert);
        $statement = $1;
    }
    else
    {
        LOG_PRINT  (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
  
    ###################################
    # Get fields and values to insert #
    ###################################
    ($error, $statement, $fieldValues)  = PARSEgetFieldValuePairs($statement);
    if ($error) {return 1};

    ###########
    # >>DEBUG #
    ###########
    if ($DEBUG)
    {
        foreach $key (keys %{$fieldValues})
        {
           DEBUG_PRINT ("\tFIELD='$key' VALUE='$fieldValues->{$key}'\n", 
		$DEBUG_PARSEInsert);
        }
    }
    ###########
    # <<DEBUG #
    ###########

    #########
    # auto? #
    ######### 
    if ($statement =~ /^\s*?auto(.*)/i)
    {
        DEBUG_PRINT ("\tDoing an autogen on some fields and '$1'\n", 
		$DEBUG_PARSEInsert);
        $auto = 1;
        $statement = $1;

        # Lets get the fields we are autogenerating
        # First, we should have a left parenthesis
        if ($statement =~ /^\s*?\((.*)/)
        {
            DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSEInsert);
            $statement = $1;
        }
        else
        {
            LOG_PRINT  (8, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
            return 1;
        }
       
        # Get the fields
        ($error, $statement, $autoFields)  = PARSEgetFields($statement);
        if ($error) {return 1;}

        #>>DEBUG
        if ($DEBUG)
        {
            foreach $item (@{$autoFields})
            {
                DEBUG_PRINT ("\tFIELD='$item'\n", $DEBUG_PARSEInsert);
            }
        }
        #<<DEBUG

     } #end if auto 

     ###########
     # unique? #
     ###########
     if ($statement =~ /^\s*?unique(.*)/i )
     {
         DEBUG_PRINT ("\tGot unique and '$1'\n",
	     $DEBUG_PARSEInsert);
         $unique = 1;
         $statement = $1;

         if ($auto && $unique)
         {
               LOG_PRINT  (9, "ERROR: \"auto\" can not be used with 
\"unique\" at line $LINE_NUMBER\n",
		      "$LINE_NUMBER"); 
	       return 1;
         }
     }# end if unique

    
     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
   {
         LOG_PRINT  (9, "ERROR: unexpected syntax '$1' at line 
$LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 


    #########################################
     # auto field same as field/value field? #
     #########################################
    foreach $afield  (@{$autoFields})
    {
	foreach $fvfield (keys %{$fieldValues})
	{
	     if ($afield eq $fvfield)
	     {
		LOG_PRINT(1,"ERROR: A field from the field/value pair 
was duplicated in the auto field list at line $LINE_NUMBER\n",
		"$LINE_NUMBER");
		return 1;
	     }
	}	

    }

  
    ############################
    # process parsed statement #
    ############################
    DEBUG_PRINT("Doing an insert...\n", $DEBUG_PARSEInsert);

    $error =cl_odmmanPROCESS::PROCESSInsert($ODMname, $unique, $auto, 
	\%{$fieldValues}, 
	\@{$autoFields});

    return $error;

}# End PARSEInsert

## PARSECopy #################################################
# Purpose:
#     To parse a copy ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"copy")
#     form - (see note at top)
#     syntax 1:
#		copy <source_ODM_name> ( {<source_field>} )
#			[where ( {<source_field> = "<value>"} ) ]
#			to <target_ODM_name> ( {<target_field>} )
#			as new [with values ( {<target_field>="<value>"} )
#			[auto ( {<field>} )]] [unique];
#     syntax 2:
#		copy <source_ODM_name> ( {<source_field>} )
#			[where ( {<source_field> = "<value>"} ) ]
#			to <target_ODM_name> ( {<target_field>} )
#			as existing where ( {<source_field>=
#			<target_field>} )
#			[static ( {<field> = "<value>"} )] [unique];
#     user supplies:
#		ODM_name
#		field, value pairs to be inserted
#		field to do auto on (optional)
# Returns:
#     1 - error
#     0 - success 
sub PARSECopy
{
    my ($statement) = @_;
    my $SourceODM;
    my $TargetODM;
    my $unique = 0;
    my $auto = 0;
    my $error = 0;
    my %SourceFieldValues = ();
    my $autoFields;
    my $SourceFields;
    my $TargetFields;
    my $Where = 0;
    my $static = 0;
    my $WhereFieldValues;
    my %TargetFieldFields;
    my $New = 0;
    my $Existing = 0;
    my $With = 1;
    my $WithFieldValues;
    my $StaticFieldValues;
    my $GettingFields = 0;
    my %FieldField;
    my %EmptyHash  = ();
    my %EmptyHash1 = ();
    my %EmptyHash2 = ();
    my @EmptyArray = ();

    $WhereFieldValues  = %EmptyHash;
    $WithFieldValues   = %EmptyHash1;
    $StaticFieldValues = %EmptyHash2;
    $autoFields        = @EmptyArray;

    DEBUG_PRINT("PARSECopy: Doing a copy...\n", $DEBUG_PARSECopy);
    
    #######################
    #  Get the Source ODM #
    ####################### 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot Source ODM '$1' and '$2'\n", 
		$DEBUG_PARSECopy);
        $SourceODM = $1;
        $statement = $2;     
     }else{
        LOG_PRINT  (3, "ERROR: Source ODM name expected at line 
$LINE_NUMBER\n",
		 "$LINE_NUMBER");
        return 1;
     }

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECopy);
        $statement = $1;
     }else{
        LOG_PRINT  (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }
 
    #####################
    # Get Source fields #
    #####################
    ($error, $statement, $SourceFields)  = PARSEgetFields($statement);
    if ($error) {return 1;}

    ##########
    # where? #
    ########## 
    if ($statement =~ /^\s*?\bwhere\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot \"where\" and '$1'\n", 
		$DEBUG_PARSECopy);
        $Where = 1;
        $statement = $1;

        ########################
        # Get left parenthesis #
        ########################
        if ($statement =~ /^\s*?\((.*)/)
        {
             DEBUG_PRINT ("\tGot left paren and '$1'\n", 
		$DEBUG_PARSECopy);
             $statement = $1;
        }else{
             LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
             return 1;
        }

        ###################################
        # Get fields and values to insert #
        ###################################
        ($error, $statement, $WhereFieldValues)  = 
		PARSEgetFieldValuePairs($statement);
        if ($error) {return 1};

        foreach $key (keys %{$WhereFieldValues})
        {
           DEBUG_PRINT ("\tFIELD='$key' VALUE='$WhereFieldValues->{$key}'\n", 
		$DEBUG_PARSECopy);
        }
     } # End if match "where
     else{ DEBUG_PRINT("\t no \"where\" found\n",$DEBUG_PARSECopy);}

 
    ##################
    # Get "to" token # 
    ##################
    if ($statement =~ /^\s*?\bto\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot \"to\" and '$1'\n", $DEBUG_PARSECopy);
        $statement = $1;
     }else{
        LOG_PRINT (4, "ERROR: \"to\" (or possibly \"where\") expected at 
line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }


     ##################
     # Get Target ODM #
     ##################
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot Target ODM '$1' and '$2'\n", 
		$DEBUG_PARSECopy);
        $TargetODM = $1;
        $statement = $2;     
     }else{
        LOG_PRINT (3, "ERROR: Source ODM name expected at line 
$LINE_NUMBER\n",
		 "$LINE_NUMBER");
        return 1;
     }

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECopy);
        $statement = $1;
     }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }
       
    #####################
    # Get Target fields #
    #####################
    ($error, $statement, $TargetFields)  = PARSEgetFields($statement);
    if ($error) {return 1;}
 
    DEBUG_PRINT("\tTarget FIELDS:\n",$DEBUG_PARSECopy);

    foreach $Fld (@{$TargetFields})
    {
	DEBUG_PRINT ("\t$Fld\n",$DEBUG_PARSECopy);
    }

    DEBUG_PRINT ("\t Source Fields = $#{$SourceFields}\n",
		$DEBUG_PARSECopy);
    DEBUG_PRINT ("\t Target Fields = $#{$TargetFields}\n",
		$DEBUG_PARSECopy);
    if( $#{$SourceFields} != $#{$TargetFields} )
    {
	LOG_PRINT (1, "ERROR: Number of source and target fields must be 
equal at line $LINE_NUMBER\n", "$LINE_NUMBER");
	return 1;
    }

    ##################
    # Get "as" token # 
    ##################
    if ($statement =~ /^\s*?\bas\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot \"as\" and '$1'\n", $DEBUG_PARSECopy);
        $statement = $1;
     }else{
        LOG_PRINT (4, "ERROR: \"as\" expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }

    #################################
    # Get "new" or "existing" token # 
    #################################
    ########
    # New? #
    ########
    if ($statement =~ /^\s*?\bnew\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot \"new\" and '$1'\n", $DEBUG_PARSECopy);
        $statement = $1;
        $New = 1;
    
     	#########
   	# with? # 
    	#########
        if ($statement =~ /^\s*?\bwith\b(.*)/i)
        {
              DEBUG_PRINT ("\tGot \"with\" and '$1'\n", $DEBUG_PARSECopy);
              $statement = $1;
	      $With = 1;
    
	      ######################
    	      # Get "values" token # 
    	      ######################
              if ($statement =~ /^\s*?\bvalues\b(.*)/i)
              {
              	  DEBUG_PRINT ("\tGot \"values\" and '$1'\n", 
			$DEBUG_PARSECopy);
		  $statement = $1;
	       }else{
        	    LOG_PRINT (4, "ERROR: \"values\" expected at line 
$LINE_NUMBER\n", 
			"$LINE_NUMBER");
        	    return 1;
               }
	
    	      ########################
    	      # Get left parenthesis #
    	      ########################
    	      if ($statement =~ /^\s*?\((.*)/)
              {
        	 DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECopy);
        	 $statement = $1;
     	      }else{
        	  LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
			"$LINE_NUMBER");
        	  return 1;
     	      }
       
               	#########################
        	# Get fields and values #
        	#########################
        	($error, $statement, $WithFieldValues)  = 
			PARSEgetFieldValuePairs($statement);
        	if ($error) {return 1};

        	foreach $key (keys (%{$WithFieldValues}))
        	{
           		DEBUG_PRINT ("\t'$key'='$WithFieldValues->{$key}'\n", 
			$DEBUG_PARSECopy);
		}
	   } # end if with

           #########
           # auto? #
           ######### 
           if ($statement =~ /^\s*?auto(.*)/i)
           {
                DEBUG_PRINT ("\tDoing an autogen on some fields and '$1'\n", 
			$DEBUG_PARSECopy);
        	$auto = 1;
        	$statement = $1;

        	# Lets get the fields we are autogenerating
        	# First, we should have a left parenthesis
        	if ($statement =~ /^\s*?\((.*)/)
        	{
            	     DEBUG_PRINT ("\tGot left paren and '$1'\n", 
			$DEBUG_PARSECopy);
            	     $statement = $1;
        	}else{
            	    LOG_PRINT (8, "ERROR: ( expected at line $LINE_NUMBER\n", 
			"$LINE_NUMBER");
            	     return 1;
        	}
       
        	##################
		# Get the fields #
		##################
        	($error, $statement, $autoFields)  = 
			PARSEgetFields($statement);
        	if ($error) {return 1;}

            	foreach $item (@{$autoFields})
            	{
                     DEBUG_PRINT ("\tFIELD='$item'\n", $DEBUG_PARSECopy);
            	}

    	    } #end if auto 


    #############
    # Existing? #
    #############
    }elsif ($statement =~ /^\s*?\bexisting\b(.*)/i) {
        
	DEBUG_PRINT ("\tGot \"existing\" and '$1'\n", $DEBUG_PARSECopy);
	$statement = $1;
	$Existing = 1;

        #####################
    	# Get "where" token # 
    	#####################
    	if ($statement =~ /^\s*?\bwhere\b(.*)/i)
    	{
            DEBUG_PRINT ("\tGot \"where\" and '$1'\n", $DEBUG_PARSECopy);
            $statement = $1;
     	}else{
            LOG_PRINT (4, "ERROR: \"where\" expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
            return 1;
     	}

    	########################
    	# Get left parenthesis #
    	########################
    	if ($statement =~ /^\s*?\((.*)/)
    	{
            DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECopy);
            $statement = $1;
     	}else{
            LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
            return 1;
     	}
       
	#####################################
	# Get SourceField-TargetField pairs #
	#####################################
	$GettingFields = 1;
	while ($GettingFields)
	{
	    # Get next pair
	    if ($statement =~ /^\s*?(\w+)?\s*?=\s*?(\w+)(.*)/)
	    {
	DEBUG_PRINT("\tGot Target Field '$1', Source Field '$2', and '$3'\n",
			$DEBUG_PARSECopy);
		if (($1 eq"")||($2 eq ""))
		{
		     LOG_PRINT(2, "ERROR: syntax error found...
missing field at line $LINE_NUMBER\n", "$LINE_NUMBER");
		     return 1;
		}

		$TargetFieldFields{$1} = $2;
		$statement = $3;
	    }else{
		LOG_PRINT(2, "ERROR: syntax error found parsing source 
field-target field pairs, possibly missing ) or included \" around field 
at line $LINE_NUMBER\n",
			"$LINE_NUMBER");
		return 1;
	    }


	    ######################
	    # See if right paren #
	    ######################
	    if ($statement =~ /^\s*?\)(.*)/)
	    {
		DEBUG_PRINT ("\tGot right paren and '$1'\n",
			$DEBUG_PARSECopy);
		$statement = $1;
		$GettingFields = 0;
	    }
	}# end while
     	

	###########
   	# static? # 
    	###########
        if ($statement =~ /^\s*?\bstatic\b(.*)/i)
        {
            DEBUG_PRINT ("\tGot \"static\" and '$1'\n", $DEBUG_PARSECopy);
            $statement = $1;
	    $static = 1;
   	      
    	    ########################
    	    # Get left parenthesis #
    	    ########################
    	    if ($statement =~ /^\s*?\((.*)/)
    	    {
            	DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECopy);
            	$statement = $1;
     	    }else{
            	LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
			"$LINE_NUMBER");
            	return 1;
     	    }
       
       	    #########################
       	    # Get fields and values #
       	    #########################
       	    ($error, $statement, $StaticFieldValues)  = 
		PARSEgetFieldValuePairs($statement);
       	    if ($error) {return 1};

       	    foreach $key (keys %{$StaticFieldValues})
       	    {
           	DEBUG_PRINT ("\tFIELD='$key' VALUE='$StaticFieldValues->{$key}'\n", 
			$DEBUG_PARSECopy);
	    }
        }#endif static

    ########################
    # Not new or Existing? #
    ########################
    }else{
        LOG_PRINT (4, "ERROR: \"new\" or \"existing\" expected at line 
$LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }

     ###########
     # unique? #
     ###########
     if ($statement =~ /^\s*?unique(.*)/i )
     {
         DEBUG_PRINT ("\tGot unique and '$1'\n",
	     $DEBUG_PARSECopy);
         $unique = 1;
         $statement = $1;

         if ($auto && $unique)
         {
               LOG_PRINT (9, "ERROR: \"auto\" can not be used with 
\"unique\" at line $LINE_NUMBER\n",
		      "$LINE_NUMBER"); 
	       return 1;
         }
     }# end if unique

     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
   {
        LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 

     ####################
     # what do we have? #
     ####################
     DEBUG_PRINT("\n\tODMs source, target: $SourceODM,$TargetODM\n",
	$DEBUG_PARSECopy);

     DEBUG_PRINT("\tSource field list\n",
	$DEBUG_PARSECopy);

     foreach $item (@{$SourceFields})
     {
	DEBUG_PRINT("\t\t$item\n",
	      $DEBUG_PARSECopy);
     }

     DEBUG_PRINT("\tTarget field list\n",
	$DEBUG_PARSECopy);

     foreach $item (@{$TargetFields})
     {
	DEBUG_PRINT("\t\t$item\n",
	      $DEBUG_PARSECopy);
     }

     DEBUG_PRINT("\tFLAGS: where, new, with, existing, auto, unique\n",
	$DEBUG_PARSECopy);

     DEBUG_PRINT("\tFLAGS: $Where, $New, $With, $Existing, $auto, $unique\n", 
	$DEBUG_PARSECopy);

     
     DEBUG_PRINT("\tauto fields:\n", 
	$DEBUG_PARSECopy);

     foreach $item (@{$autoFields})
     {
     	DEBUG_PRINT("\t\t$item\n", 
		$DEBUG_PARSECopy);
     }
     

     DEBUG_PRINT("\twhere field values:\n", 
	$DEBUG_PARSECopy);

     foreach $item (keys (%{$WhereFieldValues})) 
     {
     	DEBUG_PRINT("\t\t$item = $WhereFieldValues->{$item}\n", 
		$DEBUG_PARSECopy);
     }

     DEBUG_PRINT("\twith field values:\n", 
	$DEBUG_PARSECopy);

     foreach $item (keys (%{$WithFieldValues})) 
     {
     	DEBUG_PRINT("\t\t$item = $WithFieldValues->{$item}\n", 
		$DEBUG_PARSECopy);
     }

 
    ############################
    # process parsed statement #
    ############################
    # As New #
    ##########
     if ($New)
     {
     	$error = cl_odmmanPROCESS::PROCESSCopyAsNew ($SourceODM,
		$TargetODM, $Where, $With, $auto, $unique,
		\@{$SourceFields},\@{$TargetFields},
		\%{$WhereFieldValues},\%{$WithFieldValues},
		\@{$autoFields} );
	 if ($error) {return 1;}
     }

    ###############
    # As Existing #
    ###############
     if ($Existing)
     {
     	$error = cl_odmmanPROCESS::PROCESSCopyAsExisting ($SourceODM,
		$TargetODM, $Where, $static, $unique,
		\@{$SourceFields},\@{$TargetFields},
		\%{$WhereFieldValues},\%TargetFieldFields,
		\%{$StaticFieldValues} );
	 if ($error) {return 1;}
     }

    DEBUG_PRINT("Doing a copy...\n", $DEBUG_PARSECopy);
    return 0;

}# End PARSECopy

## PARSEDelete ###############################################
# Purpose:
#     To parse a delete ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"delete")
#     form - (see note at top)
#		delete <ODM_name> [where ( {<field>="<value>"} ) ];
#     user supplies:
#		ODM_name
#		field, value pairs to be identify stanza (optional) 
# Returns:
#     1 - error
#     0 - success 

sub PARSEDelete
{
    my ($statement) = @_;
    my $ODMname;
    my $where = 0;
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %fieldValues = ();
    my @autoFields = ();

    DEBUG_PRINT("PARSEDelete: Doing a delete...\n", $DEBUG_PARSEDelete);
    
    ################
    #  Get the ODM #
    ################ 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", $DEBUG_PARSEDelete);
        $ODMname = $1;
        $statement = $2;     
    }
    else
    {
        LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ####################
    # Get where token # 
    ####################
    if ($statement =~ /^\s*?\bwhere\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot where and '$1'\n", $DEBUG_PARSEDelete);
        $statement = $1;
	$where = 1;

        ########################
        # Get left parenthesis #
        ########################
        if ($statement =~ /^\s*?\((.*)/)
        {
             DEBUG_PRINT ("\tGot left paren and '$1'\n", 
		$DEBUG_PARSEDelete);
             $statement = $1;
        }else{
             LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
             return 1;
        }
  
        #########################
        # Get fields and values #
        #########################
        ($error, $statement, $fieldValues)  = 
		PARSEgetFieldValuePairs($statement);
        if ($error) {return 1};

        foreach $key (keys %{$fieldValues})
        {
           DEBUG_PRINT ("\tFIELD='$key' VALUE='$fieldValues->{$key}'\n", 
		$DEBUG_PARSEDelete);
        }

     }elsif ($ODMname =~ /^where$/)
     {
        LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }

     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
     {
        LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 

     DEBUG_PRINT( "\tODM is $ODMname, where = $where\n", $DEBUG_PARSEDelete);
     if ($where)
     {
        foreach $key (keys %{$fieldValues})
        {
           DEBUG_PRINT ("\tFIELD='$key' VALUE='$fieldValues->{$key}'\n", 
		$DEBUG_PARSEDelete);
        }
     }

 
    ############################
    # process parsed statement #
    ############################
    if (cl_odmmanPROCESS::PROCESSDelete($ODMname, $where, \%{$fieldValues}))
        {return 1;}
 
    DEBUG_PRINT("Doing the delete\n\n",$DEBUG_PARSEDelete);
    return 0;


}# End PARSEDelete

## PARSESort #################################################
# Purpose:
#     To parse a sort ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"sort")
#     form - (see note at top)
#		sort <ODM_name> by ( {<field>} )
#		( {\alpha|numeric|ascii\} ) ( {\ascending|descending\} );
#     user supplies:
#		ODM_name
#		field list to sort on
#		how to sort
#               ascending or descending
# Returns:
#     1 - error
#     0 - success 
sub PARSESort
{
    my ($statement) = @_;
    my $ODMname;
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %fieldValues = ();
    my @SortFields = ();
    my $DontDoThisYet = 1;
    my $NumOfSorts = 0;
    my $TmpNum = 0;
    my @HowSort = ();
    my @SortDir = ();
    my $How;
    my $Dir;
    my $Fld;
    my %Types;
    my $i;
    my $TmpField;
    my $TmpHow;
    my $GettingHowSort = 1;

    DEBUG_PRINT("PARSESort: Doing a sort...\n", $DEBUG_PARSESort);
    
    ################
    #  Get the ODM #
    ################ 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", $DEBUG_PARSESort);
        $ODMname = $1;
        $statement = $2;     
    }else{
        LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ##################
    # Get "by" token # 
    ##################
    if ($statement =~ /^\s*?\bby\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot by and '$1'\n", $DEBUG_PARSESort);
        $statement = $1;
    }else{
        if ($ODMname =~/^by$/)
        {
             LOG_PRINT (4, "ERROR: missing ODM name at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
	 }else{
             LOG_PRINT (4, "ERROR: \"by\" expected (problem may be non 
alphanumeric characters in ODM) at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        }
        return 1;
    }

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSESort);
        $statement = $1;
    }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
  
    #########################
    # Get fields to sort on #
    #########################
    ($error, $statement, $SortFields)  = PARSEgetFields($statement);
    if ($error) {return 1};

    foreach $item (@{$SortFields})
    {
	DEBUG_PRINT("\tFIELD='$item'\n", $DEBUG_PARSESort);
    }


    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSESort);
        $statement = $1;
    }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
  
    ###################
    # Get how to sort #
    ################### 
    $GettingHowSort = 1;
    while ($GettingHowSort)
    {

        # Get next how sort
        if ($statement =~ /^\s*?(\w+)(.*)/)
        {
	     DEBUG_PRINT("\tGot '$1', and $2\n",
		$DEBUG_PARSESort);
	     my $TmpHow = $1;
	     $statement = $2;
	     if ($TmpHow =~/alpha|ASCII|numeric/i)
	     {
	     	@HowSort = (@HowSort,$TmpHow);
	     }else{
	        LOG_PRINT (1, "ERROR: How to sort must be either 
'alpha', 'ASCII', or 'numeric' at line $LINE_NUMBER\n", "$LINE_NUMBER");
	        return 1;
	     }
    	}else{
	     $error = 1;
	     LOG_PRINT (1, "ERROR: syntax error found parsing how to 
sort, possibly missing ) at line $LINE_NUMBER\n", "$LINE_NUMBER");
	     return 1;
        }

	###### Look for right parenthesis
	if ($statement =~ /^\s*?\)(.*)/)
	{
	     DEBUG_PRINT ("\tGot right paren and '$1'\n",
		$DEBUG_PARSESort);
	     $statement = $1;
	     $GettingHowSort = 0;
	}
    }# End while
   

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSESort);
        $statement = $1;
    }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
    ######################
    # Get ascend/descend #
    ###################### 
    $GettingHowSort = 1;
    while ($GettingHowSort)
    {

        # Get next how sort
        if ($statement =~ /^\s*?(\w+)(.*)/)
        {
	     DEBUG_PRINT("\tGot '$1', and $2\n",
		$DEBUG_PARSESort);
	     $statement = $2;
	     my $TmpDir = $1;
             if ($TmpDir =~ /ascending|descending/i)
	     {
	          @SortDir = (@SortDir,$TmpDir);
	     }else{
	        LOG_PRINT (1, "ERROR: Direction to sort must be either 
'ascending' or 'descending' at line $LINE_NUMBER\n", "$LINE_NUMBER");
	        return 1;
             }
    	}else{
	     $error = 1;
	     LOG_PRINT (1, "ERROR: syntax error found parsing how to 
sort, possibly missing ) at line $LINE_NUMBER\n", "$LINE_NUMBER");
	     return 1;
	}

	###### Look for right parenthesis
	if ($statement =~ /^\s*?\)(.*)/)
	{
	     DEBUG_PRINT ("\tGot right paren and '$1'\n",
		$DEBUG_PARSESort);
	     $statement = $1;
	     $GettingHowSort = 0;
	}
    }# End while

    ####################### 
    # Some error checking #   
    #######################
    DEBUG_PRINT ("\tFields = $#{$SortFields},How = $#HowSort,Dir = $#SortDir\n",
	$DEBUG_PARSESort);
    DEBUG_PRINT ("\tFields:\n",$DEBUG_PARSESort);
    foreach $Fld (@{$SortFields})
    {
	DEBUG_PRINT("\t\t$Fld\n",$DEBUG_PARSESort);
    }
    
    DEBUG_PRINT ("\tHow:\n",$DEBUG_PARSESort);
    foreach $How (@HowSort)
    {
	DEBUG_PRINT("\t\t$How\n",$DEBUG_PARSESort);
    }

    DEBUG_PRINT ("\tDir:\n",$DEBUG_PARSESort);
    foreach $Dir (@SortDir)
    {
	DEBUG_PRINT("\t\t$Dir\n",$DEBUG_PARSESort);
    }

    if (($#HowSort != $#{$SortFields}) || ($#SortDir != $#{$SortFields}))
    {
	LOG_PRINT(1,"ERROR: syntax error. Number of ways or directions 
to sort does not match the number of fields to sort on in 
Line $LINE_NUMBER\n", "$LINE_NUMBER");
	$error = 1;
	return 1;
     }

     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
     {
         LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 

  
    ############################
    # process parsed statement #
    ############################
    if (cl_odmmanPROCESS::PROCESSSort($ODMname, $SortFields,
	\@HowSort, \@SortDir) )
	{return 1;}

    DEBUG_PRINT("Doing the sort\n\n",$DEBUG_PARSESort);
 

    return 0;


}# End PARSESort

## PARSEUpdate #################################################
# Purpose:
#     To parse an update ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"update")
#     form - (see note at top)
#		update <ODM_name> set ( {<field>="<value>"} )
#			[where ( {<field> = "<value>"} )] ;
#     user supplies:
#		ODM_name
#		field, value pairs to be updated 
#		field, value pairs to identify stanza
# Returns:
#     1 - error
#     0 - success 
sub PARSEUpdate
{
    my ($statement) = @_;
    my $ODMname;
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %SetFieldValues = ();
    my %WhereFieldValues = ();
    my @autoFields = ();
    my $Where = 0;

    DEBUG_PRINT("PARSEUpdate: Doing an update...\n", $DEBUG_PARSEUpdate);
    
    ################
    #  Get the ODM #
    ################ 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", $DEBUG_PARSEUpdate);
        $ODMname = $1;
        $statement = $2;     
    }else{
        LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ###################
    # Get "set" token # 
    ###################
    if ($statement =~ /^\s*?\bset\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot set and '$1'\n", $DEBUG_PARSEUpdate);
        $statement = $1;
    }elsif ($ODMname =~ /^set$/)
    {
        LOG_PRINT (4, "ERROR: missing ODM name at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }else{
        LOG_PRINT (4, "ERROR: \"set\" expected (or possible non 
alphanumeric characters in ODM at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSEUpdate);
        $statement = $1;
    }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
  
    ###################################
    # Get fields and values to insert #
    ###################################
    ($error, $statement, $SetFieldValues)  = 
		PARSEgetFieldValuePairs($statement);
    if ($error) {return 1};

    foreach $key (keys %{$SetFieldValues})
    {
        DEBUG_PRINT ("\tFIELD='$key' VALUE='$SetFieldValues->{$key}'\n", 
		$DEBUG_PARSEUpdate);
    }

    ##########
    # where? #
    ########## 
    if ($statement =~ /^\s*?\bwhere\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot \"where\" and '$1'\n", 
		$DEBUG_PARSEUpdate);
        $Where = 1;
        $statement = $1;

        ########################
        # Get left parenthesis #
        ########################
        if ($statement =~ /^\s*?\((.*)/)
        {
             DEBUG_PRINT ("\tGot left paren and '$1'\n", 
		$DEBUG_PARSEUpdate);
             $statement = $1;
        }else{
             LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
             return 1;
        }

        ###################################
        # Get fields and values to insert #
        ###################################
        ($error, $statement, $WhereFieldValues)  = 
		PARSEgetFieldValuePairs($statement);
        if ($error) {return 1};

        foreach $key (keys %{$WhereFieldValues})
        {
           DEBUG_PRINT ("\tFIELD='$key' VALUE='$WhereFieldValues->{$key}'\n", 
		$DEBUG_PARSEUpdate);
        }
     } # End if match "where
     else{ DEBUG_PRINT("\t no \"where\" found\n",$DEBUG_PARSEUpdate);}

     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
     {
        LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 

  
    ############################
    # process parsed statement #
    ############################
    if (cl_odmmanPROCESS::PROCESSUpdate($ODMname, $Where, 
	\%{$WhereFieldValues},\%{$SetFieldValues}))
        {return 1;}
    
    DEBUG_PRINT ("End PARSEUpdate\n", $DEBUG_PARSEUpdate);

    return 0;

}# End PARSEUpdate

## PARSEAuto #################################################
# Purpose:
#     To parse an auto ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"auto")
#     form - (see note at top)
#		auto <ODM_name> <field> [start "<value>"] [all];
#     user supplies:
#		ODM_name
#		field to auto generate on
#		start value (optional)
# Returns:
#     1 - error
#     0 - success 
sub PARSEAuto
{
    my ($statement) = @_;
    my $ODMname;
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %fieldValues = ();
    my @autoFields = ();
    my $Field = "";
    my $Value= "";
    my $Start = 0;
    my $All = 0;

    DEBUG_PRINT("PARSEAuto: Doing an auto...\n", $DEBUG_PARSEAuto);
    
    ################
    #  Get the ODM #
    ################ 
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
        DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", $DEBUG_PARSEAuto);
        $ODMname = $1;
        $statement = $2;     
    }else{
        LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }
   
    ##################
    # Get Field Name # 
    ##################
    if ($statement =~ /^\s*?(\w+)(.*)/)
    {
	DEBUG_PRINT ("\tGot Field '$1' and '$2'\n",
		$DEBUG_PARSEAuto);
	$Field = $1;
        $statement = $2;
     }else{
        LOG_PRINT (3, "ERROR: Field name expected (or possible non 
alphanumeric charaters in ODMname) at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
     }
   
     ##########
     # start? #
     ##########
     if ($statement =~ /^\s*?\bstart\b(.*)/i)
     {
	  DEBUG_PRINT("\tGot \"start\" and '$1'\n",
		$DEBUG_PARSEAuto);
	  $statement = $1;
	  $Start = 1;
          
          ###################
	  # Get start value #
	  ###################
	  ($error,$Value,$statement) = PARSEgetValues($statement);
	  
	  if (!$error)
	  {
		DEBUG_PRINT ("\tGot Value '$Value' and '$statement'\n",
			$DEBUG_PARSEAuto);
          }else{
                LOG_PRINT (3, "ERROR: Start value expected at line 
$LINE_NUMBER\n", 
		"$LINE_NUMBER");
                 return 1;
           }

     } # End start?

     ########
     # All? #
     ########
     if ($statement =~ /^\s*?\ball\b(.*)/i)
     {
	  DEBUG_PRINT("\tGot \"all\" and '$1'\n",
		$DEBUG_PARSEAuto);
	  $statement = $1;
	  $All = 1;
     }


     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
     {
	  if ($Field =~ /^start$/)
	  {
                LOG_PRINT (9, "ERROR: unexpected syntax '$statement' 
(possibly missing ODM name or field) at line $LINE_NUMBER\n",
		     "$LINE_NUMBER"); 
          }else{
                LOG_PRINT (9, "ERROR: unexpected syntax '$statement' 
(possibly missing ODM name or \"start\") at line $LINE_NUMBER\n",
		     "$LINE_NUMBER"); 
 	  }      
          return 1;
     } 

     DEBUG_PRINT("\tODM=$ODMname,FIELD=$Field",$DEBUG_PARSEAuto);
     if ($Start)
     {
	DEBUG_PRINT(",Start value='$Value'",$DEBUG_PARSEAuto);
     }
     if ($All)
     {
	DEBUG_PRINT(",All",$DEBUG_PARSEAuto);
     }
     DEBUG_PRINT("\n",$DEBUG_PARSEAuto);

 
    ############################
    # process parsed statement #
    ############################
    if (cl_odmmanPROCESS::PROCESSAuto($ODMname, $Start, $All,
	$Field, $Value) )
    	{return 1;}
    
    DEBUG_PRINT ("Doing auto...\n",$DEBUG_PARSEAuto);

    return 0;

}# End PARSEAuto

## PARSECustom #################################################
# Purpose:
#     To parse a custom ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"custom")
#     form - (see note at top)
#		custom ({<ODM_name>}) use <custom_script_name>;
#     user supplies:
#		ODM_name(s)
#		custom_script_name
# Returns:
#     1 - error
#     0 - success 
sub PARSECustom
{
    my ($statement) = @_;
    my @ODMnames = ();
    my $unique = 0;
    my $auto = 0;
    my $error;
    my %fieldValues = ();
    my @autoFields = ();
    my $GettingODMs = 0;
    my $CustomScriptName = "";
    my $TmpODM;   

    DEBUG_PRINT("PARSECustom: Doing a custom...\n", $DEBUG_PARSECustom);
    
    ########################
    # Get left parenthesis #
    ########################
    if ($statement =~ /^\s*?\((.*)/)
    {
        DEBUG_PRINT ("\tGot left paren and '$1'\n", $DEBUG_PARSECustom);
        $statement = $1;
    }else{
        LOG_PRINT (5, "ERROR: ( expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ################
    #  Get the ODM #
    ################ 
    $GettingODMs = 1;
    while ($GettingODMs)
    {

       if ($statement =~ /^\s*?(\w+)(.*)/)
       {
              DEBUG_PRINT ("\tGot ODM '$1' and '$2'\n", 
		   $DEBUG_PARSECustom);
	      @ODMnames = (@ODMnames,$1);
              $statement = $2;     
        }else{
             LOG_PRINT (3, "ERROR: ODM name expected at line $LINE_NUMBER\n", 
		   "$LINE_NUMBER");
              return 1;
        }

        #Look for right paren
        if ($statement =~ /^\s*?\)(.*)/)
	{
	     DEBUG_PRINT("\tGot right paren and '$1'\n",
		    $DEBUG_PARSECustom);
	     $statement = $1;
	     $GettingODMs = 0;
        }
    }#End while

    foreach $TmpODM (@ODMnames)
    {
	DEBUG_PRINT("\tODM = $TmpODM\n", $DEBUG_PARSECustom);
    }

    ###################
    # Get "use" token # 
    ###################
    if ($statement =~ /^\s*?\buse\b(.*)/i)
    {
        DEBUG_PRINT ("\tGot use and '$1'\n", $DEBUG_PARSECustom);
        $statement = $1;
    }else{
        LOG_PRINT (4, "ERROR: \"use\" expected at line $LINE_NUMBER\n", 
		"$LINE_NUMBER");
        return 1;
    }

    ##########################
    # Get Custom Script Name #
    ##########################
    if ($statement =~ /^\s*?([\w\/]+)(.*)/)
    {
	DEBUG_PRINT("\tGot '$1' and '$2'\n",$DEBUG_PARSECustom);
	$CustomScriptName = $1;
	$statement = $2;
    }else{
    LOG_PRINT (9, "ERROR: Please specify script name at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
      return 1;
    }


     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
    { 
       LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 

  
    ############################
    # process parsed statement #
    ############################
    $error = cl_odmmanPROCESS::PROCESSCustom(\@ODMnames,$CustomScriptName);
    if ($error)
	{return 1;}
    
    DEBUG_PRINT ("End PARSECustom\n\n",$DEBUG_PARSECustom);

    return 0;

}# End PARSECustom

## PARSECommit #################################################
# Purpose:
#     To parse a commit ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		"commit")
#     form - (see note at top)
#		commit;
#     user supplies:
# Returns:
#     1 - error
#     0 - success 
sub PARSECommit
{
    my ($statement) = @_;
     
    DEBUG_PRINT ( "PARSECommit: parsing commit statement [$statement]\n" , 
	$DEBUG_PARSECommit);


     ###################################
     # make sure there is nothing left #
     ###################################
     if ($statement =~ /([^\s]+)/)
     {
          LOG_PRINT (9, "ERROR: unexpected syntax '$1' at line $LINE_NUMBER\n",
		 "$LINE_NUMBER"); 
          return 1;
     } 


    ############################
    # process parsed statement #
    ############################
   cl_odmmanPROCESS::PROCESSCommit(); 
    
    DEBUG_PRINT ("Doing commit...\n",$DEBUG_PARSECommit); 


    return 0;

}# End PARSECommit

## PARSEStatement ##############################################
# Purpose:
#     To parse an ODM Manager statement
# Input:
#     statement - The string to parse (this should not include the 
#		final semicolon)
#     form - (see note at top)
#		<command word> <rest of command>
#     user supplies:
#		command
# Returns:
#     1 - error
#     0 - success 
sub PARSEStatement
{
    my ($statement) = @_;
    my $error = 0;

    DEBUG_PRINT ( "PARSEStatement: parsing statement [$statement]\n" , 
	$DEBUG_PARSEStatement);
   
    LOG_PRINT (1,"\n\nParsing command at line $LINE_NUMBER: \n\t$statement;\n",
	"");
 
    if ($statement =~ /^\s*?insert\b(.*)/i)    { $error = PARSEInsert($1); } 
    elsif ($statement =~ /^\s*?copy\b(.*)/i)   { $error = PARSECopy($1);   } 
    elsif ($statement =~ /^\s*?delete\b(.*)/i) { $error = PARSEDelete($1); } 
    elsif ($statement =~ /^\s*?sort\b(.*)/i)   { $error = PARSESort($1);   } 
    elsif ($statement =~ /^\s*?update\b(.*)/i) { $error = PARSEUpdate($1); } 
    elsif ($statement =~ /^\s*?auto\b(.*)/i)   { $error = PARSEAuto($1);   } 
    elsif ($statement =~ /^\s*?custom\b(.*)/i) { $error = PARSECustom($1); } 
    elsif ($statement =~ /^\s*?commit\b(.*)/i) { $error = PARSECommit($1); } 
    elsif ($statement =~ /^\s*?(\w+)/)
    {
        LOG_PRINT(10,"ERROR: unknown command '$1' at line $LINE_NUMBER\n",
"$LINE_NUMBER");
       $error = 1;
    }
    elsif ($statement =~ /(.+)/)
    {
        LOG_PRINT(11,"ERROR: unknown statement at line $LINE_NUMBER\n",
"$LINE_NUMBER");
        $error = 1;
    }
    
    if ($error) {return 1;}
    else {return 0;}
}# End PARSEStatement    
#####################################################################
# ODMmanager PARSER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#####################################################################

## MAIN ########################################################

DEBUG_PRINT ( "MAIN:  Entering MAIN...\n", $DEBUG_MAIN );

my $CurrentStatement = "";
my $NextStatement    = "";
my $Error            = 0;
my @Lines            = ();
my $Line             = "";
my $GotAStatement    = 0;
my $ParseError       = 0;
my $ErrorSoDie	     = 0;

LOG_PRINT (1,"\n********************************\n","");
LOG_PRINT (1,"*** ODM Manager version 0.2  ***\n","");
LOG_PRINT (1,"********************************\n\n","");

open (IN, $ARGV[0]) || die "cannot open $ARGV[0] for reading: $!";

LOG_PRINT (1,"Processing script: $ARGV[0]\n\n","");

$LINE_NUMBER = 1;
@Lines = <IN>;
close (IN);

##################
# Read in script #
##################
foreach $Line (@Lines)
{
    chomp($Line);

    DEBUG_PRINT ( "\tLine $LINE_NUMBER is [${Line}]\n",
		$DEBUG_MAIN );
    $LINE_NUMBER++;

    ###############
    # Blank line? #
    ###############
    if ($Line =~ /\S/) 
    { 
	DEBUG_PRINT ( "\tnot a blank line: $Line\n",$DEBUG_MAIN );
    }else{
	DEBUG_PRINT ( "\ta blank line: $Line\n",$DEBUG_MAIN );
	next;
    }
    #################
    # Comment line? #
    #################
    if ($Line =~ /^\s*?#/) 
    { 
	DEBUG_PRINT ( "\tComment line: $Line\n",$DEBUG_MAIN );
	next;
    }

    #########################################
    # Look for ';' (Deliminates commands    # 
    # which may run on multiple lines) 	    #
    #########################################
    $CurrentStatement = $CurrentStatement . $Line;

    if ($CurrentStatement =~/;/)
    {
	DEBUG_PRINT ("\tFound semicolon...\n",$DEBUG_MAIN);
	$GotAStatement = 1;

	#############################
	# Separates commands by ';' #
	#############################
	($Error, $CurrentStatement, $NextStatement) =
		PARSEGetStatement($CurrentStatement);

	if ($Error)
	{
	     LOG_PRINT (2, "ERROR: syntax error found when looking for 
semicolon...probably missing \" at line $LINE_NUMBER\n", "$LINE_NUMBER");
	    $ParseError = 1;
	     last;
	}

	######################################
	# when you get a statement, parse it #
	######################################
	while (!$Error)
	{
	     $ParseError = PARSEStatement($CurrentStatement);
	     DEBUG_PRINT ("\tParseError is $ParseError\n",
		$DEBUG_MAIN);
	     $CurrentStatement = $NextStatement;

		($Error, $CurrentStatement, $NextStatement) =
		   PARSEGetStatement($CurrentStatement);    

	}#end while
	
	if ($ParseError) {last;}

   }#end if ;


}#end foreach

############################
# Error processing/cleanup #
############################
if (!$GotAStatement)
{
	LOG_PRINT (2, "ERROR: syntax error found when looking for 
semicolon at line $LINE_NUMBER\n","$LINE_NUMBER");
	$ODMwasChanged = 0;  # Fatal error
}

if ($CurrentStatement =~/\S/ )  # any extraneous char at end of line?
{

	LOG_PRINT (2, "ERROR: syntax error, missing semicolon at 
line $LINE_NUMBER\n","$LINE_NUMBER");
	$ODMwasChanged = 0; # Fatal error
}

if ($ParseError){$ODMwasChanged = 0;} # fatal

# $ODMwasChanged = 0;

#######################################
# write the ODMs back to the database #
#######################################

if ($ODMwasChanged)
{
    DEBUG_PRINT("\tODMs were changed since the last commit...writing\n",
	$DEBUG_MAIN);
#    print "\nSTATUS: ODMs were changed...writing\n\n";
    cl_odmmanIO::IOwriteODMstanzasGlobal;
}else{
    DEBUG_PRINT("\tNo ODM's were actually changed since the last commit...\n",
	$DEBUG_MAIN);
#    print "\nSTATUS: No ODMs were changed...not writing\n\n";
}

LOG_PRINT (1,"\n***************************\n","");
LOG_PRINT (1,"*** End of ODM Manager  ***\n","");
LOG_PRINT (1,"***************************\n\n","");


if ($ParseError) {exit 1;}

exit 0;

## END MAIN_Module ##################################################
