#!/usr/es/sbin/cluster/wsm/utils/sperl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/eventPtr.cgi.perl 1.5 
#  
# Licensed Materials - Property of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2006,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

############################################################################
#
# File: eventPtr.cgi
#
# Description:
#
#       Simply returns the ID of the latest cluster event, according to the MIB
#       of the first active node.
#
#
# @(#)97       1.5 src/43haes/usr/sbin/cluster/wsm/cgi-bin/eventPtr.cgi.perl, hacmp.wsm, 52haes_r541, 0747C_hacmp541 11/30/07 12:58:08

use lib '/usr/es/sbin/cluster/wsm/utils';
use cldata;

use wsm_config;
my $cfg = wsm_config::get_config();
my $VERBOSE_LOGGING = ($cfg->{"VERBOSE_LOGGING"} ? $cfg->{"VERBOSE_LOGGING"} : "");
my $logdir = '/usr/es/sbin/cluster/wsm/logs';

# Hard-code these for the sake of security (i.e., to un-taint them)
$ENV{PATH} = '/bin:/sbin:/usr/bin:/usr/sbin';
$ENV{ODMDIR} = '/etc/objrepos';

#
# Get the MIB data
#
my @eventPtr   = cldata::getSnmpInformation('eventPtr');


# We should only get one line of output from the snmp request
(my $id) = $eventPtr[0] =~ /eventPtr\.0 = (\d+)/;

if ($VERBOSE_LOGGING eq 'high') {
    require Sys::Hostname;
    import Sys::Hostname;
    my $host = Sys::Hostname::hostname();
    $host = ($host ? "$host.dat" : 'dat');

    open WTF, ">$logdir/eventPtr.$host";  # Write To File
    print WTF "RAW SNMP DATA (\"eventPtr\"):\n @eventPtr\n\n\$id: \"$id\"\n";
    close WTF;
}

print <<EOF;
Content-type: text/plain
Cache-control: no-cache
Expires: -1

$id
EOF

1;
