#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_auth.cgi.sh 1.10 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2004,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

# @(#)40        1.10 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_auth.cgi.sh, hacmp, 52haes_r541, 0747B_hacmp541 11/6/07 13:28:26

##############################################################################
# Module: wsm_auth.cgi
#
# This script is run at the beginning of every CGI script to check certain
# access restrictions and user authentication.
#
# The actual processing is done by wsm_auth_run, this script is just a
# wrapper to read in the configuration environment from the wsm_smit.conf file
# and export it so that wsm_auth_run will have it's environment setup.
#
# A return value of 1 means the calling script should abort processing.
# A return value of 0 means the calling script should continue processing.
##############################################################################

PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification

BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm

# Make sure the file being sourced is owned by root and only the owner has
# write permissions.  This file is being sourced, so being writable by any
# other person could allow them to run arbitrary commands as root.
#
# There are several scripts that source this script, so they do not need to
# redo this check.
CONF_FILE=$CONFDIR/wsm_smit.conf
if [[ -n "$(find $CONF_FILE ! -user root -o -perm -0020 -o -perm -0002)" ]]
then
    print "Invalid permissions for $CONF_FILE.  " \
          "File should only be writable by root." >> $LOGFILE
    exit 1
else
    set -a
    . $CONF_FILE >/dev/null
    set +a
fi

[[ $VERBOSE_LOGGING == "high" ]] && set -x


export AUTHORIZED_PORT REDIRECT_TO_HTTPS REQUIRE_AUTHENTICATION \
       ACCEPTED_USERS SESSION_TIMEOUT

$BINDIR/wsm_auth_run $*
exit $?
