#!/usr/bin/perl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_chg_pw.cgi.pl 1.16 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# @(#)92	1.16 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_chg_pw.cgi.pl, hacmp.wsm, 52haes_r541, 0736A_hacmp541 4/18/07 17:10:50

###############################################################################
#
# Name:
#
# Description:  This script changes the password associated with user 'admin' 
#               in the file specified in $passfile_location
#
# Arguments:    (from html form): old_password, new_password
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################

BEGIN {
    #
    # Makes sure that the "use wsm_config;" will work, below!
    #
    # NOTE: a few hoops are jumped through here to make sure
    #       that this file works in an installed cluster, *and*
    #       passes a "perl -c" test in the build environment.
    #
    require Cwd;
    import Cwd;
    'NULL' =~ /()/;  # Initialize the "$1" variable
    $0 =~ m#(.*)[\\/].*#;
    chdir($1) if ($1 ne "");
    my $cgidir = cwd();
    my $wsmdir = $cgidir;
    $wsmdir =~ s#/cgi-bin/?$##;
    $ENV{PERLLIB} .= ":$wsmdir/utils";
    push(@INC, "$wsmdir/utils");
}

use wsm_config;

my $CONFDIR = "/usr/es/sbin/cluster/wsm";
my $CFG = wsm_config::get_config("$CONFDIR/wsm_smit.conf");
$ENV{NLSPATH} = $$CFG{NLSPATH};
$ENV{LANG} = $$CFG{LANG};
wsm_config::set_wsm_locale();

# global messages
my $CHANGE=qx/dspmsg wsm_smit.cat 11 "Change Password"/;
my $ENTER_OLD=qx/dspmsg wsm_smit.cat 12 "Enter old password:"/;
my $ENTER_NEW=qx/dspmsg wsm_smit.cat 13 "Enter new password:"/;
my $RE_ENTER_NEW=qx/dspmsg wsm_smit.cat 14 "Re-enter new password:"/;
my $SUBMIT=qx/dspmsg wsm_smit.cat 40 "Submit"/;
my $HOME=qx/dspmsg wsm_smit.cat 41 "Home"/;

###############################################################################
#
# Name: body_header
#
# Description: adds the htmls tags for the start of the body
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub body_header ( )
{
    my $VERSION="1.16";
    my $CORRECT=qx/dspmsg wsm_smit.cat 9 "Please verify that you typed your new password correctly."/;
    my $ENTER_NEW=qx/dspmsg wsm_smit.cat 10 "You need to enter a new password."/;

    print <<BH;
<html>
<head>
<title>IBM WebSMIT - Password Change</title>
<meta HTTP-EQUIV="cache-control" CONTENT="no-cache">
<meta name="copyright" content="copyright (c) 2004 IBM corporation" />
<meta name="source" content="$0 version $VERSION" />

<SCRIPT language="JavaScript">
function validate(Form)
{
    if (Form.new_password.value != Form.verify.value)
    {
        alert(\"$CORRECT\");
        Form.new_password.select();
        return false;
    }
    else if (Form.new_password.value == \"\")
    {
        alert(\"$ENTER_NEW\");
        Form.new_password.select();
        return false;
    }
    return true;
} // End of "validate()"

window.name='SMITmain'
</SCRIPT>
</head>

<BODY BGCOLOR="#FFFFFF" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" STYLE="margin:0px" onhelp="genHelp(); return false;">
<table border="0" cellspacing="0" width="100%" height="100%">
<tr>
<td height="1" bgcolor="#000000">

<table border="0" cellspacing="0" width="600" align="center">
<tr>
<td align="center"><img src="/wsm_logo_ibm.gif"></td>
<td align="center"><a href="/cgi-bin/wsm_index.cgi" onMouseOver="JavaScript: window.status=''; return true;"><img src="/wsm_logo_ha.gif" border="0"></a></td>
<td align="center"><img src="$main::SKIN_LOGO"></td>
</tr>
</table>

</td>
</tr>

<tr><td valign="top" align="center">
BH
} # End of "body_header()"



###############################################################################
#
# Name: body_footer
#
# Description: add a text box for SMIT FastPaths and add html tags to close the
#              body
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub body_footer ( )
{
    print <<FOOTER;
</td>
</tr>
</table>

</body>
</html>
FOOTER
} # End of "body_footer()"



###############################################################################
#
# Name: make_form
#
# Description: generaater a form for the user to change the password with
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub make_form ( )
{
    print <<MF;
<BR><FONT FACE="arial,helvetica,sans-serif" SIZE="2"><B>$CHANGE</B></FONT>
<form  method="post" action="/cgi-bin/wsm_chg_pw.cgi" onsubmit="return validate(this)">

<TABLE  border="0" align="center">
<TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$ENTER_OLD </FONT></TD>
<TD><INPUT type="password" name="old_password" size="12"></TD>
</TR>

<TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$ENTER_NEW </FONT></TD>
<TD><INPUT type="password" name="new_password" size="12"></TD>
</TR>

<TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$RE_ENTER_NEW </FONT></TD>
<TD><INPUT type="password" name="verify" size="12"></TD>
</TR>
</TABLE>

<P ALIGN="center"><input type="Submit" value="$SUBMIT">
</form>
MF
} # End of "make_form()"



###############################################################################
#
# Name: body_content
#
# Description: write new password to the file and output confirmation message
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub body_content ( )
{
    # check that user is authenticated before making changes
    if (&check_password($main::FORM{old_password}) eq "true")
    {
	my $encrypted_password = &encrypt_password($main::FORM{new_password});

        # password file is in the format of {user}:{encrypted password}
	my $new_password_entry = "admin:${encrypted_password}";
	
        my $RC = 1;
	if (open (PASSWORD, ">$main::passfile_location")) {
	    $RC=0;
	    print PASSWORD $new_password_entry;
	    close (PASSWORD);
	}

	# error trapping
	if ($RC != 0) {
            my $ERROR_WRITING=qx/dspmsg wsm_smit.cat 15 "Error writing password file! Return code was: $RC" $RC/;
	    my $CHECK_LOGS=qx/dspmsg wsm_smit.cat 16 "Check the http server log files for additional error information."/;

            print <<EOF;
<BR>
<P ALIGN="center">
<FONT FACE="Arial,Helvetica,sans-serif" SIZE="2"><B>$ERROR_WRITING</B></FONT>
</P>

<B>$CHECK_LOGS</B></FONT></P>
<P ALIGN="center">
<FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">
<INPUT TYPE="button" value="$HOME" onclick="window.location='/cgi-bin/wsm_index.cgi'">
EOF
	} else {
	    # confirmation message
	    my $CHANGE_OK=qx/dspmsg wsm_smit.cat 17 "Password changed successfully."/;

            print <<EOF;
<BR>
<P ALIGN="center">
<FONT FACE="Arial,Helvetica,sans-serif" SIZE="2"><B>$CHANGE_OK</B></FONT>
</P>

<P ALIGN="center">
<FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">
<INPUT TYPE="button" value="$HOME" onclick="window.location='/cgi-bin/wsm_index.cgi'">
EOF

	    # log the password change
	    open(LOG, ">>$main::LOGFILE");
	    my $date = `date +"[%b %d %Y, %T]"`;
	    print LOG "${date}Password Changed:\n	User IP     = \"$ENV{REMOTE_ADDR}\"\n\n";
	    close(LOG);
	}
    }
    else
    {
        # error message
	my $DENIED=qx/dspmsg wsm_smit.cat 18 "Access denied; please check that the current password was entered correctly."/;

        print <<EOF;
<BR><P ALIGN="center"><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">
<B>$DENIED</B></FONT></P>

<FORM  method="post" action="/cgi-bin/wsm_chg_pw.cgi" onsubmit="return validate(this)">
<TABLE  border="0" align="center">
<TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$ENTER_OLD password: </FONT></TD>
<TD><INPUT type="password" name="old_password" size="12"></TD>
</TR>
TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$ENTER_NEW </FONT<</TD>
<TD><INPUT type="password" name="new_password" size="12"></TD>
</TR>
<TR>
<TD><FONT FACE="Arial,Helvetica,sans-serif" SIZE="2">$RE_ENTER_NEW </FONT></TD>
<TD><INPUT type="password" name="verify" size="12"></TD>
</TR>
</TABLE>
<P ALIGN="center"><input type="Submit" value="$SUBMIT">
</form>
EOF
    }
} # End of "body_content()"



###############################################################################
#
# Name: encrypt_password
#
# Description: encrypts a string using perl's crypt()
#
# Arguments:    string to encrypt
#
# Returns:      encrypted string
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub encrypt_password ( $ )
{
    my $unencrypted_string = shift @_;
    my @salt_chars  = ('a'..'z','A'..'Z','0'..'9');

    # generates a random encryption key
    my $salt = $salt_chars[rand(63)] . $salt_chars[rand(63)];

    return crypt($unencrypted_string, $salt);
}

###############################################################################
#
# Name: check_password
#
# Description:  checks a string to see if it matches the encrypted password in
#               the file
#
# Arguments:    
#
# Returns:      true, false
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
sub check_password ( )
{
    # retrieves current encrypted password from the file
    open (PASSWORD, "$main::passfile_location") || &error("Unable to open $main::passfile_location");
    my $current_password_buffer = <PASSWORD>; 
    close (PASSWORD);
    chomp($current_password_buffer);    
    my($garbage, $current_password_crypt) = split(/:/, $current_password_buffer);
    
    # encrypts the string being tested using the same key as the encrypted password from the file
    my $form_current_password_crypt = crypt($_[0], $current_password_crypt);
    
    if ($form_current_password_crypt eq $current_password_crypt)
    {
	return "true";
    }
    else
    {
	return "false";
    }
} # End of "check_password()"



#
# Main starts here
#

my $BINDIR = "/usr/es/sbin/cluster/wsm/cgi-bin";
my $CONFDIR = "/usr/es/sbin/cluster/wsm";

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
system("$BINDIR/wsm_auth.cgi");
if (($? >> 8) != 0 ) {
    exit 0;
}

# get some data from the conf file
my $CFG = wsm_config::get_config("$CONFDIR/wsm_smit.conf");
$main::SKIN_LOGO = $$CFG{SKIN_LOGO};
$main::LOGFILE = $$CFG{LOGFILE};

# Location of password file used for htaccess
$main::passfile_location = '../htpasswd';  # Global value

# Get POST input
my $buffer = undef;
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    
# Split the name-value pairs
foreach (split(/&/, $buffer))
{
    chomp(my $pair = $_);
    my($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $main::FORM{$name} = $value;
}


&body_header;

if ( $main::FORM{old_password} ) {
    &body_content;
}
else {
    &make_form;
}

&body_footer;

# end chg_pw.cgi
