#!/usr/bin/perl 
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_cldisp.cgi.perl 1.14 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# @(#)36        1.14 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_cldisp.cgi.perl, hacmp.utils, 52haes_r541, 0736A_hacmp541 4/16/07 16:13:37
#


BEGIN {
    # Makes sure that the "use wsm_config;" will work, below!
    $ENV{PERLLIB} .= ":/usr/es/sbin/cluster/wsm/utils";
    push(@INC, "/usr/es/sbin/cluster/wsm/utils");
}

use wsm_config;
my $CONFDIR = "/usr/es/sbin/cluster/wsm";
my $CFG = wsm_config::get_config("$CONFDIR/wsm_smit.conf");
$ENV{NLSPATH} = $$CFG{NLSPATH};
$ENV{LANG} = $$CFG{LANG};
wsm_config::set_wsm_locale();


######################################################################
#
# Name: wsm_cldisp.cgi
#
# This script probes an HACMP configuration and generates html which
# displays an application-centric summary of the cluster.
#
######################################################################

# "libcl_disp" is a library that contains routines common to both
# cldisp and wsm_cldisp
use lib '/usr/es/lib/perl/';  #Adds a directory to perl's library path
use libcl_disp;

# "use strict" will help to keep this code cleaner
use strict;

# Subroutine declarations are in the same order in which they appear below
sub printTop();
sub printBottom();
sub display();
sub dispActive();
sub dispInactive();
sub print_service_label();
sub print_vgs();
sub print_cc_vgs();
sub print_filesystems();
sub print_fast_connect_services();
sub printMonitors();
sub print_topo();
sub appStateColoredHtml_of_app($);
sub nodeStateColoredHtml_of_node($);
sub networkStateColoredHtml_of_network($$);
sub serviceLabelStateColoredHtml_of_service_label($$$);
sub interfaceStateColoredHtml_of_interface($$$);

# cluster services
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
$ACTIVE = '<span class="up">'.`dspmsg scripts.cat 9999 "active"`.'</span>';
$INACTIVE = '<span class="inactive">'.`dspmsg scripts.cat 9999 "inactive"`.'</span>';

# cluster states
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
$UP = '<span class="up">'.`dspmsg scripts.cat 9999 "up"`.'</span>';
$DOWN = '<span class="down">'.`dspmsg scripts.cat 9999 "down"`.'</span>';
$UNKNOWN = '<span class="unknown">'.`dspmsg scripts.cat 9999 "unknown"`.'</span>';

# cluster substates
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
$UNSTABLE = '<span class="unstable">'.`dspmsg scripts.cat 9999 "unstable"`.'</span>';
$STABLE = '<span class="up">'.`dspmsg scripts.cat 9999 "stable"`.'</span>';
$ERROR = '<span class="down">'.`dspmsg scripts.cat 9999 "error"`.'</span>';
$RECONFIG = '<span class="unknown">'.`dspmsg scripts.cat 9999 "reconfig"`.'</span>';
#   $UNKNOWN (defined above)

# app states
# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
$ONLINE = '<span class="up">'.`dspmsg scripts.cat 9999 "online"`.'</span>';
$OFFLINE = '<span class="down">'.`dspmsg scripts.cat 9999 "offline"`.'</span>';
$ACQUIRING = '<span class="unstable">'.`dspmsg scripts.cat 9999 "acquiring"`.'</span>';
$RELEASING = '<span class="unstable">'.`dspmsg scripts.cat 9999 "releasing"`.'</span>';
#   $ERROR (defined above)
#   $UNKNOWN (defined above)

# IF THESE ARE CHANGED YOU MUST ALSO CHANGE THEM INSIDE THE 'translate' SUBROUTINE
our $JOINING = '<span class="unstable">'.`dspmsg scripts.cat 9999 "joining"`.'</span>';
our $LEAVING = '<span class="unstable">'.`dspmsg scripts.cat 9999 "leaving"`.'</span>';

#####################################################
#
# Function:
#
#    printTop
#
# Description:
#
#    Prints the static information that will be at
#    the beginning of all html pages generated by
#    this script
#
# Arguments:
#
#    none
#
#####################################################
sub printTop(){

	system "$HACMPBASE/wsm/cgi-bin/wsm_html_lib body_start_help_only '/wsm_clstat_hlp.html'";
	
}
#####################################################
#
# Function:
#
#    printBottom
#
# Description:
#
#    Prints the static information the is attached
#    to the end of all html documents generated by
#    this script
#
# Arguments:
#
#    none
#
#####################################################
sub printBottom(){
    print "<div class=\"formButtons\">\n";
    print "<input type=\"button\" value=\"Expand All\" onclick=\"twistyAll('expanded')\">\n";
    print "<input type=\"button\" value=\"Collapse All\" onclick=\"twistyAll('collapsed')\">\n";
    print "<input type=\"button\" value=\"Back\" onclick=\"history.go(-1);\">\n";
    print "</div>";
    
    print "</div>\n";  #end statusOutput
    
    print "<div id=\"colorKey\">\n";
    print "<h1>Color Key</h1>\n";
    print "<ul>\n";
    print "    <li><span class=\"up\">";
    system "dspmsg scripts.cat 9999 \"up active stable online\"";
    print "</span></li>\n";
    print "    <li><span class=\"down\">";
    system "dspmsg scripts.cat 9999 \"down offline error\"";
    print "</span></li>\n";
    print "    <li><span class=\"nostatus\">";
    system "dspmsg scripts.cat 9999 \"no status\"";
    print "</span></li>\n";
    print "    <li><span class=\"unstable\">";
    system "dspmsg scripts.cat 9999 \"unstable joining leaving acquiring releasing\"";
    print "</span></li>\n";
    print "    <li><span class=\"unknown\">";
    system "dspmsg scripts.cat 9999 \"unknown reconfig\"";
    print "</span></li>\n";
    print "    <li><span class=\"inactive\">";
    system "dspmsg scripts.cat 9999 \"inactive\"";
    print "</span></li>\n";
    print "</ul>\n";
    print "</div>\n";
    
    print "</div></div>\n";
    print "</body>\n";
    print "</html>\n";
}
#####################################################
#
# Function:
#
#    display
#
# Description:
#
#    Prints summary of cluster information
#
# Arguments:
#
#    none
#
#####################################################
sub display(){
    # If the cluster is currently active we'll display static configuration
    # info as well as information about the current state of the cluster.
    if( $overall_clstrmgr_state eq $ACTIVE){
        &dispActive;
    }
    # If the cluster isn't currently active we'll display information similar
    # to what we display for an active cluster but with only static
    # configuration information shown.
#    elsif( $overall_clstrmgr_state eq $INACTIVE){

    else{
        &dispInactive;
    }
}
#####################################################
#
# Function:
#
#    dispActive
#
# Description:
#
#    Prints the configuration and current state of an
#    active cluster (to standard out).
#
# Arguments:
#
#    none
#
#####################################################
sub dispActive(){
    print "<div id=\"clusterHeading\">\n";
    print "<h1>";
    system "dspmsg scripts.cat 9999 \"Cluster: \"";
    print "<span class=\"nostatus\">$clusterName</span></h1>\n";

    my $tmp = &translate($overall_clstrmgr_state);
    system "dspmsg scripts.cat 9999 \"Cluster services: \"";
    print "$tmp | ";
    my $transState = &translate($clusterState);
    system "dspmsg scripts.cat 9999 \"State: \"";
    print "$transState | ";
    system "dspmsg scripts.cat 9999 \"Substate: \"";
    print "$clusterSubstate\n";
    
    print "</div>\n";
    
	print "<div id=\"statusOutput\">\n";

    print "<h2>";
    system "dspmsg scripts.cat 9999 \"Applications\"";
    print "</h2>\n";
    print "<ul class=\"twistyRoot\">\n";
    for($r = 0; $apps[$r]; $r++){
        print "    <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        my $coloredAppName = &appStateColoredHtml_of_app($r);
        print "$coloredAppName\n";
        print "            <ul class=\"collapsed\">\n";
        &print_rg();
        
        if($providingNodesByApp[$r][0] && ($providingNodesByApp[$r][0] ne "NONE")){
            print "                    <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        }
        else{
            print "                    <li><span class=\"bullet\"></span>\n";
        }
    
        if($nodesByApp[$r][1]){
            system "dspmsg scripts.cat 9999 \"Nodes configured to provide\"";
            print " $apps[$r]: ";
            # Probes each of an app's nodes for it's state, and based on the returned state, prints
            # the node's name in a specific color.
            for($c = 0; $nodesByApp[$r][$c]; $c++){
                my $tmp = &nodeStateColoredHtml_of_node($nodesByApp[$r][$c]);
                print "$tmp ";
            }
            print "\n";
        }
        elsif($nodesByApp[$r][0]){
            my $tmp = &nodeStateColoredHtml_of_node($nodesByApp[$r][0]);
            system "dspmsg scripts.cat 9999 \"Nodes configured to provide\"";
            print " $apps[$r]: $tmp\n";
        }
        else{
            print "<span class=\"down\">";
            system "dspmsg scripts.cat 9999 \"No nodes are configured to provide\"";
            print " $apps[$r]!</span>\n";
        }
    
        if($providingNodesByApp[$r][1]){ # If(it's a concurrent RG with more than one node up)
            print "                        <ul class=\"collapsed\">\n";
            print "                            <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Nodes currently providing\"";
            print " $apps[$r]: ";
            for($c = 0; $providingNodesByApp[$r][$c]; $c++){
                my $coloredNodeName = &nodeStateColoredHtml_of_node($providingNodesByApp[$r][$c]);
                print "$coloredNodeName ";
            }
            print "                            </li>\n";
            print "                        </ul>\n";
            print "                </li>\n";
        }
        # else if(a single node is providing the application)
        elsif($providingNodesByApp[$r][0] && ($providingNodesByApp[$r][0] ne "NONE")){
            print "                        <ul class=\"collapsed\">\n";
            print "                            <li><span class=\"bullet\"></span>\n";
            my $coloredNodeName = &nodeStateColoredHtml_of_node($providingNodesByApp[$r][0]);
            system "dspmsg scripts.cat 9999 \"Node currently providing\"";
            print " $apps[$r]: ";
            print " $coloredNodeName\n";
            print "                            </li>\n";
            if( ($appStates[$r] eq $ONLINE) &&
                ($falloverNodesOfApps[$r]) ){
                print "                            <li><span class=\"bullet\"></span>\n";
                system "dspmsg scripts.cat 9999 \"Node that will provide\"";
                print " $apps[$r] ";
                system "dspmsg scripts.cat 9999 \"if\"";
                print " $providingNodesByApp[$r][0] ";
                system "dspmsg scripts.cat 9999 \"fails: \"";
                if($falloverNodesOfApps[$r] eq $MESSAGE_CL_HIGHEST_FREE_MEM){
                    print "<span class=\"nostatus\">";
                    system "dspmsg scripts.cat 9999 \"whichever has the most free memory\"";
                    print "</span>";
                }
                elsif($falloverNodesOfApps[$r] eq $MESSAGE_CL_HIGHEST_IDLE_CPU){
                    print "<span class=\"nostatus\">";
                    system "dspmsg scripts.cat 9999 \"whichever has the least cpu usage\"";
                    print "</span>";
                }
                elsif($falloverNodesOfApps[$r] eq $MESSAGE_CL_LOWEST_DISK_BUSY){
                    print "<span class=\"nostatus\">";
                    system "dspmsg scripts.cat 9999 \"whichever has the least disk usage\"";
                    print "</span>";
                }
                elsif($falloverNodesOfApps[$r] eq $MESSAGE_USER_SPECIFIED){
                    print "<span class=\"nostatus\">";
                    system "dspmsg scripts.cat 9999 \"this is to be decided dynamically using a user-specified RSCT resource variable\"";
                    print "</span>";
                }
                else{
                    $coloredNodeName = &nodeStateColoredHtml_of_node($falloverNodesOfApps[$r]);
                    print " $coloredNodeName\n";
                }
                print "                            </li>\n";
            }
#            else{
#                print "                            </li>\n";
#            }
            print "                        </ul>\n";
            print "                </li>\n";
        }
        else{
            print "                </li>\n";
        }
        print "                <li><span class=\"bullet\"></span>\n";
        print "$apps[$r] ";
        system "dspmsg scripts.cat 9999 \"is started by\"";
        print " <span class=\"nostatus\">$startscriptsByApp[$r]</span>\n";
        print "                </li>\n";
        print "                <li><span class=\"bullet\"></span>\n";
        print "$apps[$r] ";
        system "dspmsg scripts.cat 9999 \"is stopped by\""; 
        print " <span class=\"nostatus\">$stopscriptsByApp[$r]</span>\n";
        print "                </li>\n";
        
        # If the app has at least one resource belonging to it:
        if( ($serviceIpLabelsOfApps[$r][0] &&
            ($serviceIpLabelsOfApps[$r][0] ne "NONE") ) ||
            ($vgsOfApps[$r][0]) ||
            ($ccVgsOfApps[$r][0]) ||
            ($filesystemsOfApps[$r][0]) ||
            ($fastConnectServicesOfApps[$r][0]) ){
            print "                <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Resources associated with\"";
            print " $apps[$r]\n";
            print "                        <ul class=\"collapsed\">\n";
            &print_service_labels;
            &print_vgs;
            &print_cc_vgs;
            &print_filesystems;
            &print_fast_connect_services;
            print "                        </ul>\n";
            print "                </li>\n";
        }
        else{
            print "                <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"No resources are associated with\"";
            print " $apps[$r]";
            print "                </li>\n";
        }
        &printMonitors;
        print "            </ul>\n";
        print "    </li>\n";
    } #/for ($apps...)
    print "</ul>\n";
    &print_topo;
}
#####################################################
#
# Function:
#
#    dispInactive
#
# Description:
#
#    Prints the configuration of an inactive cluster
#    to standard out
#
# Arguments:
#
#    none
#
#####################################################
sub dispInactive(){
    print "<div id=\"clusterHeading\">\n";
    print "<h1>";
    system "dspmsg scripts.cat 9999 \"Cluster:\"";
    print " $clusterName</h1>\n";
    my $tmp = &translate($overall_clstrmgr_state);
    print "<h3>";
    system "dspmsg scripts.cat 9999 \"Cluster services: \"";
    print "$tmp</h3>\n";
    print "</div>\n";
    print "<hr width=\"40%\" style=\"margin: 0px auto; margin-top: 5px; margin-bottom: 5px;\">\n";
    print "<div id=\"content\" style=\"text-align: left; width: 500px; margin-left: 30%;\">\n";
    print "<h2>";
    system "dspmsg scripts.cat 9999 \"Applications\"";
    print "</h2>\n";
    print "<ul class=\"twistyRoot\">\n";
    for($r = 0; $apps[$r]; $r++){
        print "        <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        print "        <span class=\"nostatus\">$apps[$r]</span>\n";
        print "            <ul class=\"collapsed\">\n";
        &print_rg();
        print "                <li><span class=\"bullet\"></span>\n";
        if($nodesByApp[$r][1]){
            system "dspmsg scripts.cat 9999 \"Nodes configured to provide\"";
            print " $apps[$r]: ";
            # Probes each of an app's nodes for it's state, and based on the returned state, prints
            # the node's name in a specific color.
            for($c = 0; $nodesByApp[$r][$c]; $c++){
                my $tmp = &nodeStateColoredHtml_of_node($nodesByApp[$r][$c]);
                print $tmp;
            }
            print "\n";
        }
        elsif($nodesByApp[$r][0]){
            my $tmp = &nodeStateColoredHtml_of_node($nodesByApp[$r][0]);
            system "dspmsg scripts.cat 9999 \"Nodes configured to provide\"";
            print " $apps[$r]: $tmp\n";
        }
        else{
            print "<span class=\"offline\">";
            system "dspmsg scripts.cat 9999 \"No nodes configured to provide\"";
            print " $apps[$r]</span>\n";
        }
        print "                </li>\n";
        print "                    <li><span class=\"bullet\"></span>";
        print "$apps[$r] ";
        system "dspmsg scripts.cat 9999 \"is started by\"";
        print " <span class=\"nostatus\">$startscriptsByApp[$r]</span>";
        print "                    </li>\n";
        print "                    <li><span class=\"bullet\"></span>";
        print "$apps[$r] ";
        system "dspmsg scripts.cat 9999 \"is stopped by\""; 
        print " <span class=\"nostatus\">$stopscriptsByApp[$r]</span>\n";
        print "                    </li>\n";
        
        # If the app has at least one resource belonging to it:
        if( ($serviceIpLabelsOfApps[$r][0] &&
            ($serviceIpLabelsOfApps[$r][0] ne "NONE") ) ||
            ($vgsOfApps[$r][0]) ||
            ($ccVgsOfApps[$r][0]) ||
            ($filesystemsOfApps[$r][0]) ||
            ($fastConnectServicesOfApps[$r][0]) ){
            print "                <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
            system "dspmsg scripts.cat 9999 \"Resources associated with\"";
            print " $apps[$r]\n";
            print "                    <ul class=\"collapsed\">\n";
            &print_service_labels;
            &print_vgs;
            &print_cc_vgs;
            &print_filesystems;
            &print_fast_connect_services;
            print "                    </ul>\n";
            print "                </li>\n";
        }
        else{
            print "                <li><span class=\"bullet\"></span>";
            system "dspmsg scripts.cat 9999 \"No resources are associated with\"";
            print " $apps[$r]";
            print "                </li>\n";
        }
        &printMonitors;
        print "            </ul>\n";
        print "        </li>\n";
    } #/for ($apps...)
    print "</ul>\n";
    &print_topo;
}
#####################################################
#
# Function:
#
#    print_rg
#
# Description:
#
#    Prints information about the resource group
#    of the application '$app[$r]', including the
#    RG's type. If it's a custom RG, information
#    about the startup, fallover, and fallback
#    policies will be printed as well.
#
# Arguments:
#
#    none
#
#####################################################
sub print_rg(){
    if($nodesByApp[$r][0] && ($nodesByApp[$r][0] ne "NONE")){
    # display its startup, fallover and fallback policies
        my $rg = &rg_of_app($apps[$r]);
        initRgPrefs($rg);
        print "                <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        system "dspmsg scripts.cat 9999 \"This application is part of \"";
        system "dspmsg scripts.cat 9999 \"resource group\"";
        print " <span class=\"nostatus\">$RgsByApp[$r]</span>\n";
        print "                    <ul class=\"collapsed\">\n";
        print "                        <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Resource group policies\""; print "\n";
        print "                            <ul class=\"collapsed\">\n";
        print "                                <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Startup: \"";
        my $trans = &translateCustomAttr($startupPref);
        print "<span class=\"nostatus\">$trans</span>\n";
        print "                                </li>\n";
        print "                                <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Fallover: \"";
        $trans = &translateCustomAttr($falloverPref);
        print "<span class=\"nostatus\">$trans</span>\n";
        print "                                </li>\n";
        print "                                <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Fallback: \"";
        $trans = &translateCustomAttr($fallbackPref);
        print "<span class=\"nostatus\">$trans</span>\n";
        print "                                </li>\n";
        print "                            </ul>\n";
        print "                        </li>\n";
        print "                    </ul>\n";
        print "                </li>\n";
    }
}
#####################################################
#
# Function:
#
#    print_service_labels
#
# Description:
#
#    Prints the service labels associated with
#    whichever application in @apps is currently
#    being pointed to by $r.
#
# Arguments:
#
#    none
#
#####################################################
sub print_service_labels(){
    # Instead of being left empty when there aren't any service IP labels for
    # an application, the word NONE is used. We'll check for it and exit this
    # subroutine if it is.
    if( ($serviceIpLabelsOfApps[$r][0] eq "NONE") ||
        ( ! ($serviceIpLabelsOfApps[$r][0])) ){
        return;
    }
    print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
    system "dspmsg scripts.cat 9999 \"Service labels\"";
    print "                                <ul class=\"collapsed\">\n";
    
    # $r ->
    #       the row of an app (@apps, 1D)
    #       the row of the service labels of an app (@serviceIpLabelsOfApps, 2D)
    #       the row of the nodes of an app (@nodesByApp, 2D)
    # $c ->
    #       the cell of the row of the service labels of an app (@serviceIpLabelsOfApps, 2D)
    for($c = 0; $serviceIpLabelsOfApps[$r][$c]; $c++){
        print "                                        <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        if( $overall_clstrmgr_state eq $ACTIVE){
            my $coloredServiceLabel = &serviceLabelStateColoredHtml_of_service_label("$serviceIpLabelsOfApps[$r][$c] ($serviceIpsOfApps[$r][$c])", $r, $c);
            print "$coloredServiceLabel";
        }
        else{
            print "<span class=\"nostatus\">$serviceIpLabelsOfApps[$r][$c] ($serviceIpsOfApps[$r][$c])</span>";
        }
        print "                                            <ul class=\"collapsed\">\n";
        print "                                                <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
        system "dspmsg scripts.cat 9999 \"Interfaces configured to provide\"";
        print " $serviceIpLabelsOfApps[$r][$c]";
        print "                                                    <ul class=\"collapsed\">\n";
        # $c2 ->
        #        the cell of the row of the nodes of an app (@nodesByApp, 2D)
        for($c2 = 0; $nodesByApp[$r][$c2]; $c2++){
            # $rr2 ->
            #         the row of a node (@nodeNames, 1D)
            #         the row of the interfaces of a node (@interfacesByNode, 2D)
            #         the row of the networks of the interfaces of a node (@networksOfInterfaces, 2D)
            for($rr2 = 0; $nodeNames[$rr2]; $rr2++){
                if($nodeNames[$rr2] eq $nodesByApp[$r][$c2]){
                    # $cc2 ->
                    #         the cell of the row of the interfaces of a node (@interfacesByNode, 2D)
                    #         the cell of the row of the networks of the interfaces of a node (@networksOfInterfaces, 2D)
                    for($cc2 = 0; $interfacesByNode[$rr2][$cc2]; $cc2++){
                        if($networksOfInterfaces[$rr2][$cc2] eq $networksOfServiceLabels[$r][$c]){
                            my $interfaceName = &name_of_interface($nodeNames[$rr2], $interfacesByNode[$rr2][$cc2]);
                            my $coloredInterfaceName = &interfaceStateColoredHtml_of_interface("$interfaceName", $rr2, $cc2);
                            my $coloredNodeName = &nodeStateColoredHtml_of_node("$nodeNames[$rr2]");
                            my $coloredNetworkName = &networkStateColoredHtml_of_network($rr2, $cc2);
            #TODO: fix these for i8n
                            print "                                                               <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
                            print "$coloredInterfaceName\n";
                            print "                                                                        <ul class=\"collapsed\">\n";
                            print "                                                                            <li><span class=\"bullet\"></span>\n";
                            local $_ = $ipsByNode[$rr2][$cc2];
                            s/[0-9]//g;
                            if($_ eq "..."){
                                system "dspmsg scripts.cat 9999 \"with IP address: \"";
                            }
                            else{
                                system "dspmsg scripts.cat 9999 \"device: \"";
                            }
                            print "<span class=\"nostatus\">$ipsByNode[$rr2][$cc2]</span>\n";
                            print "                                                                            </li>\n";
                            if($_ eq "..."){
                                print "                                                                            <li><span class=\"bullet\"></span>\n";
                                system "dspmsg scripts.cat 9999 \"on interface: \"";
                                print "<span class=\"nostatus\">$interfacesByNode[$rr2][$cc2]</span>\n";
                                print "                                                                            </li>\n";
                            }
                            print "                                                                            <li><span class=\"bullet\"></span>\n";
                            system "dspmsg scripts.cat 9999 \"on node: \"";
                            print "$coloredNodeName\n";
                            print "                                                                            </li>\n";
                            print "                                                                            <li><span class=\"bullet\"></span>\n";
                            system "dspmsg scripts.cat 9999 \"on network: \"";
                            print "$coloredNetworkName\n";
                            print "                                                                            </li>\n";
                            print "                                                                        </ul>\n";
                            print "                                                                </li>\n";
                        } #/if
                    } #/for
                } #/if
            } #/for
        } #/for
        print "                                                            </ul>\n";
        print "                                                    </li>\n";
        print "                                                </ul>\n";
        print "                                        </li>\n";
    } #/for
    print "                                    </ul>\n";
    print "                            </li>\n";
}
#####################################################
#
# Function:
#
#    print_vgs
#
# Description:
#
#    Prints the shared volume groups associated with
#    whichever application in @apps is currently
#    being pointed to by $r.
#
# Arguments:
#
#    none
#
#####################################################
sub print_vgs(){
    if( !$vgsOfApps[$r][0] ){
        return;
    }
    print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    system "dspmsg scripts.cat 9999 \"Shared Volume Groups\""; print"\n";
    print "                                <ul class=\"collapsed\">\n";
    for($c = 0; $vgsOfApps[$r][$c]; $c++){
        print "                                    <li><span class=\"bullet\"></span>\n";
        print "<span class=\"nostatus\">$vgsOfApps[$r][$c]</span>\n";
        print "                                    </li>\n";
    }
    print "                                </ul>\n";
    print "                            </li>\n";
}
#####################################################
#
# Function:
#
#    print_cc_vgs
#
# Description:
#
#    Prints the concurrent volume groups associated
#    with whichever application in the @apps is
#    currently being pointed to by $r.
#
# Arguments:
#
#    none
#
#####################################################
sub print_cc_vgs(){
    if( !$ccVgsOfApps[$r][0] ){
        return;
    }
    print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    system "dspmsg scripts.cat 9999 \"Concurrent Volume Groups\"";
    print "                                    <ul class=\"collapsed\">\n";
    for($c = 0; $ccVgsOfApps[$r][$c]; $c++){
        print "                                        <li><span class=\"bullet\"></span>\n";
        print "<span class=\"nostatus\">$ccVgsOfApps[$r][$c]</span>\n";
        print "                                        </li>\n";
    }
    print "                                    </ul>\n";
    print "                            </li>\n";
}
#####################################################
#
# Function:
#
#    print_filesystems
#
# Description:
#
#    Prints the filesystems associated with whichever
#    application in the @apps is currently being
#    pointed to by $r.
#
# Arguments:
#
#    none
#
#####################################################
sub print_filesystems(){
    if( !$filesystemsOfApps[$r][0] ){
        return;
    }
    print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    system "dspmsg scripts.cat 9999 \"Filesystems\"";
    print "                                    <ul class=\"collapsed\">\n";
    for($c = 0; $filesystemsOfApps[$r][$c]; $c++){
        print "                                        <li><span class=\"bullet\"></span>\n";
        print "<span class=\"nostatus\">";
        my $tmp = $filesystemsOfApps[$r][$c];
        if($tmp eq "ALL"){
            system "dspmsg scripts.cat 9999 \"All\"";
        }
        else{
            print "$filesystemsOfApps[$r][$c]";
        }
        print "</span>\n";
        print "                                        </li>\n";
    }
    print "                                    </ul>\n";
    print "                            </li>\n";
}
#####################################################
#
# Function:
#
#    print_fast_connect_services
#
# Description:
#
#    Prints the AIX Fast Connect Services associated
#    with whichever application in the @apps is
#    currently being pointed to by $r.
#
# Arguments:
#
#    none
#
#####################################################
sub print_fast_connect_services(){
    if( !$fastConnectServicesOfApps[$r][0] ){
        return;
    }
    print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    system "dspmsg scripts.cat 9999 \"AIX Fast Connect Services\"";
    print "                                    <ul class=\"collapsed\">\n";
    for($c = 0; $fastConnectServicesOfApps[$r][$c]; $c++){
        print "                                        <li><span class=\"bullet\"></span>\n";
        print "<span class=\"nostatus\">$fastConnectServicesOfApps[$r][$c]</span>\n";
        print "                                        </li>\n";
    }
    print "                                    </ul>\n";
    print "                            </li>\n";
}
#####################################################
#
# Function:
#
#    printMonitors
#
# Description:
#
#    Displays the application monitors assigned to
#    the application $apps[$r]
#
# Arguments:
#
#    none
#
#####################################################
sub printMonitors(){
    if( !$monitorsOfApps[$r][0] ){ # If there aren't any monitors for this app:
        print "                <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"No application monitors are configured for\"";
        print " $apps[$r].";
        print "                </li>\n";
        return;
    }
    print "                <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    system "dspmsg scripts.cat 9999 \"Application monitors of\"";
    print " $apps[$r]\n";
    print "                        <ul class=\"collapsed\">\n";
    for($c = 0; $monitorsOfApps[$r][$c]; $c++){
        print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Monitor name:\"";
        print " <span class=\"nostatus\">$monitorsOfApps[$r][$c]</span>\n";
        print "                                <ul class=\"collapsed\">\n";
        # Now to display info on each monitor
        my $monitor_type = &get_monitor_value($monitorsOfApps[$r][$c], 2);
        if($monitor_type eq "user"){
            $monitor_type = "custom";
        }
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Type:\""; 
        print " <span class=\"nostatus\">$monitor_type</span>\n";
        print "                                    </li>\n";
        if($monitor_type eq "custom"){
            my $monitor_method = &get_monitor_value($monitorsOfApps[$r][$c], 3);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Monitor method:\""; 
            print " <span class=\"nostatus\">$monitor_method</span>\n";
            print "                                    </li>\n";
        }
        if($monitor_type eq "custom"){
            my $monitor_interval = &get_monitor_value($monitorsOfApps[$r][$c], 4);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Monitor interval:\""; 
            print " <span class=\"nostatus\">$monitor_interval</span> ";
            system "dspmsg scripts.cat 9999 \"seconds\"";
            print "                                    </li>\n";
        }
        if($monitor_type eq "custom"){
            my $hung_monitor_signal = &get_monitor_value($monitorsOfApps[$r][$c], 6);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Hung monitor signal:\""; 
            print " <span class=\"nostatus\">$hung_monitor_signal</span>\n";
            print "                                    </li>\n";
        }
        if($monitor_type eq "process"){
            my $process = &get_monitor_value($monitorsOfApps[$r][$c], 3);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Process monitored:\""; 
            print " <span class=\"nostatus\">$process</span>\n";
            print "                                    </li>\n";
        }
        if($monitor_type eq "process"){
            my $process_owner = &get_monitor_value($monitorsOfApps[$r][$c], 4);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Process owner:\""; 
            print " <span class=\"nostatus\">$process_owner</span>\n";
            print "                                    </li>\n";
        }
        if($monitor_type eq "process"){
            my $instance_count = &get_monitor_value($monitorsOfApps[$r][$c], 6);
            print "                                    <li><span class=\"bullet\"></span>\n";
            system "dspmsg scripts.cat 9999 \"Instance count:\""; 
            print " <span class=\"nostatus\">$instance_count</span>\n";
            print "                                    </li>\n";
        }
        my $stabilization_interval = &get_monitor_value($monitorsOfApps[$r][$c], 7);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Stabilization interval:\""; 
        print " <span class=\"nostatus\">$stabilization_interval</span> ";
        system "dspmsg scripts.cat 9999 \"seconds\"";
        print "                                    </li>\n";
        
        my $restart_count = &get_monitor_value($monitorsOfApps[$r][$c], 9);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Retry count:\""; 
        print " <span class=\"nostatus\">$restart_count</span> ";
        system "dspmsg scripts.cat 9999 \"tries\"";
        print "                                    </li>\n";
        
        my $restart_interval = &get_monitor_value($monitorsOfApps[$r][$c], 10);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Restart interval:\""; 
        print " <span class=\"nostatus\">$restart_interval</span> ";
        system "dspmsg scripts.cat 9999 \"seconds\"";
        print "                                    </li>\n";
        
        my $failure_action = &get_monitor_value($monitorsOfApps[$r][$c], 8);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Failure action:\""; 
        print " <span class=\"nostatus\">$failure_action</span>\n";
        print "                                    </li>\n";
        if($failure_action eq "notify"){
            my $notify_method = &get_monitor_value($monitorsOfApps[$r][$c], 12);
            if( !$notify_method ){
                print "                                    <li><span class=\"bullet\"></span>\n";
                system "dspmsg scripts.cat 9999 \"Notify method:\"";
                print " <span class=\"nostatus\">";
                system "dspmsg scripts.cat 9999 \"none\"";
                print "                                    </li>\n";
            }
            else{
                print "                                    <li><span class=\"bullet\"></span>\n";
                system "dspmsg scripts.cat 9999 \"Notify method:\""; 
                print " <span class=\"nostatus\">$notify_method</span>\n";
                print "                                    </li>\n";
            }
        }
        my $cleanup_method = &get_monitor_value($monitorsOfApps[$r][$c], 13);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Clean up method:\""; 
        print " <span class=\"nostatus\">$cleanup_method</span>\n";
        print "                                    </li>\n";
        my $restart_method = &get_monitor_value($monitorsOfApps[$r][$c], 11);
        print "                                    <li><span class=\"bullet\"></span>\n";
        system "dspmsg scripts.cat 9999 \"Restart method:\""; 
        print " <span class=\"nostatus\">$restart_method</span>\n";
        print "                                    </li>\n";
        print "                                </ul>\n";
        print "                            </li>\n";
    }
    print "                        </ul>\n";
    print "                </li>\n";
}
#####################################################
#
# Function:
#
#    print_topo
#
# Description:
#
#    Prints the cluster topology to standard out
#
# Arguments:
#
#    None
#
#####################################################
sub print_topo(){
    print "<h2>";
    system "dspmsg scripts.cat 9999 \"Topology\"";
    print "</h2>\n";
    print "<ul class=\"twistyRoot\">\n";
    print "    <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>\n";
    
    print "$clusterName ";
    system "dspmsg scripts.cat 9999 \"consists of the following nodes: \"";
    for($r = 0; $nodeNames[$r]; $r++){
        my $coloredNodeName = &nodeStateColoredHtml_of_node($nodeNames[$r]);
        print "$coloredNodeName";
    }
    print "\n";
    print "        <ul class=\"collapsed\">\n";
    for($r = 0; $nodeNames[$r]; $r++){    
        print "            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
        my $coloredNodeName = &nodeStateColoredHtml_of_node($nodeNames[$r]);
        print "$coloredNodeName\n";
        print "                <ul class=\"collapsed\">\n";
        print "                    <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
        system "dspmsg scripts.cat 9999 \"Network interfaces\"";
        print "\n";
        print "                        <ul class=\"collapsed\">\n";
        for($c = 0; $interfacesByNode[$r][$c]; $c++){
            my $interfaceName = &name_of_interface($nodeNames[$r], $interfacesByNode[$r][$c]);
            my $coloredInterfaceName = &interfaceStateColoredHtml_of_interface("$interfaceName", $r, $c);
            my $coloredNetworkName = &networkStateColoredHtml_of_network($r, $c);
            print "                            <li><span class=\"collapsed\" onclick=\"twisty(this);\"></span>";
            print "$coloredInterfaceName\n";
            print "                                <ul class=\"collapsed\">\n";
            print "                                    <li><span class=\"bullet\"></span>";
            local $_ = $ipsByNode[$r][$c];
            s/[0-9]//g;
            if($_ eq "..."){
                system "dspmsg scripts.cat 9999 \"with IP address: \"";
            }
            else{
                system "dspmsg scripts.cat 9999 \"device: \"";
            }
            print "<span class=\"nostatus\">$ipsByNode[$r][$c]</span>\n";
            if($_ eq "..."){
                print "                                    <li><span class=\"bullet\"></span>";
                system "dspmsg scripts.cat 9999 \"on interface: \"";
                print "<span class=\"nostatus\">$interfacesByNode[$r][$c]</span>\n";
            }
            print "                                    <li><span class=\"bullet\"></span>";
            system "dspmsg scripts.cat 9999 \"on network: \"";
            print "$coloredNetworkName\n";
            print "                                </ul>\n";
        }
        print "                        </ul>\n";
        print "                </ul>\n";
    }
    print "        </ul>\n";
    print "</ul>\n";
}
#####################################################
#
# Function:
#
#    appStateColoredHtml_of_app
#
# Description:
#
#    Returns the name of an application in either
#    green or red based on the application's state.
#
# Arguments:
#
#    $_[0]: @apps array row pointer to the app
#
#####################################################
sub appStateColoredHtml_of_app($){
    if($appStates[$_[0]] eq $ONLINE){
        return "<span class=\"up\">$apps[$_[0]]</span>";
    }
    elsif( ($appStates[$_[0]] eq $OFFLINE) ||
           ($appStates[$_[0]] eq $ERROR) ){
        return "<span class=\"down\">$apps[$_[0]]</span>";
    }
    elsif($appStates[$_[0]] eq $ACQUIRING){
        return "<span class=\"unstable\">$apps[$_[0]]</span>";
    }
    elsif($appStates[$_[0]] eq $RELEASING){
        return "<span class=\"unstable\">$apps[$_[0]]</span>";
    }
    elsif($appStates[$_[0]] eq $UNKNOWN ){
        return "<span class=\"unknown\">$apps[$_[0]]</span>";
    }
    else{
        return "<span class=\"inactive\">$apps[$_[0]]</span>";
    }
}
#####################################################
#
# Function:
#
#    nodeStateColoredHtml_of_node
#
# Description:
#
#    Returns a node name in colored html format
#    according to the state of the particular node.
#
# Arguments:
#
#    $_[0]: a node name
#
#####################################################
sub nodeStateColoredHtml_of_node($){
    my $tmp = &state_of_node($_[0]);
    if($tmp){
        if($tmp eq $UP){
            return "<span class=\"up\">$_[0]</span>";
        }
        elsif($tmp eq $DOWN){
            return "<span class=\"down\">$_[0]</span>";
        }
        elsif($tmp eq $JOINING){
            return "<span class=\"unstable\">$_[0]</span>";
        }
        elsif($tmp eq $LEAVING){
            return "<span class=\"unstable\">$_[0]</span>";
        }
    }
    # This happens when cluster services are inactive
    else{
        return "<span class=\"nostatus\">$_[0]</span>";
    }
}
#####################################################
#
# Function:
#
#    networkStateColoredHtml_of_network
#
# Description:
#
#    Returns a network name in colored html format
#    according to the state of the particular network
#
# Arguments:
#
#    $_[0]: a node name
#    $_[1]: an interface name (on that node. ex: en1)
#
#####################################################
sub networkStateColoredHtml_of_network($$){
    if($overall_clstrmgr_state eq $INACTIVE){
        return "<span class=\"nostatus\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
    if($networkStates[$_[0]][$_[1]] eq $UP){
        return "<span class=\"up\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
    elsif($networkStates[$_[0]][$_[1]] eq $DOWN){
        return "<span class=\"down\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
    elsif($networkStates[$_[0]][$_[1]] eq $JOINING){
        return "<span class=\"unstable\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
    elsif($networkStates[$_[0]][$_[1]] eq $LEAVING){
        return "<span class=\"unstable\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
    elsif($networkStates[$_[0]][$_[1]] eq $UNKNOWN){
        return "<span class=\"unknown\">$networksOfInterfaces[$_[0]][$_[1]]</span>";
    }
}
#####################################################
#
# Function:
#
#    serviceLabelStateColoredHtml_of_service_label
#
# Description:
#
#    Returns a service label in colored html format
#    according to the state of the particular label
#
# Arguments:
#
#    $_[0]: name of service label
#    $_[1]: array row pointer
#    $_[2]: array col pointer
#
#####################################################

sub serviceLabelStateColoredHtml_of_service_label($$$){
    if($appStates[$r] ne $OFFLINE){
        if($serviceIpStates[$r][$c] eq $ONLINE){
            return "<span class=\"up\">$_[0]</span>";
        }
        else{
            return "<span class=\"down\">$_[0]</span>";
        }
    }
    # If the app that this service label belongs to is offline
    # then we know that the service label is offline as well
    # so we'll just make it red
    else{
        return "<span class=\"down\">$_[0]</span>";
    }
}
#####################################################
#
# Function:
#
#    interfaceStateColoredHtml_of_interface
#
# Description:
#
#    Returns an interface name in colored html format
#    according to the state of the particular label
#
# Arguments:
#
#    $_[0]: name of interface
#    $_[1]: array row pointer
#    $_[2]: array col pointer
#
#####################################################
sub interfaceStateColoredHtml_of_interface($$$){
    if($overall_clstrmgr_state eq $ACTIVE){
        if($interfaceStatesByNode[$_[1]][$_[2]] eq $UP){
            return "<span class=\"up\">$_[0]</span>";
        }
        elsif($interfaceStatesByNode[$_[1]][$_[2]] eq $DOWN){
            return "<span class=\"down\">$_[0]</span>";
        }
        elsif($interfaceStatesByNode[$_[1]][$_[2]] eq $UNKNOWN){
            return "<span class=\"unknown\">$_[0]</span>";
        }
        return "$interfaceStatesByNode[$_[1]][$_[2]]";
    }
    elsif($overall_clstrmgr_state eq $INACTIVE){
        return "<span class=\"nostatus\">$_[0]</span>";
    }
}

#####################################################
# Main
#####################################################

umask 177;

# setup some shell variables
$ENV{'PATH'}="$ENV{'PATH'}:$HACMPBASE/utilities";
$ENV{'ODMDIR'}="/etc/objrepos";

# Random filenames will be used for increased security
my $randnum;
$randnum = int(rand 999999);

# Verification that the file doesn't already exist
while( -e "snmpinfo.out.$randnum"){
    $randnum = int(rand 999999);
}
$SNMPINFO_SOURCE = "/tmp/snmpinfo.out.$randnum";

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
my $rc = system("$HACMPBASE/wsm/cgi-bin/wsm_auth.cgi");
if ( $rc != 0 ) {
    exit 0
}

&printTop; # Starts off the html file we're creating
$local_clstrmgr_state = &state_of_local_clstrmgr();
@cllsif = `$HACMPBASE/utilities/cllsif -c`;

# These two routines collect most of the info we'll need to display
&probeStatic;
&probeDynamic;

&display;

&printBottom; # Ends the html file

# Before exiting we'll clean up the temporary snmpinfo file
# if one exists.
if( -e "$SNMPINFO_SOURCE" ){
    system "rm -fr $SNMPINFO_SOURCE";
}

exit 0;
