#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_cmd_str.cgi.sh 1.26 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# @(#)02	1.26 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_cmd_str.cgi.sh, hacmp.utils, 52haes_r541, 0747B_hacmp541 11/6/07 15:12:45

###############################################################################
#
# Name:  wsm_cmd_str.cgi
#
# Description: displays the "command to execute" (pf6) for a smit panel
#
# Arguments: panel id
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################


###############################################################################
#
# Name: body_start
#
# Description: add the html to start the body
#
# Arguments:    
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
body_start ()
{
    [[ $VERBOSE_LOGGING == "high" ]] && set -x

    TITLE=$(odmget -q "id = $NAME" sm_cmd_hdr | grep "	name =" | cut -f2 -d\")

    $BINDIR/wsm_html_lib body_start_popup "$TITLE"
}



###############################################################################
#
# Name: body_end
#
# Description: add a textbox for SMIT FastPath and add html tags to close the
#              document.
#
# Arguments:    
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
body_end ()
{
    [[ $VERBOSE_LOGGING == "high" ]] && set -x

    print "</div>

<script language='JavaScript'>
if (docbody) { docbody.style.visibility='visible'; }
</script>

</body>
</html>"
}



#
# Main starts here
#

#
# parse some cgi input from the hacmp websm, execute the command, and
# display the results
#
PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Support global/env specification

WORKDIR=/tmp

# where to look for message catalogs
export CATDIR=/usr/lib/nls/msg/C

# initialize the cgi library
CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin

# smit menus are in
export ODMDIR=/usr/lib/objrepos

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi


#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
CONFDIR=/usr/es/sbin/cluster/wsm
CONF_FILE="$CONFDIR/wsm_smit.conf"
LOGFILE="$CONFDIR/logs/wsm_smit.log"
export SCRIPTFILE="../logs/wsm_smit.script"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
set -a
. $CONF_FILE >/dev/null 2>&1
set +a

[[ $VERBOSE_LOGGING == "high" ]] && set -x


NAME=$($BINDIR/wsm_cgiparse -v panel_id)

# print the html header and opening body tags
body_start

#
# Generate a script and display it.  The script generated will be exactly the
# same script as the one generated for command execution (i.e. it calls the
# same command generation code).
#
SCRIPT="${WORKDIR}/$NAME.COMMAND.$$"
$BINDIR/wsm_cmd_exec -x -f "$SCRIPT" -i "$NAME" -t cmd_to_exec 2>&1 >>$LOGFILE

# The return code may have been negative, in which case $? will be
# 255+(negative value returned).  Because of this, 128 is the maximum
# returnable value before we are not able to distinguish between a
# positive and negative return value.  This little formula gives us the
# negative return value when above 128.
RC=$(( ($?>128)*-256+$? ))
if (( RC == -1 )) ; then
    # wsm_cmd_exec uses -1 as the return code for internal errors, as
    # opposed to an exit code returned by the generated script.  If we get
    # -1, report a general error to the user.
    print "<i>There was an internal error.  Please try again.</i><p>"

# wsm_build_cmd returns -2 if there was a data validation error.
else if (( RC == -2 )) ; then
    print "<i>There was a problem with the submitted request.  Please try again.</i><p>"

else
    print "<h2>The command string to execute is:</h2>"
    print "<hr size=4>"
    print "<pre class=\"output\">"

    # cat the script file...
    #
    # NOTE: this *must* be done via wsm_cmd_exec, because the file being
    #       'cat'ted is accessible only by root (for security). Therefore,
    #       the setuid capabilities of wsm_cmd_exec are needed in order
    #       to do *anything* with the file.
    $BINDIR/wsm_cmd_exec -C -f "$SCRIPT"

    print "</pre>"
    print "<hr size=4>"
fi ; fi

print "<input type=\"button\" value=\"Close\" onclick=\"window.close()\">"
body_end
