#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_image.cgi.sh 1.15 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

###############################################################################
#
# Name: wsm_image.cgi
#
# Description:  This script takes the html of the current SMIT panel and adds
#		it to the logfile.
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################

# @(#)67        1.15 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_image.cgi.sh, hacmp.utils, 52haes_r541, 0747B_hacmp541 11/6/07 15:48:49

PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification

#
# main() starts here
#

# initialize
CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm

#${CGI_BIN}/cgiutils -status 200 -ct text/html >/dev/null 2>&1

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi

#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
CONF_FILE="$CONFDIR/wsm_smit.conf"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
LOGFILE='/usr/es/sbin/cluster/wsm/logs/wsm_smit.log'
set -a
. $CONF_FILE >/dev/null
set +a

[[ $VERBOSE_LOGGING == "high" ]] && set -x


# get the name of the menu we are building
# for testing, export QUERY_STRING="name=hacmp"
TYPE=$(${CGI_BIN}/wsm_cgiparse -v type)

# get the type of panel so that the correct script can be used
case $TYPE in
    m)  # menu panel
	PARENT_SCRIPT="wsm_menu_opt.cgi"
	;;
    n)  # name select
	PARENT_SCRIPT="wsm_name_hdr.cgi"
	;;
    d)  # command screen
	PARENT_SCRIPT="wsm_cmd_hdr.cgi"
	;;
esac

OUTPUT=$($PARENT_SCRIPT $QUERY_STRING)

{
    date +"[%b %d %Y, %T]"
    print "\
User IP = \"$REMOTE_ADDR\"
Cut and paste into a seperate file and open in a web browser to view.
	====Begin HTML panel image====
$OUTPUT
	====End HTML panel image====
"
} >>$LOGFILE

print "\
<HTML>
<HEAD>
<TITLE>Image Captured</TITLE>
<SCRIPT LANGUAGE=\"JavaScript\">
<!-- this function catches keystrokes to trigger various actions -->
document.onkeydown = function catchKey() {
    if (event.keyCode==114)
        closeMe()
}
<!-- this function closes the help window -->
function closeMe() {
    window.close();
    event.keyCode = 0;
    event.returnValue = false;
    event.cancelBubble = true;
    return false;
}
</SCRIPT>
</HEAD>
<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" BACKGROUND=\"/wsm_background.gif\">
<P ALIGN=\"center\"><FONT FACE=\"Arial,Helvetica,sans-serif\" SIZE=\"4\">
Screen image recorded to log file.</FONT>
<P ALIGN=\"center\"><INPUT TYPE=\"button\" value=\"Close\" onclick=\"javascript:window.close()\">

</body></html>"
