#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_index.cgi.sh 1.21 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

###############################################################################
#
# Name: wsm_index.cgi 
# Description: Prints the WebSMIT index page
#
# Arguments: 
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
# Questions ? Comments ? Suggestions ? mailto:hafeedbk@us.ibm.com
#
###############################################################################

# @(#)76        1.21 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_index.cgi.sh, hacmp.utils, 52haes_r541, 0747B_hacmp541 11/6/07 15:54:07



#
# Main starts here
#


PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification
VERSION="1.21"

export WSM_VERSION=$VERSION
export WSM_PROGNAME=$PROGNAME

# initialize the cgi library
CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm

#${CGI_BIN}/cgiutils -status 200 -ct text/html >/dev/null 2>&1

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi

#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
CONF_FILE="$CONFDIR/wsm_smit.conf"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
set -a
. $CONF_FILE >/dev/null
set +a

[[ $VERBOSE_LOGGING == "high" ]] && set -x


#
# Print the HTML header and opening body tags
#
$CGI_BIN/wsm_html_lib body_start_help_only "/wsm_index_hlp.html"

print "\
<div id='menuBox'><ul class='menu'>
<li><a href='/cgi-bin/wsm_clstat.cgi' title='Cluster Status' onMouseOver=\"JavaScript: window.status=''; return true;\">Cluster Status</a></li>
<li><a href='/cgi-bin/wsm_menu_opt.cgi?name=cm_hacmp_main_menu_dmn' title='Cluster Configuration and Management' onMouseOver=\"JavaScript: window.status=''; return true;\">Cluster Configuration and Management</a></li>
<li><a href='/cgi-bin/wsm_bookshelf.cgi' title='Online Documentation' onMouseOver=\"JavaScript: window.status=''; return true;\">Online Documentation</a></li>
</ul></div>"

#
# Print the HTML footer code
#
$CGI_BIN/wsm_html_lib body_end_index "/wsm_index_hlp.html" "act_smittree act_smittree_link"
