#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_skin.cgi.sh 1.19 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

###############################################################################
#
# Name: wsm_skin.cgi
#
# Description: Presents the user with a list of skins. When a choice is made 
#              the proper modifications are made to the conf file
#
# Arguments: none
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
# Questions ? Comments ? Suggestions ? mailto:hafeedbk@us.ibm.com
#
###############################################################################

# @(#)95        1.19 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_skin.cgi.sh, hacmp.wsm, 52haes_r541, 0747B_hacmp541 11/6/07 16:35:23

PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification


###############################################################################
#
# Name: make_menu
#
# Description: build a menu of available skins
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
#
make_menu ()
{
[[ $VERBOSE_LOGGING == "high" ]] && set -x
VERSION="1.19"

# print the html for the standard WebSMIT header
print "\
<HTML>
<HEAD>
<TITLE>IBM WebSMIT - Skin Picker</TITLE>
<meta HTTP-EQUIV=\"cache-control\" CONTENT=\"no-cache\">
<meta name=\"copyright\" content=\"copyright (c) 2004 IBM corporation\" />
<meta name=\"source\" content=\"$0 version $VERSION\" />

<SCRIPT LANGUAGE=\"JavaScript\">
<!-- Start
window.name='SMITmain'
// End -->
</SCRIPT>
</HEAD>
<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" BACKGROUND=\"/wsm_background.gif\" STYLE=\"margin:0px\">
<table border=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td height=\"1\" align=\"center\" bgcolor=\"#000000\">
<table border=\"0\" cellspacing=\"0\" width=\"600\" align=\"center\"><tr>
<td align=\"center\"><img src=\"/wsm_logo_ibm.gif\"></td>
<td align=\"center\"><a href=\"/cgi-bin/wsm_index.cgi\" onMouseOver=\"JavaScript: window.status=''; return true;\"><img src=\"/wsm_logo_ha.gif\" border=\"0\"></a></td>
<td align=\"center\"><img src=\"$SKIN_LOGO\"></td>
</tr></table>
</td></tr>
<tr><td valign=\"top\" align=\"center\">
<BR>"

# check that there isn't a problem listing the skins
SKIN_LIST=$(ls $SKIN_ROOT)
if [[ -z $SKIN_LIST ]]; then
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\"><B>"
    print "Error: no skins found!<BR>"
    print "Check that skins are installed in $SKIN_ROOT with the correct permissions.</B></FONT>"
    print "</TD></TR></TABLE></BODY></HTML>"
    exit
fi

print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\"><B>"
print "Available skins in $SKIN_ROOT:<BR>&nbsp;</B></FONT>"
#print "<FORM ACTION=\"/cgi-bin/wsm_skin.cgi\">"
print "<TABLE BORDER=\"0\" WIDTH=\"600\">" 
# list the skins in $SKIN_ROOT as an html form
for skin in $SKIN_LIST
  do
  # small sanity check
  if [[ -d "$SKIN_ROOT/$skin" && -e "$SKIN_ROOT/$skin/cluster.cat" ]]; then
      print "<TR><TD ALIGN=\"center\">"
      print "<a HREF=\"/cgi-bin/wsm_skin.cgi?skin=${skin}&reload=please\" title=\"$skin\" onMouseOver=\"JavaScript: window.status=''; return true;\"><IMG SRC=\"/skins/${skin}_logo.gif\" BORDER=\"0\">"
      print "<BR><FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">$skin"
      print "</FONT></A><BR>&nbsp;</TD></TR>"
  fi
done
print "</TABLE>"
print "</TD></TR></TABLE></BODY></HTML>"
}

###############################################################################
#
# Name:
#
# Description: swap the needed files to change the skin
#
# Arguments:    
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
#
change_skin ()
{
[[ $VERBOSE_LOGGING == "high" ]] && set -x

SKIN_SRC=$SKIN_ROOT/$CHOSEN_SKIN

#set up the html header
print "\
<HTML>
<HEAD>
<TITLE>IBM WebSMIT - Skin Changed</TITLE>
<meta name=\"copyright\" content=\"copyright (c) 2004 IBM corporation\" />
<meta name=\"source\" content=\"$0 version $VERSION\" />
<script language=\"JavaScript\">
function reloadOnce() {
    var url=document.location.href;
    var url1=url.split('&');
    if (url1[1] != \"reload=done\") {
        document.location.href=url1[0]+\"&reload=done\";
    }
}
function skinBack() {
    var url=document.location.href;
    var url1=url.split('&');
    if (url1[1] == \"reload=done\") {
        window.location='/cgi-bin/wsm_index.cgi';
    }
}
</script>

</HEAD>
<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" BACKGROUND=\"/wsm_background.gif\" STYLE=\"margin:0px\" onload=\"reloadOnce()\" onunload=\"skinBack()\">
<table border=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td height=\"1\" align=\"center\" bgcolor=\"#000000\">
<table border=\"0\" cellspacing=\"0\" width=\"600\" align=\"center\"><tr>
<td align=\"center\"><img src=\"/wsm_logo_ibm.gif\"></td>
<td align=\"center\"><a href=\"/cgi-bin/wsm_index.cgi\" onMouseOver=\"JavaScript: window.status=''; return true;\"><img src=\"/wsm_logo_ha.gif\" border=\"0\"></td>
<td align=\"center\"><img src=\"$SKIN_LOGO\"></td>
</tr></table>
</td></tr>
<tr><td valign=\"top\" align=\"center\"><BR>"

# quick check for valid skin name
if [[ ! -f "$SKIN_SRC/cluster.cat" ]]; then
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\"><B>"
    print "Error: skin $SKIN not found!</B></FONT>"
    print "</TD></TR></TABLE></BODY></HTML>"
    exit
fi

ERROR_STATE=0   # tracks whether the copy commands completed successfully or not

# copy the message cats
for cat in $SKIN_CATALOGS
  do
  cp $SKIN_SRC/$cat $CAT_DIR
  RC=$?
  if [[ $RC != 0 ]]; then
      print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">"
      print "Error copying $cat for $CHOSEN_SKIN to $CAT_DIR - RC:$RC<BR></FONT>"
      ERROR_STATE=1
  fi
done

# copy the skin logo image
cp $SKIN_SRC/${CHOSEN_SKIN}_logo.gif $SKIN_HTDOCS_DIR
RC=$?
if [[ $RC != 0 ]]; then
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">"
    print "Error copying logo for $CHOSEN_SKIN to $SKIN_HTDOCS_DIR - RC:$RC<BR></FONT>"
    ERROR_STATE=1
fi

# update the conf file
if [[ -f $CONF_FILE ]]; then
    
    # check that the conf is formatted correctly
    BUF=$(cat "$CONF_FILE")
    WROTE_CURR=0
    WROTE_LOGO=0
    NO_HEADER=0
    print -- "$BUF" | while read i
      do
      FIELD=$(echo "$i" | cut -f1 -d\=)
      if [[ $FIELD == \#\!/bin/ksh* ]]; then
	  FOUND_HEADER=1
      elif [[ $FIELD == "CURR_SKIN" ]]; then
	  FOUND_CURR=1
      elif [[ $FIELD == "SKIN_LOGO" ]]; then
	  FOUND_LOGO=1
      fi
    done
    
    # if the conf file has no header, give it one
    if [[ $FOUND_HEADER != 1 ]]; then
	{
	    print "#!/bin/ksh"
	    cat "$CONF_FILE"
	} > $TEMP_BUF
	    cp $TEMP_BUF $CONF_FILE
	    rm -f $TEMP_BUF
    fi
    # if the skin fields weren't found, create them
    if [[ $FOUND_CURR != 1 || $FOUND_LOGO != 1 ]]; then
	{
	    print "CURR_SKIN=\"$CHOSEN_SKIN\"\n"
	    print "SKIN_LOGO=\"/skins/${CHOSEN_SKIN}_logo.gif\"\n"
	    print "echo \"\$SKIN_LOGO\"\n"
	} >> $CONF_FILE
	RC=$?

    # if the skin fields were found, change the values
    else
#	sed -e "s/$CURR_SKIN/$CHOSEN_SKIN/g" $TEMP_BUF > $CONF_FILE
	sed -e "s/CURR_SKIN=.*/CURR_SKIN=\"${CHOSEN_SKIN}\"/g" -e "s#SKIN_LOGO=.*#SKIN_LOGO=\"/skins/${CHOSEN_SKIN}_logo.gif\"#g" $TEMP_BUF > $CONF_FILE
	RC=$?
	rm -f $TEMP_BUF
    fi

# make a new conf file and warn the user
else
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">"
    print -- "$ENV_VAR_FILE not found! Making new configuration file.<BR></FONT>"
    {
	print "#!/bin/ksh"
	print ""
	print "# enviroment variables for the $CHOSEN_SKIN skin"
	print ""
	print "CURR_SKIN=\"$CHOSEN_SKIN\""
	print "SKIN_LOGO=\"/skins/${CHOSEN_SKIN}_logo.gif\""
	print ""
	print "VERBOSE_LOGGING=\"high\""
	print ""
	print "echo \"\$SKIN_LOGO\""
    } >$CONF_FILE
    RC=$?
    chmod +x $CONF_FILE
fi

# error checking
if [[ $RC != 0 ]]; then
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">"
    print "Error writing new WebSMIT global variables file to $ENV_VAR_FILE - RC:$RC<BR></FONT>"
    ERROR_STATE=1
fi


print "<P>"

if [[ $ERROR_STATE == 0 ]]; then   # copy commands completed successfully
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"4\">"
    print "Skin change completed successfully.</FONT>"
else
    print "<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"4\">"
    print "Please check that skin is installed correctly."
fi

print "<P ALIGN=\"center\"><INPUT TYPE=\"button\" VALUE=\"Home\" onclick=\"window.location='/cgi-bin/wsm_index.cgi'\">"
print "</TD></TR></TABLE>"
print "</BODY></HTML>"
}

#
# Main starts here
#

[[ "$VERBOSE_LOGGING" == "high" ]] && set -x


# set the location of where files will be moved to
SKIN_HTDOCS_DIR="../htdocs/en_US/skins"
CAT_DIR="/usr/lib/nls/msg/C"

# each skin must have these files
SKIN_CATALOGS="cluster.cat cluster_hlp.cat"

# initialize
CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm


# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi

# where to find the skin sources
SKIN_ROOT="/tmp/wsm_skins"

# set up the WebSMIT environment variables
CONF_FILE="$CONFDIR/wsm_smit.conf"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
export CURR_SKIN=""
LOGFILE='/usr/es/sbin/cluster/wsm/logs/wsm_smit.log'

#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
set -a
. $CONF_FILE >/dev/null
set +a

[[ $VERBOSE_LOGGING == "high" ]] && set -x


# temporary buffer file
TEMP_BUF="/tmp/wsm_smit.tmp.$$"
cp $CONF_FILE $TEMP_BUF

if [[ -n $QUERY_STRING ]]; then
    # get the name of the skin to change to; if none, build a menu
    CHOSEN_SKIN=$(${CGI_BIN}/wsm_cgiparse -v skin)
fi

if [[ -z $CHOSEN_SKIN ]]; then   # we are making a menu

    make_menu

else   # switch the skins
    
# we need to make the browser refresh itself for the changes to be evident, but
# if there is a reload script every time the page is served, it will create
# an infinite loop. we will track the page reloads with a cgi variable.
    

    change_skin

    RELOADED=$(${CGI_BIN}/cgiparse -v reload)
    if [[ $RELOADED == "please" ]]; then
	if [[ $VERBOSE_LOGGING == "high" ]]; then
            # make a log entry for the skin change
	    {
		date +"[%b %d %Y, %T]"
		print "WebSMIT skin changed:"
		print "	Chosen Skin = \"$CHOSEN_SKIN\""
		print "	Error Code  = \"$ERROR_STATE\""
		print "	User IP     = \"$REMOTE_ADDR\""
		print ""
	    } >>$LOGFILE
	fi
    fi
fi
