#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_unsupported.cgi.sh 1.16 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2004,2008 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

###############################################################################
#
# Name: wsm_unsupported.cgi
#
# Description: Generate the page displayed when the user tries to access
#              an unsupported smit menu.
#
# Arguments: panel (attempted to be) accessed
#
# Returns:      None
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################

# @(#)53        1.16 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_unsupported.cgi.sh, hacmp.wsm, 52haes_r541, 0747C_hacmp541 1/11/08 12:15:18

#
# Main starts here
#

PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification
VERSION="1.16"


# set the location of message catalog
CAT_DIR="/usr/lib/nls/msg/C"

# initialize
CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm

# where to find the skin sources
SKIN_ROOT="/tmp/wsm_skins"

# set up the WebSMIT environment variables
CONF_FILE="$CONFDIR/wsm_smit.conf"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
export CURR_SKIN=""

# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi

#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
set -a
. $CONF_FILE >/dev/null
set +a

[[ $VERBOSE_LOGGING == "high" ]] && set -x


#=========================================================================
# Load the common WebSMIT functions.
#
# NOTE: make sure the file being sourced is owned by root and only the
#       owner has write permissions.  Being writable by any other person
#       could allow them to run arbitrary commands as root.
#=========================================================================
typeset COMMON_LIB="/usr/es/sbin/cluster/wsm/cgi-bin/wsm_common"
typeset LOGFILE="/usr/es/sbin/cluster/wsm/logs/wsm_smit.log"
if [[ -n "$(find $COMMON_LIB ! -user root -o -perm -0020 -o -perm -0002)" ]]
then
    print "ERROR: invalid permissions for $COMMON_LIB. " \
          "This file must only be writable by root." >>$LOGFILE 2>&1
    exit 1
else
    . $COMMON_LIB >>$LOGFILE 2>&1
    set_wsm_locale >>$LOGFILE 2>&1
fi


$CGI_BIN/wsm_html_lib body_start_noscript "$TITLE"

# print the html for the standard WebSMIT header
print "\
<HTML>
<HEAD>
<TITLE>IBM WebSMIT - Unsupported SMIT Path</TITLE>
<meta HTTP-EQUIV=\"cache-control\" CONTENT=\"no-cache\">
<meta name=\"copyright\" content=\"copyright (c) 2004 IBM corporation\" />
<meta name=\"source\" content=\"$0 version $VERSION\" />

</HEAD>
<BR>

<FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\">
<CENTER><B>"

MSG=$(getmsg wsm_smit.cat 100 "Sorry, this SMIT path uses terminal settings or system functions that are not supported by WebSMIT.")
print -- "$MSG<BR>&nbsp;
</FONT>
</B>"

BACK=$(getmsg wsm_smit.cat 47 "Back")
print "\
<P ALIGN='center'>
<INPUT TYPE='button' VALUE=\"$BACK\" onclick='history.go(-1)'><BR>&nbsp;

</CENTER>

</BODY></HTML>"
