#!/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_view_log.cgi.sh 1.16 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2003,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

###############################################################################
#
# Name: wsm_view_log.cgi
#
# Description: display the contents of the wsm_smit log
#
# Arguments: none
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################

# @(#)68        1.16 src/43haes/usr/sbin/cluster/wsm/cgi-bin/wsm_view_log.cgi.sh, hacmp.utils, 52haes_r541, 0747B_hacmp541 11/6/07 16:56:12

PROGNAME=$(basename ${0})
export PS4='${PROGNAME}[${LINENO}] '
[[ $VERBOSE_LOGGING == "high" ]] && set -x # Supports global/env specification

###############################################################################
#
# Name: body_start
#
# Description:  prints a slightly modified version of the WebSMIT header
#
# Arguments:
#
# Returns:      0 - success
#               1 - failure
#
# Environment:  Executed by the http server daemon (user=nobody)
#
###############################################################################
#
body_start ()
{
[[ $VERBOSE_LOGGING == "high" ]] && set -x

ID=$1
CURR_TITLE=$(odmget -q "next_id = $ID" $ODM | grep "	text = ....*" | cut -f 2  -d \")
VERSION="1.16"

print "\
<HTML>
<HEAD>
<TITLE>IBM WebSMIT - Log</TITLE>
<META HTTP-EQUIV=\"cache-control\" CONTENT=\"no-cache\">
<meta name=\"copyright\" content=\"copyright (c) 2004 IBM corporation\" />
<meta name=\"source\" content=\"$0 version $VERSION\" />

</HEAD>

<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" BACKGROUND=\"/wsm_background.gif\" STYLE=\"margin:0px\" onload=\"document.all.backButton.focus()\">
<table border=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td height=\"1\" bgcolor=\"#000000\">
<table border=\"0\" cellspacing=\"0\" width=\"700\"><tr>
<td align=\"center\" width=\"150\">&nbsp;</td>
<td align=\"center\"><img src=\"/wsm_logo_ibm.gif\"></td>
<td align=\"center\"><a href=\"/cgi-bin/wsm_index.cgi\" onMouseOver=\"JavaScript: window.status=''; return true;\"><img src=\"/wsm_logo_ha.gif\" border=\"0\"></a></td>
<td align=\"center\"><img src=\"$SKIN_LOGO\"></td>
</tr></table>
</td></tr>
<tr><td valign=\"top\">"

}

#
# main() starts here
#

CGI_BIN="."
BINDIR=/usr/es/sbin/cluster/wsm/cgi-bin
CONFDIR=/usr/es/sbin/cluster/wsm


# Run some access validations.  This script will also output the
# Content-type header so we don't have to do it here.
$BINDIR/wsm_auth.cgi
if (( $? != 0 )); then
    exit 0
fi

#=============================================================
# Set up the WebSMIT environment
# ------------------------------
# NOTE: there is no need to check for root ownership of the
#       WebSMIT configuration file here. It has already been
#       validated by the call to "wsm_auth.cgi", above.
#=============================================================
CONF_FILE="$CONFDIR/wsm_smit.conf"
export SKIN_LOGO="/skins/DEFAULT_logo.gif"
export LOGFILE="../logs/wsm_smit.log" # Default log location
set -a
. $CONF_FILE >/dev/null
set +a

body_start

# check that the logfile exists
if [[ ! -f $LOGFILE ]]; then
    print "<BR><FONT FACE=\"arial,helvetica,sans-serif\" SIZE=\"2\"><B>"
    print "Error: Log file not found!"
    print "</B></FONT></TD></TR></BODY></HTML>"
    exit
fi

LOG=$(cat $LOGFILE | sed 's/\</\&lt\;/g' | sed 's/\>/\&gt\;/g')

print "\
<BR><BR><PRE>
$LOG

====END LOG FILE====
</PRE>

<TABLE BORDER=\"0\" WIDTH=\"800\"><TR><TD ALIGN=\"center\">
<INPUT TYPE=\"button\" ID=\"backButton\" value=\"Back\" onclick=\"history.go(-1)\"></P>
</TD></TR></TABLE
</TD></TR></TABLE>
</BODY></HTML>"
