/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2006               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)20       1.2 src/43haes/usr/sbin/cluster/wsm/docroot/Handler.js, hacmp.wsm, 52haes_r540, r5400622c 3/27/06 13:49:21 */

/* Code common to all frames */

// If not already defined...
if ( is_undefined('Handler') || isIE() ) {

    function Handler(name) { 
        this.moduleName = name;
        this.window = window;
    }

    Handler.prototype.processMessage = function(Msg) {
        if (this.next) {
            this.next.processMessage(Msg);
        }
    };

    Handler.prototype.addHandler = function(newHandler) {
        /* Make sure the handler is only added once to the list */
        if (this.constructor == newHandler.constructor) {
            delete newHandler;
            return;
        }
        if (this.next) {
            this.next.addHandler(newHandler);
        }
        else {
            this.next = newHandler;
            this.next.prev = this;
        }
    };

    Handler.prototype.remove = function() {
        if (this.prev) { this.prev.next = this.next; }
        if (this.next) { this.next.prev = this.prev; }
    };

    Handler.prototype.unload = function(oWindow) {
        n = this.next;
        if (this.window == oWindow) { this.remove(); }
        if (n) { n.unload(oWindow); }
    };

    Handler.prototype.mModule = function() {
        return top.MODULES[this.moduleName];
    };

} // Handler

// ++++++++++ END Handler.js ++++++++++ //
