/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/docroot/Module.js 1.9      */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)22       1.10 src/43haes/usr/sbin/cluster/wsm/docroot/Module.js, hacmp.wsm, 52haes_r541, 0736A_hacmp541 5/21/07 16:56:31 */


if ( is_undefined('Module') || isIE() ) {

    function Module(name, type) {

        this.name = name;
        this.type = type;
        this.window = window;

        this.prefix = (this.type == ACTIVITY ? "Act" : "Nav");
        this.eBody = undefined;  // Body div (e)lement
        this.eTab = undefined;   // Tab div (e)lement
        this.active = false;
        this.waiting_cursor = 'progress';
    };

    Module.prototype.mPrefix = function() { return this.prefix; };
    Module.prototype.mTabId = function() {
        return this.prefix + "Tab_" + this.name;
    };
    Module.prototype.mBodyId = function() {
        return this.prefix + "Body_" + this.name;
    };
    Module.prototype.mBodyElem = function() {
        /* Keep a reference to the body div after we've looked it up once.  It
         * should not change, and subsequent requests will return more quickly.
         */
        if ( !this.eBody ) {
            this.eBody = document.getElementById(this.mBodyId());
        }
        return this.eBody; 
    };
    Module.prototype.mTabElem = function() {
        if ( !this.eTab ) {
            this.eTab = document.getElementById(this.mTabId());
        }
        return this.eTab;
    };
    Module.prototype.mActivate = function() {
        this.mTabElem().className = this.mPrefix() + 'Tab_Active';
        this.mBodyElem().className = this.mPrefix() + 'Body_Active' + ' ' + this.name;
        this.active = true;

        /* Fix the div to fit the window */
        window.fixActiveBodySize();
    };
    Module.prototype.mDeactivate = function() {
        this.mTabElem().className = this.mPrefix() + 'Tab_Inactive';
        this.mBodyElem().className = this.mPrefix() + 'Body_Inactive' + ' ' + this.name;
        this.active = false;
    };
    Module.prototype.mActive = function() { return this.active; };

    Module.prototype.onload = function() { };
    Module.prototype.cleanup = function() { };

    Module.prototype.working_on = function() {
        this.mBodyElem().style.cursor = this.waiting_cursor;
    };

    Module.prototype.working_off = function() {
        this.mBodyElem().style.cursor = 'default';
    };
    


    /***********************************************************************
     * Method: handleClick
     *
     * Description:
     *
     *      This method actually handles all clicks, so it should be bound to
     *      the 'onmousedown' event so the context menu can be properly
     *      handled. 
     *
     *
     */
    Module.prototype.handleClick = function(node, e) {
        e = BRIL.evt(e);

        /* Get the mouse button used */
        if (e.button == 2) {
            /* When handling the mousedown event, prevent the context menu from
             * appearing.  The handler will simply stop propagation and then
             * remove itself so subsequent context menus CAN appear if they are
             * not over this element. */
            var f = function(e) {
                BRIL.stopEventBubble(e);

                if (isIE()) {
                    document.detachEvent('oncontextmenu', f);
                    top.document.detachEvent('oncontextmenu', f);
                }
                else {
                    document.removeEventListener('contextmenu', f, true);
                    top.document.removeEventListener('contextmenu', f, true);
                }
                return false;
            };

            /*Add the context-blocker to both the frame's document and the
             * top-level document (where the tooltip lives).  This will keep
             * the context menu from showing up when the tooltip is already
             * visible. */
            if (isIE()) {
                document.attachEvent('oncontextmenu', f);
                top.document.attachEvent('oncontextmenu', f);
            }
            else {
                document.addEventListener('contextmenu', f, true);
                top.document.addEventListener('contextmenu', f, true);
            }
                              
            this.handleRightClick(e);
        }
        else {
            /* A 'click' event will be triggered when the mouse-up occurs, so
             * just bind our handling function to that event.  It's just ugly
             * to put multiple handlers in the html.  So, since we're already
             * here, handling a mousedown, we know if it's a left click, and we
             * can just assign the proper handler for it. */
            eval("node.onclick = function(e)  { top.MODULES['"
                 + this.name + "'].handleLeftClick(e); };");
        }

    };



    /***********************************************************************
     * Method: handleRightClick
     *
     * Description: Display a tooltip for the given item, if there is one.
     *
     */
    Module.prototype.handleRightClick = function(e) {

        var target = BRIL.etarget(e);

        top.debug("get right click for " + target.nodeName + " " 
                  + target.getAttribute('component_name') + "...");

        if (isIE()) {
            /* Events in IE do not support the 'currentTarget' property, which
             * is the DOM node that triggered the call to the handler, as
             * opposed to the item actually clicked.  The node with the handler
             * may be a parent of the node where the event started. 
             *
             * So, we need to search upward for the node that we care about,
             * which will have the 'component_name' attribute.
             */
            while (!target.getAttribute('component_name') && target != window ) {
                target = target.parentNode;
            }
        }

        var content = TOOLTIP.tooltipContent(target);
        if ( ! content ) {
            TOOLTIP.hide();
            return false;
        }

        /* Create a new element for our content and replace what is currently
         * there */
        var tt = TOOLTIP.mContent();

        TOOLTIP.clear();

        tt.appendChild(content);


        /* Display the tooltip */
        TOOLTIP.show(e);
        BRIL.stopEventBubble(e);
        return true;
    }; // End of the "handleRightClick()" event override



    /* Method: handleLeftClick
     *
     * Description:
     *
     *      Currently, this is a no-op/placeholder function, provided to
     *      silence JavaScript errors that occurred whenever an icon was
     *      left-clicked upon. In the future, it might be nice to make the
     *      left-click emulate the behavior of clicking on the equivalent
     *      items in the Navigation frame (i.e. in the N&N and RGs tabs).
     *
     */
    Module.prototype.handleLeftClick = function(e) {
        return true;
    };


    // END Module definition




    function addModule(oModule) {

        /* Add the module to the global list, if it is not already there */
        if ((typeof top.MODULES[oModule.name]) == 'undefined') {
            top.MODULES[oModule.name] = oModule;
            top.TabIdMap[oModule.mTabId()] = oModule;
        }
        else {
            /* Cleanup silently if the module is already there... */
            delete oModule;
        }
    }

} // Module



// ++++++++++ END Module.js ++++++++++ //
