/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/AssocDrawer.js 1.7 */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)43       1.7 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/AssocDrawer.js, hacmp.wsm, 52haes_r541, 0747A_hacmp541 10/9/07 11:24:19 */


var Y_DELTA_DEPENDECY_MAX = 100;
var Y_DELTA_DEPENDECY_MIN = 10;
var ARROW_FEATHER_LENGTH = 10;
var DEPENDENCY_CONNECTION_ANGLE = 315;
var ARROW_ANGLE = 30;
var ARRROW_STROKE_WEIGHT = 2;

var RADIAN_CONVERSION = (2 * Math.PI) / 360;

var Y_OFFEST_LINE_FROM_ICON = 5;
var HORIZONTAL_SPACE_MIN = 30;
var VERTICAL_SPACE_MIN = 15;

var PARENT_CHILD_STROKE_WEIGHT = 2;
var PARENT_CHILD_COLOR = "black";

var DEPENDENCY_STROKE_WEIGHT = 3;
var ANTICOLLOCATION_OFFSET = -10;
var NODECOLLOCATION_OFFSET = 10;
var SITECOLLOCATION_OFFSET = 15;
var ANTICOLLOCATION_COLOR = "red";
var NODECOLLOCATION_COLOR = "green";
var SITECOLLOCATION_COLOR = "blue";

var TEMPORAL_OFFSET = 0;
var TEMPORAL_COLOR = "black";

// Change in width to offset scroll bars;
var GOOD_MEASURE = isMoz() ? 15 : 25;

// -----------------------------------------------------------------------
//
// Name: LinesCheckBox
//
// Description: This function is responsible toggling the display of the
//              dependency connectors between the resource groups on the
//              Associations tab for the following topological items:
//
//                  * Clusters
//                  * Sites
//                  * composite items
//
//              It makes any connecting lines between the resource groups
//              appear or disappear, as warranted.
//
// Arguments: n/a
//
// Returns: n/a
//
// Environment:
//
// -----------------------------------------------------------------------
function LinesCheckBox(cbObj)
{
    if (cbObj)
    {
        var objDiv = document.getElementById(cbObj.value);

        if (cbObj.checked)
            objDiv.style.visibility = "visible";
        else
            objDiv.style.visibility = "hidden";

        //============================================================
        // Remove the current selection from the state cookie, if it
        // exists in the cookie, then append it with it's new value.
        //============================================================
        var states = get_cookie('wsm:state:assoc');
        if (states) {
            var regex = new RegExp('\\|?' + cbObj.value + '=(true|false)', 'g');
            states = states.replace(regex, '');
        } else {
            states = '';
        }
        if (! cbObj.checked) // Only need to store unchecked items
            states += '|' + cbObj.value + '=' + cbObj.checked;
        if (! states || states == '' || states == 'null') {
            delete_cookie('wsm:state:assoc');
        } else {
            set_cookie('wsm:state:assoc',
                       states,
                       'Thu, 31 Dec 2099 23:59:59 UTC');
        }
    }
} // End of "LinesCheckBox()"


// -----------------------------------------------------------------------
//
// Name: DetailItemsCheckBox
//
// Description: This function is responsible toggling the display of the
//              "detail items" on the Associations tab, where that is
//              roughly defined as anything that is not a cluster, a site,
//              or a composite item. It makes the specified items, and any
//              connecting lines, appear or disappear, as warranted.
//
// Arguments: n/a
//
// Returns: n/a
//
// Environment:
//
// -----------------------------------------------------------------------
function DetailItemsCheckBox(cbObj)
{
    if (cbObj) {

        var visibility;
        if (cbObj.checked)
            visibility = "visible";
        else
            visibility = "hidden";

        var searchItems = cbObj.value.split(':');

        var compLayers = haDrawAssoc.arrCompLayers;

        //=================================================
        // Loop through the component layers and find the
        // items we are changing the visibility for
        //=================================================
        for (var layer_index in compLayers)
        {
            for (var i=0; i<compLayers[layer_index].onlineItems.length; i++)
            {
                var objLayerItem = compLayers[layer_index].onlineItems[i];
                var itemName = objLayerItem.id;
                var obj = objLayerItem.objRef;

                component_type = obj.getAttribute("component_type");
                sub_component_type = obj.getAttribute("sub_component_type");
                if ((component_type != null &&
                     haDrawAssoc.isValueInArray(component_type, searchItems))
                       ||
                    (sub_component_type != null &&
                     haDrawAssoc.isValueInArray(sub_component_type, searchItems)))
                {
                    //=====================================
                    // Adjust the visibility of this icon
                    //=====================================
                    obj.style.visibility = visibility;

                    //====================================================
                    // The visibility on the above item was changed, now
                    // change the parent/child lines that connect to it.
                    //====================================================
                    for (var j=0; j<haDrawAssoc.arrParentChildLines.length; j++)
                    {
                        var objLine = haDrawAssoc.arrParentChildLines[j];
                        parentAttribute = objLine.getAttribute("parentItem");
                        childAttribute = objLine.getAttribute("childItem");

                        if ((parentAttribute != null &&
                             itemName == parentAttribute)
                               ||
                            (childAttribute != null &&
                             itemName == childAttribute))
                        {
                            objLine.style.visibility = visibility;
                        }
                    } // End of Parent/Child line connectors loop
                }
            }
        } // End of the component layers loop

        //============================================================
        // Remove the current selection from the state cookie, if it
        // exists in the cookie, then append it with it's new value.
        //============================================================
        var states = get_cookie('wsm:state:assoc');
        if (states) {
            var regex = new RegExp('\\|?' + cbObj.id + '=(true|false)', 'g');
            states = states.replace(regex, '');
        } else {
            states = '';
        }
        if (! cbObj.checked) // Only need to store unchecked items
            states += '|' + cbObj.id + '=' + cbObj.checked;
        if (! states || states == '' || states == 'null') {
            delete_cookie('wsm:state:assoc');
        } else {
            set_cookie('wsm:state:assoc',
                       states,
                       'Thu, 31 Dec 2099 23:59:59 UTC');
        }
    }
} // End of "DetailItemsCheckBox()"


var Layer = function (componentNames, subtypes, parentAttributes)
{
    this.componentNames = componentNames.split(':');
    this.subtypes = subtypes;
    
    this.subtypes = new Array();
    if (subtypes != null)
    {
        this.subtypes = subtypes.split(':');
    }
    
    this.parentAttributes = new Array();
    if (parentAttributes == null)
        this.parentAttributes.push("parent");
    else
        this.parentAttributes = parentAttributes.split(':');
    
    this.onlineCount = 0;
    this.onlineItems = new Array();
    this.totalItemsWidth = 0;
    this.maxItemHeight = 0;
    this.horizPos = 0;
    
    this.width = BRIL.getInnerWinWidth() - GOOD_MEASURE;
};


var LayerItem = function(id, type, obj, maxWidth)
{
    this.id = id;
    this.type = type;
    this.objRef = obj;
    this.maxWidth = maxWidth;
    this.displayed = false;
    this.hide = false;
};
    
var Dependency = function(graphics, legendId, attribute)
{
    if (attribute == null)
    {
        attribute = "";
    }
    
    this.attribute = attribute;
    this.graphics = graphics;
    this.legendId = legendId;
    this.arrow = false;
    
    this.graphics.setWeight(DEPENDENCY_STROKE_WEIGHT);
    
    if (attribute != "")
    {
        switch (attribute) {
            case "ANTICOLLOCATION":
                this.offset = ANTICOLLOCATION_OFFSET;
                this.graphics.setColor(ANTICOLLOCATION_COLOR);
            break;
            case "NODECOLLOCATION":
                this.offset = NODECOLLOCATION_OFFSET;
                this.graphics.setColor(NODECOLLOCATION_COLOR);
            break;
            case "SITECOLLOCATION":
                this.offset = SITECOLLOCATION_OFFSET;
                this.graphics.setColor(SITECOLLOCATION_COLOR);
            break;
        }
    }
    else
    {
        this.graphics.setColor(TEMPORAL_COLOR);
        this.arrow = true;
        this.offset = TEMPORAL_OFFSET;
    }
};

    
function AssocDrawer(obj)
{
    // Properties
    
    if (obj != null)
    {
        this.drawingObject = obj
    }
    else
    {
        this.drawingObject = "";
    }
    
    this.ParentChildGraphics = new lineDraw("linesParentChild");
    this.RGParentChildGraphics = new lineDraw("linesRGParentChild");
    this.RGOnlineOnSameNodeGraphics = new lineDraw("linesRGOnlineOnSameNode");
    this.RGOnlineOnDifferentNodeGraphics = new lineDraw("linesRGOnlineOnDifferentNode");
    this.RGOnlineOnSameSiteGraphics = new lineDraw("linesRGOnlineOnSameSite");
    
    this.objItems = new Object();
    
    this.arrCompLayers = new Array();
    this.arrParentChildLines = new Array();
} // End of "AssocDrawer()"


AssocDrawer.prototype.addItem = function(type, id)
{
    if (this.objItems[type] == null)
        this.objItems[type] = new Array();

    if (! this.isValueInArray(id, this.objItems[type]))
        this.objItems[type].push(id);

    return;
}; // End of "addItem()"


AssocDrawer.prototype.getMaxChildWidth = function(obj)
{
    var maxWidth = 0;
    var i;
    for (i = 0; i < obj.childNodes.length; i++)
    {
        var child = obj.childNodes.item(i);
        if ( child.offsetWidth != null && child.offsetWidth > maxWidth )
        {
            maxWidth = child.offsetWidth;
        }
    }

    return maxWidth;
}; // End of "getMaxChildWidth()"


AssocDrawer.prototype.showInfo = function(obj)
{
    alert("The " + obj.tagName + " element is at (" + obj.offsetLeft + "," + obj.offsetTop + ")" +
          "\n" + "Width: " + obj.style.width + "\n" + "Offset width: " + obj.offsetWidth +
          "\n" + "Parent: " + obj.offsetParent.tagName +
          "\n" + "Parent Offset Width: " + obj.offsetParent.offsetWidth +
          "\n" + "Parent Margin: " + obj.offsetParent.style.margin);
}; // End of "showInfo()"


AssocDrawer.prototype.getComponentHeight = function(obj)
{
    return obj.clientHeight;
};


AssocDrawer.prototype.isValueInArray = function(value, array)
{
    for (var i = 0; i < array.length; i++)
    {
        if (value == array[i])
        {
            return true;
        }
    }

    return false;
}; // End of "isValueInArray()"


AssocDrawer.prototype.isParent = function(parent, child, arrAttributes)
{
    var obj;
    var childParents;
    var attribute;
    var i;

    obj = document.getElementById(child)
    if (obj == null)
        return false;

    for (i in arrAttributes)
    {
        attribute = arrAttributes[i];
        if (obj.getAttribute(attribute) != null)
        {
            var strParents = obj.getAttribute(attribute);
            childParents = strParents.split(":");
            if (this.isValueInArray(parent, strParents.split(":")))
            {
                return true;
            }
        }
    }

    return false;
}; // End of "isParent()"


AssocDrawer.prototype.isItemOnline = function(obj)
{
    if ((obj.getAttribute("state") == "2") || ((obj.getAttribute("state") == "") && (obj.getAttribute("parent") != "")))
    {
        return true;
    }

    false;
}; // End of "isItemOnline()"


AssocDrawer.prototype.placeItem = function(objLayerItem, compLayers, layer_index, parent)
{
    var itemName = objLayerItem.id;
    var obj = objLayerItem.objRef;

    if (!objLayerItem.displayed)
    {
        obj.style.top = compLayers[layer_index].vertPos + "px";
        obj.style.left = compLayers[layer_index].horizPos + "px";

        objLayerItem.displayed = true;

        compLayers[layer_index].horizPos += compLayers[layer_index].horizSpace + parseInt(obj.style.width);
    }

    if (parent != "")
    {
        this.connectParentChild(parent, itemName);
    }

    if (compLayers[layer_index + 1] != null)
    {
        for (var i = 0; i < compLayers[layer_index + 1].onlineItems.length; i++)
        {
            var objChildLayerItem = compLayers[layer_index + 1].onlineItems[i];

            if (this.isParent(itemName, objChildLayerItem.id, compLayers[layer_index + 1].parentAttributes))
            {
                this.placeItem(objChildLayerItem, compLayers, layer_index + 1, itemName);
            }
        }
    }
}; // End of "placeItem()"


AssocDrawer.prototype.connectImages = function(img1, img2, objLocDep)
{
    objGraphics = objLocDep.graphics;

    var obj1 = document.getElementById(img1);
    var obj2 = document.getElementById(img2);

    if (obj1.style.display != "none" && obj2.style.display != "none")
    {
        var x1 = objGraphics.getImageLeft(obj1) + Math.round(objGraphics.getImageWidth(obj1) / 2);
        var y1 = objGraphics.getImageTop(obj1) + objGraphics.getImageHeight(obj1);
        var x2 = objGraphics.getImageLeft(obj2) + Math.round(objGraphics.getImageWidth(obj2) / 2);
        var y2 = objGraphics.getImageTop(obj2) + objGraphics.getImageHeight(obj2);

        this.connectDependency(x1, y1, x2, y2, objGraphics, objLocDep.offset, objLocDep.arrow);
    }
}; // End of "connectImages()"


AssocDrawer.prototype.connectParentChild = function(parent, child)
{
    var objParent = document.getElementById(parent);
    var objChild = document.getElementById(child);

    var x1 = this.ParentChildGraphics.getImageLeft(objParent) + Math.round(this.ParentChildGraphics.getImageWidth(objParent) / 2);
    var y1 = this.ParentChildGraphics.getImageTop(objParent) + this.ParentChildGraphics.getImageHeight(objParent) + Y_OFFEST_LINE_FROM_ICON;
    var x2 = this.ParentChildGraphics.getImageLeft(objChild) + Math.round(this.ParentChildGraphics.getImageWidth(objChild) / 2);
    var y2 = this.ParentChildGraphics.getImageTop(objChild) - Y_OFFEST_LINE_FROM_ICON;

    this.ParentChildGraphics.drawLine(x1, y1, x2, y2);

    this.arrParentChildLines.push(this.ParentChildGraphics.update(parent, child));
}; // End of "connectParentChild()"


// -----------------------------------------------------------------------
//
// Name: drawAssocSummary
//
// Description: This function is responsible for the display of the
//              graphical items on the Associations tab for the following
//              topological items:
//
//                  * Clusters
//                  * Sites
//                  * composite items
//
//              It arranges and places the icons, plus draws the
//              connecting lines between them.
//
// Arguments: n/a
//
// Returns: n/a
//
// Environment:
//
// -----------------------------------------------------------------------
AssocDrawer.prototype.drawAssocSummary = function()
{
    if (this.arrCompLayers.length > 0)
    {
        this.arrCompLayers.splice(0, arrCompLayers.length - 1);
    }

    var compLayers = this.arrCompLayers;

    var TemporalDependency = new Dependency(this.RGParentChildGraphics,
                                            "legendRGParentChild");
    var LocationDependencies = new Array();
    LocationDependencies.push(new Dependency(this.RGOnlineOnDifferentNodeGraphics,
                                             "legendRGOnlineOnDifferentNode",
                                             "ANTICOLLOCATION"));
    LocationDependencies.push(new Dependency(this.RGOnlineOnSameNodeGraphics,
                                             "legendRGOnlineOnSameNode",
                                             "NODECOLLOCATION"));
    LocationDependencies.push(new Dependency(this.RGOnlineOnSameSiteGraphics,
                                             "legendRGOnlineOnSameSite",
                                             "SITECOLLOCATION"));

    // Establish the angles; all angles must be in radians
    this.connectionAngle = DEPENDENCY_CONNECTION_ANGLE * RADIAN_CONVERSION;
    this.arrowAngle = ARROW_ANGLE * RADIAN_CONVERSION;

    // Set up the component layers
    compLayers.push(new Layer("cluster",""));
    if (this.objItems["site"] != null &&
        this.objItems["site"].length > 0)
    {
        compLayers.push(new Layer("site",""));
    }
    compLayers.push(new Layer("node",""));
    compLayers.push(new Layer("resource_group",""));

    // Add the items to the layers.
    this.addItemsToLayers(compLayers);
    this.sizeLayers(compLayers, true);

    //==============================================================
    // At this point, we are ready to correctly arrange the items.
    // This is done recursively by drawing the top parent, then
    // drawing each ancestor starting from right. Children will
    // hopefully end up near their parents.
    //==============================================================
    this.ParentChildGraphics.setColor(PARENT_CHILD_COLOR);
    this.ParentChildGraphics.setWeight(PARENT_CHILD_STROKE_WEIGHT);
    for (i=0; i<compLayers[0].onlineItems.length; i++)
    {
        this.placeItem(compLayers[0].onlineItems[i], compLayers, 0, "");
    }

    //==================================================
    // Loop through all resource group items and draw
    // any/all temporal and location dependency lines.
    //==================================================
    for (i=0; i<this.objItems["resource_group"].length; i++)
    {
        var itemName = this.objItems["resource_group"][i];
        var obj = document.getElementById(itemName);

        //===========================
        // Draw Temporal Dependency
        //===========================
        if (obj.getAttribute("rg_dep_children") != "")
        {
            var depChildren = obj.getAttribute("rg_dep_children").split(':');
            for (var j = 0; j < depChildren.length; j++)
            {
                if (depChildren[j] != "")
                {
                    this.connectImages(itemName,
                                       depChildren[j],
                                       TemporalDependency);
                }
            }
        }
        TemporalDependency.graphics.update();

        //=============================
        // Draw Location Dependencies
        //=============================
        for (var ld_index in LocationDependencies)
        {
            var attribute_name = LocationDependencies[ld_index].attribute;

            if (obj.getAttribute(attribute_name) != null &&
                obj.getAttribute(attribute_name) != "")
            {
                var depChildren = obj.getAttribute(attribute_name).split(':');
                for (var j = 0; j < depChildren.length; j++)
                {
                    if (depChildren[j] != "" &&
                        itemName < depChildren[j])
                    {
                        this.connectImages(itemName,
                                           depChildren[j],
                                           LocationDependencies[ld_index]);
                    }
                }
            }

            LocationDependencies[ld_index].graphics.update();
        } // End of Location Dependencies loop
    }

    //=======================================================
    // Make the dependency lines visible here, as warranted
    //=======================================================
    var states = get_cookie('wsm:state:assoc');
    var line_divs = document.getElementsByTagName('div');
    for (d=0; d<line_divs.length; d++) {
        if (line_divs[d].id.length > 0 &&
            line_divs[d].className.search(/line/) >= 0)
        {
            var regex = new RegExp('\\|?' + line_divs[d].id + '=false');
            if (! regex.test(states)) {
                var divObj = document.getElementById(line_divs[d].id);
                if (divObj) divObj.style.visibility = ""; // Make it visible
            }
        }
    }

    //======================================
    // Update the legend with proper lines
    //======================================
    this.updateLegend(TemporalDependency);
    for (var ld_index in LocationDependencies)
    {
        this.updateLegend(LocationDependencies[ld_index]);
    }

}; // End of "drawAssocSummary()"


// -----------------------------------------------------------------------
//
// Name: drawAssocDetails
//
// Description: This function is responsible for the display of the
//              graphical items on the Associations tab for all
//              topological items not handled by "drawAssocSummary()",
//              which draws clusters, sites, and composite items. For
//              example, this function draws resource groups, and
//              resources. It arranges and places the icons, plus
//              draws the connecting lines between them.
//
// Arguments: n/a
//
// Returns: n/a
//
// Environment:
//
// -----------------------------------------------------------------------
AssocDrawer.prototype.drawAssocDetail = function()
{
    if (this.arrCompLayers.length > 0)
    {
        this.arrCompLayers.splice(0, arrCompLayers.length - 1);
    }

    var compLayers = this.arrCompLayers;

    var networkLayer_index = 0;
    var resourceGroupLayer_index = 0;
    var resourceLayer_index = 0;

    var resourceLayer_pos = 0;

    //==============================
    // Set up the component layers
    //==============================
    compLayers.push(new Layer("cluster",""));
    if (this.objItems["site"] != null &&
        this.objItems["site"].length > 0)
    {
        compLayers.push(new Layer("site",""));
    }
    compLayers.push(new Layer("node",""));

    // Some of these resource groups will be removed
    compLayers.push(new Layer("network:resource:resource_group",
                              "",
                              "hostNodes:parent"));
    networkLayer_index = compLayers.length - 1;

    compLayers.push(new Layer("resource",
                              "resource_service_label",
                              "hostNodes:parentNetwork"));
    resourceLayer_index = compLayers.length - 1;

    // All of the networks and some of the resource groups will be removed.
    compLayers.push(new Layer("resource_group",
                              "",
                              "rg_resources"));
    resourceGroupLayer_index = compLayers.length - 1;


    // Add the items to the layers.
    this.addItemsToLayers(compLayers);


    //=========================================================
    // For the detail display, the resource group and network 
    // layers need to be re-arranged so they display nicely
    //=========================================================

    //============================================================
    // Start at the end of the online items in the network layer
    // and remove resource groups that have resources.
    //============================================================
    for (var i=compLayers[networkLayer_index].onlineItems.length - 1; i>=0; i--)
    {
        var objLayerItem = compLayers[networkLayer_index].onlineItems[i];
        var itemName = objLayerItem.id;
        var obj = objLayerItem.objRef;

        if (objLayerItem.type == "resource")
        {
            var sub_component_type = obj.getAttribute("sub_component_type");
            if (sub_component_type != null && sub_component_type == "resource_service_label")
            {
                compLayers[networkLayer_index].onlineItems.splice(i, 1);
                compLayers[networkLayer_index].onlineCount--;
                compLayers[networkLayer_index].totalItemsWidth -= objLayerItem.maxWidth;
                continue;
            }
        }

        if (objLayerItem.type == "resource_group")
        {
            var resources = obj.getAttribute("rg_resources");
            if (resources != null && resources != "")
            {
                compLayers[networkLayer_index].onlineItems.splice(i, 1);
                compLayers[networkLayer_index].onlineCount--;
                compLayers[networkLayer_index].totalItemsWidth -= objLayerItem.maxWidth;
                continue;
            }
        }
    }

    //=============================================================
    // Start at the end of the online items in the resource group
    // layer and remove resources group that don't have resources
    //=============================================================
    for (var i = compLayers[resourceGroupLayer_index].onlineItems.length - 1; i >= 0; i--)
    {
        var objLayerItem = compLayers[resourceGroupLayer_index].onlineItems[i];

        var itemName = objLayerItem.id;
        var obj = objLayerItem.objRef;

        var resources = obj.getAttribute("rg_resources");
        if (resources == null || resources == "")
        {
            compLayers[resourceGroupLayer_index].onlineItems.splice(i, 1);
            compLayers[resourceGroupLayer_index].onlineCount--;
            compLayers[resourceGroupLayer_index].totalItemsWidth -= objLayerItem.maxWidth;
        }
    }

    //==============================================================
    // To draw nicely, make it look like there are the same number
    // of items on the resource and resource group layers
    //==============================================================
    compLayers[resourceLayer_index].onlineCount += compLayers[resourceGroupLayer_index].onlineCount;
    compLayers[resourceLayer_index].totalItemsWidth += compLayers[resourceGroupLayer_index].totalItemsWidth;
    compLayers[resourceGroupLayer_index].onlineCount = compLayers[resourceLayer_index].onlineCount;
    compLayers[resourceGroupLayer_index].totalItemsWidth = compLayers[resourceLayer_index].totalItemsWidth;

    // Add the items to the layers.
    this.sizeLayers(compLayers, false);

    //============================================================
    // Set the starting point of the items in the resource group
    // layer after the last item in the resource layer.
    //============================================================
    if (compLayers[resourceLayer_index].onlineItems.length > 0)
    {
        for (var i = 0; i < compLayers[resourceLayer_index].onlineItems.length; i++)
        {
            var objLayerItem = compLayers[resourceLayer_index].onlineItems[i];
            var itemName = objLayerItem.id;
            var obj = objLayerItem.objRef;

            resourceLayer_pos += compLayers[resourceLayer_index].horizSpace + parseInt(obj.style.width);
        }
        compLayers[resourceGroupLayer_index].horizPos = resourceLayer_pos;
    }


    //==========================================================
    // Time to place the items. Since these are the "details",
    // we don't care much if parents are near their children.
    //==========================================================
    for (layer_index in compLayers)
    {
        for (var i=0; i<compLayers[layer_index].onlineItems.length; i++)
        {
            var objLayerItem = compLayers[layer_index].onlineItems[i];

            if (!objLayerItem.displayed)
            {
                var itemName = objLayerItem.id;
                var obj = objLayerItem.objRef;

                obj.style.top = compLayers[layer_index].vertPos + "px";
                obj.style.left = compLayers[layer_index].horizPos + "px";

                objLayerItem.displayed = true;

                compLayers[layer_index].horizPos += compLayers[layer_index].horizSpace + parseInt(obj.style.width);
            }
        }
    }

    //===================================================
    // Draw connecting lines between the components, to
    // visually show their relationships to one another
    //===================================================
    this.connectComponentLayers(compLayers)

    //================================================================
    // Retrieve the values associated with each component type
    // from the checkboxes. That way, the value list only needs
    // needs to be maintained in one place; association_include.xsl.
    // These values are used to construct regular expressions that
    // are used in the code block, below, that honors the last
    // known state established by the customer.
    //================================================================
    var network_regex, storage_regex, apps_regex;
    var nwcbObj = document.getElementById('cbNetwork');
    if (nwcbObj) {
        var nwVals = nwcbObj.value.replace(/:/g, '|');
        network_regex = new RegExp("^(" + nwVals + ")$");
    }
    var stcbObj = document.getElementById('cbStorage');
    if (stcbObj) {
        var stVals = stcbObj.value.replace(/:/g, '|');
        storage_regex = new RegExp("^(" + stVals + ")$");
    }
    var ascbObj = document.getElementById('cbAppServersd');
    if (ascbObj) {
        var asVals = ascbObj.value.replace(/:/g, '|');
        apps_regex = new RegExp("^(" + asVals + ")$");
    }

    //==============================================================
    // Read the state cookie and make any "false" items invisible.
    // Note that this must occur *after* all the objects have been
    // created/drawn, or they will never be able to be made
    // visible again.
    //==============================================================
    var states = get_cookie('wsm:state:assoc');
    for (var layer_index in compLayers)
    {
        for (var i=0; i<compLayers[layer_index].onlineItems.length; i++)
        {
            var objLayerItem = compLayers[layer_index].onlineItems[i];
            var itemName = objLayerItem.id;
            var obj = objLayerItem.objRef;

            compLayers[layer_index].horizPos += compLayers[layer_index].horizSpace + parseInt(obj.style.width);

            var component_type = obj.getAttribute("component_type");
            if (component_type == 'resource') {
                component_type = obj.getAttribute("sub_component_type");
            }

            //=====================================================
            // If a toggleable component type is detected, create
            // an appropriate, matching regular expression for it.
            //=====================================================
            var regex = undefined;
            if (network_regex && network_regex.test(component_type)) {
                regex = new RegExp('\\|?cbNetwork=false');
            } else if (apps_regex && apps_regex.test(component_type)) {
                regex = new RegExp('\\|?cbAppServersd=false');
            } else if (storage_regex && storage_regex.test(component_type)) {
                regex = new RegExp('\\|?cbStorage=false');
            }

            if (regex && states && regex.test(states)) {
                obj.style.visibility = "hidden";

                for (var j=0; j<haDrawAssoc.arrParentChildLines.length; j++)
                {
                    var objLine = haDrawAssoc.arrParentChildLines[j];
                    parentAttribute = objLine.getAttribute("parentItem");
                    childAttribute = objLine.getAttribute("childItem");

                    if ((parentAttribute != null &&
                         itemName == parentAttribute)
                           ||
                        (childAttribute != null &&
                         itemName == childAttribute))
                    {
                        objLine.style.visibility = "hidden";
                    }
                } // End of Parent/Child line connectors loop
            }
        }
    }

}; // End of "drawAssocDetail()"


AssocDrawer.prototype.addItemsToLayers = function(compLayers)
{
    var layer_index;
    var component_name_index;

    var screenWidth = BRIL.getInnerWinWidth() - GOOD_MEASURE;

    for (layer_index in compLayers)
    {
        var objLayer = compLayers[layer_index];
        objLayer.width = screenWidth;

        for (component_name_index in objLayer.componentNames)
        {
            var componentName = objLayer.componentNames[component_name_index];

            // If there are no items of this type, continue.
            // Probably means the user selected something not online.
            if (this.objItems[componentName] == null)
            {
                continue;
            }

            for (var i = 0; i < this.objItems[componentName].length; i++)
            {
                var itemName = this.objItems[objLayer.componentNames[component_name_index]][i];
                var obj = document.getElementById(itemName);

                if (((objLayer.subtypes.length == 0) || 
                     (objLayer.subtypes[0] == "") ||
                     (obj.getAttribute("sub_component_type") == null) || 
                     (obj.getAttribute("sub_component_type") == "") || 
                     (this.isValueInArray(obj.getAttribute("sub_component_type"), objLayer.subtypes))) && 
                    (this.isItemOnline(obj)))
                {
                    obj.style.display = "block";
                    var width = this.getMaxChildWidth(obj);
                    objLayer.onlineItems.push(new LayerItem(itemName, componentName, obj, width));
                    obj.style.width = width;
                    objLayer.onlineCount++;
                    objLayer.totalItemsWidth += width;
                }
            }
        }
    }
};


// -----------------------------------------------------------------------
//
// Name: sizeLayers
//
// Description: Sets the horizontal and vertical sizing of the layers.
//
// Arguments:
//
//     compLayers     An array of component layers
//     hasDependency  Boolean indicating if a dependency exists
//
// Returns: n/a
//
// Environment:
//
// -----------------------------------------------------------------------
AssocDrawer.prototype.sizeLayers = function(compLayers, hasDependency)
{
    var layer_index;
    var compTotalHeight = GOOD_MEASURE;
    var screenWidth = BRIL.getInnerWinWidth() - GOOD_MEASURE;
    var screenHeight = BRIL.getInnerWinHeight() - GOOD_MEASURE;
    var vertSpace;

    // Part of sizing the layers is the footer.
    var footerHeight = 0;
    var footerWidth = 0;
    var objFooter = document.getElementById("AssocFooter");
    if (objFooter != null)
    {
        //=========================================
        // Uncheck checkboxes here, as warranted.
        //=========================================
        var states = get_cookie('wsm:state:assoc');
        var line_divs = document.getElementsByTagName('div');
        for (d=0; d<line_divs.length; d++) {
            if (line_divs[d].id.length > 0 &&
                line_divs[d].className.search(/line/) >= 0)
            {
                var regex = new RegExp('\\|?' + line_divs[d].id + '=false');
                if (regex.test(states)) {
                    var cbObj;
                    if (line_divs[d].id == 'linesRGParentChild')
                        var cbObj = document.getElementById('cbParentChild');
                    if (line_divs[d].id == 'linesRGOnlineOnSameNode')
                        var cbObj = document.getElementById('cbOnlineSameNode');
                    if (line_divs[d].id == 'linesRGOnlineOnDifferentNode')
                        var cbObj = document.getElementById('cbOnlineOnDifferentNode');
                    if (line_divs[d].id == 'linesRGOnlineOnSameSite')
                        var cbObj = document.getElementById('cbOnlineOnSameSite');
                    if (cbObj) cbObj.checked = false;
                }
            }
        }
        var detailsAry = new Array('cbAppServersd', 'cbStorage', 'cbNetwork');
        for (var d in detailsAry) {
            var regex = new RegExp('\\|?' + detailsAry[d] + '=false');
            if (regex.test(states)) {
                var cbObj = document.getElementById(detailsAry[d]);
                if (cbObj) cbObj.checked = false;
            }
        }

        objFooter.style.visibility = "visible";
        footerHeight = objFooter.offsetHeight;
        footerWidth = objFooter.offsetWidth;
    }

    var maxLayerWidth = screenWidth;

    for (layer_index in compLayers)
    {
        var objLayer = compLayers[layer_index];

        // horizontal
        objLayer.horizSpace = Math.ceil((objLayer.width - objLayer.totalItemsWidth) / objLayer.onlineCount);

        // If the items are two close, spread them out more and recalculate the horizontal spacing
        if (objLayer.horizSpace < HORIZONTAL_SPACE_MIN)
        {
            objLayer.horizSpace = HORIZONTAL_SPACE_MIN;
            objLayer.width = (objLayer.horizSpace * objLayer.onlineCount) + objLayer.totalItemsWidth;

            if (objLayer.width > maxLayerWidth)
            {
                maxLayerWidth = objLayer.width;
            }
        }

        // set the horizontal starting position
        objLayer.horizPos = Math.round(objLayer.horizSpace / 2);

        // Get the height of tallest item on layer
        for (var i = 0; i < objLayer.onlineItems.length; i++)
        {
            var objLayerItem = objLayer.onlineItems[i];
            var obj = objLayerItem.objRef;
            var height = this.getComponentHeight(obj);
            if (objLayer.maxItemHeight < height)
            {
                objLayer.maxItemHeight = height;
            }
        }

        // Get the total height of all layers.
        compTotalHeight += objLayer.maxItemHeight;
    }

    // reset horizontal spacing for layers if necessary
    if (maxLayerWidth > screenWidth)
    {
        for (layer_index in compLayers)
        {
            var objLayer = compLayers[layer_index];
            objLayer.horizSpace = Math.ceil((maxLayerWidth - objLayer.totalItemsWidth) / objLayer.onlineCount);
            objLayer.horizPos = Math.round(objLayer.horizSpace / 2);
            objLayer.width = maxLayerWidth;
        }
    }

    // put the footer in the correct horizontal location 
    if (objFooter != null)
    {
        objFooter.style.left = (maxLayerWidth - footerWidth) / 2;
    }

    // get the correct vertical spacing between layers and put the footer in
    // the correct vertical place
    vertSpace = Math.ceil( (screenHeight
                            - compTotalHeight
                            - (footerHeight * 1.5)
                            - (hasDependency ? Y_DELTA_DEPENDECY_MAX : 0)
                            ) / compLayers.length);

    // If the vertical spacing is to small, increase it.
    if (vertSpace < VERTICAL_SPACE_MIN)
    {
        vertSpace = VERTICAL_SPACE_MIN;

        // Set the footer below all layers.
        if (objFooter != null)
        {
            objFooter.style.top = (vertSpace * compLayers.length) + compTotalHeight + footerHeight + (hasDependency ? Y_DELTA_DEPENDECY_MAX : 0);
        }
    }
    else 
    {
        // Set the footer that the bottom of the page.
        if (objFooter != null)
        {
            objFooter.style.top = screenHeight - Math.round(footerHeight * 1.5);
        }
    }

    // initialize vertical position
    for (layer_index in compLayers)
    {
        var objLayer = compLayers[layer_index];

        if (layer_index == 0)
        {
            objLayer.vertPos = Math.round(vertSpace/ 2);
        }
        else
        {
            objLayer.vertPos = compLayers[layer_index - 1].vertPos + compLayers[layer_index - 1].maxItemHeight + vertSpace;
        }
    }
}; // End of "sizeLayers()"


AssocDrawer.prototype.connectComponentLayers = function(compLayers)
{
    var layer_index;

    for (layer_index in compLayers)
    {
        var parentAttributes = compLayers[layer_index].parentAttributes;
        for (var i = 0; i < compLayers[layer_index].onlineItems.length; i++)
        {
            var objLayerItem = compLayers[layer_index].onlineItems[i];

            var itemName = objLayerItem.id;
            var obj = objLayerItem.objRef;

            // Connect it to all existing parent, regardless of level.
            for (var parent_index in parentAttributes)
            {
                var parentStr = obj.getAttribute(parentAttributes[parent_index])

                if (parentStr != null)
                {
                    var parentList = parentStr.split(':');
                    for (p in parentList)
                    {
                        var parentItem = parentList[p];
                        var objParent = document.getElementById(parentItem);
                        if ((objParent != null) && 
                            (objParent.style.display != "none") && 
                            (obj.style.visibility != "hidden") && 
                            (objParent.style.visibility != "hidden") && 
                            (parseInt(objParent.style.top) < parseInt(obj.style.top)))  // Remember, the x-axis increases as it goes down the page.
                        {
                            this.connectParentChild(parentItem, itemName);
                        }
                    }
                }
            }
        }
    }
}; // End of "connectComponentLayers()"


AssocDrawer.prototype.testIt = function()
{
    alert("test");
};


AssocDrawer.prototype.connectDependency = function(x1, y1, x2, y2, graphics, offset, drawArrow)
{
    // y1 should equal y2, but this is not enforced

    // Get depth as a ratio of point distance to screen width.

    if (offset == null)
    {
        offset = 0;
    }

    if (drawArrow == null)
    {
        drawArrow = false;
    }

    minDepth = 10;
    var swap = false;

    if (x1 > x2)  // if necessary, swap points so x1 is furthest left.
    {
        var x2_t = x2;
        var y2_t = y2;
        x2 = x1;
        y2 = y1;
        x1 = x2_t;
        y1 = y2_t;

        swap = true;
    }

    var yDelta = Math.round((((x2 - x1) / graphics.getWidth()) * Y_DELTA_DEPENDECY_MAX) + Y_DELTA_DEPENDECY_MIN);
    var xDelta = Math.round(yDelta / Math.tan(this.connectionAngle)) * -1;  //  Multiply by -1 since the screen 
    //  corodinates are flipped on the y-axis 
    //  to cartesian coordinates

    yDelta = yDelta + offset;

    x1 = x1 - offset;
    x2 = x2 + offset;

    var x3 = x1 + xDelta + offset;
    var x4 = x2 - xDelta - offset;

    var y3 = y4 = (y1 >= y2 ? y1 : y2) + yDelta;

    graphics.drawLine(x1, y1, x3, y3);
    graphics.drawLine(x3, y3, x4, y4);
    graphics.drawLine(x4, y4, x2, y2);

    if (drawArrow)
    {
        if (swap)
        {
            this.drawArrowHead(x2, y2, x4, y4, graphics);
        }
        else
        {
            this.drawArrowHead(x1, y1, x3, y3, graphics);
        }
    }
}; // End of "connectDependency()"


AssocDrawer.prototype.drawArrow = function(x, y, arrow, graphics)
{
    var tmpWeight = graphics.getWeight();

    graphics.setWeight(ARRROW_STROKE_WEIGHT);

    var xLeft = x + Math.round((ARROW_FEATHER_LENGTH * Math.cos(arrow.leftAngle)));
    var yLeft = y + Math.round((ARROW_FEATHER_LENGTH * Math.sin(arrow.leftAngle) * -1));

    var xRight = x + Math.round((ARROW_FEATHER_LENGTH * Math.cos(arrow.rightAngle)));
    var yRight = y + Math.round((ARROW_FEATHER_LENGTH * Math.sin(arrow.rightAngle)* -1));

    graphics.drawLine(x, y, xLeft, yLeft);
    graphics.drawLine(x, y, xRight, yRight);

    graphics.setWeight(tmpWeight);
}; // End of "drawArrow()"


AssocDrawer.prototype.drawArrowHead = function(x1, y1, x2, y2, graphics)
{
    var x = x2 - x1;
    var y = (y2 - y1) * -1;

    var angle = Math.atan(y / x);

    var arrow = new Object;
    arrow.leftAngle = angle - this.arrowAngle;
    arrow.rightAngle = angle + this.arrowAngle;

    if (x < 0)
    {
        arrow.leftAngle = arrow.leftAngle + Math.PI;
        arrow.rightAngle = arrow.rightAngle + Math.PI;
    }

    this.drawArrow(x1, y1, arrow, graphics);
}; // End of "drawArrowHead()"


AssocDrawer.prototype.updateLegend = function(dependency)
{
    var tempGraphics = new lineDraw(dependency.legendId);
    tempGraphics.setWeight(dependency.graphics.getWeight());
    tempGraphics.setColor(dependency.graphics.getColor());

    var obj = document.getElementById(dependency.legendId);
    var x1 = obj.offsetLeft;
    var x2 = obj.offsetLeft + obj.offsetWidth;
    var y1 = y2 = Math.round(obj.offsetHeight / 2) + obj.offsetTop;

    tempGraphics.drawLine(x1, y1, x2, y2);

    if (dependency.arrow)
    {
        this.drawArrowHead(x1, y1, x2, y2, tempGraphics);
    }

    tempGraphics.update();
}; // End of "updateLegend()"
