/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/LineDrawing.js 1.3 */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)44       1.3 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/LineDrawing.js, hacmp.wsm, 52haes_r541, 0736A_hacmp541 4/3/07 16:48:57 */

function lineDraw(id)
{
    // Properties
    if ((id == null) || (id == ""))
    {
        this.update = this.printToWindow;
    }
    else
    {
        this.update = this.appendHTML;
    }
    
    this.id = id;
    this.html = '';
    this.weight = 3;
    this.color = "#000000";
}

lineDraw.prototype.setWeight = function(w)
{
    this.weight = w;
};

lineDraw.prototype.getWeight = function()
{
    return this.weight;
}

lineDraw.prototype.setColor = function(c)
{
    this.color = c;
};

lineDraw.prototype.getColor = function()
{
    return this.color;
};

lineDraw.prototype.createDiv = function(left, top, width, height)
{
    this.html = this.html + '<div class="line" style="left:' + left + 'px;' +
                            'top:' + top + 'px;' +
                            'height:' + height + 'px;' +
                            'width:' + width + 'px;' +
                            'background-color:' + this.color + ';' +
                            'position:absolute;overflow:hidden;"><\/div>';
};

lineDraw.prototype.getWidth = function()
{
    return window.innerWidth != null ? window.innerWidth : document.documentElement && document.documentElement.clientWidth ? document.documentElement.clientWidth : 
        document.body != null ? document.body.clientWidth : 0;
};

lineDraw.prototype.getHeight = function()
{
    return window.innerHeight != null ? window.innerHeight : document.documentElement && document.documentElement.clientHeight ? document.documentElement.clientHeight : 
        document.body != null ? document.body.clientHeight : 0;
};

lineDraw.prototype.getImageWidth = function(img)
{
    if (img.offsetWidth != null)
    {
        return img.offsetWidth;
    }
    else if (img.innerWidth != null) 
    {
        return img.innerWidth;
    } 
    else if (img.clientWidth)
    { 
        return img.clientWidth;
    }
    else
    {
        return 0;
    }
};

lineDraw.prototype.getImageHeight = function(img)
{
    if (img.offsetHeight != null)
    {
        return img.offsetHeight;
    }
    else if (img.innerHeight != null) 
    {
        return img.innerHeight;
    } 
    else if (img.clientHeight)
    { 
        return img.clientHeight;
    }
    else
    {
        return 0;
    }
};

lineDraw.prototype.getImageTop = function(img)
{
    if (img.offsetTop != null)
    {
        return img.offsetTop;
    }
    else if (img.innerTop != null) 
    {
        return img.innerTop;
    } 
    else if (img.clientTop)
    { 
        return img.clientTop;
    }
    else
    {
        return 0;
    }
};

lineDraw.prototype.getImageLeft = function(img)
{
    if (img.offsetLeft != null)
    {
        return img.offsetLeft;
    }
    else if (img.innerLeft != null) 
    {
        return img.innerLeft;
    } 
    else if (img.clientLeft)
    { 
        return img.clientLeft;
    }
    else
    {
        return 0;
    }
};

lineDraw.prototype.printToWindow = function()
{
    window.document.write(this.html);
    this.html = '';     // Remove old html before next update
};

lineDraw.prototype.appendHTML = function(parentItem, childItem)
{
    if (parentItem != null && parentItem != "" && childItem != null && childItem != "")
    {
        objDiv = document.createElement("DIV");
        objDiv.setAttribute("parentItem", parentItem);
        objDiv.setAttribute("childItem", childItem);
        objDiv.setAttribute("class", "line");
        objDiv.innerHTML = this.html;
        document.getElementById(this.id).appendChild(objDiv);
        this.html = '';
        return objDiv;
    }
    else
    {
        document.getElementById(this.id).innerHTML += this.html;
        this.html = '';
    }
};

lineDraw.prototype.drawLine = function(x1, y1, x2, y2)
{
    // drawLine works by drawing small div blocks to represent a line. A
    // vertical or horizontal line will only have one div block.  The more
    // the line orients away from being purely vertical or horizontal, the
    // more div blocks are needed.
    
    // drawLine will attempt to draw the line optimally.  For instance, if
    // the line is closer to horizontal, the div blocks will be more wide
    // than tall:          +----------+
    //                     |          |
    //                     +----------+
    //
    // If the line is closer to vertical, the div blocks will be more tall 
    // than wide.          +---+
    //                     |   |
    //                     |   |
    //                     |   |
    //                     +---+
            
    // Get the deltas fo x and y points to determine the drawing direction
    var dx = Math.abs(x1 - x2);
    var dy = Math.abs(y1 - y2);
    
    var x, y;  // Origin point of div block
    
    if (x1 > x2)  // Swap points to begin drawing the the left most one
    {
        // It would be nice to do this in a function, but JavaScript 
        // does not pass variables by reference, just by value.  Objects
        // are passed by reference.
        
        var x2_t = x2;
        var y2_t = y2;
        x2 = x1;
        y2 = y1;
        x1 = x2_t;
        y1 = y2_t;
    }
    
    if (dx >= dy)  // Drawing a more horizontal line
    {
        var yStep = (y1 > y2)? -1 : 1;   // Is line being drawn up (1) or down (-1)?
        
        // The while loop below draws a block at every y point on the line, but 
        // there is a need to find out how many x points to skip for every y.
        
        var xStep = dx / (dy + 1);
        var xOld = x1;  // Keep track of the old x
        var x_r;
        x = x1 + xStep;
        y = y1;
        
        while ( x < x2 )
        {
            x_r = Math.round(x);  // This value is used twice, so only compute it once.
            this.createDiv(xOld, y, x_r - xOld, this.weight);
            xOld = x_r;
            x += xStep;
            y += yStep;
        }
        
        // Draw the last part of the line
;        if (x2 > xOld)
        {
            this.createDiv(xOld, y2, x2 - xOld, this.weight);
        }
    }
    else   // Drawing a more vertical line
    {
        x = x1;
        y = y1;
        var xStep = 1;   // Is line being drawn left (1) or right (-1)?

        var yStep = dy / (dx + 1) * ((y1 > y2)? -1 : 1);
        var yOld = y1;  // Keep track of the old y
        var y_r;
        
        if (yStep >= 0)
        {
            y = y1 + yStep;
            while ( y < y2 )
            {
                y_r = Math.round(y);  // This value is used twice, so only compute it once.
                this.createDiv(x, yOld, this.weight, y_r - yOld);
                yOld = y_r;
                x += xStep;
                y += yStep;
            }
;            if (y2 > yOld)
            {
                this.createDiv(x2, yOld, this.weight, y2 - yOld);
            }
        }
        else
        {
            yOld = y1 + this.weight;
            y = y1 + this.weight + yStep;                
            while ( y2 < y )
            {
                y_r = Math.round(y);  // This value is used twice, so only compute it once.
                this.createDiv(x, Math.round(y), this.weight, yOld - y_r);
                yOld = y_r;
                x += xStep;
                y += yStep;
            }
            if (yOld > y2)
            {
                // Draw the last part of the line
                this.createDiv(x2, Math.round(y), this.weight, yOld - y2 + this.weight);
            }
        }
    }
};


