/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2006               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)29       1.9 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/ModuleAssoc.js, hacmp.wsm, 52haes_r540, r5400622c 5/26/06 12:46:54 */


if ( (typeof ModuleAssoc) != 'function' || isIE() ) {

    function ModuleAssoc() {
        this.base = Module;
        this.base('Assoc', ACTIVITY, "Associations");
        this.oAssocUpdater = BRIL.newXMLHttp();
        this.path = '/modules/activity/assoc/';
        
        this.statusRef = undefined;
        this.readyToPaint = false;

        
        this.SelectedItem = new Object();
        this.SelectedItem.component = "";
        this.SelectedItem.componentType = "";
        this.SelectedItem.typeCode = "";
        this.SelectedItem.composite = false;
    }

    ModuleAssoc.prototype = new Module();
    ModuleAssoc.prototype.constructor = ModuleAssoc;
    
    ModuleAssoc.prototype.updateStatus = function(statusXML) {

        /* If we were passed a status XML, then assume it's an update and store
         * a reference to it. */
        if (undefined != statusXML) 
        { 
            this.statusRef = statusXML;
        }
    };

    ModuleAssoc.prototype.mActivate = function() {

        /* Call the parent class's method so we can just add to it here. */
        this.base.prototype.mActivate.call(this);

        /* Display the association if there is one to display */
        this.paint();
    };

    ModuleAssoc.prototype.paint = function() {
        var active = activeModule(ACTIVITY);
        
        if (this.readyToPaint && (this.name == active.name)) {
            // Draw the associations
            this.working_on();
            if ((this.SelectedItem.composite) || 
                (this.SelectedItem.componentType == "cluster") || 
                (this.SelectedItem.componentType == "site"))
            {
                haDrawAssoc.drawAssocSummary();
            }
            else
            {
                haDrawAssoc.drawAssocDetail();
            }
            
            this.readyToPaint = false;
            this.working_off();
        }
    }
    
    ModuleAssoc.prototype.drawAssoc = function(component, componentType,
                                               typeCode, composite)
    {
        var currDoc = this.mBodyElem();
        currDoc.innerHTML = "Loading Association...";
        
        this.SelectedItem.component = component;
        this.SelectedItem.componentType = componentType;
        this.SelectedItem.typeCode = typeCode;
        this.SelectedItem.composite = composite;

        if (this.statusRef != undefined)
        {
            this.drawAssocNow(this.statusRef);
        }
        else
        {
            this.oAssocUpdater.abort();
            this.oAssocUpdater.open('GET', this.path + 'association.p3', true);
            this.oAssocUpdater.onreadystatechange = this.drawAssocCallback;
            this.oAssocUpdater.send(null);
            top.debug("ModuleAssoc.drawAssoc sent request.");
        }
    };
    
    ModuleAssoc.prototype.drawAssocCallback = function() {
        var currDoc = this.mBodyElem();
        currDoc.innerHTML += '...';
        var oXML = this.oAssocUpdater;
        if (oXML.readyState == 4) {

            /* When the window is reloaded or navigated away, the XML object goes
             * away, but data may still come back from the server and result in
             * this function being called.  That causes an exception, so we should
             * try to catch that.  Do so before the try/finally that resets the
             * timer, so we're not setting bogus timers... */
            try { oXML.status; }
            catch(e) { return; }

            top.debug("ModuleAssoc.drawAssocCallback received request.");
            
            if (oXML.status == 200) {
                this.drawAssocNow(oXML.responseXML)
            }
            else {
                top.logger(oXML.name + 
                           ": Got bad status from server (" + 
                           oXML.status + ")");
            }
        }
    };

    ModuleAssoc.prototype.drawAssocNow = function(statusXML) {
        this.working_on();
        
        var currDoc = this.mBodyElem();
        var associationXSLpath;
        
        /* client-side XSL */
        if (this.SelectedItem.composite || 
            (this.SelectedItem.componentType == "cluster") || 
	    (this.SelectedItem.componentType == "site"))
        {
            associationXSLpath = this.path + 'association.xsl';
        }
        else
        {
            associationXSLpath = this.path + 'association_'
                + this.SelectedItem.componentType + '.xsl';
        }
            

        // Setup the Association Drawer
        // haDrawAssoc is a set to be a global variable, else FireFox won't see it when 
        // the javascript code from the transformation gets evaluated.
        haDrawAssoc = new AssocDrawer(currDoc);

        if (isMoz()) {
            var XMLreq = new XMLHttpRequest();
            XMLreq.open("GET", associationXSLpath, false); /* synchronous */
            XMLreq.send(null);
            var transform = new XSLTProcessor();
            transform.importStylesheet(XMLreq.responseXML);
            transform.setParameter("", "paramName", this.SelectedItem.component);
            transform.setParameter("", "paramType", this.SelectedItem.typeCode);
            
            var newAssoc = transform.transformToFragment(statusXML, document);
            currDoc.innerHTML = "";
            currDoc.appendChild(newAssoc);
        }
        else { /* IE */
            var xslt = new ActiveXObject("Msxml2.XSLTemplate");
            var xsldoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
            xsldoc.async = false;
            xsldoc.load(associationXSLpath);
            xslt.stylesheet = xsldoc;
            var xslproc = xslt.createProcessor();
            xslproc.input = statusXML;
            xslproc.addParameter("paramName", this.SelectedItem.component);
                xslproc.addParameter("paramType", this.SelectedItem.typeCode);
            xslproc.transform();

            /* Assign responce from the transform to its innerHTML of the current doc. */
            currDoc.innerHTML = "";
            currDoc.innerHTML = xslproc.output;
            
            // In IE, the javascript from the inserted XML does not get 
            // evaluated automatically, so it must be done manually.
            var docScripts = currDoc.getElementsByTagName("script");
            
            for (var s in docScripts)
            {
                with(window)
                {
                    eval(docScripts[s].text);
                }
            }
        }
        
        this.readyToPaint = true;
        this.paint();
        
        this.working_off();
    };

} // ModuleAssoc

