<?xml version="1.0" encoding="utf-8"?>

<!-- @(#)16       1.10 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/association_include.xsl, hacmp.wsm, 52haes_r541, 0747B_hacmp541 10/8/07 12:12:01 -->

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:key name="node_site" match="/status/sites/site" use="nodes/node/NodeId"/>
  <xsl:key name="node_name_id" match="/status/nodes/node" use="Id"/>
  <xsl:key name="network_name_id" match="/status/networks/network" use="Id"/>
  <xsl:key name="rg_dep_parent" match="/status/dependencies/dependency" use="Parent"/>
  <xsl:key name="rg_dep_location" match="/CONFIG/RESOURCEGROUPLOCATIONDEPENDENCIES/RESOURCEGROUPLOCATIONDEPENDENCY" use=".//RESOURCEGROUPNAME"/>
  <xsl:key name="rg_res_type" match="/status/resource_groups/resource_group/resources/resource" use="Type"/>


  <!-- ########################################### -->
  <!-- ##  Load/Execute any/all external files  ## -->
  <!-- ########################################### -->
  <!-- ##  $CONFIG_XML provides MIB data        ## -->
  <xsl:variable name="CONFIG_XML" select="document('assoc_config.p3')"/>
  <!-- ##  $TYPES_XML provides data types definitions   ## -->
  <xsl:variable name="TYPES_XML" select="document('../../types_table.xml')/typestable"/>
  <!-- ##  $STATUS_XML provides status code definitions ## -->
  <xsl:variable name="STATUS_XML" select="document('../../status_table.xml')/statetable"/>


  <!-- Set the default language to English, but allow -->
  <!-- users to override from the command-line.       -->
  <xsl:param name="language" select="'en'" />


  <!-- ############################### -->
  <!-- ##  Begin "Cluster" Handler  ## -->
  <!-- ############################### -->
  <xsl:template match="cluster">

    <xsl:variable name="cluster_state" select="State"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc cluster</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/component[@type='cluster']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/cluster/state[@code=$cluster_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/component[@type='cluster']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/cluster/state[@code=$cluster_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc cluster</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc cluster</xsl:text>
          </xsl:attribute>

          <font class='act_assoc cluster'>
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Cluster" handler  ## -->


  <!-- ############################# -->
  <!-- ##  Begin "Nodes" Handler  ## -->
  <!-- ############################# -->
  <xsl:template match="nodes">

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc node</xsl:text>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc node</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc node</xsl:text>
          </xsl:attribute>

          <font class='act_assoc cluster'>
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Nodes" handler  ## -->


  <!-- ############################ -->
  <!-- ##  Begin "Node" handler  ## -->
  <!-- ############################ -->
  <xsl:template match="node">

    <xsl:variable name="node_state" select="State"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc node</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="parent">
        <xsl:if test="key('node_site',Id) != ''">
          <xsl:value-of select="concat('site_',key('node_site',Id)/Name)"/>
        </xsl:if>
        <xsl:if test="count(key('node_site',Id)) = 0">
          <xsl:value-of select="concat('cluster_',/status/cluster/Name)"/>
        </xsl:if>
      </xsl:attribute>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/component[@type='node']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/node/state[@code=$node_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/component[@type='node']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/node/state[@code=$node_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc node</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc node</xsl:text>
          </xsl:attribute>

          <font class="act_assoc node">
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Node" handler  ## -->


  <!-- ############################ -->
  <!-- ##  Begin "Site" handler  ## -->
  <!-- ############################ -->
  <xsl:template match="site">

    <xsl:variable name="site_state" select="State"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc site</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="parent">
        <xsl:value-of select="concat('cluster_',/status/cluster/Name)"/>
      </xsl:attribute>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/component[@type='site']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/site/state[@code=$site_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/component[@type='site']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/site/state[@code=$site_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc site</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc site</xsl:text>
          </xsl:attribute>

          <font class="act_assoc site">
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Site" handler  ## -->


  <!-- ############################### -->
  <!-- ##  Begin "Address" handler  ## -->
  <!-- ############################### -->
  <xsl:template match="address">

    <xsl:variable name="ROLE" select="Role"/>
    <xsl:variable name="ROLE_STRING" select="concat('address_',$TYPES_XML/address[@role=$ROLE][1]/string)"/>
    <xsl:variable name="address_state" select="State"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc address</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="id">
        <xsl:value-of select="concat(name(),'_',Label)"/>
      </xsl:attribute>

      <xsl:attribute name="sub_component_type">
        <xsl:value-of select="$ROLE_STRING"/>
      </xsl:attribute>

      <xsl:attribute name="component_name">
        <xsl:value-of select="Label"/>
      </xsl:attribute>

      <xsl:attribute name="parentNode">
        <xsl:value-of select="concat('node_',key('node_name_id',ActiveNode)/Name)"/>
      </xsl:attribute>

      <xsl:attribute name="parentNetwork">
        <xsl:value-of select="concat('network_',key('network_name_id',NetId)/Name)"/>
      </xsl:attribute>

      <xsl:attribute name="address">
        <xsl:value-of select="Address"/>
      </xsl:attribute>

      <xsl:attribute name="role">
        <xsl:value-of select="Role"/>
      </xsl:attribute>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/address[@role=$ROLE]/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/address/state[@code=$address_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/address[@role=$ROLE]/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>
        <xsl:value-of select="$STATUS_XML/address/state[@code=$address_state]/string[@lang=$language]"/>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">

        <xsl:attribute name="class">
            <xsl:text>act_assoc address</xsl:text>
        </xsl:attribute>

        <xsl:attribute name="id">
          <xsl:value-of select="concat($ROLE_STRING,'_img_',Label)"/>
        </xsl:attribute>

        <xsl:choose>
          <xsl:when test="Role = 32 or Role = 64 or Role = 144">
            <xsl:attribute name="src">
              <xsl:value-of select="concat('modules/activity/images/',$ROLE_STRING,'_assoc.gif')"/>
            </xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
            <xsl:attribute name="src">
              <xsl:text>modules/activity/images/service_ip_old_assoc.gif</xsl:text>
            </xsl:attribute>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
      <!-- End of "img" element definition -->

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
        <xsl:attribute name="class">
            <xsl:text>act_assoc address</xsl:text>
        </xsl:attribute>

        <xsl:attribute name="id">
          <xsl:value-of select="concat('address_label_',Label)"/>
        </xsl:attribute>
        <font class="act_assoc address">
            <xsl:value-of select="Label"/>
        </font>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
        <xsl:attribute name="class">
            <xsl:text>act_assoc address</xsl:text>
        </xsl:attribute>

        <xsl:attribute name="id">
          <xsl:value-of select="concat('address_ip_label_',Label)"/>
        </xsl:attribute>

        <font class="act_assoc address">
            <xsl:value-of select="Address"/>
        </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS">
      <xsl:with-param name="item_id" select="concat(name(),'_',Label)" />
    </xsl:call-template>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Address" handler  ## -->


  <!-- ############################### -->
  <!-- ##  Begin "Network" handler  ## -->
  <!-- ############################### -->
  <xsl:template match="network">

    <xsl:variable name="ID" select="concat('network_',Name)"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc network</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="networkType">
        <xsl:value-of select="Type"/>
      </xsl:attribute>

      <xsl:attribute name="parent">
        <xsl:for-each select="nodes/node[State = 2]">
          <xsl:value-of select="concat('node_',key('node_name_id',Id)/Name)"/>
          <xsl:if test="position()!=last()">:</xsl:if>
        </xsl:for-each>
      </xsl:attribute>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/component[@type='network']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/component[@type='network']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc network</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc network</xsl:text>
          </xsl:attribute>

          <font class="act_assoc network">
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Network" handler  ## -->


  <!-- ###################################### -->
  <!-- ##  Begin "Resource Group" handler  ## -->
  <!-- ###################################### -->
  <xsl:template match="resource_group">

    <xsl:variable name="UP"    select="'2'"  />
    <xsl:variable name="DOWN"  select="'4'"  />

    <xsl:variable name="upNode"    select="nodes/node[NodeState = $UP]"   />
    <xsl:variable name="downNodes" select="nodes/node[NodeState = $DOWN]" />
    <xsl:variable name="numNodes"  select="NumNodes"                      />


    <!-- Determine the state for the resource group
    <!-
    <!-  Non-concurrent RGs:
    <!-
    <!-     UP on any node:     UP
    <!-     DOWN on all nodes:  DOWN
    <!-     otherwise:          MIXED (in-between; joining or leaving)
    <!-
    <!-  Concurrent:
    <!-     UP on all participating nodes:    UP
    <!-     DOWN on all participating nodes:  DOWN
    <!-     otherwise:                        MIXED
    <!-
    <!-  -->
    <xsl:variable name="rg_state">
       <xsl:choose>

          <!--
          <!-  CONCURRENT
          <! -->
          <xsl:when test="StartupPolicy = 4">
             <xsl:choose>

                <!--
                <!-  The RG is UP on all participating nodes.
                <!- -->
                <xsl:when test="$upNode and count($upNode)=$numNodes">
                   <xsl:value-of select="$UP"/>
                </xsl:when>

                 <!--
                 <!-  The RG is DOWN on all participating nodes.
                 <!- -->
                <xsl:when test="$downNodes and count($downNodes)=$numNodes">
                   <xsl:value-of select="$DOWN"/>
                </xsl:when>

                 <!--
                 <!-  Assume the RG is currently in an in-between state.
                 <!- -->
                <xsl:otherwise>
                   -1
                </xsl:otherwise>

             </xsl:choose>
          </xsl:when>

          <!--
          <!-  NON-CONCURRENT
          <! -->
          <xsl:otherwise>
             <xsl:choose>

                 <!--
                 <!-  The RG is UP on at least one node.
                 <!- -->
                 <xsl:when test="$upNode" >
                    <xsl:value-of select="$UP"/>
                 </xsl:when>

                 <!--
                 <!-  The RG is DOWN on all nodes.
                 <!- -->
                 <xsl:when test="$downNodes and count($downNodes)=$numNodes">
                    <xsl:value-of select="$DOWN"/>
                 </xsl:when>

                 <!--
                 <!-  Assume the RG is currently in an in-between state.
                 <!- -->
                 <xsl:otherwise>
                    -1
                 </xsl:otherwise>

             </xsl:choose>
          </xsl:otherwise>
       </xsl:choose>
    </xsl:variable>

    <!-- Generate a list of any nodes that are known to be online -->
    <xsl:variable name="nodeList">
        <xsl:for-each select="nodes/node">
            <xsl:if test="NodeState = $UP">
                <xsl:variable name="nodeID" select="NodeId"/>
                <xsl:value-of select="../../../../nodes/node[@id=$nodeID]/Name"/>
                <xsl:text> </xsl:text>
            </xsl:if>
        </xsl:for-each>
    </xsl:variable>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc resource_group</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="startupPolicy">
        <xsl:value-of select="StartupPolicy"/>
      </xsl:attribute>

      <xsl:attribute name="parent">
        <xsl:for-each select="nodes/node[NodeState = 2 or NodeState = 16]">
          <xsl:value-of select="concat('node_',key('node_name_id',NodeId)/Name)"/>
          <xsl:if test="position()!=last()">:</xsl:if>
        </xsl:for-each>
      </xsl:attribute>

      <xsl:attribute name="rg_dep_children">
        <xsl:for-each select="key('rg_dep_parent',Name)">
          <xsl:value-of select="concat('resource_group_',Child)"/>
          <xsl:if test="position()!=last()">:</xsl:if>
        </xsl:for-each>
      </xsl:attribute>

      <xsl:attribute name="rg_resources">
        <xsl:for-each select="resources/resource">
          <xsl:variable name="SUB_TYPE" select="Type"/>
          <xsl:variable name="SUB_TYPE_STRING" select="concat('resource_',$TYPES_XML/resource[@code=$SUB_TYPE][1]/name)"/>
          <xsl:value-of select="concat($SUB_TYPE_STRING,'_',Name)"/>
          <xsl:if test="position()!=last()">:</xsl:if>
        </xsl:for-each>
      </xsl:attribute>

      <xsl:variable name="RG_NAME">
        <xsl:value-of select="Name"/>
      </xsl:variable>

      <xsl:for-each select="$CONFIG_XML">
        <xsl:for-each select="key('rg_dep_location',$RG_NAME)">
          <xsl:attribute name="{RESOURCEGROUPLOCATIONDEPENDENCYTYPE}">
            <xsl:for-each select=".//RESOURCEGROUPNAME[ . != $RG_NAME]">
              <xsl:sort select="."/>
              <xsl:value-of select="concat('resource_group_',.)"/>
              <xsl:if test="position()!=last()">:</xsl:if>
            </xsl:for-each>
          </xsl:attribute>
        </xsl:for-each>
      </xsl:for-each>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/component[@type='resource_group']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>

        <xsl:choose>
            <xsl:when test="$rg_state > 0">
                <xsl:value-of select="$STATUS_XML/resource_group/state[@code=$rg_state]/string[@lang=$language]"/>

                <xsl:if test="$nodeList">
                    <xsl:text> ==> </xsl:text>
                    <xsl:value-of select="$nodeList"/>
                </xsl:if>

            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$STATUS_XML/generic/state[@name='mixed']/string[@lang=$language]"/>
            </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/component[@type='resource_group']/string[@lang=$language]"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
        <xsl:text>: </xsl:text>

        <xsl:choose>
            <xsl:when test="$rg_state > 0">
                <xsl:value-of select="$STATUS_XML/resource_group/state[@code=$rg_state]/string[@lang=$language]"/>

                <xsl:if test="$nodeList">
                    <xsl:text> ==> </xsl:text>
                    <xsl:value-of select="$nodeList"/>
                </xsl:if>

            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$STATUS_XML/generic/state[@name='mixed']/string[@lang=$language]"/>
            </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc resource_group</xsl:text>
          </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"/>

      <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc resource_group</xsl:text>
          </xsl:attribute>

          <font class="act_assoc resource_group">
              <xsl:value-of select="Name"/>
          </font>
      </xsl:element>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS"/>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Resource Group" handler  ## -->


  <!-- ################################# -->
  <!-- ##  Begin "Resources" handler  ## -->
  <!-- ################################# -->
  <xsl:template match="resource">

    <xsl:variable name="SUB_TYPE" select="Type"/>
    <xsl:variable name="RESOURCE_NAME" select="$TYPES_XML/resource[@code=$SUB_TYPE][1]/name"/>
    <xsl:variable name="SUB_TYPE_STRING" select="concat('resource_',$TYPES_XML/resource[@code=$SUB_TYPE][1]/name)"/>
    <xsl:variable name="ID" select="concat($SUB_TYPE_STRING,'_',Name)"/>
    <xsl:variable name="Name" select="Name"/>

    <xsl:element name="div" use-attribute-sets="div_attrs">

      <xsl:attribute name="class">
          <xsl:text>act_assoc </xsl:text>
          <xsl:value-of select="$RESOURCE_NAME"/>
      </xsl:attribute>

      <xsl:attribute name="id">
        <xsl:value-of select="$ID"/>
      </xsl:attribute>

      <xsl:attribute name="sub_component_type">
        <xsl:value-of select="$SUB_TYPE_STRING"/>
      </xsl:attribute>

      <xsl:attribute name="type_name">
        <xsl:value-of select="$RESOURCE_NAME"/>
      </xsl:attribute>

      <xsl:attribute name="parent">
        <xsl:if test="../../nodes/node[NodeState = 2 or NodeState = 16]">
          <xsl:value-of select="concat('resource_group_',../../Name)"/>
        </xsl:if>
      </xsl:attribute>

      <xsl:choose>
        <xsl:when test="Type='1000'">
          <xsl:attribute name="parentNetwork">
            <xsl:value-of select="concat('network_',/status/networks/network[Id=/status/addresses/address[Label=$Name]/NetId]/Name)"/>
          </xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="hostNodes">
            <xsl:for-each select="../../nodes/node[NodeState = 2 or NodeState = 16]">
              <xsl:value-of select="concat('node_',key('node_name_id',NodeId)/Name)"/>
              <xsl:if test="position()!=last()">:</xsl:if>
            </xsl:for-each>
          </xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>

      <xsl:attribute name="alt">
        <xsl:value-of select="$TYPES_XML/resource[@code=$SUB_TYPE][1]/fullstring"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
      </xsl:attribute>

      <xsl:attribute name="title">
        <xsl:value-of select="$TYPES_XML/resource[@code=$SUB_TYPE][1]/fullstring"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="Name"/>
        <xsl:text>)</xsl:text>
      </xsl:attribute>

      <xsl:element name="img" use-attribute-sets="img_attrs">

        <xsl:attribute name="src">
          <xsl:value-of select="concat('modules/activity/images/',$SUB_TYPE_STRING,'_assoc.gif')"/>
        </xsl:attribute>

        <xsl:attribute name="class">
            <xsl:text>act_assoc </xsl:text>
            <xsl:value-of select="$RESOURCE_NAME"/>
        </xsl:attribute>

        <xsl:attribute name="id">
          <xsl:value-of select="concat($SUB_TYPE_STRING,'_img_',Name)"/>
        </xsl:attribute>
      </xsl:element>

      <xsl:element name="br"></xsl:element>

      <xsl:element name="span" use-attribute-sets="span_attrs">
        <xsl:attribute name="id">
          <xsl:value-of select="concat($SUB_TYPE_STRING,'_label_',Name)"/>
        </xsl:attribute>

        <xsl:attribute name="class">
            <xsl:text>act_assoc </xsl:text>
            <xsl:value-of select="$RESOURCE_NAME"/>
        </xsl:attribute>

        <xsl:element name="font">
            <xsl:attribute name="class">
                <xsl:text>act_assoc </xsl:text>
                <xsl:value-of select="$RESOURCE_NAME"/>
            </xsl:attribute>

            <xsl:value-of select="Name"/>
        </xsl:element>
      </xsl:element>

      <xsl:if test="Type='1000'">
        <xsl:element name="br"></xsl:element>

        <xsl:element name="span" use-attribute-sets="span_attrs">
          <xsl:attribute name="class">
              <xsl:text>act_assoc </xsl:text>
              <xsl:value-of select="$RESOURCE_NAME"/>
          </xsl:attribute>

          <xsl:attribute name="id">
            <xsl:value-of select="concat($SUB_TYPE_STRING,'_address_',Name)"/>
          </xsl:attribute>
          <xsl:value-of select="/status/addresses/address[Label=$Name]/Address"/>
        </xsl:element>
      </xsl:if>

    </xsl:element>
    <!-- End of the "div" element's definition -->

    <xsl:text xml:space="preserve">
    </xsl:text>

    <xsl:call-template name="addItemJS">
      <xsl:with-param name="item_id" select="$ID" />
    </xsl:call-template>

    <xsl:text xml:space="preserve">
    </xsl:text>
  </xsl:template>
  <!-- ##  End "Resources" handler  ## -->


  <!-- ############################################## -->
  <!-- ##  Begin "detailLineDrawingAreas" handler  ## -->
  <!-- ############################################## -->
  <xsl:template name="detailLineDrawingAreas">
    <!--all the line drawing areas so they can be easily hidden and removed-->
    <div class="act_assoc" style="position: absolute; top: 0px; left: 0px;" id="linesParentChild"></div>
  </xsl:template>
  <!-- ##  End "detailLineDrawingAreas" handler  ## -->


  <!-- #################################### -->
  <!-- ##  Begin "detailFooter" handler  ## -->
  <!-- #################################### -->
  <xsl:template name="detailFooter">
    <!--all the line drawing areas so they can be easily hidden and removed-->
    <!--legend footer table-->
    <div class="act_assoc" style="text-align:center; position:absolute; visibility:hidden" id="AssocFooter" noWrap="true">
      <table border="0" style="text-align:left" id="TABLE1" rules="none" frame="void" class="act_assoc">
        <tr>
          <td noWrap="true" class="act_assoc act_assoc_cb">
            <input id="cbAppServersd"
                   type="checkbox"
                   onclick="DetailItemsCheckBox(this);"
                   onmouseover="JavaScript: this.style.cursor='pointer';"
                   onmouseout="JavaScript: this.style.cursor='default';"
                   value="resource_application"
                   checked="checked" />
          </td>
          <td noWrap="true"
              class="act_assoc act_assoc_cb"
              onmouseover="JavaScript: this.style.cursor='pointer';"
              onmouseout="JavaScript: this.style.cursor='default';"
              onclick="JavaScript:
var obj = document.getElementById('cbAppServersd');
if (obj) obj.click();
if (obj) DetailItemsCheckBox(obj);
">
            Application Servers
          </td>
          <td noWrap="true" style="width: 10px;">
          </td>

          <td noWrap="true" class="act_assoc act_assoc_cb">
            <input id="cbStorage"
                   type="checkbox"
                   onclick="DetailItemsCheckBox(this);"
                   onmouseover="JavaScript: this.style.cursor='pointer';"
                   onmouseout="JavaScript: this.style.cursor='default';"
                   value="resource_concurrent_vg:resource_volume_group:resource_disk_pvid:resource_disk:resource_file_system"
                   checked="checked" />
          </td>
          <td noWrap="true"
              class="act_assoc act_assoc_cb"
              onmouseover="JavaScript: this.style.cursor='pointer';"
              onmouseout="JavaScript: this.style.cursor='default';"
              onclick="JavaScript:
var obj = document.getElementById('cbStorage');
if (obj) obj.click();
if (obj) DetailItemsCheckBox(obj);
">
            Storage
          </td>
          <td noWrap="true" style="width: 10px;">
          </td>

          <td noWrap="true" class="act_assoc act_assoc_cb">
            <input id="cbNetwork"
                   type="checkbox"
                   onclick="DetailItemsCheckBox(this);"
                   onmouseover="JavaScript: this.style.cursor='pointer';"
                   onmouseout="JavaScript: this.style.cursor='default';"
                   value="network:resource_service_label:resource_ip_label:resource_hty_service_label"
                   checked="checked" />
          </td>
          <td noWrap="true"
              class="act_assoc act_assoc_cb"
              onmouseover="JavaScript: this.style.cursor='pointer';"
              onmouseout="JavaScript: this.style.cursor='default';"
              onclick="JavaScript:
var obj = document.getElementById('cbNetwork');
if (obj) obj.click();
if (obj) DetailItemsCheckBox(obj);
">
            Network
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>
  <!-- ##  End "detailFooter" handler  ## -->


  <!-- ################################# -->
  <!-- ##  Begin "addItemJS" handler  ## -->
  <!-- ################################# -->
  <xsl:template name="addItemJS">
    <xsl:param name="item_type" select="name()"/>
    <xsl:param name="item_id" select="concat(name(),'_',Name)"/>
    <xsl:element name="script" use-attribute-sets="script_attrs" xml:space="preserve">
      
      <xsl:value-of select="concat('haDrawAssoc.addItem(&quot;',$item_type,'&quot;, &quot;',$item_id,'&quot;);')"/>
      
    </xsl:element>
  </xsl:template>
  <!-- ##  End "addItemJS" handler  ## -->


  <!-- ####################################################### -->
  <!-- ##  Define common attributes for all "DIV" elements  ## -->
  <!-- ####################################################### -->
  <xsl:attribute-set name="div_attrs">
    <xsl:attribute name="style">position:absolute;text-align:center;display:none</xsl:attribute>
    <xsl:attribute name="recenter">true</xsl:attribute>
    <xsl:attribute name="state">
      <xsl:value-of select="State"/>
    </xsl:attribute>
    <xsl:attribute name="id">
      <xsl:value-of select="concat(name(),'_',Name)"/>
    </xsl:attribute>
    <xsl:attribute name="component_name">
      <xsl:value-of select="Name"/>
    </xsl:attribute>
    <xsl:attribute name="component_type">
      <xsl:value-of select="name()"/>
    </xsl:attribute>
    <xsl:attribute name="onmousedown">
      <xsl:text>top.MODULES['Assoc'].handleClick(this,event);</xsl:text>
    </xsl:attribute>
  </xsl:attribute-set>


  <!-- ######################################################## -->
  <!-- ##  Define common attributes for all "SPAN" elements  ## -->
  <!-- ######################################################## -->
  <xsl:attribute-set name="span_attrs">
    <xsl:attribute name="NOWRAP">true</xsl:attribute>
    <xsl:attribute name="id">
      <xsl:value-of select="concat(name(),'_label_',Name)"/>
    </xsl:attribute>
  </xsl:attribute-set>


  <!-- ####################################################### -->
  <!-- ##  Define common attributes for all "IMG" elements  ## -->
  <!-- ####################################################### -->
  <xsl:attribute-set name="img_attrs">
    <xsl:attribute name="id">
      <xsl:value-of select="concat(name(),'_img_',Name)"/>
    </xsl:attribute>
    <xsl:attribute name="src">
      <xsl:value-of select="concat('modules/activity/images/',name(),'_assoc.gif')"/>
    </xsl:attribute>
  </xsl:attribute-set>


  <!-- ########################################################## -->
  <!-- ##  Define common attributes for all "SCRIPT" elements  ## -->
  <!-- ########################################################## -->
  <xsl:attribute-set name="script_attrs">
    <xsl:attribute name="language">javascript</xsl:attribute>
    <xsl:attribute name="type">text/javascript</xsl:attribute>
  </xsl:attribute-set>

</xsl:stylesheet>
