<?xml version="1.0" encoding="utf-8"?>
<!-- @(#)17       1.1 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/association_network.xsl, hacmp.wsm, 52haes_r540, r5400622c 4/3/06 12:55:03 -->

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output indent="yes" method="html" omit-xml-declaration="yes"/>
  <xsl:param name="paramName"/>
  <xsl:param name="paramType"/>

  <xsl:include href="association_include.xsl"/>

  <xsl:template match="/">
    <xsl:call-template name="detailLineDrawingAreas"/>
    <xsl:call-template name="detailFooter"/>

    <xsl:variable name="Id" select="/status/networks/network[Name=$paramName]/Id"/>
    <xsl:for-each select="/status/addresses/address[NetId=$Id]">
      <xsl:variable name="Label" select="Label"/>
      <xsl:apply-templates select="/status/resource_groups/resource_group[resources/resource/Name=$Label and resources/resource/Type='1000']"/>

      <xsl:choose>
        <xsl:when test="Role != 128 and Role != 144">
          <xsl:apply-templates select="."/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="/status/resource_groups/resource_group/resources/resource[Type='1000' and Name = $Label]"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>

    <xsl:for-each select="/status/networks/network[Name=$paramName]">
      <xsl:apply-templates select="."/>

      <xsl:for-each select="nodes/node[State = 2]">
        <xsl:variable name="NodeId" select="Id"/>
        <xsl:apply-templates select="/status/nodes/node[Id=$NodeId]"/>

        <xsl:apply-templates select="/status/sites/site[nodes/node/NodeId=$NodeId]"/>
      </xsl:for-each>

      <xsl:apply-templates select="/status/cluster"/>

    </xsl:for-each>

  </xsl:template>
</xsl:stylesheet>
