<?xml version="1.0" encoding="utf-8"?>
<!-- @(#)18       1.1 src/43haes/usr/sbin/cluster/wsm/modules/activity/assoc/association_node.xsl, hacmp.wsm, 52haes_r540, r5400622c 4/3/06 12:55:05 -->

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output indent="yes" method="html" omit-xml-declaration="yes"/>
  <xsl:param name="paramName"/>
  <xsl:param name="paramType"/>

  <xsl:include href="association_include.xsl"/>

  <xsl:template match="/">
    <xsl:call-template name="detailLineDrawingAreas"/>
    <xsl:call-template name="detailFooter"/>

    <xsl:variable name="Id" select="/status/nodes/node[Name=$paramName]/Id"/>

    <xsl:for-each select="/status/addresses/address[ActiveNode=$Id and Role != 128 and Role != 144]">
      <xsl:apply-templates select="."/>
      <xsl:variable name="NetId" select="NetId"/>
      <xsl:apply-templates select="/status/networks/network[Id=$NetId]"/>
    </xsl:for-each>

    <xsl:for-each select="/status/resource_groups/resource_group[nodes/node[NodeState = 2 or NodeState = 16]/NodeId = $Id]">
      <xsl:apply-templates select="."/>

      <xsl:variable name="Name" select="Name"/>
      <xsl:for-each select="resources/resource[../../Name=$Name]">
        <xsl:apply-templates select="."/>

        <xsl:if test="Type='1000'">
          <xsl:variable name="ResName" select="Name"/>
          <xsl:apply-templates select="/status/networks/network[Id=/status/addresses/address[Label=$ResName]/NetId]"/>
        </xsl:if>

      </xsl:for-each>
    </xsl:for-each>

    <xsl:for-each select="/status/nodes/node[Name=$paramName]">
      <xsl:apply-templates select="."/>

      <xsl:apply-templates select="/status/sites/site[nodes/node/NodeId=$Id]"/>
    </xsl:for-each>

    <xsl:apply-templates select="/status/cluster"/>
  </xsl:template>
</xsl:stylesheet>
