#!/usr/es/sbin/cluster/wsm/utils/sperl
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/modules/activity/details/content.cgi.perl 1.9 
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2006,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
# @(#)67       1.11 src/43haes/usr/sbin/cluster/wsm/modules/activity/details/content.cgi.perl, hacmp.wsm, 52haes_r541, 0736A_hacmp541 6/22/07 13:12:55 %
#

use strict;
#use warnings;
#use diagnostics;
use lib '/usr/es/sbin/cluster/wsm/utils';
use wsm_config qw(get_odmdir);

my $utilities = "/usr/es/sbin/cluster/utilities";
my $lvm_utilities = "/usr/es/sbin/cluster/sbin";
my $cgi_bin = "/usr/es/sbin/cluster/wsm/cgi-bin";

$ENV{PATH} ='/bin:/sbin:/usr/bin:/usr/sbin:/usr/es/sbin/cluster/sbin:/usr/es/sbin/cluster/utilities:/usr/es/sbin/cluster/wsm/utils';
$ENV{ODMDIR} = get_odmdir();

my $itemType;
my $itemName;
my $typeName;
my @command_output;

use lib '/usr/es/sbin/cluster/wsm/utils/';
use cgiutils;

$itemType = cgival('type');
$itemName = cgival('name');
$typeName = cgival ('type_name');

if ($itemType eq 'cluster') {
  @command_output = qx($utilities/cltopinfo);
}
elsif ($itemType eq 'site') {
  @command_output = qx($utilities/cllssite -uc);
}
elsif ($itemType eq 'sites') {
  @command_output = qx($utilities/cllssite);
}
elsif ($itemType eq 'node') {
  if (qx($utilities/cltopinfo -n) =~ /\b$itemName\b/) { # untaint, but first check if the argument is present in the topology to enhance security
    $itemName =~ /(.*)/; # untaint
    $itemName = $1;
    @command_output = qx($utilities/cltopinfo -n $itemName);
    push @command_output, qx($utilities/clshowsrv -v);
  }
  else {
    @command_output = "\nnot found\n";
  }
}
elsif ($itemType eq 'nodes') {
  @command_output = qx($utilities/cltopinfo -n);
}
elsif ($itemType eq 'network') {
 if (qx($utilities/cltopinfo -w) =~ /\b$itemName\b/) {
    $itemName =~ /(.*)/;
    $itemName = $1;
    @command_output = qx($utilities/cltopinfo -w $itemName);
  }
  else {
    @command_output = "\nnot found\n";
  }
}
elsif ($itemType eq 'resource_group') {
 if (qx($utilities/clshowres) =~ /\b$itemName\b/) {
    $itemName =~ /(.*)/;
    $itemName = $1;
    @command_output = qx($utilities/clshowres -g $itemName);
  }
 else {
   @command_output = "\nnot found\n";
 }
}
elsif ($itemType eq 'resource_groups') {
  @command_output = qx($utilities/clshowres);
}
elsif ($itemType eq 'resource') {

  if (qx($utilities/clshowres) =~ /\b$itemName\b/) {
    $itemName =~ /(.*)/;
    $itemName = $1;
    $typeName =~ /(.*)/;
    $typeName = $1;

    if ($typeName eq 'volume_group') {
      {
	$< = $>;
	$( = $);
	@command_output = qx($lvm_utilities/cl_lsvg $itemName);
      }
    }
    elsif ($typeName eq 'service_label') {
      my @tmp_output = qx($utilities/cl_harvestIP_scripts -u $itemName);
      my (
	  $name,
	  $type,
	  $network,
	  $nettype,
	  $attr,
	  $node,
	  $ipaddr,
	  $haddr,
	  $interfacename,
	  $globalname,
	  $sitename,
	  $netm
	 ) = split (/:/, $tmp_output[1]);
      push @command_output, "IP Label/Address: $name\n";
      push @command_output, "Network Name: $network\n";
      push @command_output, "Alternate HW Address to accompany IP Label/Address: $haddr\n";
      push @command_output, "Node Name: $node\n";	 
    }
    elsif ($typeName eq 'boot_ip') {
      @command_output = qx($utilities/cltopinfo -i $itemName);
    }
    elsif ($typeName eq 'application') {
      @command_output = qx($utilities/cllsserv -hn $itemName);
    }
  }
  else {
    @command_output = "\nnot found\n";
  }
}

if (! @command_output) {
    @command_output = ("No detailed information is available for $typeName $itemType \"$itemName\".");
}

my $custom_css = join("", `$cgi_bin/wsm_display_css`);

print STDOUT <<END;
Content-type: text/html
Cache-Control: no-cache
Expires: -1

<html>

<head>
<style type='text/css'>
\@import url(/wsm_default.css);
\@import url(/wsm_custom.css);
$custom_css
</style>
</head>

<body class='act_details'>
    <pre class='act_details'>
@command_output
    </pre>
</body>
</html>
END
