/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/modules/navigation/ModuleStatusLoader.js 1.7 */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

/* @(#)45       1.7 src/43haes/usr/sbin/cluster/wsm/modules/navigation/ModuleStatusLoader.js, hacmp.wsm, 52haes_r541, 0736A_hacmp541 6/28/07 14:58:09 */

if ( is_undefined('Message_Status') || isIE() ) {

    function Message_Status(status) {
        this.type = 'status_update';
        this.statusXML = status;
    }
    Message_Status.prototype = new Message();
    Message_Status.prototype.constructor = Message_Status;
}



if ( (typeof ModuleStatusLoader) != 'function' || isIE() ) {

    function ModuleStatusLoader() {
        this.base = Module;
        this.base("StatusLoader", GLOBAL);

        if (! isNaN(pollint)) {
            this.updateInterval = pollint;
        } else {
            this.updateInterval = 5000;  /* milliseconds */
        }
        this.updateTimerId = 0;     /* so we can cancel it, if needed */
        this.lastEventPtr = 0;      /* Event index of last status update */
        this.statusEvent = 0;       /* Event triggering the last status update */
        this.path = '/';

        /* The XMLHttp objects to be used for status updates */
        this.oStatusUpdater = undefined;
        this.oEventsUpdater = undefined;

        /* The actual status (XML) */
        this.status = undefined;

    }

    ModuleStatusLoader.prototype = new Module();
    ModuleStatusLoader.prototype.constructor = ModuleStatusLoader;

    ModuleStatusLoader.prototype.mActivate = undefined;
    ModuleStatusLoader.prototype.mDeactivate = undefined;


    /***********************************************************************
     * Method: onload
     *
     * Description: Do those things that need to be done after the page is done
     *              loading.  For example, document.getElementById() will not
     *              work until then.
     */
    ModuleStatusLoader.prototype.onload = function() {
        top.debug("In status loader onload()...");
        /*
         * Create the XMLHttp object for Ajax updates.
         */
        this.oStatusUpdater = BRIL.newXMLHttp();
        this.oEventsUpdater = BRIL.newXMLHttp();
        
        /* Update the tree right away initially.  Updates will be done at the
         * regular interval after that.  */
        this.updateTimerId = window.setTimeout(
                "top.MODULES['" + this.name + "'].checkForEvents()",
                200);

    };


    /**********************************************************************
     * Method: checkForEvents
     *
     * Description:
     *
     *      Check the eventPtr MIB.  If there has been an event since the last
     *      time we checked, update the status data.
     *
     */
    ModuleStatusLoader.prototype.checkForEvents = function() {
        var url = '/cgi-bin/eventPtr.cgi';
        top.debug(this.name + ": Starting new eventPtr request...");

        /* onreadystatechange needs to be re-assigned each time */
        this.eventUpdateStartTime = (new Date()).getTime();
        this.oEventsUpdater.open('GET', url, true);
        this.oEventsUpdater.onreadystatechange = this.checkForEventsCallback;
        this.oEventsUpdater.send(null);

    };

    ModuleStatusLoader.prototype.checkForEventsCallback = function() {

        // Occasionally when WebSMIT reloads, it emits a JavaScript
        // error when the "var module = " assignment is performed,
        // below. This appears to be caused by a race condition, due
        // to one frame loading faster than another. The following
        // line was added in an attempt to silence this intermittent
        // bug.
        if (! top) { return false; }

        var module = top.MODULES['StatusLoader'];

        var oXML = module.oEventsUpdater;

        if (oXML && oXML.readyState == 4) {

            /* When the window is reloaded or navigated away, the XML object goes
             * away, but data may still come back from the server and result in
             * this function being called.  That causes an exception, so we should
             * try to catch that.  Do so before the try/finally that resets the
             * timer, so we're not setting bogus timers... */
            try { oXML.status; }
            catch(e) { return; }

            try {

            top.debug("checkForEventsCallback: Got eventPtr from server after "
                      + ( ((new Date()).getTime()
                           - module.eventUpdateStartTime ) / 1000 )
                      + " seconds.");

            /* If successful, update the page.  Otherwise, leave the page
             * untouched. */
            if (oXML.status && oXML.status == 200) {

                /* Convert the response to an integer and compare it to what we
                 * have.  If there's been a change, update the status. */
                var latestEvent = parseInt(oXML.responseText);
                if (latestEvent != module.lastEventPtr) {
                    top.debug("Events have occurred (" 
                              + latestEvent + ' != ' + module.lastEventPtr
                              + ").  Updating status...");
                    if ( !module.statusQueryPending ) {
                        module.lastEventPtr = latestEvent;

                        /* Update our status after a short delay.  The event
                         * MIB has been updated, but the cluster manager may
                         * not be done updating the rest of the MIB. */
                        window.setTimeout("top.MODULES['StatusLoader'].getUpdate()",
                                          500);
                    }
                }
            }

            }
            finally {

                /* Set a new timer to repeat the process. Do this in a 'finally'
                 * block so that it gets called no matter what (exception,
                 * error, or return).
                 *
                 * Note that we don't use window.setInterval() because a slow
                 * server response may cause an update to start before the last
                 * one has completed, and that can get pretty ugly when we're
                 * working with only one XMLHttp object. We assume that it will
                 * take less than module.updateInterval to finish processing.
                 */
                module.updateTimerId = window.setTimeout(
                        "top.MODULES['" + module.name + "'].checkForEvents()",
                        module.updateInterval
                        );
            }
        }
    };


    /**********************************************************************
     * Method: getUpdate
     *
     * Description: 
     *
     *      Update the status XML with new content retrieved asynchronously
     *      from the server.
     *
     */
    ModuleStatusLoader.prototype.getUpdate = function() {

        /* If a status request is not already in progress, start a new one. */
        top.debug(this.name + ": Starting new status request due to event "
                  + this.lastEventPtr + "...");


        /* Set the "status pending" flag.  The event update timer will probably
         * go off again before the status has been received, but we don't want
         * to initiate another status update until the current one has
         * finished.  So, the event update code will see this flag and only
         * initiate a status update when it is false.  */
        this.statusQueryPending = true;

        /* onreadystatechange needs to be re-assigned each time */
        this.updateStartTime = (new Date()).getTime();
        this.oStatusUpdater.open('GET', this.path + 'status.p3', true);
        this.oStatusUpdater.onreadystatechange = this.updateStatusCallback;
        this.oStatusUpdater.send(null);
    };

    ModuleStatusLoader.prototype.updateStatusCallback = function() {

        // Occasionally when WebSMIT reloads, it emits a JavaScript
        // when the "var module = " assignment is performed, below.
        // This appears to be caused by a race condition, due to one
        // frame loading faster than another. The following line was
        // added in an attempt to silence this intermittent bug.
        if (! top) { return false; }

        var module = top.MODULES['StatusLoader'];
        var oXML = module.oStatusUpdater;

        if (oXML && oXML.readyState == 4) {

            /* When the window is reloaded or navigated away, the XML object goes
             * away, but data may still come back from the server and result in
             * this function being called.  That causes an exception, so we should
             * try to catch that.  Do so before the try/finally that resets the
             * timer, so we're not setting bogus timers... */
            try { oXML.status; }
            catch(e) { return; }

            try {

            top.debug("updateStatusCallback: Got response from server after "
                      + ( ((new Date()).getTime() - module.updateStartTime ) / 1000 )
                      + " seconds.");

            /* If successful, update the page.  Otherwise, leave the page
             * untouched. */
            if (oXML.status && oXML.status == 200) {

                /* Make a deep copf of the received XML.  The XML request
                 * object becomes invalid when the next update begins, so
                 * this will reduce errors if/when another module is still
                 * trying to access the status information. */
                module.status = oXML.responseXML.cloneNode(true);

                /* Broadcast the new status */
                (new Message_Status(module.status)).send();
                
            }
            else {
                top.error("updateStatusCallback: Received status code "
                          + oXML.status + " from the server.");
            } }
            catch(e) {
                if (e) {
                    top.error('ModuleStatusLoader.updateStatusCallback: ' + e.toString());
                }
                throw e;
                return;
            }
            finally {
                module.statusQueryPending = false;
            }
        }
    };


    /* Create and add the module to the global list */
    addModule(new ModuleStatusLoader());

} /* ModuleStatusLoader */
