/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2006               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)46       1.1 src/43haes/usr/sbin/cluster/wsm/modules/navigation/navtree.js, hacmp.wsm, 52haes_r540, r5400622c 3/21/06 13:22:32 */

var IMAGES = {};

IMAGES.plus = new Image();
IMAGES.plus.src = 'modules/navigation/images/plus.gif';
IMAGES.minus = new Image();
IMAGES.minus.src = 'modules/navigation/images/minus.gif';
IMAGES.status_up = new Image();
IMAGES.status_up.src = 'modules/navigation/images/status_up.gif';
IMAGES.status_down = new Image();
IMAGES.status_down.src = 'modules/navigation/images/status_down.gif';
IMAGES.status_mixed = new Image();
IMAGES.status_mixed.src = 'modules/navigation/images/status_mixed.gif';
IMAGES.status_mixed.title = 'MIXED';
IMAGES.status_error = new Image();
IMAGES.status_error.src = 'modules/navigation/images/status_error.gif';


// -----------------------------------------------------------------------
//
// Name: twisty
//
// Description: toggles between expanded and collapsed state
//
// Arguments: this (the calling element)
//
// Returns: none
//
// Environment:
//
// -----------------------------------------------------------------------
function twisty(caller) {

    // check for old browsers
    if (!caller.parentNode)
        return;

    // get the list that belongs to this twisty
    var subULArray = getChildrenByTagName(caller.parentNode, 'UL');

    // toggle the css class
    if (caller.className == 'collapsed') {
        caller.className = 'expanded';
        if (subULArray.length) subULArray[0].className = 'expanded';
        caller.src = IMAGES.minus.src;
    } else {
        caller.className = 'collapsed';
        if (subULArray.length) subULArray[0].className = 'collapsed';
        caller.src = IMAGES.plus.src;
    }

}


// -----------------------------------------------------------------------
//
// Name: twistyAll
//
// Description: expands or collapses all twisties on a page
//
// Arguments: string (either 'collapsed' or 'expanded')
//
// Returns: none
//
// Environment:
//
// -----------------------------------------------------------------------
function twistyAll(top_id, state) {

    var img = state == "collapsed" ? IMAGES.plus.src : IMAGES.minus.src;
    var treetop = document.getElementById(top_id);

    allTwisties = treetop.getElementsByTagName('img');
    for (i=0; i<allTwisties.length; i++) {
        if ( (allTwisties[i].className == 'expanded')
             || (allTwisties[i].className == 'collapsed') )
        {
            allTwisties[i].className = state;
            allTwisties[i].src = img;
        }
    }

    allLists = treetop.getElementsByTagName('ul');
    for (i=0; i<allLists.length; i++) {
        if ( (allLists[i].className == 'expanded')
             || (allLists[i].className == 'collapsed') )
        {
            allLists[i].className = state;
        }
    }
}


// ++++++++++ END navtree.js ++++++++++ //
