<?xml version="1.0"?>
<!-- @(#)88       1.2 src/43haes/usr/sbin/cluster/wsm/modules/navigation/status_tooltips.xsl, hacmp.wsm, 52haes_r540, r5400622c 3/27/06 13:51:22 -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xalan="http://xml.apache.org/xalan"
  exclude-result-prefixes="xalan"
  version="1.0">

  <!-- exclude-result-prefixes="statemap imgmap" -->
  <!-- exclude-result-prefixes: prevents unwanted namespace declarations -->

  <!-- This language parameter can be set on the command line, with english as
  <!-  the default. -->
  <xsl:param name="language" select="'en'" />

  <xsl:output
    method="xml"
    indent="yes"
    xalan:indent-amount="4"
    />

  <xsl:template match="/status">
    <p3>
        $::WAM_ID = time();
        $::WSM_SESSION = '/usr/es/sbin/cluster/wsm/cgi-bin/wsm_session';
        $ENV{ODMDIR} = '/usr/lib/objrepos';

        ####
        #### TODO: when/where should old cache be cleared??
        ####
        #system $::WSM_SESSION, "-clear";

        <!-- 
        <!-  Function: getStanzaText
        <!-
        <!-  Description: Gets the text entry for the given SMIT stanza.
        <!-
        <!-  Args: 
        <!-
        <!-     1 : The name of the target stanza's ID field
        <!-     2 : The ID of the stanza whose text we want
        <!-     3 : The containing ODM
        <!-     4 : Field containing the text
        <!-
        <!-  -->
        sub getStanzaText {
            my $match_field = shift;
            my $id = shift;
            my $odm = shift;
            my $text_field = 'text';

            if ($odm eq 'sm_name_hdr') { $text_field = 'name' };


            my $stanza = qx(odmget -q '$match_field = $id' $odm);
            (my $text) = $stanza =~ m/$text_field = "(.*)"/;
            $text;
        }
        return;
    </p3>

    <!-- Reproduce the top-level element -->
    <xsl:element name="{name()}">

      <!-- Add tooltips for specific items, and just print out the rest as-is.
      <!-->
      <xsl:for-each select="*">
        <xsl:choose>

          <!-- 
          <!-  Resource group tooltips.  Add them to the individual RG
          <!-  elements, as opposed to the composite.
          <!- -->
          <xsl:when test="name() = 'resource_groups'">
            <resource_groups>
              <xsl:for-each select="./resource_group">
                <xsl:call-template name="addtip" />
              </xsl:for-each>
            </resource_groups>
          </xsl:when>

          <!-- 
          <!-  Default to adding the tip to the current element
          <!-  -->
          <xsl:otherwise>
            <xsl:call-template name="addtip"/>
          </xsl:otherwise>

        </xsl:choose>
      </xsl:for-each>

    </xsl:element>

  </xsl:template>


  <!-- <xsl:apply-templates select="/" /> -->

  <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  <!-  Template: tooltip
  <!-
  <!-  Description: Generate XML with additional inforamtion for tooltips
  <!-
  <!-  -->
  <xsl:template name="addtip">

    <xsl:variable name="SESSION_CMD">
      <xsl:text>system "$::WSM_SESSION", "-d", "webam_id_" . $::SESSION_ID</xsl:text>
    </xsl:variable>

    <!-- 
    <!-  Copy the current contents as-is 
    <!-  -->
    <xsl:element name="{name()}">
      <xsl:for-each select="./*">
        <xsl:copy-of select="current()" />
      </xsl:for-each>

      <!--
      <!-  Now append the XML for the tooltip 
      <!-  -->

      <tooltip>

        <!-- 
        <!-  Generate tooltips based on the type of item
        <!-  -->
        <xsl:choose>

          <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          <!-  Cluster tooltip
          <!- -->


          <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          <!-  Resource group tooltip
          <!- -->
          <xsl:when test="name() = 'resource_group'">
            <xsl:variable name="rgname" select="Name" />
            <p3>
              $::RGNAME = "<xsl:value-of select="$rgname" />";

              <!-- Get an ID that's unique to this RG.  It needs to be in
              <!-  P3-land so we can pass it to wsm_session. -->
              $::DATA_ID = $::WAM_ID . "<xsl:value-of select="Id" />";
              '';
            </p3>



            <!-- 
            <!-
            <!-  TODO: USE THIS AS A TEMPLATE FOR OTHER ACTIONS
            <!-
            <!-  -->

            <!-- 
            <!-  Action: Move RG to another node
            <!-  -->
            <action>
              <!-- The destination panel -->
              <p3>
                $::PANEL = 'cl_resgrp_move.select_node';
                $::SESSION_ID = $::DATA_ID . "_$::PANEL";
                '';
              </p3>

              <!-- The URL for the link -->
              <url>
                <p3>
                  '/cgi-bin/wsm_name_hdr.cgi?panel_id=' . $::PANEL . '&amp;webam_id=' . $::DATA_ID;
                </p3>
              </url>

              <!-- The text for the link.  Get this from the SMIT ODMs. -->
              <text>
                <p3>
                  getStanzaText('next_id', 'cl_resgrp_move_node.select', 'sm_menu_opt');
                </p3>
              </text>

              <!-- Add the necessary values to the session file for this link
              <!-  to simulate the preceding selector screen. -->
              <p3>
                <!-- Get the name of the node where this RG is online -->
                my $online_node = "<xsl:value-of
                  select="/status/nodes/node[current()/nodes/node[NodeState = '2']/@id]/Name" />";

                <!-- Put together the command to add values to the session -->
                <xsl:value-of select="$SESSION_CMD"/>
                <xsl:text>, "-s", "value_list=group_name:"</xsl:text>
                <xsl:text>, "-s", "group_name=$::RGNAME  ONLINE $online_node";</xsl:text>
                return;
              </p3>

            </action>

          </xsl:when>


          <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          <!-  
          <!- -->


          <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          <!-  
          <!- -->



          <!-- !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          <!-  
          <!- -->


        </xsl:choose>
      </tooltip>

    </xsl:element>
  </xsl:template>


</xsl:stylesheet>

<!-- vim:set shiftwidth=2: -->
