/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/modules/navigation/sw/ModuleSoftware.js 1.9 */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)48       1.9 src/43haes/usr/sbin/cluster/wsm/modules/navigation/sw/ModuleSoftware.js, hacmp.wsm, 52haes_r541, 0736A_hacmp541 4/16/07 15:07:23 */



if ( (typeof ModuleSoftware) != 'function' || isIE() ) {

    function ModuleSoftware() {
        this.base = ModuleStatus;
        this.base('Software', NAVIGATION, "RGs");

        this.path = '/modules/navigation/sw/';
        this.treeRootID = 'SoftwareNavTree';

        /* client-side XSL */
        var statusXSLpath = this.path + 'status.xsl';


        /* Get the stylesheet for this module, and keep it in a module-level
         * object so we only have to download it once. */
        if (isMoz()) {
            var XMLreq = new XMLHttpRequest();
            XMLreq.open("GET", statusXSLpath, false); /* synchronous */
            XMLreq.send(null);
            this.transform = new XSLTProcessor();
            this.transform.importStylesheet(XMLreq.responseXML);
        }
        else { /* IE */
            this.transform = new ActiveXObject("Microsoft.XMLDOM");
            this.transform.async = false; /* synchronous */
            this.transform.load(statusXSLpath);
        }
    }

    ModuleSoftware.prototype = new ModuleStatus();
    ModuleSoftware.prototype.constructor = ModuleSoftware;


    /* Method: updateTreeCallback
     *
     * Description:
     *
     *      AJAX callback function attached to the XMLHttp object.  This is
     *      really just a wrapper function; the onreadystatechange property of
     *      the XMLHttp object cannot be a string (it must be a function
     *      reference), meaning it will not run in the context of the module
     *      object (i.e. 'this' will not be the module).  So, here we just
     *      hard-code the module we want and run the real handler.
     *
     * Notes: 
     *
     *      'this', in the context of this function, refers to the function itself.
     */
    ModuleSoftware.prototype.updateTreeCallback = function() {

        var module = top.MODULES['Software'];
        module.handleStatusUpdateCallback();
    };


    /* Method: handleLeftClick
     *
     * Description:
     *
     *      This function is assigned to the onclick handler for the links in
     *      the tree.  The onmousedown handler assigns this as the onclick
     *      handler.
     *
     */
    ModuleSoftware.prototype.handleLeftClick = function(e) {

        var node = BRIL.etarget(e);

        this.selected = node;

        var component     = node.getAttribute('component_name');
        var componentType = node.getAttribute('component_type');
        var typeCode      = node.getAttribute('type_code');
        var type_name     = node.getAttribute('type_name');
        var composite     = (node.getAttribute('composite') == 1);
        try {

            /* This gives the browser some breathing room to update the
             * appearance of the selected item.  Otherwise, it's too busy doing
             * hard-core Javascript, and it looks to the user like s/he needs
             * to click the item again.
             *
             * It's only 1/2 a second, so it should be unnoticeable to the user.
             */
            window.setTimeout(
                    function() {
                        new MessageSoftwareSelect(component,
                                                  componentType,
                                                  typeCode,
                                                  composite,
                                                  type_name     ).send();
                    },
                    500
                );
        }
        catch(e) {
            top.error('ModuleSoftware.handleLeftClick: ' + e);
            throw e;
        }
        finally {
            /* Always stop event propogation.  Otherwise, any error would cause
             * the default event processing by the browser. */
            BRIL.stopEventBubble(e);
            return false;
        }
    };


} // ModuleSoftware



if ( (typeof Handler_NavSoftware) != 'function' || isIE() ) {

    function Handler_NavSoftware() {
        /* Call the parent class constructor */
        this.base = Handler;
        this.base('Software');
    }
    Handler_NavSoftware.prototype = new Handler();
    Handler_NavSoftware.prototype.constructor = Handler_NavSoftware;



    /*
     * Method: processMessage
     *
     */
    Handler_NavSoftware.prototype.processMessage = function(Message) {
        try {
            switch (Message.type)
            {
            case "status_update":

                top.MODULES[this.moduleName].updateStatus(Message.statusXML);

                break;
            default:
                break;
            }
        }
        catch(e) {
            top.error('Handler_NavSoftware: ' + e);
            throw e;
        }
        /* Ensure that the message is forwarded on no matter what */
        finally {
            if (this.next) {
                this.next.processMessage(Message);
            }
        }
    };


    /* Create a handler and add it to the global chain. */
    top.HandlerChain.addHandler(new Handler_NavSoftware());

} // Handler_NavSoftware
