/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* 52haes_r541 src/43haes/usr/sbin/cluster/wsm/docroot/tabs/tabs.js 1.6   */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2006,2007              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)26       1.6 src/43haes/usr/sbin/cluster/wsm/docroot/tabs/tabs.js, hacmp.wsm, 52haes_r541, 0736A_hacmp541 6/28/07 11:44:07 */



/* Action to be taken when a tab is clicked.  This will likely be a wrapper
 * around activateTab, but allows for an easy change in behavior without
 * changing all of the tabs.
 */
function tabClick(oTab) {
    activateModule(top.TabIdMap[oTab.id]);
    TOOLTIP.hide();
}

/* Function: activeModule
 *
 * Description:
 *
 *      Return the currently active module
 */
function activeModule(type) {
    var n;
    for (n in top.MODULES) {
        var m = top.MODULES[n];
        if (m.type == type && m.mActive()) {
            return m;
        }
    }
}

/* Function: activateModule
 *
 * Description:
 *
 *      Activate a tab by setting all other tabs inactive and then setting the
 *      selected tab to active.
 *
 */
function activateModule(m) {

    // Allow the caller to activate a module by passing either the module object
    // or the name of the module, in which case we just quickly look it up.
    if ((typeof m) == 'string') { m = top.MODULES[m]; }
    top.debug('activateModule('+m.name+')');

    var currDoc = m.mBodyElem();
    if (m.mActive()) {
        if (currDoc && navigator.userAgent.indexOf('Firefox')>=0) {
            top.focus(); // This removes the text insertion pointer
                         // from the tab that was clicked.
        }
        return;
    }

    // Deactivate all other modules.  We could just deactivate the currently
    // active one, but if something went wrong, this ensures that nothing else
    // is active.
    var n;
    for (n in top.MODULES) {
        var x = top.MODULES[n];

        // If we're activating a navigation module, don't deactivate any
        // activity modules.  
        if (x.type != m.type) { continue; }

        x.mDeactivate();
    }

    // Activate the given module
    m.mActivate();

    // This removes the text insertion pointer
    // from the tab that was clicked.
    if (currDoc && navigator.userAgent.indexOf('Firefox')>=0) {
        top.focus();
    }
}
