/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2006               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)27       1.3 src/43haes/usr/sbin/cluster/wsm/docroot/top.js, hacmp.wsm, 52haes_r540, r5400622c 3/29/06 15:00:46 */

var HandlerChain = new Handler();

var MODULES = {};
var TabIdMap = {};



/* 
 * Function: init
 *
 * Description:
 *
 *      Post-load initializations.
 *
 */
function init() {




}

/* 
 * Function: getActiveModule
 *
 * Description:
 *
 *      Return the Module object for the currently active module of the given type.
 *
 * Input(s):
 *
 *      type: ACTIVITY or NAVIGATION
 *
 */
function getActiveModule(type) {
    for (var mName in MODULES) {
        m = MODULES[mName];
        if ( (m.type == type) && m.mActive()) {
            return m;
        }
    }
    return undefined;
}


/* Open the logger window for writing... */
function openLogger() {

    /* Re-open the window, if needed */
    if (navigator.loggerwin == undefined || navigator.loggerwin.closed) {

        navigator.loggerwin = window.open(
                '',
                'logger',
                'height=300, width=700, scrollbars=1, resizable=1, status=1'
                );
    }

    /* Clear out existing content */
    navigator.loggerwin.document.close();
    navigator.loggerwin.document.open();

    navigator.loggerwin.document.write('<html><body><pre id="LOG"></div></body></html>');

    // Store references to the logger window and the LOG div in the navigator
    // object so we can use them without re-opening the logger window after the
    // page is re-loaded.
    navigator.log = navigator.loggerwin.document.getElementById("LOG");

    top.logger("Logger started...", false);
}


/* Function: logger
 *
 * Description:
 *
 *      Log a message to the logging area and to the server.
 *
 */
function logger(msg, log_to_server) {

    /* Make sure this is a string, in case an object was passed in */
    msg = msg.toString();

    if ( msg.charAt(msg.length - 1) != "\n") { msg += "\n"; }

    /* Make logging to the server optional, doing so by default. */
    if (arguments.length < 2 || log_to_server == true) {
        var oXML = BRIL.newXMLHttp();

        oXML.open('POST', '/cgi-bin/jslogger');
        oXML.send('msg=' + escape(msg));
    }

    if (navigator.loggerwin && !navigator.loggerwin.closed)
    {
        msg = msg.replace(/(\n\r?)(.)/g, "$1>$2"); // show "wrap" char for multi-line
        if (isIE()) { // MS's funny idea of a newline... ;)
            msg.replace(/\n[^\r]/g, "\n\r");
        }
        var d = new Date();
        var timestr = '[';
        timestr +=(isIE() ? d.getYear() : (d.getYear()+1900));
        timestr += '-'+(d.getMonth()+1)+'-'+d.getDate();
        timestr += ' '+d.toLocaleTimeString()+'] ';

        // Create a text node containing the date and the log msg to append to
        // the DOM tree.
        var append = navigator.loggerwin.document.createTextNode(timestr + msg);
        navigator.log.appendChild(append);
        if (isIE()) {
            try {
                append = navigator.loggerwin.document.createElement('br');
                navigator.log.appendChild(append);
            }
            catch(ex) {}  /* Window may be closed while this function is
                             running.  Ignore the error. */
        }

        navigator.loggerwin.scrollTo(0, navigator.log.offsetHeight);

    }
}

function error(msg) { top.logger("ERROR: " + msg); }

/* Use this variable in conjunction with the debug function.  The debug
 * function will only log the message if the variable evaluates to true. */

/* TODO: Disable default debugging before we are done... */
var DEBUG = false;
function debug(msg) { if (top.DEBUG) top.logger("DEBUG: " + msg, false); }

// ++++++++++ END top.js ++++++++++ //
