// @(#)39       1.22 src/43haes/usr/sbin/cluster/wsm/htdocs/en_US/wsm.js, hacmp, 52haes_r540, r5400622c 5/26/06 12:30:31
// IBM_PROLOG_BEGIN_TAG 
// This is an automatically generated prolog. 
//  
// 52haes_r541 src/43haes/usr/sbin/cluster/wsm/htdocs/en_US/wsm_custom.js 1.5 
//  
// Licensed Materials - Property of IBM 
//  
// Restricted Materials of IBM 
//  
// COPYRIGHT International Business Machines Corp. 2007 
// All Rights Reserved 
//  
// US Government Users Restricted Rights - Use, duplication or 
// disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
//  
// IBM_PROLOG_END_TAG 


// -----------------------------------------------------------------------
//
// Name: gcc_cookie ("Get Current Color - Cookie")
//
// Description: Checks the WebSMIT color cookie to see if it containts
//              the specified object (cObj). If so, the color stored
//              that object is extracted from the cookie and returned.
//
// Arguments:
//
//        cObj  the colorizable object to search the cookie for
//              (NOTE: these are defined in "cgi-bin/wsm_custom.dat")
//
// Returns:     the stored color for the specified object, if found, or
//              the undefined value, it not found.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//              This function has a dependency on "wsm.js", so that
//              file *must* be loaded, as well.
//
// -----------------------------------------------------------------------
function gcc_cookie(cObj) {

    var custom = get_cookie('WEBSMIT:COLORS');
    var color;
    if (custom) {
        var customAry = custom.split('|');
        for (var i in customAry) {
            if (customAry[i].indexOf(cObj + '@') == 0) {
                color = customAry[i].substring(customAry[i].indexOf('@')+1);
                break;
            }
        }
    }

    return color;
} // End of "gcc_cookie()"


// -----------------------------------------------------------------------
//
// Name: gcc_actual ("Get Current Color - Actual")
//
// Description: This function sifts through the elements retrieved
//              from the specified node/class/element, and returns
//              the first color that it successfully retrieves.
//
//              NOTE: this might actually *not* be the expected/intuitive
//                    color. However, this was the best I could do with
//                    the allotted time.
//
// Arguments:
//
//       cType  the type of the colorizable object: BG or FG
//
//  gccClasses  a list of classes to use for the object search.
//              NOTE: this is optional, and defaults to "*"
//
// gccElements  a list of elements to use for the object search.
//              NOTE: this is optional, and defaults to "*".
//                    However, if you *can* specify an element
//                    list, it should provide a boost in performance.
//
//    gccNodes  the list of nodes to use for the object search.
//              NOTE: this is optional, and defaults to "document".
//                    However, in a framed environment such as WebSMIT,
//                    that will never give you what you want, so be sure
//                    to specify at least one node to search.
//
// Returns:     the actual color for the specified object, as best we were
//              able to determine what that really is (it's neither easy,
//              nor precise). If we came up with nothing, then the undefined
//              value is returned.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function gcc_actual(cType, gccClasses, gccElements, gccNodes) {

    var elements = getElements(gccClasses,
                               gccElements,
                               gccNodes);

    var gccColor;
    for (var i=0; i<elements.length; i++) {

        if (cType.toUpperCase() == 'FG') {
            if (window.getComputedStyle) {
                if (document.defaultView && document.defaultView.getComputedStyle) {
                    gccColor = document.defaultView.getComputedStyle(elements[i],null).getPropertyValue('color');
                }
            } else if (elements[i].currentStyle) {
                gccColor = elements[i].currentStyle['color'];
            } else {
                gccColor = elements[i].style.color;
            }
        } else {
            if (window.getComputedStyle) {
                if (document.defaultView && document.defaultView.getComputedStyle) {
                    gccColor = document.defaultView.getComputedStyle(elements[i],null).getPropertyValue('background-color');
                }
            } else if (elements[i].currentStyle) {
                gccColor = elements[i].currentStyle['background-color'];
            } else {
                gccColor = elements[i].style.backgroundColor;
            }
        }

        if (gccColor) {
            if (gccColor.indexOf('rgb') >= 0) { // Convert to rgb to hex
                gccColor = gccColor.replace(/rgb/, '').replace('(', '').replace(')', '').replace(/, /g, ',');
                var rgb = gccColor.split(',');
                gccColor = '#';
                for (var v=0; v<rgb.length; v++) {
                    var val = rgb[v];
                    var valInDec = parseInt(val, 10)
                    var valInHex = valInDec.toString(16);
                    gccColor += ((valInHex.length == 1) ? '0' : '') + valInHex;
                }
            }
            gccColor = gccColor.toUpperCase();

            // Attempt to convert the hex color to a proper name
            //==================================================
            var colorObj = document.getElementById(gccColor);
            if (colorObj) {
                gccColor = colorObj.title;
            }

            if (gccColor && gccColor.length > 0) {
                break;
            }
        }
    }

    return gccColor;
} // End of "gcc_actual()"


// -----------------------------------------------------------------------
//
// Name: convert_rgb_to_hex
//
// Description: This function converts the provided RGB value
//              into its equivalent hexadecimal format.
//
// Arguments:
//
//     rgbval  The RGB value to be converted (i.e. "rgb(124, 0, 255)").
//
// Returns:    The converted, hexadecimal value, in all upppercase.
//
// Environment: n/a
//
// -----------------------------------------------------------------------
function convert_rgb_to_hex(rgbval) {

    if (rgbval.indexOf('rgb') >= 0) {
        rgbval = rgbval.replace(/rgb/, '').replace('(', '').replace(')', '').replace(/, /g, ',');
        var rgb = rgbval.split(',');
        rgbval = '#';
        for (var v=0; v<rgb.length; v++) {
            var val = rgb[v];
            var valInDec = parseInt(val, 10)
            var valInHex = valInDec.toString(16);
            rgbval += ((valInHex.length == 1) ? '0' : '') + valInHex;
        }
    }

    return(rgbval.toUpperCase());
} // End of "convert_rgb_to_hex()"


// -----------------------------------------------------------------------
//
// Name: get_elements
//
// Description: This function returns a list of element objects found
//              within the specified node/document, based upon a given
//              class name and/or element type. Both of the latter are
//              optional, and default to "*" (a.k.a. all classes/elements).
//
// Arguments:
//
//   geClasses  a list of classes to use for the object search.
//              NOTE: this is optional, and defaults to "*"
//
//  geElements  a list of elements to use for the object search.
//              NOTE: this is optional, and defaults to "*".
//                    However, if you *can* specify an element
//                    list, it should provide a boost in performance.
//
//     geNodes  the list of nodes to use for the object search.
//              NOTE: this is optional, and defaults to "document".
//                    However, in a framed environment such as WebSMIT,
//                    that will never give you what you want, so be sure
//                    to specify at least one node to search.
//
// Returns:     an array containing all the discovered elements that
//              match the provided criteria.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function getElements(geClasses, geElements, geNodes) {

    //-------------------------------------------------------
    // Provide some sort of default for variables that were
    // not provided. The node default will give you trouble
    // in a complex/framed environment, though...
    //-------------------------------------------------------
    if (! geElements) geElements = '*';
    if (! geNodes) geNodes = 'document';

    var nodeAry = geNodes.split(' ');
    var classAry = geClasses.split(' ');
    var elementAry = geElements.split(' ');
    var elements = new Array();
    var idx = 0;

    for (var n=0; n<nodeAry.length; n++) {
        for (var c=0; c<classAry.length; c++) {

            var geClass = classAry[c];
            var geNode = nodeAry[n];

            //-----------------------------------------------------------
            // Determine if this node needs to be 'calculated', meaning
            // it is actually code which will provide the node object.
            //-----------------------------------------------------------
            var objects = new Array();
            for (var d=0; d<elementAry.length; d++) {
                var tmpAry = new Array();

                if (geNode.indexOf('.getElementById') >= 0) {
                    eval("var iframeObj = " + geNode);
                    if (iframeObj) {
                        // Mozilla: iframeElem.contentDocument
                        // Int. Ex: iframeElem.contentWindow.document
                        var iframeDoc = iframeObj.contentDocument ||
                                        (iframeObj.contentWindow &&
                                         iframeObj.contentWindow.document);
                        if (iframeDoc) {
                            tmpAry = iframeDoc.getElementsByTagName(elementAry[d]);
                        }
                    }
                } else {
                    eval("tmpAry = " + geNode + ".getElementsByTagName(elementAry[d])");
                }

                // concat() wouldn't work here. Not sure why. Strings only?
                for (var t in tmpAry) {
                    objects.push(tmpAry[t]);
                }
            } // # End of the elements loop

            var regex = null;
            if (geClass && geClass != '*') {
                regex = new RegExp('(^|\\s)' + geClass + '(\\s|$)');
            }

            //===================================================
            // Append the matching objects to the elements list
            //===================================================
            for (var i=0, j=0; i<objects.length; i++) {
                if (objects[i].className) {
                    if (geClass && geClass != '*') {
                        if (regex.test(objects[i].className)) {
                            elements[idx++] = objects[i];
                        }
                    } else {
                        // Do not allow the tabs to be manipulated.
                        if (objects[i].className.indexOf('Tab') < 0 &&
                            objects[i].className != 'customize')
                        {
                            elements[idx++] = objects[i];
                        }
                    }
                }
            } // # End of the objects loop

        } // # End of the classes loop

    } // # End of the nodes loop

    return elements;
} // End of "getElements()"


// -----------------------------------------------------------------------
//
// Name: wsm_color_select
//
// Description: This function fires when a color is selected in the
//              customization GUI, and takes charge of applying the
//              selected color to the appropriate sample area for the
//              user to see.
//
// Arguments:
//
//    colorObj  the colors list object.
//              (NOTE: these are defined at the bottom of 
//                     "cgi-bin/wsm_custom.cgi")
//
//    wsm_info  an array containing data about all the known colorizable
//              objects (as defined in "cgi-bin/wsm_custom.dat").
//
// Returns:     returns a Boolean "true" value, to ensure that the
//              "onclick()" function that invokes this function
//              continues to work properly.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function wsm_color_select(colorObj, wsm_info) {

    var current = colorObj.options[colorObj.selectedIndex].value;
    var current_id = colorObj.options[colorObj.selectedIndex].id;
    var wsmobj  = window.document.forms[0].wsm_objects;
    var object = new String();
    if (wsmobj && wsmobj.selectedIndex >= 0) {
        object = wsmobj.options[wsmobj.selectedIndex].value;

        // Remove leading whitespace/nbsp, and trailing whitespace
        object = object.replace(/^[\s\xA0]+/g, '').replace(/\s+$/g, '');

        if (object && wsm_info[object] && current) {
            var wsm_data = wsm_info[object].split('|');
            var level         = wsm_data[0];
            var color_type    = wsm_data[1].toUpperCase();
            var association   = wsm_data[2];
            var nodes         = wsm_data[3];
            var classes       = wsm_data[4];
            var ancestor      = wsm_data[5]; // Can't use "parent"!
            var default_color = wsm_data[6];

            if (color_type == 'FG') {
                window.document.forms[0].new_sample.style.color = current_id;
            } else if (color_type == 'BG') {
                window.document.forms[0].new_sample.style.backgroundColor = current_id;
            }

            //================================================================
            // Store this item in the "changes" array. Also, determine if
            // this is a parent object. If so, then all its children need
            // to be stored, too. This prevents the child object from
            // displaying a different color from the parent, which is not
            // intuitive in this interface (defies the implied inheritance).
            //================================================================
            changes[object] = current_id;
            for (var item in wsm_info) {
                var wsm_data = wsm_info[item].split('|');
                var ancestor = wsm_data[5];
                if (ancestor.indexOf(object) >= 0) {
                    changes[item] = current_id;
                }
            }
        }
    }

    return true;
} // End of "wsm_color_select()"


// -----------------------------------------------------------------------
//
// Name: wsm_object_select
//
// Description: This function fires when a colorizable object is selected
//              in the customization GUI, and takes charge of applying the
//              current color set for this object to the sample areas for
//              the user to see.
//
// Arguments:
//
//      wsmObj  the colorizable objects list.
//              (NOTE: these are defined in "cgi-bin/wsm_custom.dat")
//
//    wsm_info  an array containing data about all the known colorizable
//              objects (as defined in "cgi-bin/wsm_custom.dat").
//
// Returns:     returns a Boolean "true" value, to ensure that the
//              "onclick()" function that invokes this function
//              continues to work properly.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function wsm_object_select(wsmObj, wsm_info) {

    var colorObj =window.document.forms[0].color_names; 
    var current = wsmObj.options[wsmObj.selectedIndex].value;

    if (current                     &&
        current.indexOf('===') != 0 &&
        current.indexOf('- -') != 0)
    {
        // Remove leading whitespace/nbsp, and trailing whitespace
        current = current.replace(/^[\s\xA0]+/g, '').replace(/\s+$/g, '');

        if (current && wsm_info[current]) {

            var wsm_data = wsm_info[current].split('|');
            var level               = wsm_data[0];
            var color_type          = wsm_data[1].toUpperCase(); // BG or FG
            var association         = wsm_data[2];
            var nodes               = wsm_data[3];
            var classes             = wsm_data[4];
            var ancestor            = wsm_data[5]; // Can't use "parent"!
            var original_color      = wsm_data[6];
            var original_complement = wsm_data[7];

            //========================================================
            // Try to avoid the "transparent" color. Although it is
            // very useful in practice, in the Customization GUI, it
            // results in displaying the background color of the
            // "Configuration" tab, instead of the expected value.
            //========================================================
            if (original_color == 'TRANSPARENT') {
                original_color = default_fg_color;
                if (color_type == 'BG') {
                     original_color = default_bg_color;
                }
            }

            var colors = get_cookie('WEBSMIT:COLORS');

            //============================================================
            // Check to see if there is already a stored change for this
            // object within this session. If there is, override the
            // default data using the stored color. Otherwise, use the
            // original color.
            //============================================================
            var current_color;
            if (changes[current]) {
                current_color = changes[current];

                //=================================================
                // Change the selected color in the colors list
                // to match this color. Much better for the user.
                //=================================================
                for (var i=0; i<colorObj.length; i++) {
                    if (colorObj.options[i].id == current_color) {
                        colorObj.selectedIndex = i;
                        break;
                    }
                }

            } else if (colors && colors.indexOf(current) > 0) {
                var idx = colors.indexOf(current) + current.length + 1;
                current_color = colors.substring(idx, idx+7);

            } else {
                current_color = default_fg_color;
                if (color_type == 'BG') {
                     current_color = default_bg_color;
                }

                //=================================================
                // Change the selected color in the colors list
                // to match this color. Much better for the user.
                //=================================================
                for (var i=0; i<colorObj.length; i++) {
                    if (colorObj.options[i].id == current_color) {
                        colorObj.selectedIndex = i;
                        break;
                    }
                }
            }

            update_samples(current, current_color);
        }
    }

    return true;
} // End of "wsm_object_select()"


// -----------------------------------------------------------------------
//
// Name: update_samples
//
// Description: This function fires when a colorizable object is selected
//              in the customization GUI, and takes charge of applying the
//              current color set for this object to the sample areas for
//              the user to see.
//
// Arguments:
//
//     custObj  the label of the customized object (e.g. "Clusters")
//              (NOTE: these are defined in "cgi-bin/wsm_custom.dat")
//
//   new_color  the color to be applied to the samples
//
// Returns:     returns a Boolean "true" value
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function update_samples(custObj, new_color) {

    var wsm_data = wsm_info[custObj].split('|');
    var level               = wsm_data[0];
    var color_type          = wsm_data[1].toUpperCase(); // BG or FG
    var association         = wsm_data[2];
    var nodes               = wsm_data[3];
    var classes             = wsm_data[4];
    var ancestor            = wsm_data[5]; // Can't use "parent"!
    var original_color      = wsm_data[6];
    var original_complement = wsm_data[7];
    var previewed_color     = wsm_data[8];

    //========================================================
    // Try to avoid the "transparent" color. Although it is
    // very useful in practice, in the Customization GUI, it
    // results in displaying the background color of the
    // "Configuration" tab, instead of the expected value.
    //========================================================
    if (original_color == 'TRANSPARENT') {
        original_color = default_fg_color;
        if (color_type == 'BG') {
             original_color = default_bg_color;
        }
    }
    if (original_complement == 'TRANSPARENT') {
        original_complement = default_bg_color;
        if (color_type == 'BG') {
            original_complement = default_fg_color;
        }
    }

    //============================================================
    // Determine the appropriate complementary color:
    //     1) if the association field contains an
    //        explicit color, then just use it
    //     2) if the association field has been changed
    //        during this session, use its new value
    //     3) if the association field has a value stored
    //        in the WEBSMIT:COLORS cookie, use it
    //     4) use the appropriate WebSMIT default color
    //============================================================
    var new_complement;
    if (association.indexOf('#') == 0) {
        new_complement = association;
    } else {
        if (changes[association]) {
            new_complement = changes[association];
        } else {
            new_complement = gcc_cookie(association);

            if (! new_complement) {
                new_complement = default_bg_color;
                if (color_type == 'BG') {
                     new_complement = default_fg_color;
                }
            }
        }
    }

    //=============================================
    // Determine the current color and complement
    //=============================================
    var curr_color = original_color;
    var curr_complement = original_complement;
    if (previewed_color) { curr_color = previewed_color; }
    if (association.indexOf('#') < 0 &&
        wsm_info[association])
    {
        var a_wsm_data = wsm_info[association].split('|');
        var pc = a_wsm_data[8];
        if (pc) { curr_complement = pc; }
    }

    //=========================================================================
    // The "Original" sample is our best guess at the colors that were in
    // place for the selected object at the time of the page load.
    // The "Current" sample represents the currently previewed colors.
    // The "New" sample represents the selected, but not yet previewed colors.
    //=========================================================================
    var orig_samp = window.document.forms[0].original_sample;
    var curr_samp = window.document.forms[0].current_sample;
    var new_samp  = window.document.forms[0].new_sample;
    if (color_type == 'FG') {

        if (! new_color) {
            new_color = default_fg_color;
        }

        orig_samp.style.color           = original_color;
        orig_samp.style.backgroundColor = original_complement;
        curr_samp.style.color           = curr_color;
        curr_samp.style.backgroundColor = curr_complement;
        new_samp.style.color            = new_color;
        new_samp.style.backgroundColor  = new_complement;

    } else if (color_type == 'BG') {

        if (! new_color) {
            new_color = default_bg_color;
        }

        orig_samp.style.backgroundColor = original_color;
        orig_samp.style.color           = original_complement;
        curr_samp.style.backgroundColor = curr_color;
        curr_samp.style.color           = curr_complement;
        new_samp.style.backgroundColor  = new_color;
        new_samp.style.color            = new_complement;
    }

} // End of "update_samples()"


// -----------------------------------------------------------------------
//
// Name: preview_color
//
// Description: Retrieves the current WebSMIT "object" selection, and the
//              current color selection, then applies the latter to the former.
//              If an object and a color are selected, then that color will be
//              applied to that object area temporarily. Depending on the
//              object this could be until that page/panel/frame is reloaded,
//              or it could be the duration of the entire WebSMIT session.
//
// Arguments:
//
//    colors_obj  the colors list object. Alternatively, this may be an
//                explicit color name.
//                (NOTE: these are defined at the bottom of 
//                       "cgi-bin/wsm_custom.cgi")
//
// wsm_items_obj  the colorizable objects list. Alternatively, this may
//                be an explicit object name.
//                (NOTE: these are defined in "cgi-bin/wsm_custom.dat")
//
//      wsm_info  an array containing data about all the known colorizable
//                objects (as defined in "cgi-bin/wsm_custom.dat").
//
// Returns:     returns a Boolean "true" value, to ensure that the
//              "onclick()" function that invokes this function
//              continues to work properly.
//
// Environment: this must be run within WebSMIT via an HTTP server.
//
// -----------------------------------------------------------------------
function preview_color(colors_obj, wsm_items_obj, wsm_info) {

    var object, selected_color;

    if (wsm_items_obj.selectedIndex < 0 ) {
        return false;
    }

    //===================================================================
    // Determine if the colors object was provided, or an actual color.
    //===================================================================
    if (typeof(colors_obj) != 'object') {
        selected_color = colors_obj;
    }

    //===============================================================
    // Determine if an object was provided, or an actual menu name.
    //===============================================================
    if (typeof(wsm_items_obj) == 'object') {
        object = wsm_items_obj.options[wsm_items_obj.selectedIndex].value;
    } else {
        object = wsm_items_obj;  // The menu item was provided directly
    }
    // Remove leading whitespace/nbsp, and trailing whitespace
    object = object.replace(/^[\s\xA0]+/g, '').replace(/\s+$/g, '');

    if (object &&
        wsm_info[object] &&
        (selected_color || typeof(colors_obj) == 'object'))
    {
        var wsm_data = wsm_info[object].split('|');
        var level              = wsm_data[0];
        var color_type         = wsm_data[1].toUpperCase();
        var association        = wsm_data[2];
        var nodes              = wsm_data[3];
        var classes            = wsm_data[4];
        var ancestor           = wsm_data[5]; // Can't use "parent"!
        var default_color      = wsm_data[6];
        var default_complement = wsm_data[7];
        var previewed_colors   = wsm_data[8];

        //==========================================================
        // If there is an association for this customizable object,
        // retrieve its nodes and classes, and append them to the
        // lists o' nodes/classes. That way everything that should
        // logically get the new colors *will* get the new colors!
        //==========================================================
        if (association &&
            association.length>0 &&
            wsm_info[association])
        {
            var a_wsm_data = wsm_info[association].split('|');
            var a_level    = a_wsm_data[0];
            var a_nodes    = a_wsm_data[3];
            var a_classes  = a_wsm_data[4];

            //==============================================
            // Only do this for associations that are from
            // the same level as the original object.
            //==============================================
            if (a_level == level) {
                var parts = a_nodes.split(' ');
                for (var p in parts) {
                    var regex = new RegExp('(^| )' + parts[p]);
                    if (! regex.test(nodes)) {
                        nodes += ' ' + parts[p];
                    }
                }

                parts = a_classes.split(' ');
                for (var p in parts) {
                    var regex = new RegExp('(^| )' + parts[p]);
                    if (! regex.test(classes)) {
                        classes += ' ' + parts[p];
                    }
                }
            }
        }

        var elements = getElements(classes,
                                   null,
                                   nodes);

        if (typeof(colors_obj) == 'object') {
            var ns = window.document.forms[0].new_sample;
            for (var j=0; j<elements.length; j++) {
               if (elements[j].style) {
                  elements[j].style.color           = ns.style.color
                  elements[j].style.backgroundColor = ns.style.backgroundColor;
               }
            }
        } else {
            for (var j=0; j<elements.length; j++) {
                if (elements[j].style) {
                    if (color_type == 'FG') {
                        elements[j].style.color = selected_color;
                    } else if (color_type == 'BG') {
                        elements[j].style.backgroundColor = selected_color;
                    }
                }
            }
        }

        //====================================================
        // Determine if the sample areas need to be updated.
        // They only need to be updated if either the object
        // being previewed, or its associated object, is
        // currently selected.
        //====================================================
        var need_update = true;
        if (typeof(wsm_items_obj) != 'object') {
            var wiobj = window.document.forms[0].wsm_objects;
            var selected_obj = wiobj.options[wiobj.selectedIndex].value;
            // Remove leading whitespace/nbsp, and trailing whitespace
            selected_obj = selected_obj.replace(/^[\s\xA0]+/g, '').replace(/\s+$/g, '');
            if (selected_obj != object) {
                if (association) {
                    if (selected_obj != association) {
                        need_update = false;
                    }
                } else {
                    need_update = false;
                }
            }
        }

        //==========================================
        // Recreate the info entry for the object,
        // appending the just-previewed color.
        //==========================================
        wsm_info[object] = level + '|' +
                           color_type + '|' +
                           association + '|' +
                           nodes + '|' +
                           classes + '|' +
                           ancestor + '|' +
                           default_color + '|' +
                           default_complement + '|';
        if (typeof(colors_obj) == 'object') {
            if (color_type == 'FG') {
                wsm_info[object] += ns.style.color;
                selected_color = ns.style.color;
            } else if (color_type == 'BG') {
                wsm_info[object] += ns.style.backgroundColor;
                selected_color = ns.style.backgroundColor;
            }
        } else {
            wsm_info[object] += selected_color;
        }

        if (need_update) {
            update_samples(object, selected_color);
        }

        //===========================================================
        // If there is an association for this customizable object,
        // recreate the info entry for the association object,
        // appending the just-previewed color.
        //===========================================================
        if (typeof(colors_obj) == 'object' &&
            association &&
            association.length>0 &&
            wsm_info[association])
        {
            var a_wsm_data = wsm_info[association].split('|');
            var a_level              = a_wsm_data[0];
            var a_color_type         = a_wsm_data[1].toUpperCase();
            var a_association        = a_wsm_data[2];
            var a_nodes              = a_wsm_data[3];
            var a_classes            = a_wsm_data[4];
            var a_ancestor           = a_wsm_data[5]; // Can't use "parent"!
            var a_default_color      = a_wsm_data[6];
            var a_default_complement = a_wsm_data[7];

            wsm_info[association] = a_level + '|' +
                                    a_color_type + '|' +
                                    a_association + '|' +
                                    a_nodes + '|' +
                                    a_classes + '|' +
                                    a_ancestor + '|' +
                                    a_default_color + '|' +
                                    a_default_complement + '|';
            if (a_color_type == 'FG') {
                wsm_info[association] += ns.style.color;
                selected_color = ns.style.color;
            } else if (a_color_type == 'BG') {
                wsm_info[association] += ns.style.backgroundColor;
                selected_color = ns.style.backgroundColor;
            }

            if (need_update) {
                update_samples(association, selected_color);
            }
        }

        previewed = true;
    }

    return true;
} // End of "preview_color()"
