# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
# 52haes_r541 src/43haes/usr/sbin/cluster/wsm/utils/logger.pm 1.2 
#  
# Licensed Materials - Property of IBM 
#  
# COPYRIGHT International Business Machines Corp. 2006,2007 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

# @(#)94       1.2 src/43haes/usr/sbin/cluster/wsm/utils/logger.pm, hacmp.wsm, 52haes_r541, 0736A_hacmp541 5/22/07 15:37:01

package logger;

use strict;
use warnings;

use Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(logger);



#
# Function: log
#
# Description:
#
#       Log a message using the logger utility.
#
# Arguments:
#
#       type: type of message (i.e. which log to write to), from the list in
#             the logger script.  This argument is optional.
#       msg:  the message text
#
# Return: The exit value of the logger script
#
sub logger {
    my $type = '';
    if (scalar @_ > 1) {
        $type = shift;
    }
    my $msg = shift;

    $type = 'wsm_log' if (! $type);
    my $logsdir = '/usr/es/sbin/cluster/wsm/logs';

    if (! open LOGGER, ">>$logsdir/$type") {
        warn "Could not log message to '$logsdir/$type'.";
        return 1;
    }
    print LOGGER $msg;
    close LOGGER;

    return $?;
}

1;
